/*
	Copyright (c) 2004-2011, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/

/*
	This is an optimized version of Dojo, built for deployment and not for
	development. To get sources and documentation, please visit:

		http://dojotoolkit.org
*/

require({cache:{
'ibm_ilog*graphlayout/ILayoutProvider':function(){
define(["dojo","dijit","dojox","ibm_ilog/graphlayout/internalutil/TranslateUtil"], function(dojo, dijit, dojox){
dojo.getObject("ibm_ilog.graphlayout.ILayoutProvider", 1);
/* builder delete begin
dojo.provide('ibm_ilog.graphlayout.ILayoutProvider');


 builder delete end */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');


 builder delete end */
dojo.declare('ibm_ilog.graphlayout.ILayoutProvider', null, 
{
  // summary:
  //		An interface used to specify the layout instance to be used for
  //		laying out a given graph. 
  // description:
  //		An interface used to specify the layout instance to be used for
  //		laying out a given graph. 
  //		<p>
  //		This is an advanced API. In Dojo Diagrammer, you specify the layout
  //		to use for a specific Subgraph by calling
  //		<code>ibm&#95;diagram.Subgraph.setNodeLayout(layout)</code> or
  //		<code>ibm&#95;diagram.Subgraph.setLinkLayout(layout)</code>.    
  //		</p>
  
  getGraphLayout : function(graphModel)
  {
    // summary:
    //		Returns the layout instance to be used for laying out
    //		'graphModel'. 
    // description:
    //		Returns the layout instance to be used for laying out
    //		<code>graphModel</code>. 
    //		The layout instance that is returned must be attached to
    //		<code>graphModel</code> via the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.attach()</code> .  
    //		<p>
    //		Note that this method must return a different layout instance for
    //		each subgraph. The same layout instance should not be returned for
    //		two different subgraphs of the same graph. Also, the layout instance
    //		returned for a subgraph should not be the same as the one returned
    //		for the topmost graph.   
    //		</p>
    //		<p>
    //		This method is called during the recursive layout of a nested graph
    //		. If the method returns <code>null</code>, this means that no layout
    //		is needed for <code>graphModel</code>.    
    //		</p>
    // graphModel: ibm_ilog.graphlayout.AbstractGraphLayoutModel
    //		The graph model (eventually the graph model that
    //		encapsulates the topmost grapher).
    // returns:
    //		The layout instance to be used for 'graphModel', or
    //		'null' if no layout is need for 'graphModel'.
    
  }
  
});

return dojo.getObject("ibm_ilog.graphlayout.ILayoutProvider");});
require(["ibm_ilog/graphlayout/ILayoutProvider"]);

},
'ibm_ilog*graphlayout/internalutil/ConnectorStyles':function(){
define(["dojo","dijit","dojox","ibm_ilog/graphlayout/internalutil/TranslateUtil","ibm_ilog/graphlayout/internalutil/LinkStyles"], function(dojo, dijit, dojox){
dojo.getObject("ibm_ilog.graphlayout.internalutil.ConnectorStyles", 1);
/* builder delete begin
dojo.provide('ibm_ilog.graphlayout.internalutil.ConnectorStyles');


 builder delete end */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.LinkStyles');


 builder delete end */
dojo.declare('ibm_ilog.graphlayout.internalutil.ConnectorStyles', null, 
{
  // summary:
  //		This class contains all enumeration constants used for connector
  //		styles. 
  // description:
  //		This class contains all enumeration constants used for connector
  //		styles. 
  //		Currently, hierarchical layout, tree layout and short link layout use
  //		the connector styles. It ensures that they all use the same coding.
  //		Notice that the different layouts may support the same set of values.
  //		It also contains some generic support for the connector styles.   
  // tags:
  //		private
  
  constructor : function()
  {
    
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.internalutil.ConnectorStyles,
{
  AUTOMATIC_PINS : null,
  CENTERED_PINS : null,
  CLIPPED_PINS : null,
  EVENLY_SPACED_PINS : null,
  FIXED_OFFSET_PINS : null,

  MIXED_STYLE : null,

  toString : function(style)
  {
    switch (style)
    {
      case ibm_ilog.graphlayout.internalutil.ConnectorStyles.AUTOMATIC_PINS:
        return ("AUTOMATIC_PINS"); // String
      case ibm_ilog.graphlayout.internalutil.ConnectorStyles.CENTERED_PINS:
        return ("CENTERED_PINS"); // String
      case ibm_ilog.graphlayout.internalutil.ConnectorStyles.CLIPPED_PINS:
        return ("CLIPPED_PINS"); // String
      case ibm_ilog.graphlayout.internalutil.ConnectorStyles.EVENLY_SPACED_PINS:
        return ("EVENLY_SPACED_PINS"); // String
      case ibm_ilog.graphlayout.internalutil.ConnectorStyles.FIXED_OFFSET_PINS:
        return ("FIXED_OFFSET_PINS"); // String
      case ibm_ilog.graphlayout.internalutil.ConnectorStyles.MIXED_STYLE:
        return ("MIXED_STYLE"); // String
      default:
        throw new ArgumentError("Wrong connector style " + style); // String
    }
  },

  valueOf : function(s)
  {
    if (s == "AUTOMATIC_PINS") {
      return ibm_ilog.graphlayout.internalutil.ConnectorStyles.AUTOMATIC_PINS; // int
    }
    if (s == "CENTERED_PINS") {
      return ibm_ilog.graphlayout.internalutil.ConnectorStyles.CENTERED_PINS; // int
    }
    if (s == "CLIPPED_PINS") {
      return ibm_ilog.graphlayout.internalutil.ConnectorStyles.CLIPPED_PINS; // int
    }
    if (s == "EVENLY_SPACED_PINS") {
      return ibm_ilog.graphlayout.internalutil.ConnectorStyles.EVENLY_SPACED_PINS; // int
    }
    if (s == "FIXED_OFFSET_PINTS") {
      return ibm_ilog.graphlayout.internalutil.ConnectorStyles.FIXED_OFFSET_PINS; // int
    }
    if (s == "MIXED_STYLE") {
      return ibm_ilog.graphlayout.internalutil.ConnectorStyles.MIXED_STYLE; // int
    }
    throw new ArgumentError("Wrong connector style " + s); // int
  },

  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.internalutil.ConnectorStyles;
    
    c.AUTOMATIC_PINS = 0;
    c.CENTERED_PINS = 1;
    c.CLIPPED_PINS = 2;
    c.EVENLY_SPACED_PINS = 3;
    c.FIXED_OFFSET_PINS = 4;
    c.MIXED_STYLE = ibm_ilog.graphlayout.internalutil.LinkStyles.MIXED_STYLE;
  }
  
}
);

(function(){ ibm_ilog.graphlayout.internalutil.ConnectorStyles._fields_init(); })();

return dojo.getObject("ibm_ilog.graphlayout.internalutil.ConnectorStyles");});
require(["ibm_ilog/graphlayout/internalutil/ConnectorStyles"]);

},
'ibm_ilog*graphlayout/internalutil/DefaultParameterContainer':function(){
define(["dojo","dijit","dojox"], function(dojo, dijit, dojox){
dojo.getObject("ibm_ilog.graphlayout.internalutil.DefaultParameterContainer", 1);
/* builder delete begin
dojo.provide("ibm_ilog.graphlayout.internalutil.DefaultParameterContainer");


 builder delete end */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// #######################################
// ######## NOT Generated by J2JS ########
// ###### DO NOT DELETE THIS FILE! #######
// #######################################

// ------------------------------------------------------------------------
// Utility methods used in the code generated by J2JS.
// ------------------------------------------------------------------------

dojo.declare('ibm_ilog.graphlayout.internalutil.DefaultParameterContainer', null, {
	_obj : null,
	
	constructor : function()
	{
		this._obj = {};
	},
	
	setParameter : function(key, value)
	{
      var old = this._obj[key];
	  if(old === undefined) old = null;
      
      if (value == null)
        delete this._obj[key];
      else
        this._obj[key] = value;
		
      return old;      
	},
	
	getParameter : function(key)
	{
		var v = this._obj[key];
		if(v === undefined)
			return null;
		else
			return v;
	},
	
	isEmpty : function()
	{
		for(var i in this._obj)
			return false;
		return true;
	}
});

return dojo.getObject("ibm_ilog.graphlayout.internalutil.DefaultParameterContainer");});
require(["ibm_ilog/graphlayout/internalutil/DefaultParameterContainer"]);

},
'ibm_ilog*graphlayout/internalutil/AlignmentOptions':function(){
define(["dojo","dijit","dojox","ibm_ilog/graphlayout/internalutil/TranslateUtil","ibm_ilog/graphlayout/internalutil/LinkStyles"], function(dojo, dijit, dojox){
dojo.getObject("ibm_ilog.graphlayout.internalutil.AlignmentOptions", 1);
/* builder delete begin
dojo.provide('ibm_ilog.graphlayout.internalutil.AlignmentOptions');


 builder delete end */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.LinkStyles');


 builder delete end */
dojo.declare('ibm_ilog.graphlayout.internalutil.AlignmentOptions', null, 
{
  // summary:
  //		This class contains all enumeration constants used for any alignment 
  //		options. 
  // description:
  //		This class contains all enumeration constants used for any alignment 
  //		options. 
  //		This ensures that ALL setAlignment or setGlobalAlignment of ALL
  //		layout algorithms use the same constants.  It also contains some
  //		generic support for the alignment options.    
  // tags:
  //		private
  
  constructor : function()
  {
    
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.internalutil.AlignmentOptions,
{
  UNSPECIFIED : null,
  CENTER : null,
  LEFT : null,
  RIGHT : null,
  TOP : null,
  BOTTOM : null,
  BORDER_CENTER : null,
  EAST : null,
  WEST : null,
  NORTH : null,
  SOUTH : null,
  TIP_OVER : null,

  TIP_OVER_BOTH_SIDES : null,
  TIP_OVER_WEST : null,
  TIP_OVER_EAST_WEST : null,

  EAST_NEIGHBOR : null,
  WEST_NEIGHBOR : null,
  TIP_OVER_ASSOCIATE_BOTH_SIDES : null,
  TIP_OVER_ASSOCIATE_EAST : null,
  TIP_OVER_ASSOCIATE_WEST : null,

  MIXED_STYLE : null,
  MIXED : null,

  toString : function(alignment)
  {
    switch (alignment)
    {
      case ibm_ilog.graphlayout.internalutil.AlignmentOptions.UNSPECIFIED:
        return ("UNSPECIFIED"); // String
      case ibm_ilog.graphlayout.internalutil.AlignmentOptions.CENTER:
        return ("CENTER"); // String
      case ibm_ilog.graphlayout.internalutil.AlignmentOptions.LEFT:
        return ("LEFT"); // String
      case ibm_ilog.graphlayout.internalutil.AlignmentOptions.RIGHT:
        return ("RIGHT"); // String
      case ibm_ilog.graphlayout.internalutil.AlignmentOptions.TOP:
        return ("TOP"); // String
      case ibm_ilog.graphlayout.internalutil.AlignmentOptions.BOTTOM:
        return ("BOTTOM"); // String
      case ibm_ilog.graphlayout.internalutil.AlignmentOptions.MIXED:
        return ("MIXED"); // String
      case ibm_ilog.graphlayout.internalutil.AlignmentOptions.BORDER_CENTER:
        return ("BORDER_CENTER"); // String
      case ibm_ilog.graphlayout.internalutil.AlignmentOptions.EAST:
        return ("EAST"); // String
      case ibm_ilog.graphlayout.internalutil.AlignmentOptions.WEST:
        return ("WEST"); // String
      case ibm_ilog.graphlayout.internalutil.AlignmentOptions.NORTH:
        return ("NORTH"); // String
      case ibm_ilog.graphlayout.internalutil.AlignmentOptions.SOUTH:
        return ("SOUTH"); // String
      case ibm_ilog.graphlayout.internalutil.AlignmentOptions.TIP_OVER:
        return ("TIP_OVER"); // String
      case ibm_ilog.graphlayout.internalutil.AlignmentOptions.TIP_OVER_WEST:
        return ("TIP_OVER_WEST"); // String
      case ibm_ilog.graphlayout.internalutil.AlignmentOptions.TIP_OVER_EAST_WEST:
        return ("TIP_OVER_EAST_WEST"); // String
      case ibm_ilog.graphlayout.internalutil.AlignmentOptions.TIP_OVER_BOTH_SIDES:
        return ("TIP_OVER_BOTH_SIDES"); // String
      case ibm_ilog.graphlayout.internalutil.AlignmentOptions.EAST_NEIGHBOR:
        return ("EAST_NEIGHBOR"); // String
      case ibm_ilog.graphlayout.internalutil.AlignmentOptions.WEST_NEIGHBOR:
        return ("WEST_NEIGHBOR"); // String
      case ibm_ilog.graphlayout.internalutil.AlignmentOptions.TIP_OVER_ASSOCIATE_BOTH_SIDES:
        return ("TIP_OVER_ASSOCIATE_BOTH_SIDES"); // String
      case ibm_ilog.graphlayout.internalutil.AlignmentOptions.TIP_OVER_ASSOCIATE_EAST:
        return ("TIP_OVER_ASSOCIATE_EAST"); // String
      case ibm_ilog.graphlayout.internalutil.AlignmentOptions.TIP_OVER_ASSOCIATE_WEST:
        return ("TIP_OVER_ASSOCIATE_WEST"); // String
      default:
        throw new ArgumentError("Wrong alignment option: " + alignment); // String
    }
  },

  valueOf : function(s)
  {
    if (s == "UNSPECIFIED") {
      return ibm_ilog.graphlayout.internalutil.AlignmentOptions.UNSPECIFIED; // int
    }
    if (s == "CENTER") {
      return ibm_ilog.graphlayout.internalutil.AlignmentOptions.CENTER; // int
    }
    if (s == "LEFT") {
      return ibm_ilog.graphlayout.internalutil.AlignmentOptions.LEFT; // int
    }
    if (s == "RIGHT") {
      return ibm_ilog.graphlayout.internalutil.AlignmentOptions.RIGHT; // int
    }
    if (s == "TOP") {
      return ibm_ilog.graphlayout.internalutil.AlignmentOptions.TOP; // int
    }
    if (s == "BOTTOM") {
      return ibm_ilog.graphlayout.internalutil.AlignmentOptions.BOTTOM; // int
    }
    if (s == "MIXED") {
      return ibm_ilog.graphlayout.internalutil.AlignmentOptions.MIXED; // int
    }
    if (s == "MIXED_STYLE") {
      return ibm_ilog.graphlayout.internalutil.AlignmentOptions.MIXED_STYLE; // int
    }
    if (s == "BORDER_CENTER") {
      return ibm_ilog.graphlayout.internalutil.AlignmentOptions.BORDER_CENTER; // int
    }
    if (s == "EAST") {
      return ibm_ilog.graphlayout.internalutil.AlignmentOptions.EAST; // int
    }
    if (s == "WEST") {
      return ibm_ilog.graphlayout.internalutil.AlignmentOptions.WEST; // int
    }
    if (s == "NORTH") {
      return ibm_ilog.graphlayout.internalutil.AlignmentOptions.NORTH; // int
    }
    if (s == "SOUTH") {
      return ibm_ilog.graphlayout.internalutil.AlignmentOptions.SOUTH; // int
    }
    if (s == "TIP_OVER") {
      return ibm_ilog.graphlayout.internalutil.AlignmentOptions.TIP_OVER; // int
    }
    if (s == "TIP_OVER_WEST") {
      return ibm_ilog.graphlayout.internalutil.AlignmentOptions.TIP_OVER_WEST; // int
    }
    if (s == "TIP_OVER_EAST_WEST") {
      return ibm_ilog.graphlayout.internalutil.AlignmentOptions.TIP_OVER_EAST_WEST; // int
    }
    if (s == "TIP_OVER_BOTH_SIDES") {
      return ibm_ilog.graphlayout.internalutil.AlignmentOptions.TIP_OVER_BOTH_SIDES; // int
    }
    if (s == "EAST_NEIGHBOR") {
      return ibm_ilog.graphlayout.internalutil.AlignmentOptions.EAST_NEIGHBOR; // int
    }
    if (s == "WEST_NEIGHBOR") {
      return ibm_ilog.graphlayout.internalutil.AlignmentOptions.WEST_NEIGHBOR; // int
    }
    if (s == "TIP_OVER_ASSOCIATE_BOTH_SIDES") {
      return ibm_ilog.graphlayout.internalutil.AlignmentOptions.TIP_OVER_ASSOCIATE_BOTH_SIDES; // int
    }
    if (s == "TIP_OVER_ASSOCIATE_EAST") {
      return ibm_ilog.graphlayout.internalutil.AlignmentOptions.TIP_OVER_ASSOCIATE_EAST; // int
    }
    if (s == "TIP_OVER_ASSOCIATE_WEST") {
      return ibm_ilog.graphlayout.internalutil.AlignmentOptions.TIP_OVER_ASSOCIATE_WEST; // int
    }
    throw new ArgumentError("Wrong alignment option: " + s); // int
  },

  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.internalutil.AlignmentOptions;
    
    c.UNSPECIFIED = -1;
    c.CENTER = 0;
    c.LEFT = 1;
    c.RIGHT = 2;
    c.TOP = 3;
    c.BOTTOM = 4;
    c.BORDER_CENTER = 5;
    c.EAST = 6;
    c.WEST = 7;
    c.NORTH = 8;
    c.SOUTH = 9;
    c.TIP_OVER = 10;
    c.TIP_OVER_BOTH_SIDES = 11;
    c.TIP_OVER_WEST = 12;
    c.TIP_OVER_EAST_WEST = 13;
    c.EAST_NEIGHBOR = 14;
    c.WEST_NEIGHBOR = 15;
    c.TIP_OVER_ASSOCIATE_BOTH_SIDES = 16;
    c.TIP_OVER_ASSOCIATE_EAST = 17;
    c.TIP_OVER_ASSOCIATE_WEST = 18;
    c.MIXED_STYLE = ibm_ilog.graphlayout.internalutil.LinkStyles.MIXED_STYLE;
    c.MIXED = ibm_ilog.graphlayout.internalutil.AlignmentOptions.MIXED_STYLE;
  }
  
}
);

(function(){ ibm_ilog.graphlayout.internalutil.AlignmentOptions._fields_init(); })();

return dojo.getObject("ibm_ilog.graphlayout.internalutil.AlignmentOptions");});
require(["ibm_ilog/graphlayout/internalutil/AlignmentOptions"]);

},
'ibm_ilog*graphlayout/RecursiveMultipleLayout':function(){
define(["dojo","dijit","dojox","ibm_ilog/graphlayout/internalutil/TranslateUtil","ibm_ilog/graphlayout/internalutil/LayoutUtil","ibm_ilog/graphlayout/internalutil/LogResUtil","ibm_ilog/graphlayout/MultipleLayout","ibm_ilog/graphlayout/RecursiveLayout"], function(dojo, dijit, dojox){
dojo.getObject("ibm_ilog.graphlayout.RecursiveMultipleLayout", 1);
/* builder delete begin
dojo.provide('ibm_ilog.graphlayout.RecursiveMultipleLayout');


 builder delete end */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.LayoutUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.LogResUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.MultipleLayout');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.RecursiveLayout');


 builder delete end */
dojo.declare('ibm_ilog.graphlayout.RecursiveMultipleLayout', ibm_ilog.graphlayout.RecursiveLayout, 
{
  // summary:
  //		The main class for the Recursive Multiple Layout algorithm. 
  // description:
  //		The main class for the Recursive Multiple Layout algorithm. 
  //		<p>
  //		This is not a layout algorithm but rather a facility to perform
  //		multiple layouts recursively in a nested graph. In principle, this is
  //		just the combination of Recursive Layout and  Multiple Layout.   
  //		</p>
  //		<p>
  //		Unless otherwise mentioned, the normal layout algorithms such as
  //		<code> ibm&#95;ilog.graphlayout.hierarchical.HierarchicalLayout</code>,
  //		<code> ibm&#95;ilog.graphlayout.tree.TreeLayout</code>, <code>
  //		ibm&#95;ilog.graphlayout.MultipleLayout</code>, and so forth work on a
  //		flat graph, that is, they lay out the attached graph but not the
  //		subgraphs of the attached graph. Similarly, label layout algorithms
  //		work only on flat managers, not on nested graphs. The Recursive
  //		Multiple Layout is different: it traverses the nesting structure
  //		starting from the attached graph and recursively applies a first
  //		graph layout, then a second graph layout, and  finally a label layout
  //		on all subgraphs. It can be tailored for which sublayouts have to be
  //		applied to which subgraph.  
  //		</p>
  //		<p>
  //		The Recursive Multiple Layout is a Recursive Layout (see <code>
  //		RecursiveLayout</code>) where all layouts of subgraphs are Multiple
  //		Layouts (see <code> ibm&#95;ilog.graphlayout.MultipleLayout</code>).  
  //		</p>
  //		<p>
  //		For instance, assume that you want to apply to each subgraph a Tree
  //		layout, then a Link layout for the nontree links, and finally  a
  //		Label layout for the link labels. It would be unfortunate to call
  //		<code> ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code>
  //		multiple times to achieve this, because the tree layout of the parent
  //		graph  would be finished before the link layout of its subgraph has
  //		started; hence the link layout of the subgraph invalidates the tree
  //		layout of the parent graph again. To avoid this effect, the   Tree
  //		layout, Link layout, and Label layout   of the subgraph should be
  //		finished before any layout of the parent graph has started. The
  //		following examples shows how to achieve this by using the Recursive
  //		Multiple Layout class. There are basically two scenarios:  
  //		<ul>
  //		<li> The same set of layout algorithms must be applied to all
  //		subgraphs.</li>  
  //		<li> An individual layout style must be applied to each
  //		subgraph.</li>  
  //		</ul>
  //		<b>First scenario: Same layout styles everywhere</b> 
  //		</p>
  //		<p>
  //		To perform a Tree Layout, a Link Layout, and an Annealing Label
  //		Layout on a nested graph, call:  
  //		</p>
  //		<pre>
  //		GraphLayout layout = new MultipleRecursiveLayout(
  //		                              new TreeLayout(),
  //		                              new LinkLayout(),
  //		                              new AnnealingLabelLayout());
  //		layout.attach(grapher);
  //		layout.performLayout(true, true); </pre>
  //		If you simply want to apply a label layout in a nested grapher, call:
  //		 
  //		<pre>
  //		GraphLayout layout = new MultipleRecursiveLayout(
  //		                              new AnnealingLabelLayout());
  //		layout.attach(grapher);
  //		layout.performLayout(true, true);
  //		</pre>
  //		In this case, each subgraph is treated bottom-up. First a tree layout
  //		is performed on the subgraph. Then a link layout is performed on the
  //		subgraph, finally the label layout is performed  on the subgraph. All
  //		subgraphs of the nested graph including the top-level graph are
  //		treated in this way. All layouts are performed with the same global
  //		layout parameters as the layout instances passed as arguments to the
  //		constructor of <code>RecursiveMultipleLayout</code>, which are called
  //		the <i>reference layouts</i>.  You can access the reference layout
  //		instances to change the global  layout parameters:   
  //		<pre>
  //		TreeLayout treeLayout =
  //		    (TreeLayout)layout.getFirstReferenceGraphLayout();
  //		treeLayout.setFlowDirection(Direction.Left);
  //		LinkLayout linkLayout =
  //		    (LinkLayout)layout.getSecondReferenceGraphLayout();
  //		linkLayout.setLinkOffset(5f);
  //		AnnealingLabelLayout labelLayout =
  //		    (AnnealingLabelLayout)layout.getReferenceLabelLayout();
  //		labelLayout.setObstacleOffset(20f); </pre>
  //		Internally, a clone of the reference instance is created for each
  //		subgraph. This clone remains attached as long as the Recursive
  //		Multiple Layout is attached to the top-level graph. Before layout is
  //		performed, the global layout parameters are copied from the reference
  //		instance to each clone. If you need to set layout parameters for
  //		individual  nodes, links, or labels,   you have to access the layout
  //		instance of the subgraph that owns  the node, link, or label:     
  //		<pre>
  //		TreeLayout treeLayout = (TreeLayout)layout.getFirstGraphLayout(subgraph);
  //		treeLayout.setAlignment(node, TreeLayout.TIP&#95;OVER);
  //		LinkLayout linkLayout = (LinkLayout)layout.getSecondGraphLayout(subgraph);
  //		linkLayout.setLinkStyle(link, LinkLayout.ORTHOGONAL&#95;STYLE);
  //		AnnealingLabelLayout labelLayout = (AnnealingLabelLayout)layout.getLabelLayout(subgraph);
  //		labelLayout.setLabelDescriptor(label, descriptor); </pre>      
  //		<p>
  //		In the typical case, when you use instances of <code>Graphic</code>
  //		as nodes and instances of <code>Grapher</code> as subgraphs, it is:  
  //		</p>
  //		<pre>
  //		TreeLayout treeLayout = (TreeLayout)layout.getFirstGraphLayout(node.getGraphicBag());
  //		treeLayout.setAlignment(node, TreeLayout.TIP&#95;OVER);
  //		... </pre>   
  //		<p>
  //		<b>Second scenario: Different layout styles at different
  //		subgraphs</b> 
  //		</p>
  //		<p>
  //		The following example shows the second scenario: Each subgraph should
  //		be laid out by a different layout style or with individual layout
  //		parameters. In this case, there are no reference layouts. You specify
  //		the layouts of subgraphs in a very convenient way:   
  //		</p>
  //		<pre>
  //		RecursiveMultipleLayout layout = new RecursiveMultipleLayout();
  //		layout.attach(topLevelGrapher);
  //		// specify the layout of the top-level graph
  //		layout.setLayout(null, new GridLayout(),
  //		                       new LinkLayout(),
  //		                       new RandomLabelLayout()); 
  //		// specify the layout of subgraphs
  //		layout.setLayout(subgraph1, new TreeLayout(),
  //		                            new LinkLayout(),
  //		                            new AnnealingLabelLayout()); 
  //		layout.setLayout(subgraph2, new HierarchicalLayout(),
  //		                            new LinkLayout(),
  //		                            new AnnealingLabelLayout()); 
  //		// perform the layout
  //		LayoutReport report = layout.performLayout(true, true); </pre>
  //		In this scenario, all layout parameters of different subgraphs are
  //		independent. You access the layout instance of each individual
  //		subgraph in the same way as when you have a reference layout. This
  //		allows you to change global layout parameters for this subgraph as
  //		well as parameters of nodes , links, or labels  of the subgraph.  
  //		<p>
  //		<b>Notes:</b>  
  //		<ul>
  //		<li> The Recursive Multiple Layout does not support the specified
  //		provider mode of <code> RecursiveLayout</code>.</li>  
  //		<li> It is not allowed to create a Recursive Layout that contains
  //		another Recursive Layout:   
  //		<pre>
  //		layout = new RecursiveLayout(new RecursiveMultipleLayout());
  //		layout.performLayout(true, true);
  //		</pre>
  //		This would traverse the nested graph and perform the Recursive Layout
  //		for each subgraph, which, however, itself would recursively traverse
  //		the nested graph again. This would just be waste of run time.</li>   
  //		<li> The layout event listeners installed at the Recursive Multiple
  //		Layout receive layout events whenever the layout of a subgraph fires
  //		a layout event. These events, however, do not contain the information
  //		on which sublayout was started or finished. If you need this
  //		information, you should install an event listener at all
  //		sublayouts.</li>   
  //		<li> The reference labeling model cannot be saved to named properties
  //		via <code>
  //		ibm&#95;ilog.graphlayout.AbstractGraphLayoutModel.saveParametersToNamedProperties()</code>.
  //		</li>   
  //		</ul>   
  //		</p>
  /*=====
  // ACTIVE: int
  //		The sublayout is active for all subgraphs.
  ACTIVE : null,
  // INACTIVE: int
  //		The sublayout is inactive for all subgraphs.
  INACTIVE : null,
  // MIXED: int
  //		The sublayout can be active or inactive for individual subgraphs.
  MIXED : null,
  =====*/
  
  _firstLayoutActive: null,
  _secondLayoutActive: null,

  _oldFirstLayoutActive: null,
  _oldSecondLayoutActive: null,

  constructor : function (a0, a1)
  {
    if(arguments.length == 2)
      this._constructor_overload_ibm_ilog_graphlayout_RecursiveMultipleLayout_2(a0, a1);
    else if(arguments.length == 1)
      this._constructor_overload_ibm_ilog_graphlayout_RecursiveMultipleLayout_1(a0);
  },
  
  _constructor_overload_ibm_ilog_graphlayout_RecursiveMultipleLayout_2 : function(referenceLayout1 , referenceLayout2 )
  {
    if(referenceLayout1 instanceof ibm_ilog.graphlayout.GraphLayout && 
       referenceLayout2 instanceof ibm_ilog.graphlayout.GraphLayout)
      this.getReferenceLayout().setSilentAttach(true);
  },
  
  init : function()
  {
    // summary:
    //		Initializes instance variables. 
    // description:
    //		Initializes instance variables. 
    //		<p>
    //		You should not call this method directly. The method is called
    //		internally by the constructor without arguments and by the copy
    //		constructor. The method must be overridden by subclasses that need
    //		to initialize  additional instance variables.
    //		</p>
    // tags:
    //		protected
    
    this.inherited("init", arguments, []);

    this._referenceLabelingModel = null;
    this._firstLayoutActive =
      ibm_ilog.graphlayout.RecursiveMultipleLayout.ACTIVE | (ibm_ilog.graphlayout.RecursiveMultipleLayout.ACTIVE << ibm_ilog.graphlayout.RecursiveMultipleLayout.SHIFT_FOR_AUTOLAYOUT);
    this._secondLayoutActive =
      ibm_ilog.graphlayout.RecursiveMultipleLayout.ACTIVE | (ibm_ilog.graphlayout.RecursiveMultipleLayout.ACTIVE << ibm_ilog.graphlayout.RecursiveMultipleLayout.SHIFT_FOR_AUTOLAYOUT);

    this._labelLayoutActive =
      ibm_ilog.graphlayout.RecursiveMultipleLayout.ACTIVE | (ibm_ilog.graphlayout.RecursiveMultipleLayout.ACTIVE << ibm_ilog.graphlayout.RecursiveMultipleLayout.SHIFT_FOR_AUTOLAYOUT);
  },

  _constructor_overload_ibm_ilog_graphlayout_RecursiveMultipleLayout_1 : function(source)
  {
  },
  
  copy : function()
  {
    // summary:
    //		Copies the layout instance. 
    // description:
    //		Copies the layout instance. 
    //		<p>
    //		This method copies the layout instance by calling the copy
    //		constructor. Note that the parameters which are specific to a node
    //		or a link are not copied.  The reference labeling model is not
    //		copied. It depends on the layout mode what is copied:  
    //		<ul>
    //		<li> <code> RecursiveMultipleLayout.REFERENCE&#95;LAYOUT&#95;MODE</code> -
    //		The reference layouts are copied deeply.</li>  
    //		<li> <code> RecursiveMultipleLayout.INTERNAL&#95;PROVIDER&#95;MODE</code> -
    //		The information which subgraph uses which sublayouts is not
    //		copied.</li>  
    //		</ul>  
    //		</p>
    // returns:
    //		A copy of the layout instance.
    
    return new ibm_ilog.graphlayout.RecursiveMultipleLayout(this); // ibm_ilog.graphlayout.GraphLayout
  },

  copyParameters : function(source)
  {
    // summary:
    //		Copies the parameters from a given layout instance. 
    // description:
    //		Copies the parameters from a given layout instance. 
    //		Note that the parameters which are specific to a node or a link are
    //		not copied.  The reference labeling model is not copied. It depends
    //		on the layout mode what is copied:  
    //		<ul>
    //		<li> <code> RecursiveMultipleLayout.REFERENCE&#95;LAYOUT&#95;MODE</code> -
    //		The reference layouts are copied deeply.</li>  
    //		<li> <code> RecursiveMultipleLayout.INTERNAL&#95;PROVIDER&#95;MODE</code> -
    //		The information which subgraph uses which sublayouts is not
    //		copied.</li>  
    //		</ul>  
    // source: ibm_ilog.graphlayout.GraphLayout
    //		The layout instance from which the parameters are copied.
    
    this.inherited("copyParameters", arguments, [source]);

    if (source instanceof ibm_ilog.graphlayout.RecursiveMultipleLayout)
    {
      var rsource = source;
      this._firstLayoutActive = rsource._firstLayoutActive;
      this._secondLayoutActive = rsource._secondLayoutActive;
    }
  },

  getFirstReferenceGraphLayout : function()
  {
    // summary:
    //		Returns the first reference graph layout, if the reference layout
    //		mode is used. 
    // description:
    //		Returns the first reference graph layout, if the reference layout
    //		mode is used. 
    //		Returns <code>null</code> otherwise.  
    //		<p>
    //		In reference layout mode, the reference layout is used to lay out
    //		the top-level graph. Clones of the reference layout are used to lay
    //		out the subgraphs. The entire nested graph is laid out with the
    //		global layout parameters of the reference layout. If you change
    //		global layout parameters of the reference layout, this will affect
    //		the layout of subgraphs as well, because the global layout
    //		parameters are copied from the reference layout to the layouts of
    //		the subgraphs.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    var refLayout = this.getReferenceLayout();
    if (refLayout != null) {
      return refLayout.getFirstGraphLayout(); // ibm_ilog.graphlayout.GraphLayout
    }
    return null; // ibm_ilog.graphlayout.GraphLayout
  },

  getSecondReferenceGraphLayout : function()
  {
    // summary:
    //		Returns the second reference graph layout, if the reference layout
    //		mode is used. 
    // description:
    //		Returns the second reference graph layout, if the reference layout
    //		mode is used. 
    //		Returns <code>null</code> otherwise.  
    //		<p>
    //		In reference layout mode, the reference layout is used to lay out
    //		the top-level graph. Clones of the reference layout are used to lay
    //		out the subgraphs. The entire nested graph is laid out with the
    //		global layout parameters of the reference layout. If you change
    //		global layout parameters of the reference layout, this will affect
    //		the layout of subgraphs as well, because the global layout
    //		parameters are copied from the reference layout to the layouts of
    //		the subgraphs.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    var refLayout = this.getReferenceLayout();
    if (refLayout != null) {
      return refLayout.getSecondGraphLayout(); // ibm_ilog.graphlayout.GraphLayout
    }
    return null; // ibm_ilog.graphlayout.GraphLayout
  },

  setLayout : function(subgraph, layout)
  {
    // summary:
    //		Sets the layout instance to be used for the input subgraph. 
    // description:
    //		Sets the layout instance to be used for the input subgraph. 
    //		The input layout must be an instance of <code>MultipleLayout</code>.
    //		If <code>null</code> is passed as the subgraph, the input layout is
    //		used for the top-level graph. If <code>null</code> is passed as the
    //		layout, no layout will be performed for the corresponding subgraph. 
    //		
    //		<p>
    //		You can use this method only in internal provider mode. You must
    //		attach a grapher or graph model first before using this method. Each
    //		subgraph must get a different layout instance, that is, the layout
    //		instances cannot be shared among different subgraphs. The input
    //		layout is automatically attached and detached by the Recursive
    //		Multiple Layout as needed.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // subgraph: Object
    //		The subgraph or 'null'.
    // layout: ibm_ilog.graphlayout.GraphLayout
    //		The layout instance used to lay out the subgraph. This
    //		can be 'null', or must be an instance of
    //		'MultipleLayout'.
    
    if(this._callSuper_setLayout){
      this.inherited("setLayout", arguments);
      return;
    }

    if(layout && !(layout instanceof ibm_ilog.graphlayout.MultipleLayout))
      throw new Error("An instance of MultipleLayout is expected at RecursiveMultipleLayout(Object, GraphLayout)");

    var mlayout = layout;
    if (mlayout != null) {
      mlayout.setSilentAttach(true);
    }
    this.inherited("setLayout", arguments, [subgraph, layout,  true,  false]);
  },

  setLayoutImpl : function(subgraph, layout, detachPrevious , traverse )
  {
    // summary:
    //		Sets the layout instance to be used for the input subgraph. 
    // description:
    //		Sets the layout instance to be used for the input subgraph. 
    //		The input layout must be an instance of <code>MultipleLayout</code>.
    //		If the <code>traverse</code> flag is <code>true</code>, it traverses
    //		the nested graph starting from the input graph and sets a clone of
    //		the input layout recursively for each subgraphs. Notice that if you
    //		insert subgraphs after calling this method, the new subgraphs have
    //		no layout yet assigned.  
    //		<p>
    //		If <code>null</code> is passed as the subgraph, the input layout is
    //		used for the top-level graph, and the traversal, if any, starts at
    //		the  top-level graph. If <code>null</code> is passed as the layout,
    //		no layout will be performed for the corresponding subgraphs.  
    //		</p>
    //		<p>
    //		You can use this method only in internal provider mode. Each
    //		subgraph must get a different layout instance, that is, the layout
    //		instances cannot be shared among different subgraphs. You must
    //		attach a grapher or graph model first before using this method. The
    //		input layout is automatically attached and detached by the Recursive
    //		Multiple Layout as needed.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // subgraph: Object
    //		The subgraph or 'null'.
    // layout: ibm_ilog.graphlayout.GraphLayout
    //		The layout instance used to lay out the subgraph. This
    //		must be an instance of 'MultipleLayout'.
    // detachPrevious: Boolean
    //		If 'true', the layout instance
    //		previously specified as the preferred layout of the subgraph (if
    //		any) is detached.
    // traverse: Boolean
    //		If 'true', clones of the input layout are
    //		recursively used for all current subgraphs of the input graph.
    
    if (layout != null && !(layout instanceof ibm_ilog.graphlayout.MultipleLayout))
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.RecursiveMultipleLayout, "graphlayout.expert.message.6681E");
    }

    var mlayout = layout;
    if (mlayout != null) {
      mlayout.setSilentAttach(true);
    }    this._callSuper_performLayout = true;
    this.setLayout(subgraph, layout, detachPrevious, traverse);
    delete this._callSuper_performLayout;
    
  },

  setMultipleLayout : function(subgraph, layout1 , layout2 )
  {
    // summary:
    //		Sets the layout instances to be used for the input subgraph. 
    // description:
    //		Sets the layout instances to be used for the input subgraph. 
    //		If <code>null</code> is passed as the subgraph, the input layout is
    //		used for the top-level graph. Internally, a Multiple Layout is
    //		created that contains the input layouts as sublayouts.  
    //		<p>
    //		When the Recursive Multiple Layout is performed,
    //		<code>layout1</code> is applied first and <code>layout2</code>
    //		second to the input subgraph.  
    //		</p>
    //		<p>
    //		You can use this method only in internal provider mode. You must
    //		attach a grapher or graph model before using this method. Each
    //		subgraph must get different layout instances, that is, the layout
    //		instances cannot be shared among different subgraphs. The input
    //		layouts are automatically attached and detached by the recursive
    //		multiple layout as needed.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // subgraph: Object
    //		The subgraph or 'null'.
    // layout1: ibm_ilog.graphlayout.GraphLayout
    //		The first graph layout used to lay out the subgraph.
    // layout2: ibm_ilog.graphlayout.GraphLayout
    //		The second graph layout used to lay out the subgraph.
    
    var layout = new ibm_ilog.graphlayout.MultipleLayout(layout1, layout2);
    layout.setSilentAttach(true);
    this._callSuper_performLayout = true;
    this.setLayout(subgraph, layout);
    delete this._callSuper_performLayout;
  },

  getFirstGraphLayout : function(subgraph)
  {
    // summary:
    //		Returns the layout instance to be used for the input subgraph as the
    //		first layout. 
    // description:
    //		Returns the layout instance to be used for the input subgraph as the
    //		first layout. 
    //		If <code>null</code> is passed as the subgraph, the layout instance
    //		of the top-level graph is returned. You can use this method in all
    //		layout modes. You must attach a grapher or graph model first before
    //		using this method. The method may return <code>null</code> if no
    //		layout should be performed for the subgraph.  
    //		<p>
    //		In reference layout mode, changing global layout parameters of the
    //		layout instances of subgraphs is useless, because during layout, the
    //		global parameters of the first reference graph layout are used for
    //		each subgraph.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // subgraph: Object
    //		The subgraph or 'null'.
    // returns:
    //		The layout instance used as the first layout for the subgraph.
    
    var layout = this.getLayout(subgraph);
    if (layout != null) {
      return layout.getFirstGraphLayout(); // ibm_ilog.graphlayout.GraphLayout
    }
    return null; // ibm_ilog.graphlayout.GraphLayout
  },

  getSecondGraphLayout : function(subgraph)
  {
    // summary:
    //		Returns the layout instance to be used for the input subgraph as the
    //		second layout. 
    // description:
    //		Returns the layout instance to be used for the input subgraph as the
    //		second layout. 
    //		If <code>null</code> is passed as the subgraph, the layout instance
    //		of the top-level graph is returned. You can use this method in all
    //		layout modes. You must attach a grapher or graph model first before
    //		using this method. The method may return <code>null</code> if no
    //		layout should be performed for the subgraph.  
    //		<p>
    //		In reference layout mode, changing global layout parameters of the
    //		layout instances of subgraphs is useless, because during layout, the
    //		global parameters of the second reference graph layout are used for
    //		each subgraph.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // subgraph: Object
    //		The subgraph or 'null'.
    // returns:
    //		The layout instance used as the second layout for the subgraph.
    
    var layout = this.getLayout(subgraph);
    if (layout != null) {
      return layout.getSecondGraphLayout(); // ibm_ilog.graphlayout.GraphLayout
    }
    return null; // ibm_ilog.graphlayout.GraphLayout
  },

  getLayout : function(subgraph)
  {
    // summary:
    //		Returns the layout instance to be used for the input subgraph. 
    // description:
    //		Returns the layout instance to be used for the input subgraph. 
    //		Here, it always returns an instance of <code>MultipleLayout</code>.
    //		If <code>null</code> is passed as the subgraph, the layout instance
    //		of the top-level graph is returned. You can use this method in all
    //		layout modes. You must attach a grapher or graph model first before
    //		using this method. The method may return <code>null</code> if no
    //		layout should be performed for the subgraph.  
    //		<p>
    //		In reference layout mode, changing global layout parameters of the
    //		layout instances of subgraphs is useless, because during layout, the
    //		global parameters of the reference layout are used for each
    //		subgraph.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // subgraph: Object
    //		The subgraph or 'null'.
    // returns:
    //		The Multiple Layout instance used to lay out the subgraph.
    
    var layout = this.inherited("getLayout", arguments, [subgraph]);
    return layout; // ibm_ilog.graphlayout.GraphLayout
  },

  getLayoutsImpl : function(preOrder)
  {
    // summary:
    //		Returns the instances of 'MultipleLayout' for the nested
    //		graph encapsulated by the graph model of this layout instance. 
    // description:
    //		Returns the instances of <code>MultipleLayout</code> for the nested
    //		graph encapsulated by the graph model of this layout instance. 
    //		You can use this method in all layout modes. You must attach a
    //		grapher or graph model first before using this method.  
    //		<p>
    //		It returns the layout instance for the top-level graph, and
    //		recursively for all subgraphs. The order of the enumeration can be
    //		preorder (that is, the layout of the parent graph comes before the
    //		layout of the subgraphs) or postorder (that is, the layout of the
    //		subgraphs comes before the layout of the parent graph).  
    //		</p>
    //		<p>
    //		In reference layout mode, changing global layout parameters of the
    //		layout instances of subgraphs is useless, because during layout, the
    //		global parameters of the reference layout are used for each
    //		subgraph.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // preOrder: Boolean
    //		If 'true', the layout instances are returned
    //		in preorder, otherwise in postorder.
    // tags:
    //		private
    
    var model = this.getGraphModel();

    if (model == null)
    {
      var name = "getLayouts";
      var params = [name ];
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.RecursiveMultipleLayout, "graphlayout.expert.message.6680E", params);
    }

    var rootModel = ibm_ilog.graphlayout.internalutil.LayoutUtil.getRootModel(model);
    return this.inherited("getLayoutsImpl", arguments, [preOrder]); // ibm_ilog.graphlayout.IIterator
  },

  attach : function(graphModel)
  {
    // summary:
    //		Allows you to specify the top-level graph model of the nested graph
    //		you want to lay out. 
    // description:
    //		Allows you to specify the top-level graph model of the nested graph
    //		you want to lay out. 
    //		In addition to the functionality of the base class, the Recursive
    //		Multiple Layout prepares and attaches the reference layouts in
    //		layout mode <code>
    //		RecursiveMultipleLayout.REFERENCE&#95;LAYOUT&#95;MODE</code>.  If a label
    //		layout algorithm is used but no reference labeling model was
    //		specified before, it tries to use an <code>
    //		ibm&#95;ilog.graphlayout.label.DefaultLabelingModel</code>.  
    //		<p>
    //		  
    //		</p>
    // graphModel: ibm_ilog.graphlayout.AbstractGraphLayoutModel
    //		The graph model.
    
    this.inherited("attach", arguments, [graphModel]);
  },

  detach : function()
  {
    // summary:
    //		Detaches the graph model from the layout instance. 
    // description:
    //		Detaches the graph model from the layout instance. 
    //		When you attach a new graph model to the layout instance, you do not
    //		need  to detach the old graph model because this is done
    //		automatically when you call <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.attach()</code>. The
    //		<code>detach</code> method performs cleaning operations on the graph
    //		model. In addition to the cleaning operations in the base class, the
    //		Recursive Multiple Layout detaches the sublayouts of subgraphs and
    //		disposes of the labeling models including the reference labeling
    //		model. In internal provider mode, it also cleans all settings of
    //		layout instances for subgraphs.  
    //		<p>
    //		Note that you must call this method when you no longer need the
    //		layout instance. Otherwise, some objects may not be garbage
    //		collected.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    this.inherited("detach", arguments, []);
  },

  propagateFirstGraphLayoutActive : function(active)
  {
    // summary:
    //		Sets whether the first graph layout of all subgraphs is active. 
    // description:
    //		Sets whether the first graph layout of all subgraphs is active. 
    //		This allows you to temporarily disable the first graph layouts. The
    //		first graph layouts are active by default. However, if you want to
    //		perform a layout using only the second graph layouts or the label
    //		layouts of the subgraphs,  you can set the first layout inactive. 
    //		In this case, none of the first graph layouts of subgraphs are
    //		performed  when calling <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code> on the 
    //		Recursive Multiple layout instance.  
    //		<p>
    //		In reference layout mode, it calls <code>
    //		ibm&#95;ilog.graphlayout.MultipleLayout.setFirstGraphLayoutActive()</code>
    //		at the reference layout, which is in this case a Multiple Layout. If
    //		a graph is attached and the layout mode is the internal provider
    //		mode, it traverses the nesting hierarchy and calls  <code>
    //		ibm&#95;ilog.graphlayout.MultipleLayout.setFirstGraphLayoutActive()</code>
    //		for all Multiple Layout instances of subgraphs. However, if you
    //		insert subgraphs after calling this method, or if you change the
    //		layout instances of subgraphs in the internal provider after calling
    //		this method, the new layouts of these subgraphs may have a different
    //		setting.  
    //		</p>
    //		<p>
    //		This method throws a runtime exception when no graph model is yet
    //		attached.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // active: Boolean
    //		'true' if the first graph layout is active, or
    //		'false' otherwise.
    
    var l;

    if (this.getLayoutMode() == ibm_ilog.graphlayout.RecursiveLayout.REFERENCE_LAYOUT_MODE)
    {
      l = this.getReferenceLayout();
      l.setFirstGraphLayoutActive(active);
    }
    else
    {
      if (this.getGraphModel() == null)
      {
        var name = "propagateFirstGraphLayoutActive";
        var params = [name ];
        ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.RecursiveMultipleLayout, "graphlayout.expert.message.6680E", params);
      }

      var e = this.getLayoutsImpl(true);

      while (e.hasNext())
      {
        l = e.next();
        if (l != null) {
          l.setFirstGraphLayoutActive(active);
        }
      }
    }
  },

  propagateSecondGraphLayoutActive : function(active)
  {
    // summary:
    //		Sets whether the second graph layout of all subgraphs is active. 
    // description:
    //		Sets whether the second graph layout of all subgraphs is active. 
    //		This allows you to temporarily disable the second graph layouts. The
    //		second graph layouts are active by default. To perform a layout
    //		using only the first graph layouts  or the label layouts of the
    //		subgraphs,  set the second layout to be inactive.  In this case,
    //		none of the second graph layouts of  subgraphs are performed when
    //		calling <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code> on the
    //		Recursive Multiple layout instance.  
    //		<p>
    //		In reference layout mode,  <code>
    //		ibm&#95;ilog.graphlayout.MultipleLayout.setSecondGraphLayoutActive()</code>
    //		is called  at the reference layout, which is in this case a Multiple
    //		Layout. If a graph is attached and the layout mode is the internal
    //		provider mode, it traverses the nesting hierarchy and calls  <code>
    //		ibm&#95;ilog.graphlayout.MultipleLayout.setSecondGraphLayoutActive()</code>
    //		for all Multiple Layout instances of subgraphs. If you insert
    //		subgraphs after calling this method, or if you change the layout
    //		instances of subgraphs in the internal provider after calling this
    //		method, the new layouts of these subgraphs may have a different
    //		setting.  
    //		</p>
    //		<p>
    //		This method throws a runtime exception when no graph model is yet
    //		attached.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // active: Boolean
    //		Set to 'true' if the second graph layout is 
    //		active.
    
    var l;

    if (this.getLayoutMode() == ibm_ilog.graphlayout.RecursiveLayout.REFERENCE_LAYOUT_MODE)
    {
      l = this.getReferenceLayout();
      l.setSecondGraphLayoutActive(active);
    }
    else
    {
      if (this.getGraphModel() == null)
      {
        var name = "propagateSecondGraphLayoutActive";
        var params = [name ];
        ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.RecursiveMultipleLayout, "graphlayout.expert.message.6680E", params);
      }

      var e = this.getLayoutsImpl(true);

      while (e.hasNext())
      {
        l = e.next();
        if (l != null) {
          l.setSecondGraphLayoutActive(active);
        }
      }
    }
  },

  setFirstGraphLayoutActive : function(value)
  {
    // summary:
    //		Sets whether the first graph layout of all subgraphs is active. 
    // description:
    //		Sets whether the first graph layout of all subgraphs is active. 
    //		This holds for calls of <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code> , except for
    //		calls that were triggered by automatic layout. See <code>
    //		RecursiveLayout.setAutoLayout()</code> for  more. Possible values
    //		are:  
    //		<ul>
    //		<li> <code> RecursiveMultipleLayout.ACTIVE</code>: the first graph
    //		layout is active for all subgraphs. </li>  
    //		<li> <code> RecursiveMultipleLayout.INACTIVE</code>: the first graph
    //		layout is inactive for all subgraphs. </li>  
    //		<li> <code> RecursiveMultipleLayout.MIXED</code>: it is unspecified
    //		whether the first layout is active or inactive for all subgraphs.
    //		Instead, it is possible to specify for each subgraph individually by
    //		calling <code>
    //		ibm&#95;ilog.graphlayout.MultipleLayout.setFirstGraphLayoutActive()</code>
    //		to control whether the first graph layout should be active or
    //		inactive. </li>  
    //		</ul>  
    //		<p>
    //		 
    //		</p>
    // value: int
    //		Sets whether the first graph layout is active.
    
    if (value != ibm_ilog.graphlayout.RecursiveMultipleLayout.ACTIVE && value != ibm_ilog.graphlayout.RecursiveMultipleLayout.INACTIVE && value != ibm_ilog.graphlayout.RecursiveMultipleLayout.MIXED)
    {
      var name = "firstGraphLayoutActive";
      var params = [value, name ];
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.RecursiveMultipleLayout, "graphlayout.expert.message.6682E", params);
    }

    if (value != this.getFirstGraphLayoutActive())
    {
      this._firstLayoutActive &= ~ibm_ilog.graphlayout.RecursiveMultipleLayout.AMASK;
      this._firstLayoutActive |= value;
      this.onParameterChanged("FirstGraphLayoutActive");
    }
  },

  getFirstGraphLayoutActive : function()
  {
    // summary:
    //		Returns whether the first graph layout of all subgraphs is active. 
    // description:
    //		Returns whether the first graph layout of all subgraphs is active. 
    //		This holds for calls of <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code>, except for
    //		calls triggered by automatic layout. See <code>
    //		RecursiveLayout.setAutoLayout()</code> for more  information.  
    // returns:
    //		If the first graph layout of all subgraphs is active, '
    //		RecursiveMultipleLayout.ACTIVE' is returned. If the first
    //		graph layout of all subgraphs is
    //		inactive, ' RecursiveMultipleLayout.INACTIVE' is
    //		returned. Otherwise ' RecursiveMultipleLayout.MIXED'
    //		is returned.
    
    return this._firstLayoutActive & ibm_ilog.graphlayout.RecursiveMultipleLayout.AMASK; // int
  },

  setSecondGraphLayoutActive : function(value)
  {
    // summary:
    //		Sets whether the second graph layout of all subgraphs is active. 
    // description:
    //		Sets whether the second graph layout of all subgraphs is active. 
    //		This holds for calls to <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code>, except
    //		calls triggered by automatic layout (see <code>
    //		RecursiveLayout.setAutoLayout()</code>). Possible values are:  
    //		<ul>
    //		<li> <code> RecursiveMultipleLayout.ACTIVE</code>: the second graph
    //		layout is active for all subgraphs. </li>  
    //		<li> <code> RecursiveMultipleLayout.INACTIVE</code>: the second
    //		graph layout is inactive for all subgraphs. </li>  
    //		<li> <code> RecursiveMultipleLayout.MIXED</code>: it is unspecified
    //		whether the second layout is active or inactive for all subgraphs.
    //		Instead, it is possible to specify for each subgraph individually by
    //		calling <code>
    //		ibm&#95;ilog.graphlayout.MultipleLayout.setSecondGraphLayoutActive()</code>
    //		to control whether the second graph layout should be active or
    //		inactive. </li>  
    //		</ul>  
    //		<p>
    //		 
    //		</p>
    // value: int
    //		Sets whether the second graph layout is active.
    
    if (value != ibm_ilog.graphlayout.RecursiveMultipleLayout.ACTIVE && value != ibm_ilog.graphlayout.RecursiveMultipleLayout.INACTIVE && value != ibm_ilog.graphlayout.RecursiveMultipleLayout.MIXED)
    {
      var name = "secondGraphLayoutActive";
      var params = [value, name ];
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.RecursiveMultipleLayout, "graphlayout.expert.message.6682E", params);
    }

    if (value != this.getSecondGraphLayoutActive())
    {
      this._secondLayoutActive &= ~ibm_ilog.graphlayout.RecursiveMultipleLayout.AMASK;
      this._secondLayoutActive |= value;
      this.onParameterChanged("SecondGraphLayoutActive");
    }
  },

  getSecondGraphLayoutActive : function()
  {
    // summary:
    //		Tests if the second graph layout of all subgraphs is active. 
    // description:
    //		Tests if the second graph layout of all subgraphs is active. 
    //		This holds for calls to <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code>, except for
    //		calls triggered by automatic layout (see <code>
    //		RecursiveLayout.setAutoLayout()</code>).  
    // returns:
    //		If the second graph layout of all subgraphs is active, '
    //		RecursiveMultipleLayout.ACTIVE' is returned. If the second
    //		graph layout of all subgraphs
    //		is inactive, ' RecursiveMultipleLayout.INACTIVE' is
    //		returned. Otherwise '
    //		RecursiveMultipleLayout.MIXED' is returned.
    
    return this._secondLayoutActive & ibm_ilog.graphlayout.RecursiveMultipleLayout.AMASK; // int
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.RecursiveMultipleLayout,
{
  ACTIVE : null,

  INACTIVE : null,

  MIXED : null,
  AMASK : null,
  SHIFT_FOR_AUTOLAYOUT : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.RecursiveMultipleLayout;
    if(ibm_ilog.graphlayout.RecursiveLayout._fields_init)
      ibm_ilog.graphlayout.RecursiveLayout._fields_init(c);
    
    c.ACTIVE = 1;
    c.INACTIVE = 2;
    c.MIXED = 0;
    c.AMASK = ibm_ilog.graphlayout.RecursiveMultipleLayout.ACTIVE | ibm_ilog.graphlayout.RecursiveMultipleLayout.INACTIVE;
    c.SHIFT_FOR_AUTOLAYOUT = 2;
  }
  
}
);

ibm_ilog.graphlayout.RecursiveMultipleLayout._getGlobalProperties = function()
{
  // tags:
  //		private
  return ibm_ilog.graphlayout.RecursiveLayout._getGlobalProperties();
};

ibm_ilog.graphlayout.RecursiveMultipleLayout._getNodeProperties = function()
{
  // tags:
  //		private
  return ibm_ilog.graphlayout.RecursiveLayout._getNodeProperties();
};

ibm_ilog.graphlayout.RecursiveMultipleLayout._getLinkProperties = function()
{
  // tags:
  //		private
  return ibm_ilog.graphlayout.RecursiveLayout._getLinkProperties();
};

(function(){ ibm_ilog.graphlayout.RecursiveMultipleLayout._fields_init(); })();

return dojo.getObject("ibm_ilog.graphlayout.RecursiveMultipleLayout");});
require(["ibm_ilog/graphlayout/RecursiveMultipleLayout"]);

},
'ibm_ilog*graphlayout/internalutil/rowcolumngrid/OrderingModes':function(){
define(["dojo","dijit","dojox","ibm_ilog/graphlayout/internalutil/TranslateUtil"], function(dojo, dijit, dojox){
dojo.getObject("ibm_ilog.graphlayout.internalutil.rowcolumngrid.OrderingModes", 1);
/* builder delete begin
dojo.provide('ibm_ilog.graphlayout.internalutil.rowcolumngrid.OrderingModes');


 builder delete end */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');


 builder delete end */
dojo.declare('ibm_ilog.graphlayout.internalutil.rowcolumngrid.OrderingModes', null, 
{
  // summary:
  //		This class contains all enumeration constants used for layouts modes
  //		for internalutil/rowcolumngrid. 
  // description:
  //		This class contains all enumeration constants used for layouts modes
  //		for internalutil/rowcolumngrid. 
  //		This ensures that ALL modes of ALL layout algorithms share the same
  //		values.    
  // tags:
  //		private
  /*=====
  // NO_ORDERING: Function
  //		No order. 
  //		When used as the argument of the method '
  //		Graph.setNodeComparator()', no particular order is applied.
  NO_ORDERING : null,
  =====*/
  
  constructor : function()
  {
    
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.internalutil.rowcolumngrid.OrderingModes,
{
  NO_ORDERING : null,
  _static_init : function()
  {
    ibm_ilog.graphlayout.internalutil.rowcolumngrid.OrderingModes.AUTOMATIC_ORDERING = 1;
    ibm_ilog.graphlayout.internalutil.rowcolumngrid.OrderingModes.DESCENDING_HEIGHT = 2;
    ibm_ilog.graphlayout.internalutil.rowcolumngrid.OrderingModes.ASCENDING_HEIGHT = 3;
    ibm_ilog.graphlayout.internalutil.rowcolumngrid.OrderingModes.ASCENDING_WIDTH = 4;
    ibm_ilog.graphlayout.internalutil.rowcolumngrid.OrderingModes.DESCENDING_WIDTH = 5;
    ibm_ilog.graphlayout.internalutil.rowcolumngrid.OrderingModes.ASCENDING_AREA = 6;
    ibm_ilog.graphlayout.internalutil.rowcolumngrid.OrderingModes.DESCENDING_AREA = 7;
    ibm_ilog.graphlayout.internalutil.rowcolumngrid.OrderingModes.ASCENDING_INDEX = 8;
    ibm_ilog.graphlayout.internalutil.rowcolumngrid.OrderingModes.ASCENDING_INDEX = 9;
    ibm_ilog.graphlayout.internalutil.rowcolumngrid.OrderingModes.DESCENDING_INDEX = 10;
  },
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.internalutil.rowcolumngrid.OrderingModes;
    
    c.NO_ORDERING = null;
  }
  
}
);

(function(){ ibm_ilog.graphlayout.internalutil.rowcolumngrid.OrderingModes._fields_init(); })();
(function(){ ibm_ilog.graphlayout.internalutil.rowcolumngrid.OrderingModes._static_init(); })();

return dojo.getObject("ibm_ilog.graphlayout.internalutil.rowcolumngrid.OrderingModes");});
require(["ibm_ilog/graphlayout/internalutil/rowcolumngrid/OrderingModes"]);

},
'ibm_ilog*graphlayout/RecursiveLayout':function(){
define(["dojo","dijit","dojox","ibm_ilog/graphlayout/internalutil/TranslateUtil","ibm_ilog/graphlayout/internalutil/LogResUtil","ibm_ilog/graphlayout/DefaultLayoutProvider","ibm_ilog/graphlayout/GraphLayout","ibm_ilog/graphlayout/RLayoutModes"], function(dojo, dijit, dojox){
dojo.getObject("ibm_ilog.graphlayout.RecursiveLayout", 1);
/* builder delete begin
dojo.provide('ibm_ilog.graphlayout.RecursiveLayout');


 builder delete end */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.LogResUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.DefaultLayoutProvider');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.GraphLayout');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.RLayoutModes');


 builder delete end */
dojo.declare('ibm_ilog.graphlayout.RecursiveLayout', ibm_ilog.graphlayout.GraphLayout, 
{
  // summary:
  //		The main class for the Recursive Layout algorithm. 
  // description:
  //		The main class for the Recursive Layout algorithm. 
  //		<p>
  //		This is not a layout algorithm but rather a facility to perform
  //		layouts recursively in a nested graph. Unless otherwise mentioned,
  //		the normal layout algorithms such as <code>
  //		ibm&#95;ilog.graphlayout.hierarchical.HierarchicalLayout</code>, <code>
  //		ibm&#95;ilog.graphlayout.tree.TreeLayout</code>, <code>
  //		ibm&#95;ilog.graphlayout.MultipleLayout</code>, and so forth work on a
  //		flat graph, that is, they lay out the attached graph but not the
  //		subgraphs of the attached graph. The Recursive Layout is different:
  //		it traverses the nesting structure starting from the attached graph
  //		and applies a layout recursively on all subgraphs. It can be tailored
  //		for which sublayout has to be applied to which subgraph.   
  //		</p>
  //		<p>
  //		There are basically two scenarios:  
  //		<ul>
  //		<li> The same layout style must be applied to all subgraphs.</li>  
  //		<li> An individual layout style must be applied to each
  //		subgraphs.</li>  
  //		</ul>
  //		<b>First scenario: Same layout style everywhere</b>  
  //		</p>
  //		<p>
  //		The following example shows the first scenario:   
  //		</p>
  //		<pre>
  //		GraphLayout layout = new RecursiveLayout(new TreeLayout());
  //		layout.attach(topLevelGrapher);
  //		LayoutReport report = layout.performLayout(true, true); </pre>
  //		In this case, a tree layout is performed recursively to the top-level
  //		graph and to each subgraph. All layouts are performed with the same
  //		global layout parameters as for the layout instance passed as an
  //		argument to the constructor of <code>RecursiveLayout</code>, which is
  //		called its <i>reference layout</i>. You can access the reference
  //		layout instance to change the global layout parameters:   
  //		<pre>
  //		TreeLayout treeLayout = (TreeLayout)layout.getReferenceLayout();
  //		treeLayout.setFlowDirection(Direction.Left); </pre>
  //		Internally, a clone of the reference instance is created for each
  //		subgraph. This clone remains attached as long as the Recursive Layout
  //		is attached to the top-level graph. Before layout is performed, the
  //		global layout parameters are copied from the reference instance to
  //		each clone. If you need to set layout parameters for individual nodes
  //		and links, you have to access the layout instance of the subgraph
  //		that owns the node or link:   
  //		<pre>
  //		TreeLayout treeLayout = (TreeLayout)layout.getLayout(subgraph);
  //		treeLayout.setAlignment(node, TreeLayout.TIP&#95;OVER); </pre>     
  //		<p>
  //		In the typical case, when you use instances of <code>Graphic</code>
  //		as nodes and instances of <code>Grapher</code> as subgraphs, it is:  
  //		</p>
  //		<pre>
  //		TreeLayout treeLayout = (TreeLayout)layout.getLayout(node.getGraphicBag());
  //		treeLayout.setAlignment(node, TreeLayout.TIP&#95;OVER); </pre>   
  //		<p>
  //		<b>Second scenario: Different layout styles at different
  //		subgraphs</b>  
  //		</p>
  //		<p>
  //		The following example shows the second scenario: Each subgraph should
  //		be laid out by a different layout style or with individual layout
  //		parameters. In this case, we need a layout provider (see <code>
  //		ibm&#95;ilog.graphlayout.ILayoutProvider</code>) that specifies which
  //		layout instance is used for which subgraph.   
  //		</p>
  //		<pre>
  //		GraphLayout layout = new RecursiveLayout(layoutProvider);
  //		layout.attach(topLevelGrapher);
  //		LayoutReport report = layout.performLayout(true, true); </pre>
  //		The layout provider returns a different layout instance for each
  //		subgraph. For example, it may return a grid layout for the top-level
  //		graph, but a tree layout for one subgraph and a bus layout for
  //		another subgraph of the top-level graph. Furthermore, each layout can
  //		have different global layout parameters. You can implement your own
  //		application-specific layout provider, or you can use the predefined
  //		<code> ibm&#95;ilog.graphlayout.DefaultLayoutProvider</code> or <code>
  //		RecursiveLayoutProvider</code> that allows you to specify the
  //		preferred layout of each subgraph. If neither a reference layout nor
  //		a layout provider is given to the Recursive Layout, an internal
  //		default layout provider of class <code>RecursiveLayoutProvider</code>
  //		is used. This allows you to specify the layouts of subgraphs in a
  //		very convenient way:   
  //		<pre>
  //		RecursiveLayout layout = new RecursiveLayout();
  //		layout.attach(topLevelGrapher);
  //		// specify the layout of the top-level graph
  //		layout.setLayout(null, new GridLayout());
  //		// specify the layout of subgraphs
  //		layout.setLayout(subgraph1, new TreeLayout());
  //		layout.setLayout(subgraph2, new BusLayout());
  //		// perform the layout
  //		LayoutReport report = layout.performLayout(true, true); </pre>
  //		In this scenario, there is no reference layout. All layout parameters
  //		of different subgraphs are independent. You access the layout
  //		instance of each individual subgraph in order to change global layout
  //		parameters for this subgraph as well as parameters of nodes and links
  //		of the subgraph. For instance, if the attached top-level graph
  //		contains two subgraphs, and node1 belongs to subgraph1 and node2
  //		belongs to subgraph2, you can set individual global and local layout
  //		parameters in this way:   
  //		<pre>
  //		// access the layout of the top-level graph
  //		GridLayout gridLayout = (GridLayout)layout.getLayout(null);
  //		gridLayout.setLayoutMode(GridLayout.TILE&#95;TO&#95;COLUMNS);
  //		// access the layouts of the subgraph
  //		TreeLayout treeLayout = (TreeLayout)layout.getLayout(subgraph1);
  //		treeLayout.setFlowDirection(Direction.Left);
  //		treeLayout.setAlignment(node1, TreeLayout.TIP&#95;OVER);
  //		BusLayout busLayout = (BusLayout)layout.getLayout(subgraph2);
  //		busLayout.setOrdering(BusLayout.ORDER&#95;BY&#95;HEIGHT);
  //		busLayout.setBus(node2);
  //		</pre>    
  //		<p>
  //		<b>Notes:</b>  
  //		<ul>
  //		<li> The normal layout algorithms such as <code>
  //		ibm&#95;ilog.graphlayout.hierarchical.HierarchicalLayout</code>, <code>
  //		ibm&#95;ilog.graphlayout.tree.TreeLayout</code>, <code>
  //		ibm&#95;ilog.graphlayout.MultipleLayout</code>, and so forth work only on
  //		a flat graph, but for convenience, you can apply <code>
  //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code> with the
  //		<code>traverse</code> flag set to <code>true</code>. This does not
  //		mean that the normal layout instance works on the entire nested graph
  //		including the subgraphs in this case. In fact, internally it uses a
  //		Recursive Layout in reference layout mode, that is, a clone of the
  //		top-level graph layout instance is created for each subgraph, and
  //		these clones are applied recursively to the nested graph. Each clone
  //		still treats only a flat graph.</li>  
  //		<li> It is not possible to create a Recursive Layout that has a
  //		Recursive Layout as reference layout:   
  //		<pre>
  //		layout = new RecursiveLayout(new RecursiveLayout()); </pre>
  //		This calls the copy constructor of the Recursive Layout, but does not
  //		create a Recursive Layout in reference layout mode. A Recursive
  //		Layout inside another Recursive Layout would traverse the nested
  //		graph and perform the Recursive Layout for each subgraph, which,
  //		however, itself would recursively traverse the nested graph again.
  //		This would just be waste of run time.</li>  
  //		<li> The layout event listeners installed at the Recursive Layout
  //		receive layout events whenever the layout of a subgraph fires a
  //		layout event. These events, however, do not contain the information
  //		on which sublayout was started or finished. If you need this
  //		information, you should install an event listener at all
  //		sublayouts.</li>  
  //		<li> If you want to combine <code>MultipleLayout</code> and
  //		<code>RecursiveLayout</code>, you should use <code>
  //		RecursiveMultipleLayout</code>, in particular when you use explicitly
  //		specified labeling models. The Recursive Layout that has a Multiple
  //		Layout as the reference layout works as long as default labeling
  //		models (instances of <code>
  //		ibm&#95;ilog.graphlayout.label.DefaultLabelingModel</code>) are used. The
  //		Recursive Multiple Layout is more flexible; it is in principle a
  //		Recursive Layout that has instances of Multiple Layout as sublayouts
  //		for the subgraphs.  Additionally, the Recursive Multiple Layout
  //		ensures that the correct labeling models (clones of the specified
  //		labeling model) are created in the nested graph. </li>  
  //		</ul>  
  //		</p>
  /*=====
  // REFERENCE_LAYOUT_MODE: int
  //		Layout mode with reference layout.
  REFERENCE_LAYOUT_MODE : null,
  // INTERNAL_PROVIDER_MODE: int
  //		Layout mode with internal layout provider.
  INTERNAL_PROVIDER_MODE : null,
  // SPECIFIED_PROVIDER_MODE: int
  //		Layout mode with explicitly specified provider.
  SPECIFIED_PROVIDER_MODE : null,
  =====*/
  
  constructor : function()
  {
    
  this.DEFAULT_RECURSIVE_ALLOWED_TIME = 1000000000;},

  _layoutProvider: null,
  _referenceLayout: null,

  _mode: null,
  _subgraphCorrection: null,

  _force: null,
  _subgraphsToLayout: null,
  _actLayout: null,
  _startTime: null,
  _stoppedBeforeCompletion: null,
  _oldAllowedTime: null,

  _basePercentage: null,
  _numSubLayouts: null,

  _usePercentageCompletionSubstitute: null,
  _numStepsInSublayout: null,

  DEFAULT_RECURSIVE_ALLOWED_TIME : null,

  constructor : function(layout, layoutProvider)
  {
  // summary:
  //        Creates a new instance of the Recursive Layout algorithm that allows
  //        you to apply layouts to the entire nested graph.
  // description:
  //        If a layout instance is provided, this constructor creates a new
  //        recursive layout instance using the layout as a reference. In this
  //        case, the recursive layout mode is REFERENCE_LAYOUT_MODE.
  //        If the given layout is a recursive layout, this constructor creates
  //        a new recursive layout instance by copying the given one.
  //        
  //        If a layout instance is not provided, but a layout provider is passed
  //        as parameter, the recursive layout instance will have a layout mode
  //        set to SPECIFIED_PROVIDER_MODE. Therefore using the
  //        layout instances as specified by the layout provider.
  //        
  //        If neither the layout nor the layout provider are specified,
  //        the recursive layout instance created is set to INTERNAL_LAYOUT_MODE.
  // layout: ibm_ilog.graphlayout.GraphLayout:
  //        If the given layout is a recursive layout, this constructor
  //        creates a new layout instance by copying the given one. If this is another
  //        layout, this constructor creates a new instance of the Recursive Layout
  //        algorithm that allows you to apply the reference layout to the entire nested graph.
  // layoutProvider: ibm_ilog.graphlayout.ILayoutProvider:
  //        Allows to specify a different layout style or individual
  //        layout parameters to each subgraph of the nested graph. When this parameter is
  //        specified, the layout mode of this Recursive Layout is SPECIFIED_PROVIDER_MODE.
    if(layout instanceof ibm_ilog.graphlayout.GraphLayout &&
       layoutProvider instanceof ibm_ilog.graphlayout.GraphLayout){
      layout = new ibm_ilog.graphlayout.MultipleLayout(layout, layoutProvider);
      layoutProvider = null;
    }
    if (layout != null) {
      if (layout instanceof ibm_ilog.graphlayout.RecursiveLayout) {
        // Copy source layout
        this.copyParameters(layout);
        this.setParametersUpToDate(false);
      } else {
        // Use given layout as reference
        this.setLayoutMode(ibm_ilog.graphlayout.RecursiveLayout.REFERENCE_LAYOUT_MODE, layout, null);
      }
    } else {
      if (layoutProvider != null) {
        this.setLayoutMode(ibm_ilog.graphlayout.RecursiveLayout.SPECIFIED_PROVIDER_MODE, null, layoutProvider);
      } else {
        this.setLayoutMode(ibm_ilog.graphlayout.RecursiveLayout.INTERNAL_PROVIDER_MODE, null, null);
      }
    }
  },
  
  init : function()
  {
    // summary:
    //		Initializes instance variables. 
    // description:
    //		Initializes instance variables. 
    //		<p>
    //		You should not call this method directly. The method is called
    //		internally by the constructor without arguments and by the copy
    //		constructor. The method must be overridden by subclasses that need
    //		to initialize additional instance variables.
    //		</p>
    // tags:
    //		protected
    
    this.inherited("init", arguments, []);
    this._subgraphCorrection = null;
    this.DEFAULT_RECURSIVE_ALLOWED_TIME = 100000000;
    this.setAllowedTime(this.DEFAULT_RECURSIVE_ALLOWED_TIME);
  },

  copy : function()
  {
    // summary:
    //		Copies the layout instance. 
    // description:
    //		Copies the layout instance. 
    //		<p>
    //		This method copies the layout instance by calling the copy
    //		constructor. Note that the parameters which are specific to a node
    //		or a link are not copied. It depends on the layout mode what is
    //		copied.  
    //		<ul>
    //		<li> <code> RecursiveLayout.REFERENCE&#95;LAYOUT&#95;MODE</code> - The
    //		reference layout is copied deeply.</li>  
    //		<li> <code> RecursiveLayout.INTERNAL&#95;PROVIDER&#95;MODE</code> - The
    //		information on which subgraph uses which sublayout is not
    //		copied.</li>  
    //		<li> <code> RecursiveLayout.SPECIFIED&#95;PROVIDER&#95;MODE</code> - The
    //		specified layout provider is copied, but not deeply.</li>  
    //		</ul>  
    //		</p>
    // returns:
    //		A copy of the layout instance.
    
    return new ibm_ilog.graphlayout.RecursiveLayout(this); // ibm_ilog.graphlayout.GraphLayout
  },

  copyParameters : function(source)
  {
    // summary:
    //		Copies the parameters from a given layout instance. 
    // description:
    //		Copies the parameters from a given layout instance. 
    //		Note that the parameters which are specific to a node or a link are
    //		not copied. It depends on the layout mode what is copied:  
    //		<ul>
    //		<li> <code> RecursiveLayout.REFERENCE&#95;LAYOUT&#95;MODE</code> - The
    //		reference layout is copied deeply.</li>  
    //		<li> <code> RecursiveLayout.INTERNAL&#95;PROVIDER&#95;MODE</code> - The
    //		information on which subgraph uses which sublayout is not
    //		copied.</li>  
    //		<li> <code> RecursiveLayout.SPECIFIED&#95;PROVIDER&#95;MODE</code> - The
    //		specified layout provider is copied, but not deeply.</li>  
    //		</ul>  
    // source: ibm_ilog.graphlayout.GraphLayout
    //		The layout instance from which the parameters are copied.
    
    this.inherited("copyParameters", arguments, [source]);

    if (source instanceof ibm_ilog.graphlayout.RecursiveLayout)
    {
      var rsource = source;

      this._savePreferredLayouts = rsource._savePreferredLayouts;
      this._loadLayoutMode = rsource._loadLayoutMode;

      this._subgraphCorrection = rsource._subgraphCorrection;
      this._mode = rsource.getLayoutMode();

      switch (this._mode)
      {
        case ibm_ilog.graphlayout.RecursiveLayout.REFERENCE_LAYOUT_MODE:
          this.copyReferenceLayout(rsource._referenceLayout);

          this.initDefaultLayoutProvider();

          break;
        case ibm_ilog.graphlayout.RecursiveLayout.INTERNAL_PROVIDER_MODE:
          this.initRecursiveLayoutProvider();

          break;
        case ibm_ilog.graphlayout.RecursiveLayout.SPECIFIED_PROVIDER_MODE:
          break;
      }
    }
  },

  initDefaultLayoutProvider : function()
  {
    // summary:
    // tags:
    //		private
    
  },

  initRecursiveLayoutProvider : function()
  {
    // summary:
    // tags:
    //		private
    
  },

  setLayoutMode : function(mode, referenceLayout, layoutProvider)
  {
    // summary:
    //		Set the layout mode. 
    // description:
    //		Set the layout mode. 
    //		This is nonpublic. It is used for the save/loadParameters mechanism.
    // tags:
    //		private
    
    if (this.getGraphModel() != null) {
      this.beforeDetach();
    }
    var msg = null;
    this._mode = mode;

    switch (mode)
    {
      case ibm_ilog.graphlayout.RecursiveLayout.REFERENCE_LAYOUT_MODE:
        if (referenceLayout == null)
        {
          ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.RecursiveLayout, "graphlayout.expert.message.6677E");
        }

        if (referenceLayout instanceof ibm_ilog.graphlayout.RecursiveLayout)
        {
          ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.RecursiveLayout, "graphlayout.expert.message.6678E");
        }

        this._referenceLayout = referenceLayout;

        this.initDefaultLayoutProvider();

        break;
      case ibm_ilog.graphlayout.RecursiveLayout.INTERNAL_PROVIDER_MODE:
        this._referenceLayout = null;

        this.initRecursiveLayoutProvider();

        break;
      case ibm_ilog.graphlayout.RecursiveLayout.SPECIFIED_PROVIDER_MODE:
        if (layoutProvider == null)
        {
          ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.RecursiveLayout, "graphlayout.expert.message.6676E");
        }

        this._referenceLayout = null;
        this._layoutProvider = layoutProvider;
        break;
    }
    if (this.getGraphModel() != null) {
      this.afterAttach(this.getGraphModel());
    }
  },

  getLayoutMode : function()
  {
    // summary:
    //		Returns the layout mode of the Recursive Layout. 
    // description:
    //		Returns the layout mode of the Recursive Layout. 
    //		The possible values are:  
    //		<ul>
    //		<li> <code> RecursiveLayout.REFERENCE&#95;LAYOUT&#95;MODE</code> - The same
    //		layout style with the same global layout parameters is applied to
    //		all subgraphs of the nested graph.</li>  
    //		<li> <code> RecursiveLayout.INTERNAL&#95;PROVIDER&#95;MODE</code> - The
    //		layout is applied using an internal recursive layout provider. The
    //		layout styles of individual subgraphs can be specified by <code>
    //		RecursiveLayout.setLayout()</code>.</li>  
    //		<li> <code> RecursiveLayout.SPECIFIED&#95;PROVIDER&#95;MODE</code> - The
    //		layout is applied using an explicitly specified layout
    //		provider.</li>  
    //		</ul>  
    // returns:
    //		The layout mode.
    
    return this._mode; // int
  },

  getLayoutProvider : function()
  {
    // summary:
    //		Returns the layout provider. 
    // description:
    //		Returns the layout provider. 
    //		<p>
    //		If the reference layout mode is used, this method returns an
    //		internally created instance of <code>
    //		ibm&#95;ilog.graphlayout.DefaultLayoutProvider</code>.  
    //		</p>
    //		<p>
    //		If the internal provider mode is used, this method returns an
    //		internally created instance of <code>
    //		RecursiveLayoutProvider</code>.  
    //		</p>
    //		<p>
    //		In both reference layout and internal provider modes, you should not
    //		manipulate the internally created layout provider directly.  
    //		</p>
    //		<p>
    //		If the specified provider mode is used, it returns the specified
    //		layout provider.  
    //		</p>
    // returns:
    //		The layout provider, which is the instance that is responsible
    //		for specifying the layout instance to be used for laying out each
    //		graph.
    
    return this._layoutProvider; // ibm_ilog.graphlayout.ILayoutProvider
  },

  getReferenceLayout : function()
  {
    // summary:
    //		Returns the reference layout if the reference layout mode is used;
    //		returns 'null' otherwise. 
    // description:
    //		Returns the reference layout if the reference layout mode is used;
    //		returns <code>null</code> otherwise. 
    //		<p>
    //		In reference layout mode, the reference layout is used to lay out
    //		the top-level graph. Clones of the reference layout are used to lay
    //		out the subgraphs. The entire nested graph is laid out with the
    //		global layout parameters of the reference layout. If you change
    //		global layout parameters of the reference layout, this will affect
    //		the layout of subgraphs as well, because the global layout
    //		parameters are copied from the reference layout to the layouts of
    //		the subgraphs.  
    //		</p>
    // returns:
    //		The reference layout if the reference layout mode is used.
    
    return this._referenceLayout; // ibm_ilog.graphlayout.GraphLayout
  },

  copyReferenceLayout : function(sourceReferenceLayout)
  {
    // summary:
    //		Copies the input reference layout.
    // tags:
    //		private
    
    if (sourceReferenceLayout == this._referenceLayout) {
      return;
    }
    if (sourceReferenceLayout == null)
    {
      if (this._referenceLayout != null) {
        this._referenceLayout.detach();
      }
      this._referenceLayout = null;
    }
    else
    {
      if (this._referenceLayout == null) {
        this._referenceLayout = sourceReferenceLayout.copy();
      }
      else if (sourceReferenceLayout.declaredClass == this._referenceLayout.declaredClass) {
        this._referenceLayout.copyParameters(sourceReferenceLayout);
      }
      else
      {
        var tmodel = this._referenceLayout.getGraphModel();
        this._referenceLayout.detach();
        this._referenceLayout = sourceReferenceLayout.copy();
        if (tmodel != null) {
          this._referenceLayout.attach(tmodel);
        }
      }
    }
  },

  setLayout : function(subgraph, layout)
  {
    // summary:
    //		Sets the layout instance to be used for the input subgraph. 
    // description:
    //		Sets the layout instance to be used for the input subgraph. 
    //		If <code>null</code> is passed as the subgraph, the input layout is
    //		used for the top-level graph. If <code>null</code> is passed as the
    //		layout, no layout will be performed for the corresponding subgraph. 
    //		
    //		<p>
    //		You can use this method only in internal provider mode. You must
    //		attach a grapher or graph model first before using this method. Each
    //		subgraph must get a different layout instance, that is, the layout
    //		instances cannot be shared among different subgraphs. The input
    //		layout is automatically attached and detached by the Recursive
    //		Layout as needed.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // subgraph: Object
    //		The subgraph or 'null'.
    // layout: ibm_ilog.graphlayout.GraphLayout
    //		The layout instance used to lay out the subgraph. This
    //		should be a new layout instance that is not used anywhere else.
    
    this.setLayout(subgraph, layout, true, false);
  },

  getLayout : function(subgraph)
  {
    // summary:
    //		Returns the layout instance to be used for the input subgraph. 
    // description:
    //		Returns the layout instance to be used for the input subgraph. 
    //		If <code>null</code> is passed as the subgraph, the layout instance
    //		of the top-level graph is returned. You can use this method in all
    //		layout modes. You must attach a  graph model first before using this
    //		method. The method may return <code>null</code> if no layout should
    //		be performed for the subgraph.  
    //		<p>
    //		In reference layout mode, changing global layout parameters of the
    //		layout instances of subgraphs is useless, because during layout, the
    //		global parameters of the reference layout are used for each
    //		subgraph.  
    //		</p>
    // subgraph: Object
    //		The subgraph or 'null'.
    // returns:
    //		The layout instance used to lay out the subgraph.
    
    var model = this.getGraphModel();

    if (model == null)
    {
      var name = "getLayout";
      var params = [name ];
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.RecursiveLayout, "graphlayout.expert.message.6680E", params);
    }

    var provider = this.getLayoutProvider();
    var submodel;
    var result;

    if (subgraph == null || subgraph == this.getGraphModel())
    {
      submodel = model;

      var flag = ibm_ilog.graphlayout.internalutil.GraphModelData.getData(model).internalGraphModelChecking;

      try
      {
        ibm_ilog.graphlayout.internalutil.GraphModelData.setInternalGraphModelChecking(model, false);
        result = this.getCleanLayout(submodel, provider.getGraphLayout(submodel));
      }
      finally
      {
        ibm_ilog.graphlayout.internalutil.GraphModelData.setInternalGraphModelChecking(model, flag);
      }
    }
    else
    {
      submodel = model.getGraphModel(subgraph);
      result = this.getCleanLayout(submodel, provider.getGraphLayout(submodel));
    }

    return result; // ibm_ilog.graphlayout.GraphLayout
  },

  getLayouts : function(preOrder)
  {
    // summary:
    //		Returns the instances of 'GraphLayout' for the nested
    //		graph encapsulated by the graph model of this layout instance. 
    // description:
    //		Returns the instances of <code>GraphLayout</code> for the nested
    //		graph encapsulated by the graph model of this layout instance. 
    //		You can use this method in all layout modes. You must attach a 
    //		graph model before using this method.  
    //		<p>
    //		This method returns the layout instance for the top-level graph and
    //		recursively for all subgraphs. The order of the enumeration can be
    //		preorder (that is, the layout of the parent graph comes before the
    //		layout of the subgraphs) or postorder (that is, the layout of the
    //		subgraphs comes before the layout of the parent graph).  
    //		</p>
    //		<p>
    //		In reference layout mode, changing global layout parameters of the
    //		layout instances of subgraphs is useless, because during layout, the
    //		global parameters of the reference layout are used for each
    //		subgraph.  
    //		</p>
    // preOrder: Boolean
    //		If 'true', the layout instances are returned
    //		in preorder, otherwise in postorder.
    // returns:
    //		The instances of 'GraphLayout' for the nested
    //		graph encapsulated by the graph model of this layout instance.
    
    return this.getLayoutsImpl(preOrder); // ibm_ilog.graphlayout.IIterator
  },

  getCleanLayout : function(model, layout)
  {
    // summary:
    //		Cleans the mess in reference layout mode. 
    // description:
    //		Cleans the mess in reference layout mode. 
    //		Normally this is not necessary, if people would follow the
    //		documentation. But just to be sure nobody has messed up in
    //		REFERENCE&#95;LAYOUT&#95;MODE, we make sure that the layout has the same
    //		global parameters as the reference layout.
    // tags:
    //		private
    
    if (this.getLayoutMode() == ibm_ilog.graphlayout.RecursiveLayout.REFERENCE_LAYOUT_MODE)
    {
      if (layout == null || !layout.declaredClass == this.getReferenceLayout().declaredClass)
      {
        if (model == null && layout != null) {
          model = layout.getGraphModel();
        }
        layout = this.getReferenceLayout().copy();
        var provider = this.getLayoutProvider();
        if (model != null) {
          provider.setPreferredLayout(model, layout);
        }
      }
      else if (layout != this.getReferenceLayout()) {
        layout.copyParameters(this.getReferenceLayout());
      }
    }

    return layout; // ibm_ilog.graphlayout.GraphLayout
  },

  attach : function(graphModel)
  {
    // summary:
    //		Allows you to specify the top-level graph model of the nested graph
    //		you want to lay out. 
    // description:
    //		Allows you to specify the top-level graph model of the nested graph
    //		you want to lay out. 
    //		<p>
    //		In addition to the functionality of the base class, the Recursive
    //		Layout prepares and attaches the reference layout in layout mode
    //		<code> RecursiveLayout.REFERENCE&#95;LAYOUT&#95;MODE</code>.  
    //		</p>
    // graphModel: ibm_ilog.graphlayout.AbstractGraphLayoutModel
    //		The graph model.
    
    this.inherited("attach", arguments, [graphModel]);
    this.afterAttach(graphModel);
  },

  afterAttach : function(graphModel)
  {
    // summary:
    //		In reference layout mode, attach the reference layout.
    // tags:
    //		private
    
    if (this.getLayoutMode() == ibm_ilog.graphlayout.RecursiveLayout.REFERENCE_LAYOUT_MODE)
    {
      var refLayout = this.getReferenceLayout();
      var provider = this.getLayoutProvider();

      var flag = ibm_ilog.graphlayout.internalutil.GraphModelData.getData(graphModel).internalGraphModelChecking;

      try
      {
        ibm_ilog.graphlayout.internalutil.GraphModelData.setInternalGraphModelChecking(graphModel, false);
        provider.setPreferredLayout(graphModel, refLayout);
      }
      finally
      {
        ibm_ilog.graphlayout.internalutil.GraphModelData.setInternalGraphModelChecking(graphModel, flag);
      }

      if (refLayout.getGraphModel() != graphModel)
      {
        if (refLayout.getGraphModel() != null) {
          refLayout.detach();
        }
        refLayout.attach(graphModel);
      }
    }
  },

  detach : function()
  {
    // summary:
    //		Detaches the graph model from the layout instance. 
    // description:
    //		Detaches the graph model from the layout instance. 
    //		When you attach a new graph model to the layout instance, you do not
    //		need to detach the old graph model because this is done
    //		automatically when you call <code> RecursiveLayout.attach()</code>.
    //		The <code>detach</code> method performs cleaning operations on the
    //		graph model. In addition to the cleaning operations in the base
    //		class, the Recursive Layout detaches the sublayouts of subgraphs. In
    //		internal provider mode, it also cleans all settings of layout
    //		instances for subgraphs.  
    //		<p>
    //		Note that you must call this method when you no longer need the
    //		layout instance. Otherwise, some objects may not be garbage
    //		collected.  
    //		</p>
    
    this.beforeDetach();
    this.inherited("detach", arguments, []);
  },

  beforeDetach : function()
  {
    // summary:
    //		Detach the sublayouts if necessary.
    // tags:
    //		private
    
    var model = this.getGraphModel();

    if (model != null)
    {
      var provider = this.getLayoutProvider();

      if (provider != null && provider instanceof ibm_ilog.graphlayout.DefaultLayoutProvider) {
        (provider).detachLayouts(model, true);
      }
      else
      {
        var e = this.getLayoutsImpl(true);

        while (e.hasNext())
        {
          var layout = e.next();
          if (layout != null && layout.getGraphModel() != null) {
            layout.detach();
          }
        }
      }
    }
  },

  performLayout : function(force, traverse)
  {
    // summary:
    //      This is different from the implementation of the base class; the Recursive
    //      Layout always ignores the <code>traverse</code> flag because the layout is
    //      always done recursively.
    this._force = force;
    return this.inherited("performLayout", arguments, [force, false]);
  },
  
  performSubgraphLayout : function(subgraph, force, traverse)
  {
  // summary:
  //        Starts the layout algorithm with a subgraph.
  // description:
  //        Layout is performed for <code>subgraph</code> and, the <code>traverse</code>
  //        flag is set to <code>true</code> recursively for all subgraphs
  //        contained in this <code>subgraph</code>. If the <code>subgraph</code> is set
  //        to <code>null</code>, the layout is started at the top level graph.
  // subgraph:
  //        The subgraph to start the layout.
  // force:
  //        If <code>true</code>, the method {@link #isLayoutNeeded}
  //        is not called. No check is made to determine if it is necessary
  //        to perform the layout.
  // traverse:
  //        If <code>true</code>, the layout is applied recursively
  //        to all subgraphs contained in the subgraph.
  //        Otherwise, it is only applied on the input subgraph.
  // returns:
  //        The report with information about the execution of
  //        the graph layout in the given subgraph.
    this.collectSubgraphsToLayout(subgraph, traverse);
    this.performLayout(force);
    this._subgraphsToLayout = null;
    return this.getLayoutReport();
  },
  
  performSublayout : function(subgraph, layout, force)
  {
  // summary:
  //        Starts the input layout algorithm.
  // description:
  //        This method is used when this layout controls the input layout as
  //        a sublayout.
  //        Layout classes can override this method if changes are needed with
  //        respect to the way in which the input layout is started.
  //        You should not call this method directly.
  //        In addition to the functionality of the base class, the Recursive
  //        Layout prepares the sublayouts according to the layout mode.
  // subgraph:
  //        The subgraph if used during nested layout, or <code>null</code>.
  // layout:
  //        The sublayout to be preformed.
  // force:
  //        If <code>true</code>, no check is made to determine if
  //        it is necessary to perform the layout.
  // returns:
  //        The layout code.
  //        @see GraphLayoutReport#code
    if(this._callSuper_performSublayout)
      return this.inherited("performSublayout", arguments, [subgraph, layout, force, true]);
    return this.performSublayoutImpl(subgraph, layout, force, true);
  },
  
  mayContinue : function()
  {
    // summary:
    //		Returns true if layout should continue.
    // tags:
    //		private
    
    if (this._stoppedBeforeCompletion) {
      return false; // Boolean
    }
    if (this.isLayoutTimeElapsed() || this.isStoppedImmediately())
    {
      this._stoppedBeforeCompletion = true;
      return false; // Boolean
    }

    return true; // Boolean
  },

  setSubgraphCorrectionInterface : function(ifc)
  {
    // summary:
    //		Sets the correction strategy for subgraphs. 
    // description:
    //		Sets the correction strategy for subgraphs. 
    //		The method <code> ISubgraphCorrection.correct()</code> of the
    //		subgraph correction interface is called immediately after the layout
    //		of the subgraph has finished. This allows you, for instance, to
    //		correct the position of the subgraph after its contents have been
    //		laid out.  
    //		<p>
    //		If all subgraphs are laid out completely, and the layout mode of all
    //		layouts in the nested graph is not incremental, then you do not need
    //		to install any subgraph correction interface. However, in the
    //		following situations, it is useful to install a subgraph correction
    //		interface:  
    //		<ul>
    //		<li> The subgraph is laid out, but its parent graph is not laid out
    //		(because no layout is specified for the parent graph).</li>  
    //		<li> The subgraph is laid out, but the subgraph is specified as
    //		fixed inside the parent graph (for instance by <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.isFixed()</code>).</li>  
    //		<li> The subgraph and its parent graph are laid out, but the layout
    //		of the parent graph uses an incremental mode that analyzes the old
    //		position of the subgraph (see for instance <code>
    //		ibm&#95;ilog.graphlayout.tree.TreeLayout.setIncrementalMode()</code> or
    //		<code>
    //		ibm&#95;ilog.graphlayout.hierarchical.HierarchicalLayout.setIncrementalMode()</code>).
    //		</li>  
    //		</ul>
    //		If subgraphs of type <code> ibm&#95;ilog.diagram.Graph</code> are used,
    //		the layout of the subgraph affects the bounding box of the subgraph.
    //		The subgraph may appear at a completely different position after
    //		layout, even though no layout of the parent graph was performed that
    //		contains the subgraph as a node, and even though <code>
    //		ibm&#95;ilog.diagram.Graph.moveObject()</code> was never called for the
    //		subgraph. The reason for this effect is simply the internal bounding
    //		box mechanism of <code> ibm&#95;ilog.diagram.Graph</code>. This effect
    //		is very unfortunate in the situations that were described above.
    //		There are two predefined subgraph correction strategies that help to
    //		eliminate this effect: <code>
    //		SubgraphCorrectionBarycenterFixed</code> and <code>
    //		SubgraphCorrectionBoundsFixed</code>.   
    //		</p>
    
    if (this._subgraphCorrection != ifc)
    {
      this._subgraphCorrection = ifc;
      this.onParameterChanged("SubgraphCorrectionInterface");
    }
  },

  getSubgraphCorrectionInterface : function()
  {
    // summary:
    //		Returns the subgraph correction interface that is applied after the
    //		nodes and links of the subgraph were laid out. 
    // description:
    //		Returns the subgraph correction interface that is applied after the
    //		nodes and links of the subgraph were laid out. 
    //		<p>
    //		It returns <code>null</code> if none is specified.  
    //		</p>
    
    return this._subgraphCorrection; // ibm_ilog.graphlayout.ISubgraphCorrection
  },

  setAllowedTime : function(time)
  {
    // summary:
    //		Sets the upper limit for the duration of the layout algorithm. 
    // description:
    //		Sets the upper limit for the duration of the layout algorithm. 
    //		<p>
    //		The default value for Recursive layout is <code>1000000000</code>
    //		(1000000 seconds). The allowed time is additionally limited by the
    //		allowed time parameter on the sublayouts.  
    //		</p>
    // time: Number
    //		The allowed time in milliseconds.
    
    this.inherited("setAllowedTime", arguments, [time]);
  },

  getAllowedTime : function()
  {
    // summary:
    //		Returns the currently allowed time for the layout algorithm in
    //		milliseconds. 
    // description:
    //		Returns the currently allowed time for the layout algorithm in
    //		milliseconds. 
    //		The allowed time is additionally limited by the allowed time
    //		parameter on the sublayouts. The effective allowed time is the
    //		minimum of the sum of allowed times for for the sublayouts and the
    //		value returned as allowed time for this Recursive layout.  
    //		<p>
    //		Note that the method <code>performLayout</code> does not
    //		automatically stop the layout when the allowed time is exceeded. It
    //		only delegates  the stop to the sublayouts, and it is entirely the
    //		responsibility of the implementation of the method <code>
    //		RecursiveLayout.layout()</code> on the sublayouts to do this.  
    //		</p>
    
    return (false ? this.DEFAULT_RECURSIVE_ALLOWED_TIME : this.inherited("getAllowedTime", arguments, [])); // Number
  },

  setMinBusyTime : function(time)
  {
    // summary:
    //		Sets the minimal time the layout algorithm can be busy between two
    //		calls of '
    //		ibm_ilog.graphlayout.GraphLayout.onLayoutStepPerformed()' when
    //		the method '
    //		ibm_ilog.graphlayout.GraphLayout.callLayoutStepPerformedIfNeeded()'
    //		is used. 
    // description:
    //		Sets the minimal time the layout algorithm can be busy between two
    //		calls of <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.onLayoutStepPerformed()</code> when
    //		the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.callLayoutStepPerformedIfNeeded()</code>
    //		is used. 
    //		In reference layout mode, it also calls <code>setMinBusyTime</code> 
    //		at the reference layout, hence all layouts of subgraphs will use
    //		this parameter setting. If a graph is attached and the layout mode
    //		is the internal or specified provider mode, it traverses the nesting
    //		hierarchy and calls <code>setMinBusyTime</code>  for all layout
    //		instances of subgraphs. However, if you insert subgraphs after
    //		calling this method, or if you change the layout instances of
    //		subgraphs in your specified provider or via <code>
    //		RecursiveLayout.setLayout()</code> in the internal provider after
    //		calling this method, the new layouts of these subgraphs may have a
    //		different setting.  
    //		<p>
    //		Warning: In internal or specified provider mode, this method does
    //		not throw an exception when no graph model is yet attached. However,
    //		if no graph model is yet attached, the method cannot traverse any
    //		nesting hierarchy.  
    //		</p>
    //		<p>
    //		The default value is <code>50</code> (milliseconds). 
    //		</p>
    
    this.inherited("setMinBusyTime", arguments, [time]);

    if (this.getLayoutMode() == ibm_ilog.graphlayout.RecursiveLayout.REFERENCE_LAYOUT_MODE) {
      this.getReferenceLayout().setMinBusyTime(time);
    }
    else if (this.getGraphModel() != null)
    {
      var e = this.getLayoutsImpl(true);

      while (e.hasNext())
      {
        var layout = e.next();
        if (layout != null) {
          layout.setMinBusyTime(time);
        }
      }
    }
  },

  setLayoutRunning : function(running, fromParents)
  {
    // summary:
    //		Sets whether layout is running. 
    // description:
    //		Sets whether layout is running. 
    //		This method is part of IBM ILOG Dojo Diagrammer internals. You
    //		should not use it.   
    // running: Boolean
    //		Whether layout is running or not.
    // fromParents: Boolean
    //		Whether this notification is from a parent layout or
    //		from this layout instance.
    
    this.inherited("setLayoutRunning", arguments, [running, fromParents]);

    if (this.getGraphModel() != null)
    {
      var e = this.getLayoutsImpl(true);

      while (e.hasNext())
      {
        var layout = e.next();
        if (layout != null) {
          layout.setLayoutRunning(running, true);
        }
      }
    }
  },

  contentsChanged : function(event)
  {
    // summary:
    //		Called when the structure or the geometry of the graph changes. 
    // description:
    //		Called when the structure or the geometry of the graph changes. 
    //		This method is the implementation of the <code>
    //		ibm&#95;ilog.graphlayout.GraphModelListener</code> interface.  
    // event: ibm_ilog.graphlayout.GraphLayoutModelEvent
    //		The event which describes the change that has occurred in
    //		the graph model.
    
    this.contentsChangedImpl(event.graphModel, event);
  },

  setInputCheckEnabled : function(enable)
  {
    // summary:
    //		Sets whether checks are enabled for the  nodes, links, and/or labels
    //		  provided as arguments for the different methods of this layout
    //		algorithm and its sublayout algorithms. 
    // description:
    //		Sets whether checks are enabled for the  nodes, links, and/or labels
    //		  provided as arguments for the different methods of this layout
    //		algorithm and its sublayout algorithms. 
    //		<p>
    //		In reference layout mode, it also calls
    //		<code>setInputCheckEnabled</code>  at the reference layout, hence
    //		all layouts of subgraphs will use this parameter setting. If a graph
    //		is attached and the layout mode is the internal or specified
    //		provider mode, it traverses the nesting hierarchy and calls
    //		<code>setInputCheckEnabled</code>  for all layout instances of
    //		subgraphs. However, if you insert subgraphs after calling this
    //		method, or if you change the layout instances of subgraphs in your
    //		specified provider or via <code> RecursiveLayout.setLayout()</code>
    //		in the internal provider after calling this method, the new layouts
    //		of these subgraphs may have a different setting.  
    //		</p>
    //		<p>
    //		Warning: In internal or specified provider mode, this method does
    //		not throw an exception when no graph model is yet attached. However,
    //		if no graph model is yet attached, the method cannot traverse any
    //		nesting hierarchy.  
    //		</p>
    //		<p>
    //		It is enabled by default. 
    //		</p>
    
    this.inherited("setInputCheckEnabled", arguments, [enable]);

    if (this.getLayoutMode() == ibm_ilog.graphlayout.RecursiveLayout.REFERENCE_LAYOUT_MODE) {
      this.getReferenceLayout().setInputCheckEnabled(enable);
    }
    else if (this.getGraphModel() != null)
    {
      var e = this.getLayoutsImpl(true);

      while (e.hasNext())
      {
        var layout = e.next();
        if (layout != null) {
          layout.setInputCheckEnabled(enable);
        }
      }
    }
  },

  stopImmediately : function()
  {
    // summary:
    //		Stops the running layout algorithm as soon as possible. 
    // description:
    //		Stops the running layout algorithm as soon as possible. 
    //		This works only if all layouts of all subgraphs support stopping the
    //		layout immediately. If the currently running sublayout of a subgraph
    //		does not support this feature, the sublayout will run to completion,
    //		but the layouts of other subgraphs will not be started.   
    //		<p>
    //		This method can be used if multiple threads are used for layout and
    //		GUI control. The GUI control thread calls this method to notify the
    //		layout thread that the layout run must be stopped. The layout
    //		algorithm will perform some final cleanup operations before
    //		terminating. Therefore, the layout thread will continue until the
    //		cleanup operations are finished. The GUI thread, however, returns
    //		immediately from this method.   
    //		</p>
    //		<p>
    //		If the layout algorithm is stopped before completion, the result
    //		code of the layout report is <code>
    //		ibm&#95;ilog.graphlayout.GraphLayoutReport.STOPPED&#95;AND&#95;INVALID</code>.  
    //		</p>
    // returns:
    //		'true' if the algorithm can be stopped at this time.
    
    var result = this.inherited("stopImmediately", arguments, []);

    if (this.getGraphModel() != null)
    {
      var e = this.getLayoutsImpl(true);

      while (e.hasNext())
      {
        var layout = e.next();

        if (layout != null && layout.isLayoutRunning())
        {
          result = layout.stopImmediately() && result;
        }
      }
    }

    return (result); // Boolean
  },

  setAutoCheckAppropriateLinksEnabled : function(enable)
  {
    // summary:
    //		Sets whether the layout checks whether links are appropriate. 
    // description:
    //		Sets whether the layout checks whether links are appropriate. 
    //		This is internally used. You should not use it.  
    // returns:
    //		The previous value.
    
    var e = this.getLayoutsImpl(true);

    while (e.hasNext())
    {
      var layout = e.next();
      if (layout != null) {
        layout.setAutoCheckAppropriateLinksEnabled(enable);
      }
    }

    return this.inherited("setAutoCheckAppropriateLinksEnabled", arguments, [enable]); // Boolean
  },

  isParametersUpToDate : function()
  {
    // summary:
    //		Returns 'false' if at least one parameter was modified
    //		since the last time the layout was successfully performed on the
    //		same graph or if the layout has never been performed successfully on
    //		the same graph. 
    // description:
    //		Returns <code>false</code> if at least one parameter was modified
    //		since the last time the layout was successfully performed on the
    //		same graph or if the layout has never been performed successfully on
    //		the same graph. 
    //		It returns <code>true</code> if no changes occurred.  
    //		<p>
    //		The method returns <code>false</code> if the parameters of one of
    //		the sublayouts is out-of-date.  
    //		</p>
    
    if (this.getGraphModel() != null)
    {
      var e = this.getLayoutsImpl(true);

      while (e.hasNext())
      {
        var layout = e.next();
        if (layout != null && !layout.isParametersUpToDate()) {
          return false; // Boolean
        }
      }
    }

    return this.inherited("isParametersUpToDate", arguments, []); // Boolean
  },

  isStructureUpToDate : function()
  {
    // summary:
    //		Returns 'false' if at least one modification occurred in
    //		the structure of the graph since the last time the layout was
    //		successfully performed on the same graph or if the layout has never
    //		been performed successfully on the same graph. 
    // description:
    //		Returns <code>false</code> if at least one modification occurred in
    //		the structure of the graph since the last time the layout was
    //		successfully performed on the same graph or if the layout has never
    //		been performed successfully on the same graph. 
    //		Returns <code>true</code> if no changes occurred.  
    //		<p>
    //		The method returns <code>false</code> if the structure of one of the
    //		sublayouts is out-of-date.  
    //		</p>
    
    if (this.getGraphModel() != null)
    {
      var e = this.getLayoutsImpl(true);

      while (e.hasNext())
      {
        var layout = e.next();
        if (layout != null && !layout.isStructureUpToDate()) {
          return false; // Boolean
        }
      }
    }

    return this.inherited("isStructureUpToDate", arguments, []); // Boolean
  },

  isGeometryUpToDate : function()
  {
    // summary:
    //		Returns 'false' if at least one node or link was moved or
    //		reshaped since the last time the layout was successfully performed
    //		on the same graph or if the layout has never been performed
    //		successfully on the same graph. 
    // description:
    //		Returns <code>false</code> if at least one node or link was moved or
    //		reshaped since the last time the layout was successfully performed
    //		on the same graph or if the layout has never been performed
    //		successfully on the same graph. 
    //		It returns <code>true</code> if no changes occurred.  
    //		<p>
    //		The method returns <code>false</code> if the geometry of one of the
    //		sublayouts is out-of-date.  
    //		</p>
    
    if (this.getGraphModel() != null)
    {
      var e = this.getLayoutsImpl(true);

      while (e.hasNext())
      {
        var layout = e.next();
        if (layout != null && !layout.isGeometryUpToDate()) {
          return false; // Boolean
        }
      }
    }

    return this.inherited("isGeometryUpToDate", arguments, []); // Boolean
  },

  supportsPercentageComplete : function()
  {
    // summary:
    //		Indicates whether the layout class can estimate the percentage of
    //		completion during the run of the layout. 
    // description:
    //		Indicates whether the layout class can estimate the percentage of
    //		completion during the run of the layout. 
    //		If all layouts of subgraphs support this feature, the percentage
    //		value is calculated from the sublayouts.  
    //		<p>
    //		If some sublayouts do not support this feature, the Recursive Layout
    //		algorithm can indicate by discrete percentage values how many
    //		layouts of subgraphs are already finished. For instance, if the
    //		nesting hierarchy contains five graphs, the percentage will increase
    //		in fixed steps by 20%.  
    //		</p>
    //		<p>
    //		The calculated percentage values are not very precise.  
    //		</p>
    
    return true; // Boolean
  },

  supportsStopImmediately : function()
  {
    // summary:
    //		Indicates whether the layout class can immediately interrupt the
    //		current run of the layout in a controlled way. 
    // description:
    //		Indicates whether the layout class can immediately interrupt the
    //		current run of the layout in a controlled way. 
    //		<p>
    //		In principle, the Recursive Layout supports this feature. If,
    //		however, the sublayout of a subgraph is running and does not support
    //		this feature, then the sublayout runs to completion first before the
    //		entire nested layout is stopped.  
    //		</p>
    //		<p>
    //		If the layout algorithm is stopped before completion, the result
    //		code of the layout report is <code>
    //		ibm&#95;ilog.graphlayout.GraphLayoutReport.STOPPED&#95;AND&#95;INVALID</code>.  
    //		</p>
    
    return true; // Boolean
  },

  supportsAllowedTime : function()
  {
    // summary:
    //		Indicates whether the layout class can stop the layout computation
    //		when a user-defined allowed time is exceeded. 
    // description:
    //		Indicates whether the layout class can stop the layout computation
    //		when a user-defined allowed time is exceeded. 
    //		<p>
    //		In principle, the Recursive Layout supports this feature. If,
    //		however, the sublayout of a subgraph is running and does not support
    //		this feature, then the sublayout runs to completion first before the
    //		entire nested layout is stopped when the allowed time has elapsed.  
    //		</p>
    //		<p>
    //		If the layout algorithm is stopped before completion, the result
    //		code of the layout report is <code>
    //		ibm&#95;ilog.graphlayout.GraphLayoutReport.STOPPED&#95;AND&#95;INVALID</code>.  
    //		</p>
    
    return true; // Boolean
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.RecursiveLayout,
{
  REFERENCE_LAYOUT_MODE : null,

  INTERNAL_PROVIDER_MODE : null,

  SPECIFIED_PROVIDER_MODE : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.RecursiveLayout;
    if(ibm_ilog.graphlayout.GraphLayout._fields_init)
      ibm_ilog.graphlayout.GraphLayout._fields_init(c);
    
    c.REFERENCE_LAYOUT_MODE = ibm_ilog.graphlayout.RLayoutModes.REFERENCE_LAYOUT_MODE;
    c.INTERNAL_PROVIDER_MODE = ibm_ilog.graphlayout.RLayoutModes.INTERNAL_PROVIDER_MODE;
    c.SPECIFIED_PROVIDER_MODE = ibm_ilog.graphlayout.RLayoutModes.SPECIFIED_PROVIDER_MODE;
  }
  
}
);

ibm_ilog.graphlayout.RecursiveLayout._getGlobalProperties = function()
{
  // tags:
  //		private
  return ibm_ilog.graphlayout.GraphLayout._getGlobalProperties();
};

ibm_ilog.graphlayout.RecursiveLayout._getNodeProperties = function()
{
  // tags:
  //		private
  return ibm_ilog.graphlayout.GraphLayout._getNodeProperties();
};

ibm_ilog.graphlayout.RecursiveLayout._getLinkProperties = function()
{
  // tags:
  //		private
  return ibm_ilog.graphlayout.GraphLayout._getLinkProperties();
};

(function(){ ibm_ilog.graphlayout.RecursiveLayout._fields_init(); })();

return dojo.getObject("ibm_ilog.graphlayout.RecursiveLayout");});
require(["ibm_ilog/graphlayout/RecursiveLayout"]);

},
'ibm_ilog*graphlayout/internalutil/LayoutParametersUtil':function(){
define(["dojo","dijit","dojox","ibm_ilog/graphlayout/internalutil/TranslateUtil","ibm_ilog/graphlayout/internalutil/LogResUtil","ibm_ilog/graphlayout/GraphLayout"], function(dojo, dijit, dojox){
dojo.getObject("ibm_ilog.graphlayout.internalutil.LayoutParametersUtil", 1);
/* builder delete begin
dojo.provide('ibm_ilog.graphlayout.internalutil.LayoutParametersUtil');


 builder delete end */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.LogResUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.GraphLayout');


 builder delete end */
dojo.declare('ibm_ilog.graphlayout.internalutil.LayoutParametersUtil', null, 
{
  // summary:
  //		This class contains utilities for managing node/link parameters. 
  // description:
  //		This class contains utilities for managing node/link parameters. 
  //		To use the standard parameter storage mechanism (including input
  //		check, and taking into account isUseDefaultParameters), use the
  //		high-level API: Set/GetNode/Link/NodeOrLinkParameter To avoid use of
  //		isUseDefaultParameters, or in other specific cases, use the
  //		lower-level API: Set/GetNode/Link/NodeOrLinkProperty
  // tags:
  //		private
  
  // no nonstatic constructor in static JavaScript class

}
);

dojo.mixin(ibm_ilog.graphlayout.internalutil.LayoutParametersUtil,
{

  checkInputNode : function(layout, node, objDescr)
  {
    ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.checkInputNodeOrLink(layout, node, objDescr, "The node", "a node", true, false);
  },

  checkInputLink : function(layout, link, objDescr)
  {
    ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.checkInputNodeOrLink(layout, link, objDescr, "The link", "a link", false, true);
  },

  checkInputNodeOrLink : function(layout, nodeOrLink, objDescr, defaultDescr

, reqDescr , checkNode , checkLink )
  {
    var graphModel = layout.getGraphModel();

    if (graphModel == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6018E");
    }

    if (nodeOrLink == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6048E");
    }

    if (!layout.isInputCheckEnabled()) {
      return;
    }
    if (!(checkNode && graphModel.isNode(nodeOrLink)) && !(checkLink && (graphModel.isLink(nodeOrLink) || graphModel.isIntergraphLink(nodeOrLink))))
    {
      var params = [nodeOrLink, graphModel ];
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6049E", params);
    }
  },

  setNodeParameter : function(layout, node, key, value

)
  {
    return ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.setNodeParameter2(layout, node, true, key, value ); // Boolean
  },

  setNodeParameter2 : function(layout, node, checkNode, key, value

)
  {
    return ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.setNodeOrLinkParameterImpl(layout, node, "The input node", checkNode, false, key, value ); // Boolean
  },

  setLinkParameter : function(layout, link, key, value

)
  {
    return ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.setNodeOrLinkParameterImpl(layout, link, "The input link", false, true, key, value ); // Boolean
  },

  setNodeOrLinkParameter : function(layout, nodeOrLink, key, value

)
  {
    return ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.setNodeOrLinkParameterImpl(layout, nodeOrLink, "The input node or link", true, true, key, value ); // Boolean
  },

  setNodeOrLinkParameterImpl : function(layout, nodeOrLink, objectDescr, checkNode, checkLink, key, value

)
  {
    var graphModel = ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.getGraphModel(layout, nodeOrLink, objectDescr, checkNode, checkLink);
    var changed = false;
    var oldValue = null;

    oldValue = layout.setObjectParameter(graphModel, nodeOrLink, key, value);

    changed = !ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.areEqual(oldValue, value);
    if (changed) {
      layout.onObjectParameterChanged(nodeOrLink, key);
    }
    return changed; // Boolean
  },

  setNodeOrLinkProperty : function(layout, nodeOrLink, objectDescr, checkNode, checkLink, key, value)
  {
    var graphModel = ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.getGraphModel(layout, nodeOrLink, objectDescr, checkNode, checkLink);
    var oldValue = layout.setObjectParameter(graphModel, nodeOrLink, key, value);
    return !ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.areEqual(oldValue, value); // Boolean
  },

  getGraphModel : function(layout, nodeOrLink, objectDescr, checkNode, checkLink)
  {
    if (checkNode && checkLink) {
      ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.checkInputNodeOrLink(layout, nodeOrLink, objectDescr, "The object", "a node or link", true, true);
    }
    else if (checkNode) {
      ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.checkInputNode(layout, nodeOrLink, objectDescr);
    }
    else if (checkLink) {
      ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.checkInputLink(layout, nodeOrLink, objectDescr);
    }

    var graphModel = layout.getGraphModel();

    if (graphModel == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6018E");
    }

    return graphModel; // ibm_ilog.graphlayout.AbstractGraphLayoutModel
  },

  areEqual : function(obj1, obj2)
  {
    if (obj1 == null) {
      return obj2 == null; // Boolean
    }
    else {
      return obj1 == obj2; // Boolean
    }
  },

  getNodeBooleanParameter : function(layout, node, key, defaultValue)
  {
    if (node == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6050E");
    }

    return ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.getNodeOrLinkBooleanParameter(layout, node, key, defaultValue); // Boolean
  },

  getNodeIntParameter : function(layout, node, key, defaultValue)
  {
    if (node == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6050E");
    }

    return ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.getNodeOrLinkIntParameter(layout, node, key, defaultValue); // int
  },

  getNodeFloatParameter : function(layout, node, key, defaultValue)
  {
    if (node == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6050E");
    }

    return ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.getNodeOrLinkFloatParameter(layout, node, key, defaultValue); // Number
  },

  getNodeEnumParameter : function(layout, node, key, defaultValue)
  {
    if (node == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6050E");
    }

    if (false) {
      return defaultValue; // int
    }
    var prop = ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.getNodeOrLinkParameter(layout, node, key);

    if (prop == null) {
      return defaultValue; // int
    }
    else
    {
      return  (prop); // int
    }
  },

  getNodeParameter : function(layout, node, key)
  {
    if (node == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6050E");
    }

    return ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.getNodeOrLinkParameter(layout, node, key); // Object
  },

  getLinkBooleanParameter : function(layout, link, key, defaultValue)
  {
    if (link == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6051E");
    }

    return ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.getNodeOrLinkBooleanParameter(layout, link, key, defaultValue); // Boolean
  },

  getLinkIntParameter : function(layout, link, key, defaultValue)
  {
    if (link == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6051E");
    }

    return ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.getNodeOrLinkIntParameter(layout, link, key, defaultValue); // int
  },

  getLinkFloatParameter : function(layout, link, key, defaultValue)
  {
    if (link == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6051E");
    }

    return ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.getNodeOrLinkFloatParameter(layout, link, key, defaultValue); // Number
  },

  getLinkParameter : function(layout, link, key)
  {
    if (link == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6051E");
    }

    return ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.getNodeOrLinkParameter(layout, link, key); // Object
  },

  getLinkEnumParameter : function(layout, link, key, defaultValue)
  {
    if (link == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6051E");
    }

    if (false) {
      return defaultValue; // int
    }
    var prop = ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.getNodeOrLinkParameter(layout, link, key);

    if (prop == null)
    {
      return defaultValue; // int
    }
    else
    {
      return  (prop); // int
    }
  },

  getNodeOrLinkBooleanParameter : function(layout, nodeOrLink, key, defaultValue)
  {
    if (false) {
      return defaultValue; // Boolean
    }
    var prop = ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.getNodeOrLinkParameter(layout, nodeOrLink, key);
    return ((prop != null) ? prop : defaultValue);
  },

  getNodeOrLinkIntParameter : function(layout, nodeOrLink, key, defaultValue)
  {
    if (false) {
      return defaultValue; // int
    }
    var prop = ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.getNodeOrLinkParameter(layout, nodeOrLink, key);
    return (prop == null ? defaultValue :  (prop)); // int
  },

  getNodeOrLinkFloatParameter : function(layout, nodeOrLink, key, defaultValue)
  {
    if (false) {
      return defaultValue; // Number
    }
    var prop = ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.getNodeOrLinkParameter(layout, nodeOrLink, key);
    return (prop == null ? defaultValue : (prop)); // Number
  },

  getNodeOrLinkParameter : function(layout, nodeOrLink, key)
  {
    var graphModel = layout.getGraphModel();

    if (graphModel == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6018E");
    }

    return layout.getObjectParameter(graphModel, nodeOrLink, key); // Object
  },

  getNodeParameterName : function(propertyName)
  {
    return (propertyName + "N"); // String
  },

  getLinkParameterName : function(propertyName)
  {
    return (propertyName + "L"); // String
  }

}
);


return dojo.getObject("ibm_ilog.graphlayout.internalutil.LayoutParametersUtil");});
require(["ibm_ilog/graphlayout/internalutil/LayoutParametersUtil"]);

},
'ibm_ilog*graphlayout/DefaultLayoutProvider':function(){
define(["dojo","dijit","dojox","ibm_ilog/graphlayout/internalutil/TranslateUtil","ibm_ilog/graphlayout/internalutil/HashTable","ibm_ilog/graphlayout/internalutil/LogResUtil","ibm_ilog/graphlayout/ILayoutProvider"], function(dojo, dijit, dojox){
dojo.getObject("ibm_ilog.graphlayout.DefaultLayoutProvider", 1);
/* builder delete begin
dojo.provide('ibm_ilog.graphlayout.DefaultLayoutProvider');


 builder delete end */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.HashTable');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.LogResUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.ILayoutProvider');


 builder delete end */
dojo.declare('ibm_ilog.graphlayout.DefaultLayoutProvider', ibm_ilog.graphlayout.ILayoutProvider, 
{
  // summary:
  //		A default implementation of the interface '
  //		ILayoutProvider'. 
  // description:
  //		A default implementation of the interface <code>
  //		ILayoutProvider</code>. 
  //		<p>
  //		This class is mainly useful when laying out nested graphs, that is,
  //		graphs containing nodes that are also graphs. It provides the
  //		following services:  
  //		<ul>
  //		<li>Allows you to set a layout instance for a given graph model (see
  //		the method <code> DefaultLayoutProvider.setPreferredLayout()</code>
  //		).</li>  
  //		<li>When no layout instance is specified for a given graph model
  //		using the method <code>
  //		DefaultLayoutProvider.setPreferredLayout()</code> , the
  //		<code>protected</code> method (<code>
  //		DefaultLayoutProvider.createGraphLayout()</code>) is called. The
  //		default implementation of this method clones the layout instance of
  //		the closest parent graph for which a layout has been set. You can
  //		override this method to change this behavior.  
  //		<p>
  //		Warning: to avoid repeatedly cloning the layout instance, the method
  //		<code> DefaultLayoutProvider.getGraphLayout()</code> stores the
  //		cloned layout instance as the preferred layout of the given graph
  //		model. This means that any change to the parameters of the layout
  //		that has been cloned, after the call of <code>
  //		DefaultLayoutProvider.getGraphLayout()</code>, does not affect the
  //		cloned layout instance. This allows you to set parameters
  //		independently on each layout instance. However, if you need to
  //		replicate the same parameter settings on the layout instance that has
  //		been previously cloned, you can, for instance, delete the preferred
  //		layout (<code>setPreferredLayout(model, null)</code>). This way the
  //		layout instance of the parent graph will be cloned again with its new
  //		parameter settings.
  //		</p>
  //		</li>  
  //		</ul>  
  //		</p>
  //		<p>
  //		Note that you must call the method <code>
  //		DefaultLayoutProvider.detachLayouts()</code> when you no longer need
  //		the layout provider instance; otherwise, some objects may not be
  //		garbage collected.  
  //		</p>
  
  _uniqueId: null,
  _layoutHashMap : null,

  constructor : function()
  {
    this._layoutHashMap = new ibm_ilog.graphlayout.internalutil.HashTable();
    this.initPropertiesNames();
  },
  
  getInstanceId : function()
  {
    // summary:
    //		Returns a unique integer value for each layout provider instance in
    //		the same JavaScript program. 
    // description:
    //		Returns a unique integer value for each layout provider instance in
    //		the same JavaScript program. 
    //		Use this utility method to obtain names for properties that are
    //		unique for each layout provider instance.  
    // returns:
    //		Unique integer value for each layout provider instance.
    
    return this._uniqueId; // int
  },

  setPreferredLayout : function(graphModel, layout, detachPrevious , traverse )
  {
    // summary:
    //		Sets the layout instances to be used for laying out
    //		'graphModel'. 
    // description:
    //		Sets the layout instances to be used for laying out
    //		<code>graphModel</code>. 
    //		<p>
    //		If the argument <code>traverse</code> is <code>false</code>,
    //		<code>layout</code> is stored as the preferred layout of
    //		<code>graphModel</code>. If the argument <code>traverse</code> is
    //		<code>true</code>, <code>layout</code> is stored as the preferred
    //		layout of <code>graphModel</code> and, recursively, a clone of
    //		<code>layout</code> is stored as preferred layout of all the models
    //		encapsulating the subgraphs of <code>graphModel</code>. The clones
    //		are obtained by calling the method <code>
    //		DefaultLayoutProvider.copy()</code>.  
    //		</p>
    //		<p>
    //		You can call this method with a <code>null</code> value for the
    //		argument <code>layout</code> to reset previous settings. By default,
    //		there is no preferred layout and the method <code>
    //		DefaultLayoutProvider.getPreferredLayout()</code> returns
    //		<code>null</code>.  
    //		</p>
    //		<p>
    //		If it is not already attached, the method attaches the layout
    //		instance to the graph model using the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.attach()</code>. The layout
    //		instance is stored in the provider until it is detached using the
    //		method <code> ibm&#95;ilog.graphlayout.GraphLayout.detach()</code>. If a
    //		different layout instance was previously specified and the argument
    //		<code>detachPrevious</code> is <code>true</code>, the graph model is
    //		detached from it using the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.detach()</code>.  
    //		</p>
    //		<p>
    //		If no layout instance is specified for a subgraph, then the layout
    //		instance specified for the nearest parent graph will be used (see
    //		<code> DefaultLayoutProvider.getGraphLayout()</code>).  
    //		</p>
    //		<p>
    //		The same layout instance should not be used for different subgraphs
    //		in the same nested graph, and should not be used inside a different
    //		default layout provider. The method should also not be called for
    //		graph models that are adapters created internally by the method
    //		<code> ibm&#95;ilog.graphlayout.GraphLayout.attach()</code> on a layout
    //		instance which is not <code>layout</code>.  
    //		</p>
    //		<p>
    //		Note that the settings are valid only for this instance of
    //		<code>DefaultLayoutProvider</code>. The persistence of the choice of
    //		the layouts to be applied to each subgraph in IVL files (using named
    //		properties) can be obtained using the methods <code>
    //		ibm&#95;ilog.graphlayout.AbstractGraphLayoutModel.savePreferredLayoutsToNamedProperties()</code>
    //		and <code>
    //		ibm&#95;ilog.graphlayout.AbstractGraphLayoutModel.loadPreferredLayoutsFromNamedProperties()</code>.
    //		  
    //		</p>
    // graphModel: ibm_ilog.graphlayout.AbstractGraphLayoutModel
    //		The graph model (the graph model that encapsulates the
    //		topmost grapher, or a subgraph).
    // layout: ibm_ilog.graphlayout.GraphLayout
    //		The layout instance to be used for laying out
    //		'graphModel', or 'null'.
    // detachPrevious: Boolean
    //		If 'true', the layout instance
    //		previously specified as the preferred layout of
    //		'graphModel' (if any) is detached.
    // traverse: Boolean
    //		If 'true', 'layout' is stored as
    //		the preferred layout of 'graphModel', and clones of
    //		'layout' are recursively stored on the submodels of
    //		'graphModel'. Otherwise, the method does not go
    //		recursively into the submodels.
    
    if(detachPrevious === undefined) detachPrevious = true;
    if(traverse === undefined) traverse = false;

    if (graphModel == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.DefaultLayoutProvider, "graphlayout.expert.message.6012E");
    }

    this.setPreferredLayoutRecursive(graphModel, graphModel, layout, detachPrevious, traverse);
  },

  setPreferredLayoutRecursive : function(startModel, graphModel, startLayout, detachPrevious, traverse)
  {
    if (traverse)
    {
      var subGraphModel;
      var subgraph;
      var subgraphs = new ibm_ilog.graphlayout.internalutil.ArrayIterator(graphModel.getSubgraphs());

      while (subgraphs.hasNext())
      {
        subgraph = subgraphs.next();

        subGraphModel = graphModel.getGraphModel(subgraph);
        if (subGraphModel != null) {
          this.setPreferredLayoutRecursive(startModel, subGraphModel, startLayout, detachPrevious, true);
        }
      }
    }

    var layout = (startModel == graphModel ? startLayout : ((startLayout != null ? this.copy(startLayout) : null)));
    this.setPreferredLayoutNonRecursive(graphModel, layout, detachPrevious);
  },

  setPreferredLayoutNonRecursive : function(graphModel, layout, detachPrevious)
  {
    if (graphModel == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.DefaultLayoutProvider, "graphlayout.expert.message.6012E");
    }

    if (ibm_ilog.graphlayout.internalutil.GraphModelData.getData(graphModel).internalGraphModelChecking)
    {
      if (graphModel.isDisposed() && layout != null)
      {
        ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.DefaultLayoutProvider, "graphlayout.expert.message.6013E");
      }
      if (layout != null) {
        // NOTE: Converting to object and checking the property
        // The best would be to check for GraphLayoutModelAdapter
        // but I want to avoid dependency towards diagrammer module.
        var adapter = graphModel;
        if (adapter.originatingLayout) {
          if (adapter.originatingLayout != layout)
            LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.DefaultLayoutProvider, "graphlayout.expert.message.6014E", [graphModel, adapter.originatingLayout, layout]);
        }
      }
    }

    var oldLayout = this.getStoredPreferredLayout(graphModel);
    if (oldLayout == layout) {
      return;
    }
    if (detachPrevious && oldLayout != null && oldLayout.getGraphModel() != null)
    {
      oldLayout.removeLayoutProviderThatContainsMe(this);
      oldLayout.detach();
    }

    if (layout != null && layout.getGraphModel() != graphModel) {
      layout.attach(graphModel);
    }
    this.storePreferredLayout(graphModel, layout);
  },

  getPreferredLayout : function(graphModel)
  {
    // summary:
    //		Returns the layout instance that has been specified using the method
    //		' DefaultLayoutProvider.setPreferredLayout()'  for laying
    //		out 'graphModel', or 'null' if none has been
    //		specified or a 'null' layout has been specified (that is,
    //		no layout should be applied to this graph model). 
    // description:
    //		Returns the layout instance that has been specified using the method
    //		<code> DefaultLayoutProvider.setPreferredLayout()</code>  for laying
    //		out <code>graphModel</code>, or <code>null</code> if none has been
    //		specified or a <code>null</code> layout has been specified (that is,
    //		no layout should be applied to this graph model). 
    //		<p>
    //		The layout instance is already attached. If you detach the layout
    //		instance, it is automatically removed from the provider.  
    //		</p>
    // graphModel: ibm_ilog.graphlayout.AbstractGraphLayoutModel
    //		The graph model (the graph model that encapsulates the
    //		topmost grapher , or a subgraph).
    // returns:
    //		The layout instance that has been specified for laying out the
    //		specified model.
    
    if (graphModel == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.DefaultLayoutProvider, "graphlayout.expert.message.6012E");
    }

    var layout = this.getStoredPreferredLayout(graphModel);

    if (layout != null)
    {
      var oldModel = layout.getGraphModel();

      if (oldModel != graphModel)
      {
        if (oldModel == null || !oldModel.isDisposed()) {
          layout.attach(graphModel);
        }
        else if (ibm_ilog.graphlayout.internalutil.GraphModelData.getData(graphModel).internalGraphModelChecking)
        {
          ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.DefaultLayoutProvider, "graphlayout.expert.message.6015E");
        }
      }
    }

    return layout; // ibm_ilog.graphlayout.GraphLayout
  },

  getStoredPreferredLayout : function(graphModel)
  {
    // summary:
    // tags:
    //		private
    
    return this._layoutHashMap.item(graphModel); // ibm_ilog.graphlayout.GraphLayout
  },

  storePreferredLayout : function(graphModel, layout)
  {
    // summary:
    //		Stores the layout for the graph model. 
    // description:
    //		Stores the layout for the graph model. 
    //		This method is overridden in some subclasses. You should not use
    //		this method.
    // tags:
    //		protected
    
    if (layout != null)
    {
      layout.addLayoutProviderThatContainsMe(this);
      this._layoutHashMap.add(graphModel, layout);
    }
    else {
      this._layoutHashMap.remove(graphModel);
    }
  },

  detachLayouts : function(graphModel, traverse)
  {
    // summary:
    //		Detaches the layout instances from 'graphModel' and
    //		cleans the preferred layout settings. 
    // description:
    //		Detaches the layout instances from <code>graphModel</code> and
    //		cleans the preferred layout settings. 
    //		<p>
    //		This method allows you to easily detach all the layout instances
    //		used for a nested graph. The layout instances are obtained using the
    //		method <code> DefaultLayoutProvider.getGraphLayout()</code>. If the
    //		argument <code>traverse</code> is <code>true</code>, the method is
    //		applied recursively on the subgraphs of <code>graphModel</code>.  
    //		</p>
    //		<p>
    //		Note that you must call this method when you no longer need the
    //		layout provider instance; otherwise, some objects may not be garbage
    //		collected.  
    //		</p>
    // graphModel: ibm_ilog.graphlayout.AbstractGraphLayoutModel
    //		The graph model (the graph model that encapsulates the
    //		topmost grapher , or a subgraph).
    // traverse: Boolean
    //		If 'true', the method applies to
    //		'graphModel' and recursively to all subgraph models.
    //		Otherwise, it applies only to 'graphModel' itself.
    
    if (graphModel == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.DefaultLayoutProvider, "graphlayout.expert.message.6012E");
    }

    if (traverse)
    {
      var lay;
      var keys = this._layoutHashMap.getKeyList();
      for(var i = 0; i < keys.length; i++)
      {
        var key = keys[i];
        lay = this._layoutHashMap.item(key);
        if (lay != null && lay.getGraphModel() == key) {
          lay.removeLayoutProviderThatContainsMe(this);
          lay.detach();
          this._layoutHashMap.remove(key);
          key = null;
        }
      }
    }
    else
    {
      var layout = this.getStoredPreferredLayout(graphModel);
      this.storePreferredLayout(graphModel, null);

      if (layout != null && layout.getGraphModel() == graphModel)
      {
        layout.removeLayoutProviderThatContainsMe(this);

        layout.detach();
      }
    }
  },

  getGraphLayout : function(graphModel)
  {
    // summary:
    //		Returns the layout instance to be used to lay out
    //		'graphModel'. 
    // description:
    //		Returns the layout instance to be used to lay out
    //		<code>graphModel</code>. 
    //		<p>
    //		The default implementation first searches for a preferred layout
    //		specified using <code>
    //		DefaultLayoutProvider.setPreferredLayout()</code> . If none is
    //		found, the method returns the layout instance returned by the method
    //		<code> DefaultLayoutProvider.createGraphLayout()</code>.  
    //		</p>
    // graphModel: ibm_ilog.graphlayout.AbstractGraphLayoutModel
    //		The graph model (the graph model that encapsulates the
    //		topmost grapher , or a subgraph).
    // returns:
    //		The layout instance to be used for 'graphModel', or
    //		'null' if no layout is need for 'graphModel'.
    
    var prefLayout = this.getPreferredLayout(graphModel);
    if (prefLayout != null) {
      return prefLayout; // ibm_ilog.graphlayout.GraphLayout
    }
    var newLayout = this.createGraphLayout(graphModel);
    if (newLayout == null) {
      return null; // ibm_ilog.graphlayout.GraphLayout
    }
    else {
      newLayout.attach(graphModel);
    }
    this.setPreferredLayout(graphModel, newLayout);
    return newLayout; // ibm_ilog.graphlayout.GraphLayout
  },

  createGraphLayout : function(graphModel)
  {
    // summary:
    //		Returns a layout instance to be used to lay out a graph model for
    //		which no layout has been specified using the method '
    //		DefaultLayoutProvider.setPreferredLayout()' . 
    // description:
    //		Returns a layout instance to be used to lay out a graph model for
    //		which no layout has been specified using the method <code>
    //		DefaultLayoutProvider.setPreferredLayout()</code> . 
    //		<p>
    //		The method clones (using the method <code>
    //		DefaultLayoutProvider.copy()</code>) the layout instance of the
    //		nearest parent graph model for which a non-<code>null</code>
    //		preferred layout has been specified. If no non-<code>null</code>
    //		preferred layout has been specified for any of its parents,
    //		including the topmost (root) graph model, the method returns
    //		<code>null</code>.  
    //		</p>
    //		<p>
    //		The layout instance that is returned does not need to be attached to
    //		the specified graph model. The attachment (using the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.attach()</code> is done in the
    //		method <code> DefaultLayoutProvider.getGraphLayout()</code>.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // graphModel: ibm_ilog.graphlayout.AbstractGraphLayoutModel
    //		The graph model (the graph model that encapsulates the
    //		topmost grapher , or a subgraph).
    // returns:
    //		The layout instance to be used for 'graphModel', or
    //		'null' if no layout is need for 'graphModel'.
    // tags:
    //		protected
    
    return this.copy(this.getParentLayout(graphModel)); // ibm_ilog.graphlayout.GraphLayout
  },

  copy : function(layout)
  {
    // summary:
    //		Returns a copy of a layout instance. 
    // description:
    //		Returns a copy of a layout instance. 
    //		The method is called by <code>
    //		DefaultLayoutProvider.createGraphLayout()</code> to obtain a clone
    //		of the preferred layout of the closest parent graph. The method
    //		calls <code> ibm&#95;ilog.graphlayout.GraphLayout.copy()</code> to copy
    //		the layout instance. The method returns <code>null</code> if the
    //		argument <code>layout</code> is <code>null</code>.  
    //		<p>
    //		 
    //		</p>
    // layout: ibm_ilog.graphlayout.GraphLayout
    //		The preferred layout of the closest parent graph that has
    //		a specified preferred layout, or 'null'.
    // returns:
    //		A copy of the layout instance, or 'null'.
    // tags:
    //		protected
    
    return (layout != null ? layout.copy() : null); // ibm_ilog.graphlayout.GraphLayout
  },

  getParentLayout : function(graphModel)
  {
    // summary:
    //		Returns the preferred layout of the closest parent graph model of
    //		'graphModel', or 'null' if none.
    // tags:
    //		private
    
    var parentLayout = null;
    var parentGraphModel = graphModel.getParent();

    while (parentGraphModel != null)
    {
      parentLayout = this.getGraphLayout(parentGraphModel);
      if (parentLayout != null) {
        return parentLayout; // ibm_ilog.graphlayout.GraphLayout
      }
      parentGraphModel = parentGraphModel.getParent();
    }

    return parentLayout; // ibm_ilog.graphlayout.GraphLayout
  },

  initPropertiesNames : function()
  {
    // synchronized (...)
    
      ibm_ilog.graphlayout.DefaultLayoutProvider._uniqueIdCounter++;
      this._uniqueId = ibm_ilog.graphlayout.DefaultLayoutProvider._uniqueIdCounter;
    
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.DefaultLayoutProvider,
{
  _uniqueIdCounter : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.DefaultLayoutProvider;
    
    c._uniqueIdCounter = -1;
  }
  
}
);

(function(){ ibm_ilog.graphlayout.DefaultLayoutProvider._fields_init(); })();

return dojo.getObject("ibm_ilog.graphlayout.DefaultLayoutProvider");});
require(["ibm_ilog/graphlayout/DefaultLayoutProvider"]);

},
'ibm_ilog*graphlayout/MultipleLayout':function(){
define(["dojo","dijit","dojox","ibm_ilog/graphlayout/internalutil/TranslateUtil","ibm_ilog/graphlayout/GraphLayout"], function(dojo, dijit, dojox){
dojo.getObject("ibm_ilog.graphlayout.MultipleLayout", 1);
/* builder delete begin
dojo.provide('ibm_ilog.graphlayout.MultipleLayout');


 builder delete end */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.GraphLayout');


 builder delete end */
dojo.declare('ibm_ilog.graphlayout.MultipleLayout', ibm_ilog.graphlayout.GraphLayout, 
{
  // summary:
  //		The main class for the Multiple Layout algorithm. 
  // description:
  //		The main class for the Multiple Layout algorithm. 
  //		<p>
  //		This is not a layout algorithm but rather a facility to compose
  //		multiple layout algorithms and treat them as one algorithm object.
  //		This is more convenient if a sequence of layout algorithms must be
  //		applied to subgraphs. For instance, assume that you want to apply to
  //		each subgraph a Tree layout, then a Link layout for the nontree
  //		links. It would be unfortunate to call <code>
  //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code> multiple
  //		times to achieve this, because the tree layout of the parent graph
  //		would be finished before the link layout of its subgraph has started;
  //		hence the link layout of the subgraph invalidates the tree layout of
  //		the parent graph again.  To avoid this effect, the Tree layout, Link
  //		layout, and Label layout   of the subgraph should be finished before
  //		any layout of the parent graph has started. The following sample
  //		shows how to achieve this by using the Multiple Layout class:   
  //		</p>
  //		<pre>
  //		GraphLayout layout = new MultipleLayout(
  //		                              new TreeLayout(),
  //		                              new LinkLayout(),
  //		                              new AnnealingLabelLayout());
  //		layout.attach(grapher);
  //		layout.performLayout(true, true, true);
  //		</pre>
  //		If more than two graph layouts and one label layout are necessary,
  //		you can construct an <code>MultipleLayout</code> from another
  //		<code>MultipleLayout</code>, as follows:   
  //		<pre>
  //		GraphLayout layout = new MultipleLayout(
  //		                              new MultipleLayout(layout1, layout2, null),
  //		                              new MultipleLayout(layout3, layout4, null),
  //		                              labelLayout);
  //		</pre>
  //		The multiple layout offers only a few layout parameters that are
  //		global to all three sublayouts (such as the allowed time), but you
  //		can specify the other layout parameters individually for each
  //		sublayout by accessing <code>
  //		MultipleLayout.getFirstGraphLayout()</code>, <code>
  //		MultipleLayout.getSecondGraphLayout()</code> , and <code>
  //		MultipleLayout.getLabelLayout()</code> directly.   
  //		<p>
  //		If complex combinations of graph layouts and label layouts are needed
  //		in a nested graph, you should use the Recursive Multiple Layout (see
  //		<code> ibm&#95;ilog.graphlayout.RecursiveMultipleLayout</code>) that
  //		utilizes the Multiple Layout inside a Recursive Layout.   
  //		</p>
  
  _firstLayout: null,
  _secondLayout: null,

  _actLayout: null,

  _basePercentage: null,
  _numSubLayouts: null,

  _usePercentageCompletionSubstitute: null,
  _numStepsInSublayout: null,

  _firstGraphLayoutActive: null,
  _secondGraphLayoutActive: null,

  _firstGraphLayoutTemporarilyDisabled: null,
  _secondGraphLayoutTemporarilyDisabled: null,

  _silentAttach: null,

  DEFAULT_MULTIPLE_ALLOWED_TIME : null,

  constructor : function (a0, a1)
  {
    if(arguments.length == 2)
      this._constructor_overload_ibm_ilog_graphlayout_MultipleLayout_2(a0, a1);
    else if(arguments.length == 1)
      this._constructor_overload_ibm_ilog_graphlayout_MultipleLayout_1(a0);
  },
  
  _constructor_overload_ibm_ilog_graphlayout_MultipleLayout_2 : function(layout1 , layout2 )
  {
    this.DEFAULT_MULTIPLE_ALLOWED_TIME = 1000000000;
    this.setFirstGraphLayout(layout1 || null );
    this.setSecondGraphLayout(layout2 || null );
  },
  
  init : function()
  {
    // summary:
    //		Initializes instance variables. 
    // description:
    //		Initializes instance variables. 
    //		<p>
    //		You should not call this method directly. The method is called
    //		internally by the constructor without arguments and by the copy
    //		constructor. The method must be overridden by subclasses that need
    //		to initialize additional instance variables.
    //		</p>
    // tags:
    //		protected
    
    this.inherited("init", arguments, []);

    this._firstGraphLayoutPersistent = true;
    this._secondGraphLayoutPersistent = true;

    this._firstGraphLayoutActive = ibm_ilog.graphlayout.MultipleLayout._defaultLayoutActive;
    this._secondGraphLayoutActive = ibm_ilog.graphlayout.MultipleLayout._defaultLayoutActive;
    this._silentAttach = false;
    this.DEFAULT_MULTIPLE_ALLOWED_TIME = 100000000;
    this.setAllowedTime(this.DEFAULT_MULTIPLE_ALLOWED_TIME);
  },

  _constructor_overload_ibm_ilog_graphlayout_MultipleLayout_1 : function(source)
  {
    this.DEFAULT_MULTIPLE_ALLOWED_TIME = 1000000000;
  },
  
  copy : function()
  {
    // summary:
    //		Copies the layout instance. 
    // description:
    //		Copies the layout instance. 
    //		<p>
    //		This method copies the layout instance by calling the copy
    //		constructor.  
    //		</p>
    //		<p>
    //		When performing a recursive layout on a nested graph, this method is
    //		used by <code> ibm&#95;ilog.graphlayout.ILayoutProvider</code> to
    //		"clone" the layout instance of a parent graph. Note that the
    //		parameters which are specific to a node or a link are not copied.
    //		The persistence flags are copied. The sublayout instances and their
    //		global layout parameters are copied. The labeling model is not
    //		copied.  
    //		</p>
    // returns:
    //		A copy of the layout instance.
    
    return new ibm_ilog.graphlayout.MultipleLayout(this); // ibm_ilog.graphlayout.GraphLayout
  },

  copyParameters : function(source)
  {
    // summary:
    //		Copies the parameters from a given layout instance. 
    // description:
    //		Copies the parameters from a given layout instance. 
    //		<p>
    //		Note that the parameters which are specific to a node or a link are
    //		not copied. The activation and persistence flags are copied. The
    //		sublayout instances and their global layout parameters are copied.
    //		The labeling model is not copied.  
    //		</p>
    
    this.inherited("copyParameters", arguments, [source]);

    if (source instanceof ibm_ilog.graphlayout.MultipleLayout)
    {
      var msource = source;
      this._silentAttach = msource._silentAttach;

      var slayout = msource.getFirstGraphLayout();
      var tlayout = this.getFirstGraphLayout();
      var tmodel = null;

      if (slayout != tlayout)
      {
        if (slayout == null) {
          this.setFirstGraphLayout(null);
        }
        else
        {
          if (tlayout == null) {
            this.setFirstGraphLayout(slayout.copy());
          }
          else if (slayout.declaredClass == tlayout.declaredClass) {
            tlayout.copyParameters(slayout);
          }
          else
          {
            tmodel = tlayout.getGraphModel();
            this.setFirstGraphLayout(slayout.copy());

            if (tmodel != null)
            {
              this.getFirstGraphLayout().attach(tmodel);
              ibm_ilog.graphlayout.MultipleLayout.setMultipleLayoutProperty(this.getFirstGraphLayout(), this);
            }
          }
        }
      }

      slayout = msource.getSecondGraphLayout();
      tlayout = this.getSecondGraphLayout();

      if (slayout != tlayout)
      {
        if (slayout == null) {
          this.setSecondGraphLayout(null);
        }
        else
        {
          if (tlayout == null) {
            this.setSecondGraphLayout(slayout.copy());
          }
          else if (slayout.declaredClass == tlayout.declaredClass) {
            tlayout.copyParameters(slayout);
          }
          else
          {
            tmodel = tlayout.getGraphModel();
            this.setSecondGraphLayout(slayout.copy());

            if (tmodel != null)
            {
              this.getSecondGraphLayout().attach(tmodel);
              ibm_ilog.graphlayout.MultipleLayout.setMultipleLayoutProperty(this.getSecondGraphLayout(), this);
            }
          }
        }
      }

      this.setFirstGraphLayoutActive(msource.isFirstGraphLayoutActive());
      this.setSecondGraphLayoutActive(msource.isSecondGraphLayoutActive());
    }
  },

  setFirstGraphLayout : function(layout)
  {
    // summary:
    //		Sets the first layout to be applied. 
    // description:
    //		Sets the first layout to be applied. 
    //		You should set the layout before attaching the graph model.  
    // layout: ibm_ilog.graphlayout.GraphLayout
    //		The first layout.
    
    if (this._firstLayout != layout)
    {
      if (this._firstLayout != null)
      {
        ibm_ilog.graphlayout.MultipleLayout.setMultipleLayoutProperty(this._firstLayout, null);
        this._firstLayout.detach();
      }

      this._firstLayout = layout;
      this.onParameterChanged("FirstGraphLayout");
    }
  },

  getFirstGraphLayout : function()
  {
    // summary:
    //		Returns the layout that is applied first.
    
    return this._firstLayout; // ibm_ilog.graphlayout.GraphLayout
  },

  setFirstGraphLayoutActive : function(active)
  {
    // summary:
    //		Sets whether the first graph layout is active. 
    // description:
    //		Sets whether the first graph layout is active. 
    //		<p>
    //		This allows you to temporarily disable the first graph layout. The
    //		first graph layout is active by default. However, if you want to
    //		perform a layout using only the second graph layout or the label
    //		layout, you can set the first layout inactive. The first layout
    //		remains attached when inactive, but it is not performed when calling
    //		<code> ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code> on
    //		the Multiple layout instance.  
    //		</p>
    // active: Boolean
    //		'true' if the first graph layout is active, or
    //		'false' otherwise.
    
    if (this._firstGraphLayoutActive != active)
    {
      this._firstGraphLayoutActive = active;
      this.onParameterChanged("FirstGraphLayoutActive");
    }
  },

  isFirstGraphLayoutActive : function()
  {
    // summary:
    //		Returns whether the first graph layout is active.
    
    return this._firstGraphLayoutActive; // Boolean
  },

  setSecondGraphLayout : function(layout)
  {
    // summary:
    //		Sets the second layout to be applied. 
    // description:
    //		Sets the second layout to be applied. 
    //		You should set the layout before attaching the graph model.  
    // layout: ibm_ilog.graphlayout.GraphLayout
    //		The second graph layout.
    
    if (this._secondLayout != layout)
    {
      if (this._secondLayout != null)
      {
        ibm_ilog.graphlayout.MultipleLayout.setMultipleLayoutProperty(this._secondLayout, null);
        this._secondLayout.detach();
      }

      this._secondLayout = layout;
      this.onParameterChanged("SecondGraphLayout");
    }
  },

  getSecondGraphLayout : function()
  {
    // summary:
    //		Returns the layout that is applied second. 
    // description:
    //		Returns the layout that is applied second. 
    //		It returns <code>null</code> if no second layout is necessary.
    
    return this._secondLayout; // ibm_ilog.graphlayout.GraphLayout
  },

  setSecondGraphLayoutActive : function(active)
  {
    // summary:
    //		Sets whether the second graph layout is active. 
    // description:
    //		Sets whether the second graph layout is active. 
    //		<p>
    //		This allows you to temporarily disable the second graph layout. The
    //		second graph layout is active by default. However, if you want to
    //		perform a layout using only the first graph layout or the label
    //		layout, you can set the second layout inactive. The second layout
    //		remains attached when inactive, but it is not performed when calling
    //		<code> ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code> on
    //		the Multiple layout instance.  
    //		</p>
    // active: Boolean
    //		'true' if the second graph layout is active, or
    //		'false' otherwise.
    
    if (this._secondGraphLayoutActive != active)
    {
      this._secondGraphLayoutActive = active;
      this.onParameterChanged("SecondGraphLayoutActive");
    }
  },

  isSecondGraphLayoutActive : function()
  {
    // summary:
    //		Returns whether the second graph layout is active.
    
    return this._secondGraphLayoutActive; // Boolean
  },

  attach : function(graphModel)
  {
    // summary:
    //		Allows you to specify the graph model you want to lay out. 
    // description:
    //		Allows you to specify the graph model you want to lay out. 
    //		<p>
    //		In addition to the functionality in the base class, the Multiple
    //		Layout attaches its sublayouts.   
    //		</p>
    // graphModel: ibm_ilog.graphlayout.AbstractGraphLayoutModel
    //		The graph model.
    
    this.inherited("attach", arguments, [graphModel]);

    if (this._firstLayout != null)
    {
      this._firstLayout.attach(graphModel);
      ibm_ilog.graphlayout.MultipleLayout.setMultipleLayoutProperty(this._firstLayout, this);
    }

    if (this._secondLayout != null)
    {
      this._secondLayout.attach(graphModel);
      ibm_ilog.graphlayout.MultipleLayout.setMultipleLayoutProperty(this._secondLayout, this);
    }
  },

  detach : function()
  {
    // summary:
    //		Detaches the graph model from the layout instance. 
    // description:
    //		Detaches the graph model from the layout instance. 
    //		When you attach a new graph model to the layout instance, you do not
    //		need to detach the old graph model because this is done
    //		automatically when you call <code> MultipleLayout.attach()</code>.
    //		The <code>detach</code> method performs cleaning operations on the
    //		graph model. In addition to the cleaning operations in the base
    //		class, the Multiple Layout detaches its sublayouts.  
    //		<p>
    //		Note that you must call this method when you no longer need the
    //		layout instance. Otherwise, some objects may not be garbage
    //		collected.  If you explicitly set a labeling model, this labeling
    //		model will be disposed inside detach.   
    //		</p>
    
    if (this.getGraphModel() != null)
    {
      if (this._firstLayout != null)
      {
        ibm_ilog.graphlayout.MultipleLayout.setMultipleLayoutProperty(this._firstLayout, null);
        this._firstLayout.detach();
      }

      if (this._secondLayout != null)
      {
        ibm_ilog.graphlayout.MultipleLayout.setMultipleLayoutProperty(this._secondLayout, null);
        this._secondLayout.detach();
      }
    }

    this.inherited("detach", arguments, []);
  },

  setGraphModel : function(graphModel)
  {
    // summary:
    //		Sets the graph model to be laid out. 
    // description:
    //		Sets the graph model to be laid out. 
    //		You should not call this method. You should use the methods <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.attach()</code> or <code>
    //		MultipleLayout.attach()</code>.  
    // graphModel: ibm_ilog.graphlayout.AbstractGraphLayoutModel
    //		The graph model to be laid out.
    
    this.inherited("setGraphModel", arguments, [graphModel]);
    if (this._firstLayout != null) {
      this._firstLayout.setGraphModel(graphModel);
    }
    if (this._secondLayout != null) {
      this._secondLayout.setGraphModel(graphModel);
    }
  },

  mayContinue : function()
  {
    return (!this.isLayoutTimeElapsed() && !this.isStoppedImmediately()); // Boolean
  },

  setAllowedTime : function(time)
  {
    // summary:
    //		Sets the upper limit for the duration of the layout algorithm. 
    // description:
    //		Sets the upper limit for the duration of the layout algorithm. 
    //		<p>
    //		The default value for Multiple layout is <code>1000000000</code>
    //		(1000000 seconds). The allowed time is additionally limited by the
    //		allowed time parameter on the sublayouts.  
    //		</p>
    // time: Number
    //		The allowed time in milliseconds.
    
    this.inherited("setAllowedTime", arguments, [time]);
  },

  getAllowedTime : function()
  {
    // summary:
    //		Returns the currently allowed time for the layout algorithm in
    //		milliseconds. 
    // description:
    //		Returns the currently allowed time for the layout algorithm in
    //		milliseconds. 
    //		The allowed time is additionally limited by the allowed time
    //		parameter on the sublayouts. The effective allowed time is the
    //		minimum of the sum of allowed times for for the sublayouts and the
    //		value returned as allowed time for this Multiple layout.  
    //		<p>
    //		Note that the method <code>performLayout</code> does not
    //		automatically stop the layout when the allowed time is exceeded. It
    //		only delegates  the stop to the sublayouts, and it is entirely the
    //		responsibility of the implementation of the method <code>
    //		MultipleLayout.layout()</code> on the sublayouts to do this.  
    //		</p>
    
    return (false ? this.DEFAULT_MULTIPLE_ALLOWED_TIME : this.inherited("getAllowedTime", arguments, [])); // Number
  },

  setMinBusyTime : function(time)
  {
    // summary:
    //		Sets the minimal time the layout algorithm can be busy between two
    //		calls of '
    //		ibm_ilog.graphlayout.GraphLayout.onLayoutStepPerformed()' when
    //		the method '
    //		ibm_ilog.graphlayout.GraphLayout.callLayoutStepPerformedIfNeeded()'
    //		is used. 
    // description:
    //		Sets the minimal time the layout algorithm can be busy between two
    //		calls of <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.onLayoutStepPerformed()</code> when
    //		the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.callLayoutStepPerformedIfNeeded()</code>
    //		is used. 
    //		<p>
    //		The default value is <code>50</code> (milliseconds). 
    //		</p>
    
    this.inherited("setMinBusyTime", arguments, [time]);
    if (this._firstLayout != null) {
      this._firstLayout.setMinBusyTime(time);
    }
    if (this._secondLayout != null) {
      this._secondLayout.setMinBusyTime(time);
    }
  },

  setLayoutRunning : function(running, fromParents)
  {
    // summary:
    //		Sets whether layout is running. 
    // description:
    //		Sets whether layout is running. 
    //		This method is part of IBM ILOG Dojo Diagrammer internals. You
    //		should not use it.  
    // running: Boolean
    //		Whether layout is running or not.
    // fromParents: Boolean
    //		Whether this notification is from a parent layout or
    //		from this layout instance.
    
    this.inherited("setLayoutRunning", arguments, [running, fromParents]);
    if (this._firstLayout != null) {
      this._firstLayout.setLayoutRunning(running, true);
    }
    if (this._secondLayout != null) {
      this._secondLayout.setLayoutRunning(running, true);
    }
  },

  setInputCheckEnabled : function(enable)
  {
    // summary:
    //		Sets whether the checks for the nodes, links, and/or labels provided
    //		as arguments for the different methods of this layout algorithm and
    //		its sublayout algorithms are enabled. 
    // description:
    //		Sets whether the checks for the nodes, links, and/or labels provided
    //		as arguments for the different methods of this layout algorithm and
    //		its sublayout algorithms are enabled. 
    //		<p>
    //		It is enabled by default. 
    //		</p>
    
    this.inherited("setInputCheckEnabled", arguments, [enable]);
    if (this._firstLayout != null) {
      this._firstLayout.setInputCheckEnabled(enable);
    }
    if (this._secondLayout != null) {
      this._secondLayout.setInputCheckEnabled(enable);
    }
  },

  stopImmediately : function()
  {
    // summary:
    //		Stops the running layout algorithm as soon as possible. 
    // description:
    //		Stops the running layout algorithm as soon as possible. 
    //		<p>
    //		This method can be used if multiple threads are used for layout and
    //		GUI control. The GUI control thread calls this method to notify the
    //		layout thread that the layout run must be stopped. The layout
    //		algorithm will perform some final cleanup operations before
    //		terminating. Therefore, the layout thread will continue until the
    //		cleanup operations are finished. The GUI thread, however, returns
    //		immediately from this method.  
    //		</p>
    //		<p>
    //		If the layout algorithm is stopped before completion, the result
    //		code of the layout report is <code>
    //		ibm&#95;ilog.graphlayout.GraphLayoutReport.STOPPED&#95;AND&#95;INVALID</code>.  
    //		</p>
    // returns:
    //		'true' if the algorithm can be stopped at this time.
    
    var result = this.inherited("stopImmediately", arguments, []);
    if (this._firstLayout != null && this._firstLayout.isLayoutRunning()) {
      result = this._firstLayout.stopImmediately() && result;
    }
    if (this._secondLayout != null && this._secondLayout.isLayoutRunning()) {
      result = this._secondLayout.stopImmediately() && result;
    }
    return (result); // Boolean
  },

  setParametersUpToDate : function(uptodate)
  {
    // summary:
    //		Sets whether the parameters of the layout are up to date. 
    // description:
    //		Sets whether the parameters of the layout are up to date. 
    //		<p>
    //		Automatically called with a <code>false</code> argument each time
    //		the value of a parameter is changed.  
    //		</p>
    //		<p>
    //		This method is automatically called with a <code>true</code>
    //		argument each time the layout is successfully performed. In this
    //		case, it calls <code>setParametersUpToDate</code>  with a
    //		<code>true</code> argument for the sublayouts as well.  
    //		</p>
    
    if (uptodate)
    {
      if (this._firstLayout != null) {
        this._firstLayout.setParametersUpToDate(true);
      }
      if (this._secondLayout != null) {
        this._secondLayout.setParametersUpToDate(true);
      }
    }

    this.inherited("setParametersUpToDate", arguments, [uptodate]);
  },

  isParametersUpToDate : function()
  {
    // summary:
    //		Returns 'false' if at least one parameter was modified
    //		since the last time the layout was successfully performed on the
    //		same graph or if the layout has never been performed successfully on
    //		the same graph. 
    // description:
    //		Returns <code>false</code> if at least one parameter was modified
    //		since the last time the layout was successfully performed on the
    //		same graph or if the layout has never been performed successfully on
    //		the same graph. 
    //		Returns <code>true</code> if no changes occurred.  
    //		<p>
    //		The method returns <code>false</code> if the parameters of one of
    //		the sublayouts is out-of-date.  
    //		</p>
    
    if (this._firstLayout != null && !this._firstLayout.isParametersUpToDate()) {
      return false; // Boolean
    }
    if (this._secondLayout != null && !this._secondLayout.isParametersUpToDate()) {
      return false; // Boolean
    }
    return this.inherited("isParametersUpToDate", arguments, []); // Boolean
  },

  setStructureUpToDate : function(uptodate)
  {
    // summary:
    //		Sets whether the structure of the graph is up to date. 
    // description:
    //		Sets whether the structure of the graph is up to date. 
    //		<p>
    //		Normally called with a <code>false</code> argument if the structure
    //		of the graph changed.  
    //		</p>
    //		<p>
    //		It is automatically called with a <code>true</code> argument each
    //		time the layout is successfully performed. In this case, it calls
    //		<code>setStructureUpToDate</code>  with a <code>true</code> argument
    //		for the sublayouts as well.  
    //		</p>
    
    if (uptodate)
    {
      if (this._firstLayout != null) {
        this._firstLayout.setStructureUpToDate(true);
      }
      if (this._secondLayout != null) {
        this._secondLayout.setStructureUpToDate(true);
      }
    }

    this.inherited("setStructureUpToDate", arguments, [uptodate]);
  },

  isStructureUpToDate : function()
  {
    // summary:
    //		Returns 'false' if at least one modification occurred in
    //		the structure of the graph since the last time the layout was
    //		successfully performed on the same graph or if the layout has never
    //		been performed successfully on the same graph. 
    // description:
    //		Returns <code>false</code> if at least one modification occurred in
    //		the structure of the graph since the last time the layout was
    //		successfully performed on the same graph or if the layout has never
    //		been performed successfully on the same graph. 
    //		Returns <code>true</code> if no changes occurred.  
    //		<p>
    //		The method returns <code>false</code> if the structure of one of the
    //		sublayouts is out-of-date.  
    //		</p>
    
    if (this._firstLayout != null && !this._firstLayout.isStructureUpToDate()) {
      return false; // Boolean
    }
    if (this._secondLayout != null && !this._secondLayout.isStructureUpToDate()) {
      return false; // Boolean
    }
    return this.inherited("isStructureUpToDate", arguments, []); // Boolean
  },

  setGeometryUpToDate : function(uptodate)
  {
    // summary:
    //		Sets whether the geometry of the graph is up to date. 
    // description:
    //		Sets whether the geometry of the graph is up to date. 
    //		<p>
    //		Normally called with a <code>false</code> argument if the geometry
    //		of the graph changed.  
    //		</p>
    //		<p>
    //		This method is automatically called with a <code>true</code>
    //		argument each time the layout is successfully performed. In this
    //		case, it calls <code>setGeometryUpToDate</code>  with a
    //		<code>true</code> argument for the sublayouts as well.  
    //		</p>
    
    if (uptodate)
    {
      if (this._firstLayout != null) {
        this._firstLayout.setGeometryUpToDate(true);
      }
      if (this._secondLayout != null) {
        this._secondLayout.setGeometryUpToDate(true);
      }
    }

    this.inherited("setGeometryUpToDate", arguments, [uptodate]);
  },

  isGeometryUpToDate : function()
  {
    // summary:
    //		Returns 'false' if at least one node, link, label, or
    //		obstacle was moved or reshaped since the last time the layout was
    //		successfully performed on the same graph or if the layout has never
    //		been performed successfully on the same graph. 
    // description:
    //		Returns <code>false</code> if at least one node, link, label, or
    //		obstacle was moved or reshaped since the last time the layout was
    //		successfully performed on the same graph or if the layout has never
    //		been performed successfully on the same graph. 
    //		Returns <code>true</code> if no changes occurred.  
    //		<p>
    //		The method returns <code>false</code> if the geometry of one of the
    //		sublayouts is out-of-date.  
    //		</p>
    
    if (this._firstLayout != null && !this._firstLayout.isGeometryUpToDate()) {
      return false; // Boolean
    }
    if (this._secondLayout != null && !this._secondLayout.isGeometryUpToDate()) {
      return false; // Boolean
    }
    return this.inherited("isGeometryUpToDate", arguments, []); // Boolean
  },

  supportsPercentageComplete : function()
  {
    // summary:
    //		Indicates whether the layout class can estimate the percentage of
    //		completion during the run of the layout. 
    // description:
    //		Indicates whether the layout class can estimate the percentage of
    //		completion during the run of the layout. 
    //		If the sublayouts support this feature, the percentage value is
    //		calculated from the sublayouts. If the sublayouts do not support
    //		this feature, the Multiple Layout algorithm can indicate by discrete
    //		percentage values (typically 33% and 66% and 100%) whether   the
    //		first graph layout, the second graph layout, or the label layout are
    //		already finished.   
    //		<p>
    //		The calculated percentage values are not very precise.  
    //		</p>
    
    return true; // Boolean
  },

  supportsStopImmediately : function()
  {
    // summary:
    //		Indicates whether the layout class can immediately interrupt the
    //		current run of the layout in a controlled way. 
    // description:
    //		Indicates whether the layout class can immediately interrupt the
    //		current run of the layout in a controlled way. 
    //		<p>
    //		If the first graph layout, the second graph layout, and the label
    //		layout support this feature, then it returns <code>true</code>.    
    //		</p>
    // returns:
    //		'true' if the first graph layout , the second graph
    //		layout, and the label layout support this feature.
    
    if (this._firstLayout != null && !this._firstLayout.supportsStopImmediately()) {
      return false; // Boolean
    }
    if (this._secondLayout != null && !this._secondLayout.supportsStopImmediately()) {
      return false; // Boolean
    }
    return true; // Boolean
  },

  supportsAllowedTime : function()
  {
    // summary:
    //		Indicates whether the layout class can stop the layout computation
    //		when a user-defined allowed time is exceeded. 
    // description:
    //		Indicates whether the layout class can stop the layout computation
    //		when a user-defined allowed time is exceeded. 
    //		<p>
    //		If the first graph layout, the second graph layout, and the label
    //		layout support this feature, then it returns <code>true</code>.    
    //		</p>
    // returns:
    //		'true' if the first graph layout , the second graph
    //		layout and the label layout support this feature.
    
    if (this._firstLayout != null && !this._firstLayout.supportsAllowedTime()) {
      return false; // Boolean
    }
    if (this._secondLayout != null && !this._secondLayout.supportsAllowedTime()) {
      return false; // Boolean
    }
    return true; // Boolean
  },

  supportsLayoutOfConnectedComponents : function()
  {
    // summary:
    //		Indicates whether the layout class can cut the attached graph into
    //		connected components, apply itself on each connected component
    //		separately, and then use the layout instance returned by the method
    //		'
    //		ibm_ilog.graphlayout.GraphLayout.getLayoutOfConnectedComponents()'
    //		to position the connected components. 
    // description:
    //		Indicates whether the layout class can cut the attached graph into
    //		connected components, apply itself on each connected component
    //		separately, and then use the layout instance returned by the method
    //		<code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.getLayoutOfConnectedComponents()</code>
    //		to position the connected components. 
    //		<p>
    //		If the first graph layout and the second graph layout support this
    //		feature, then it returns <code>true</code>.  
    //		</p>
    // returns:
    //		'true' if the first graph layout and the second graph
    //		layout support this feature.
    
    if (this._firstLayout != null && !this._firstLayout.supportsLayoutOfConnectedComponents()) {
      return false; // Boolean
    }
    if (this._secondLayout != null && !this._secondLayout.supportsLayoutOfConnectedComponents()) {
      return false; // Boolean
    }
    if (this._firstLayout == null && this._secondLayout == null) {
      return false; // Boolean
    }
    return true; // Boolean
  },

  onSubGraphLayoutStepPerformed : function(layout) {
  // summary
  //   This method is called by the first graph layout and the second
  //   graph layout.
  //   It forwards the layout event to this Multiple layout.
  // event
  //   The event that has been generated by the first
  //   graph layout or the second graph layout.
    this.updateLayoutStepData(layout);
    this.onLayoutStepPerformed(false, false);
  },
  
  updateLayoutStepData : function(event)
  {
    this._numStepsInSublayout++;
    var percentageInSublayout;
    if (this._usePercentageCompletionSubstitute) {
      percentageInSublayout = Math.floor(100 / 99 * this._numStepsInSublayout / (1 + Math.floor(this._numStepsInSublayout / 99)));
    }
    else {
      percentageInSublayout = event.getLayoutReport().getPercentageComplete();
    }
    this.increasePercentageComplete(Math.floor((this._basePercentage + percentageInSublayout / this._numSubLayouts)));
    var report = this.getLayoutReport();

    if (report != null)
    {
      if (this._actLayout == 0) {
        report._firstLayoutReport = event.getLayoutReport();
      }
      else if (this._actLayout == 1) {
        report._secondLayoutReport = event.getLayoutReport();
      }
    }
  },

  setSilentAttach : function(flag)
  {
    // summary:
    //		This method is used internally. 
    // description:
    //		This method is used internally. 
    //		You should not call this method.
    
    this._silentAttach = flag;
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.MultipleLayout,
{
  MULTIPLE_LAYOUT_PROP : null,

  _defaultLayoutActive : null,

  setMultipleLayoutProperty : function(layout, mlayout)
  {
    var prop = ibm_ilog.graphlayout.MultipleLayout.MULTIPLE_LAYOUT_PROP + layout.getInstanceId();
    if (layout.getGraphModel() != null) {
      layout.getGraphModel().setParameter(prop, mlayout);
    }
  },

  getMultipleLayout : function(layout)
  {
    var prop = ibm_ilog.graphlayout.MultipleLayout.MULTIPLE_LAYOUT_PROP + layout.getInstanceId();
    if (layout.getGraphModel() == null) {
      return null; // ibm_ilog.graphlayout.MultipleLayout
    }
    return layout.getGraphModel().getParameter(prop); // ibm_ilog.graphlayout.MultipleLayout
  },

  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.MultipleLayout;
    if(ibm_ilog.graphlayout.GraphLayout._fields_init)
      ibm_ilog.graphlayout.GraphLayout._fields_init(c);
    
    c.MULTIPLE_LAYOUT_PROP = "__IlvMultipleLayoutProp";
    c._defaultLayoutActive = true;
  }
  
}
);

ibm_ilog.graphlayout.MultipleLayout._getGlobalProperties = function()
{
  // tags:
  //		private
  return ibm_ilog.graphlayout.GraphLayout._getGlobalProperties();
};

ibm_ilog.graphlayout.MultipleLayout._getNodeProperties = function()
{
  // tags:
  //		private
  return ibm_ilog.graphlayout.GraphLayout._getNodeProperties();
};

ibm_ilog.graphlayout.MultipleLayout._getLinkProperties = function()
{
  // tags:
  //		private
  return ibm_ilog.graphlayout.GraphLayout._getLinkProperties();
};

(function(){ ibm_ilog.graphlayout.MultipleLayout._fields_init(); })();

return dojo.getObject("ibm_ilog.graphlayout.MultipleLayout");});
require(["ibm_ilog/graphlayout/MultipleLayout"]);

},
'ibm_ilog*graphlayout/internalutil/ReshapeModes':function(){
define(["dojo","dijit","dojox","ibm_ilog/graphlayout/internalutil/TranslateUtil","ibm_ilog/graphlayout/internalutil/ConnectionPointModes"], function(dojo, dijit, dojox){
dojo.getObject("ibm_ilog.graphlayout.internalutil.ReshapeModes", 1);
/* builder delete begin
dojo.provide('ibm_ilog.graphlayout.internalutil.ReshapeModes');


 builder delete end */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.ConnectionPointModes');


 builder delete end */
dojo.declare('ibm_ilog.graphlayout.internalutil.ReshapeModes', ibm_ilog.graphlayout.internalutil.ConnectionPointModes, 
{
  // summary:
  //		This class contains all enumeration constants used for reshape modes.
  //		
  // description:
  //		This class contains all enumeration constants used for reshape modes.
  //		
  //		This ensures that ALL reshape modes of ALL layout algorithms share
  //		the same values.   
  //		<p>
  //		It also contains some generic support for the reshape modes.   
  //		</p>
  // tags:
  //		private
  
  constructor : function()
  {
    
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.internalutil.ReshapeModes,
{
  FIXED_SHAPE_TYPE_MODE : null,
  FIXED_NODE_SIDES_MODE : null,
  FIXED_CONNECTION_POINTS_MODE : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.internalutil.ReshapeModes;
    if(ibm_ilog.graphlayout.internalutil.ConnectionPointModes._fields_init)
      ibm_ilog.graphlayout.internalutil.ConnectionPointModes._fields_init(c);
    
    c.FIXED_SHAPE_TYPE_MODE = 4;
    c.FIXED_NODE_SIDES_MODE = 5;
    c.FIXED_CONNECTION_POINTS_MODE = 6;
  }
  
}
);

(function(){ ibm_ilog.graphlayout.internalutil.ReshapeModes._fields_init(); })();

return dojo.getObject("ibm_ilog.graphlayout.internalutil.ReshapeModes");});
require(["ibm_ilog/graphlayout/internalutil/ReshapeModes"]);

},
'ibm_ilog*graphlayout/grid/GridLayout':function(){
define(["dojo","dijit","dojox","ibm_ilog/graphlayout/internalutil/TranslateUtil","ibm_ilog/graphlayout/internalutil/rowcolumngrid/LayoutModes","ibm_ilog/graphlayout/internalutil/rowcolumngrid/OrderingModes","ibm_ilog/graphlayout/internalutil/AlignmentOptions","ibm_ilog/graphlayout/internalutil/LayoutParametersUtil","ibm_ilog/graphlayout/internalutil/LogResUtil","ibm_ilog/graphlayout/internalutil/Rectangle","ibm_ilog/graphlayout/GraphLayout"], function(dojo, dijit, dojox){
dojo.getObject("ibm_ilog.graphlayout.grid.GridLayout", 1);
/* builder delete begin
dojo.provide('ibm_ilog.graphlayout.grid.GridLayout');


 builder delete end */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.rowcolumngrid.LayoutModes');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.rowcolumngrid.OrderingModes');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.AlignmentOptions');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.LayoutParametersUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.LogResUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.Rectangle');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.GraphLayout');


 builder delete end */
dojo.declare('ibm_ilog.graphlayout.grid.GridLayout', ibm_ilog.graphlayout.GraphLayout, 
{
  // summary:
  //		The main class for the Grid Layout algorithm. 
  // description:
  //		The main class for the Grid Layout algorithm. 
  //		<p>
  //		The Grid Layout algorithm has two major modes: <b>grid</b> and
  //		<b>row/column</b>. (For details, see the method <code>
  //		GridLayout.setLayoutMode()</code>.) In <b>grid</b> mode, the layout
  //		arranges the nodes of a graph in the cells of a grid (matrix). If a
  //		node is too large to fit into one grid cell (with a margin), it
  //		occupies multiple cells. The size of the grid cells can be specified
  //		using the methods  <code> GridLayout.setHorizontalGridOffset()</code>
  //		and <code> GridLayout.setVerticalGridOffset()</code>. The margins can
  //		be specified using the methods <code>
  //		GridLayout.setTopMargin()</code>, <code>
  //		GridLayout.setBottomMargin()</code>, <code>
  //		GridLayout.setLeftMargin()</code>, and <code>
  //		GridLayout.setRightMargin()</code>.  
  //		</p>
  //		<p>
  //		The following sample drawing shows a layout in the grid mode where
  //		the grid size has been specified so that each node fits into one grid
  //		cell. (Usually such layouts are more esthetic and appear to be more
  //		regular, but a larger area is left empty around the smallest nodes.
  //		This is generally the best option when all the nodes have the same
  //		size.)  
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Grid-Small-Center-Center-MaxNodeSize.gif" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		The following sample drawing shows a layout in the grid mode where
  //		the grid size has been specified so that some nodes fit into one grid
  //		cell and other nodes occupy multiple cells. (Usually such layouts
  //		take less space if the nodes have a heterogeneous size.)  
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Grid-Small-Center-Center-MeanNodeSize.gif" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		The following diagram shows the dimensional parameters of the layout
  //		in grid mode.  
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Grid-DimensionalParamsWithoutNodeBox.gif" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		In <b>row/column</b> mode, the layout arranges the nodes of a graph
  //		either by rows or by columns (according to the specified option). The
  //		width of the rows is controlled by the width of the layout region
  //		parameter. The height of the columns is controlled by the height of
  //		the layout region parameter. The margins can be specified using the
  //		methods <code> GridLayout.setTopMargin()</code>, <code>
  //		GridLayout.setBottomMargin()</code>, <code>
  //		GridLayout.setLeftMargin()</code>, and <code>
  //		GridLayout.setRightMargin()</code>. The minimum horizontal distance
  //		between nodes is equal to the sum of the left and right margins. The
  //		minimum vertical distance between nodes is equal to the sum of the
  //		top and bottom margins.  
  //		</p>
  //		<p>
  //		For graphs with nodes of heterogeneous size, the row/column mode
  //		often allows a more compact layout than the grid mode.  
  //		</p>
  //		<p>
  //		The following sample drawing shows a layout in the row mode.  
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-row-center.gif" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		The following sample drawing shows a layout in the column mode.  
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-column-center.gif" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		The following diagram shows the dimensional parameters of the layout
  //		in row mode (the parameters for the column mode are analogous).  
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Rows-DimensionalParams.gif" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		The algorithm is primarily designed for graphs without (visible)
  //		links between the nodes. If links exist, they are ignored by the Grid
  //		layout.  
  //		</p>
  //		<p>
  //		Several alignment options are provided (see <code>
  //		GridLayout.setGlobalHorizontalAlignment()</code> and <code>
  //		GridLayout.setGlobalVerticalAlignment()</code>). The alignment can be
  //		specified individually for each node (see <code>
  //		GridLayout.setHorizontalAlignment()</code> and <code>
  //		GridLayout.setVerticalAlignment()</code>).  
  //		</p>
  //		<p>
  //		An incremental mode is provided (see <code>
  //		GridLayout.setIncrementalMode()</code>). If the incremental mode is
  //		enabled, the stability of the layout is preserved as much as possible
  //		when new nodes are added, existing ones removed, or node sizes
  //		modified. This means that the nodes are placed at the same location,
  //		or in the same order, as in the previous layout whenever possible. In
  //		this mode, the layout algorithm processes the changes incrementally
  //		rather than redoing the entire layout for every change.  
  //		</p>
  //		<p>
  //		Nodes that the layout algorithm is not allowed to move can be
  //		specified using the method <code>
  //		ibm&#95;ilog.graphlayout.GraphLayout.setFixed()</code>. (See also <code>
  //		ibm&#95;ilog.graphlayout.GraphLayout.setPreserveFixedNodes()</code>.) In
  //		grid mode, nonfixed nodes are placed in such a way that they do not
  //		overlap the grid cells occupied by other fixed or nonfixed nodes. In
  //		row/column mode, nonfixed nodes are placed in such a way that they do
  //		not overlap fixed or nonfixed nodes. Of course, fixed nodes can
  //		overlap other fixed nodes.  
  //		</p>
  //		<p>
  //		The layout algorithm can take into account a different node size than
  //		the size corresponding to the bounding box of the node. Using <code>
  //		GridLayout.setNodeBoxInterface()</code>, you can specify an object
  //		that provides the box that has to be taken into account for each
  //		node. The following diagram shows the dimensional parameters of the
  //		layout in grid mode (the row/column case mode is analogous) when a
  //		node box that is different from the bounding box of the node is used:
  //		 
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Grid-DimensionalParamsWithNodeBox.gif" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		 
  //		</p>
  /*=====
  // CENTER: int
  //		Center alignment option. 
  //		When used as the argument of the method  '
  //		GridLayout.setGlobalHorizontalAlignment()', all the nodes are
  //		horizontally centered in their grid cell or column. The alignment of
  //		an individual node can be set by '
  //		GridLayout.setHorizontalAlignment()'.  
  //		
  //		When used as the argument of the method  '
  //		GridLayout.setGlobalVerticalAlignment()', all the nodes are
  //		vertically centered in their grid cell or row. The alignment of an
  //		individual node can be set by '
  //		GridLayout.setVerticalAlignment()'.  
  //		
  CENTER : null,
  // LEFT: int
  //		Left alignment option. 
  //		When used as the argument of the method  '
  //		GridLayout.setGlobalHorizontalAlignment()', all the nodes are
  //		aligned to the left border of their grid cell or column. The
  //		alignment of an individual node can be set by '
  //		GridLayout.setHorizontalAlignment()'.
  LEFT : null,
  // RIGHT: int
  //		Right alignment option. 
  //		When used as the argument of the method  '
  //		GridLayout.setGlobalHorizontalAlignment()', all the nodes are
  //		aligned to the right border of their grid cell or column. The
  //		alignment of an individual node can be set by '
  //		GridLayout.setHorizontalAlignment()'.
  RIGHT : null,
  // TOP: int
  //		Top alignment option. 
  //		When used as the argument of the method  '
  //		GridLayout.setGlobalVerticalAlignment()', all the nodes are
  //		aligned to the top border of their grid cell or row. The alignment of
  //		an individual node can be set by '
  //		GridLayout.setVerticalAlignment()'.
  TOP : null,
  // BOTTOM: int
  //		Bottom alignment option. 
  //		When used as the argument of the method  '
  //		GridLayout.setGlobalVerticalAlignment()', all the nodes are
  //		aligned to the bottom border of their grid cell or row. The alignment
  //		of an individual node can be set by '
  //		GridLayout.setVerticalAlignment()'.
  BOTTOM : null,
  // MIXED: int
  //		Mixed alignment option. 
  //		When used as the argument of the methods  '
  //		GridLayout.setGlobalHorizontalAlignment()' or '
  //		GridLayout.setGlobalVerticalAlignment()', each node can have a
  //		different alignment. The alignment of an individual node can be set
  //		by ' GridLayout.setHorizontalAlignment()' and '
  //		GridLayout.setVerticalAlignment()'.
  MIXED : null,
  // TILE_TO_ROWS: int
  //		Tile-to-rows layout mode. 
  //		When used as the argument of the method  '
  //		GridLayout.setLayoutMode()', all the nodes are organized in
  //		rows and are vertically aligned with respect to the row border
  //		according to the vertical alignment option. In this mode, the grid
  //		offset parameters are not used and the height of the layout region 
  //		controls the maximum total height of the layout.
  TILE_TO_ROWS : null,
  // TILE_TO_COLUMNS: int
  //		Tile-to-columns layout mode. 
  //		When used as the argument of the method  '
  //		GridLayout.setLayoutMode()', all the nodes are organized in
  //		columns and are horizontally aligned with respect to the row border
  //		according to the horizontal alignment option. In this mode, the grid
  //		offset parameters are not used and the width of the layout region 
  //		controls the maximum total width of the layout.
  TILE_TO_COLUMNS : null,
  // TILE_TO_GRID_FIXED_WIDTH: int
  //		Tile-to-grid layout mode with fixed width of the grid. 
  //		When used as the argument of the method  '
  //		GridLayout.setLayoutMode()', the nodes are placed in the cells
  //		of a grid and the width of the layout region  controls the maximum
  //		width of the grid.
  TILE_TO_GRID_FIXED_WIDTH : null,
  // TILE_TO_GRID_FIXED_HEIGHT: int
  //		Tile-to-grid layout mode with fixed height of the grid. 
  //		When used as the argument of the method  '
  //		GridLayout.setLayoutMode()', the nodes are placed in the cells
  //		of a grid and the height of the layout region  controls the maximum
  //		height of the grid.
  TILE_TO_GRID_FIXED_HEIGHT : null,
  // AUTOMATIC_ORDERING: int
  //		Automatic ordering option. 
  //		When this value is used as the argument of the method  '
  //		GridLayout.setNodeComparator()', the algorithm is free to
  //		choose an order aimed at reducing the total area occupied by the
  //		layout.
  AUTOMATIC_ORDERING : null,
  // NO_ORDERING: int
  //		No ordering option. 
  //		When his value is used as the argument of the method  '
  //		GridLayout.setNodeComparator()', the nodes are arranged in an
  //		arbitrary order.
  NO_ORDERING : null,
  // DESCENDING_HEIGHT: int
  //		Ordering by height option. 
  //		When this value is used as the argument of the method  '
  //		GridLayout.setNodeComparator()', the nodes are arranged by
  //		height, starting at the upper-left corner with the tallest node.
  //		Ordering the nodes by height can save vertical space and produce a
  //		more compact layout.
  DESCENDING_HEIGHT : null,
  // ASCENDING_HEIGHT: int
  //		Ordering by ascending height option. 
  //		When this value is used as the argument of the method  '
  //		GridLayout.setNodeComparator()', the nodes are arranged by
  //		ascending height, starting at the upper-left corner with the shortest
  //		node. Ordering the nodes by ascending height can save vertical space
  //		and produce a more compact layout.
  ASCENDING_HEIGHT : null,
  // ASCENDING_WIDTH: int
  //		Ordering by ascending width option. 
  //		When this value is used as the argument of the method  '
  //		GridLayout.setNodeComparator()', the nodes are arranged by
  //		ascending width, starting at the upper-left corner with the narrowest
  //		node.
  ASCENDING_WIDTH : null,
  // DESCENDING_WIDTH: int
  //		Ordering by descending width option. 
  //		When this value is used as the argument of the method  '
  //		GridLayout.setNodeComparator()', the nodes are arranged by
  //		width, starting at the upper-left corner with the widest node.
  DESCENDING_WIDTH : null,
  // ASCENDING_AREA: int
  //		Ordering by ascending area option. 
  //		When this value is used as the argument of the method  '
  //		GridLayout.setNodeComparator()', the nodes are arranged by
  //		ascending area, starting at the upper-left corner with the node that
  //		has the smallest area.
  ASCENDING_AREA : null,
  // DESCENDING_AREA: int
  //		Ordering by descending area option. 
  //		When this value is used as the argument of the method  '
  //		GridLayout.setNodeComparator()', the nodes are arranged by
  //		area, starting at the upper-left corner with the node that has the
  //		largest area.
  DESCENDING_AREA : null,
  // ASCENDING_INDEX: int
  //		Ordering by ascending index option. 
  //		When this value is used as the argument of the method  '
  //		GridLayout.setNodeComparator()', the nodes are arranged in the
  //		order of their indexes, starting at the upper-left corner with the
  //		node that has the smallest index. Nodes that do not have an index are
  //		placed after nodes for which an index is specified. Ordering by index
  //		allows you to specify a particular order for the nodes.
  ASCENDING_INDEX : null,
  // DESCENDING_INDEX: int
  //		Ordering by descending index option. 
  //		When this value is used as the argument of the method  '
  //		GridLayout.setNodeComparator()', the nodes are arranged in the
  //		order of their indexes, starting at the upper-left corner with the
  //		node that has the largest index. Nodes that do not have an index are
  //		placed after nodes for which an index is specified. Ordering by index
  //		allows you to specify a particular order for the nodes.
  DESCENDING_INDEX : null,
  // NO_INDEX: int
  //		No index code. 
  //		This value is returned by the method '
  //		GridLayout.getIndex()' when a node has no index value.
  NO_INDEX : null,
  =====*/
  
  _globalHorizontalAlignment: null,

  _globalVerticalAlignment: null,

  _layoutMode: null,

  _incrementalMode: null,

  _horizontalGridOffset: null,

  _verticalGridOffset: null,

  _topMargin: null,

  _bottomMargin: null,

  _leftMargin: null,

  _rightMargin: null,

  _comparator: null,

  _maxNumberOfNodesPerRowOrColumn: null,

  _nodeBoxInterface: null,

  _preliminaryStopped: null,

  _criticalParamMatrixUpToDate: null,

  _criticalParamRowColumnUpToDate: null,

  _previousLayoutRegion: null,

  constructor : function(source )
  {
  },
  
  init : function()
  {
    // summary:
    //		Initializes instance variables. 
    // description:
    //		Initializes instance variables. 
    //		<p>
    //		You should not call this method directly. The method is called
    //		internally by the constructor without arguments and by the copy
    //		constructor. The method must be overridden by subclasses that need
    //		to initialize additional instance variables.
    //		</p>
    // tags:
    //		protected
    
    this.inherited("init", arguments, []);
    this._comparator = ibm_ilog.graphlayout.grid.GridLayout._defaultComparator;
    this._globalHorizontalAlignment = ibm_ilog.graphlayout.grid.GridLayout._defaultHorizontalAlignment;
    this._globalVerticalAlignment = ibm_ilog.graphlayout.grid.GridLayout._defaultVerticalAlignment;
    this._layoutMode = ibm_ilog.graphlayout.grid.GridLayout._defaultLayoutMode;
    this._incrementalMode = ibm_ilog.graphlayout.grid.GridLayout._defaultIncrementalMode;
    this._horizontalGridOffset = ibm_ilog.graphlayout.grid.GridLayout._defaultHorizontalGridOffset;
    this._verticalGridOffset = ibm_ilog.graphlayout.grid.GridLayout._defaultVerticalGridOffset;
    this._topMargin = ibm_ilog.graphlayout.grid.GridLayout._defaultTopMargin;
    this._bottomMargin = ibm_ilog.graphlayout.grid.GridLayout._defaultBottomMargin;
    this._leftMargin = ibm_ilog.graphlayout.grid.GridLayout._defaultLeftMargin;
    this._rightMargin = ibm_ilog.graphlayout.grid.GridLayout._defaultRightMargin;
    this._maxNumberOfNodesPerRowOrColumn = ibm_ilog.graphlayout.grid.GridLayout._defaultMaxNumberOfNodesPerRowOrColumn;
    this._nodeBoxInterface = ibm_ilog.graphlayout.grid.GridLayout._defaultNodeBoxInterface;
    this._previousLayoutRegion = new ibm_ilog.graphlayout.internalutil.Rectangle();
  },

  copy : function()
  {
    // summary:
    //		Copies the layout instance. 
    // description:
    //		Copies the layout instance. 
    //		<p>
    //		This method copies the layout instance by calling the copy
    //		constructor.  
    //		</p>
    //		<p>
    //		When performing a recursive layout on a nested graph, this method is
    //		used by <code> ibm&#95;ilog.graphlayout.ILayoutProvider</code> to
    //		"clone" the layout instance of a parent graph.  
    //		</p>
    //		<p>
    //		Note that the parameters which are specific to a node or a link are
    //		not copied. The other parameters, including the layout region
    //		specification and the node box interface, are also copied.  
    //		</p>
    //		<p>
    //		If a method of the type <code>supportsXXX</code> is associated with
    //		a parameter, the parameter is copied only if the corresponding
    //		method returns <code>true</code>.  
    //		</p>
    // returns:
    //		A copy of the layout instance.
    
    return new ibm_ilog.graphlayout.grid.GridLayout(this); // ibm_ilog.graphlayout.GraphLayout
  },

  copyParameters : function(source)
  {
    // summary:
    //		Copies the parameters from a given layout instance. 
    // description:
    //		Copies the parameters from a given layout instance. 
    //		<p>
    //		Note that the parameters which are specific to a node or a link are
    //		not copied. The other parameters, including the layout region
    //		specification and the node box interface, are also copied.  
    //		</p>
    //		<p>
    //		If a method of the type <code>supportsXXX</code> is associated with
    //		a parameter, the parameter is copied only if the corresponding
    //		method returns <code>true</code>.  
    //		</p>
    // source: ibm_ilog.graphlayout.GraphLayout
    //		The layout instance from which the parameters are copied.
    
    this.inherited("copyParameters", arguments, [source]);

    if (source instanceof ibm_ilog.graphlayout.grid.GridLayout)
    {
      var gsource = source;
      this.setNodeComparator(gsource.getNodeComparator());
      this.setGlobalHorizontalAlignment(gsource.getGlobalHorizontalAlignment());
      this.setGlobalVerticalAlignment(gsource.getGlobalVerticalAlignment());
      this.setLayoutMode(gsource.getLayoutMode());
      this.setIncrementalMode(gsource.isIncrementalMode());
      this.setHorizontalGridOffset(gsource.getHorizontalGridOffset());
      this.setVerticalGridOffset(gsource.getVerticalGridOffset());
      this.setTopMargin(gsource.getTopMargin());
      this.setBottomMargin(gsource.getBottomMargin());
      this.setLeftMargin(gsource.getLeftMargin());
      this.setRightMargin(gsource.getRightMargin());
      this.setMaxNumberOfNodesPerRowOrColumn(gsource.getMaxNumberOfNodesPerRowOrColumn());
      this.setNodeBoxInterface(gsource.getNodeBoxInterface());
    }
  },

  detach : function()
  {
    // summary:
    //		Detaches the graph model from the layout instance. 
    // description:
    //		Detaches the graph model from the layout instance. 
    //		When you attach a new graph model to the layout instance, you do not
    //		need to detach the old graph model because this is done
    //		automatically when you call <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.attach()</code>.  
    //		<p>
    //		The method performs cleaning operations on the graph model. In
    //		addition to the cleaning operations in the base class, the Grid
    //		Layout algorithm removes the alignment specifications of individual
    //		nodes.  
    //		</p>
    //		<p>
    //		Note that you must call this method when you no longer need the
    //		layout instance. Otherwise, some objects may not be garbage
    //		collected.  
    //		</p>
    
    this.cleanInternalData();
    this.inherited("detach", arguments, []);
  },

  cleanInternalData : function()
  {
    // summary:
    //		Cleans the internal data structures.
    // tags:
    //		private
    
  },

  supportsLayoutRegion : function()
  {
    // summary:
    //		Indicates that this layout class can control the size of the graph
    //		drawing to fit a user-defined region (a rectangle) or a user-defined
    //		manager view. 
    // description:
    //		Indicates that this layout class can control the size of the graph
    //		drawing to fit a user-defined region (a rectangle) or a user-defined
    //		manager view. 
    //		<p>
    //		If the layout mode (see <code> GridLayout.setLayoutMode()</code>) is
    //		<code> GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code>, the width of the
    //		layout region determines the maximum width of the layout (the
    //		maximum number of columns).  
    //		</p>
    //		<p>
    //		If the layout mode is <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;HEIGHT</code>, the height of the
    //		layout region determines the maximum height of the layout (the
    //		maximum number of rows).  
    //		</p>
    //		<p>
    //		If the layout mode is <code> GridLayout.TILE&#95;TO&#95;ROWS</code>, the
    //		width of the layout region determines the maximum width of the rows.
    //		 
    //		</p>
    //		<p>
    //		If the layout mode is <code> GridLayout.TILE&#95;TO&#95;COLUMNS</code>, the
    //		height of the layout region determines the maximum height of the
    //		columns.  
    //		</p>
    //		<p>
    //		However, if the width of a node is larger than the maximum width of
    //		the layout or the height of the node is larger than the maximum
    //		height of the layout, the bounding box of the node will be placed
    //		partially out of the specified layout region.  
    //		</p>
    //		<p>
    //		In all layout modes, the coordinates of the top-left corner of the
    //		layout region determines the coordinates of the top-left border of
    //		the layout.  
    //		</p>
    
    return true; // Boolean
  },

  supportsPreserveFixedNodes : function()
  {
    // summary:
    //		Indicates that this layout class allows the user to specify fixed
    //		nodes. 
    // description:
    //		Indicates that this layout class allows the user to specify fixed
    //		nodes. 
    //		<p>
    //		Fixed nodes are not moved during the layout if the method  <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setPreserveFixedNodes()</code> is
    //		called with a <code>true</code> argument . Nonfixed nodes are placed
    //		in such a manner that overlaps with fixed nodes are avoided.  
    //		</p>
    
    return true; // Boolean
  },

  supportsAllowedTime : function()
  {
    // summary:
    //		Indicates that this layout class can stop the layout computation in
    //		a proper manner when the user-defined allowed time is exceeded. 
    // description:
    //		Indicates that this layout class can stop the layout computation in
    //		a proper manner when the user-defined allowed time is exceeded. 
    //		<p>
    //		If the allowed time elapses before termination of the Grid Layout
    //		algorithm, the result code in the layout report is <code>
    //		ibm&#95;ilog.graphlayout.GraphLayoutReport.STOPPED&#95;AND&#95;INVALID</code>.  
    //		</p>
    
    return true; // Boolean
  },

  supportsStopImmediately : function()
  {
    // summary:
    //		Indicates that this layout class can control the current run by
    //		interrupting the run of the layout immediately. 
    // description:
    //		Indicates that this layout class can control the current run by
    //		interrupting the run of the layout immediately. 
    //		<p>
    //		If the algorithm is stopped before termination, the result code in
    //		the layout report is <code>
    //		ibm&#95;ilog.graphlayout.GraphLayoutReport.STOPPED&#95;AND&#95;INVALID</code>.  
    //		</p>
    
    return true; // Boolean
  },

  setLayoutMode : function(mode)
  {
    // summary:
    //		Sets the layout mode. 
    // description:
    //		Sets the layout mode. 
    //		Valid values are:  
    //		<ul>
    //		<li> <code> GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code> - The nodes
    //		are placed in the cells of a grid (matrix) that has a fixed maximum
    //		number of columns. This number is equal to the width of the layout
    //		region parameter divided by the horizontal grid offset (see <code>
    //		GridLayout.setHorizontalGridOffset()</code>). </li>  
    //		<li> <code> GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;HEIGHT</code> - The nodes
    //		are placed in the cells of a grid (matrix) that has a fixed maximum
    //		number of rows. This number is equal to the height of the layout
    //		region parameter divided by the vertical grid offset (see <code>
    //		GridLayout.setVerticalGridOffset()</code>). </li>  
    //		<li> <code> GridLayout.TILE&#95;TO&#95;ROWS</code> - The nodes are placed in
    //		rows. The maximum width of the rows is equal to the width of the
    //		layout region parameter. The height of each row is the maximum
    //		height of the nodes contained in the row (plus margins). </li>  
    //		<li> <code> GridLayout.TILE&#95;TO&#95;COLUMNS</code> - The nodes are placed
    //		in columns. The maximum height of the columns is equal to the height
    //		of the layout region parameter. The width of each column is the
    //		maximum width of the nodes contained in the column (plus margins).
    //		</li>  
    //		</ul>  
    //		<p>
    //		The default value is <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code>.  
    //		</p>
    
    if (
      !
        (mode == ibm_ilog.graphlayout.grid.GridLayout.TILE_TO_COLUMNS || mode == ibm_ilog.graphlayout.grid.GridLayout.TILE_TO_ROWS ||
            mode == ibm_ilog.graphlayout.grid.GridLayout.TILE_TO_GRID_FIXED_WIDTH || mode == ibm_ilog.graphlayout.grid.GridLayout.TILE_TO_GRID_FIXED_HEIGHT))
      {
        ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.grid.GridLayout, "graphlayout.expert.message.6376E",  mode);
      }

    if (mode != this._layoutMode)
    {
      this._layoutMode = mode;
      this.setCriticalParametersUpToDate("LayoutMode", false);
    }
  },

  getLayoutMode : function()
  {
    // summary:
    //		Returns the current layout mode.
    
    return (false ? ibm_ilog.graphlayout.grid.GridLayout._defaultLayoutMode : this._layoutMode); // int
  },

  setIncrementalMode : function(enable)
  {
    // summary:
    //		Sets the incremental mode. 
    // description:
    //		Sets the incremental mode. 
    //		<p>
    //		If the incremental mode is enabled, the stability of the layout is
    //		preserved as much as possible when new nodes are added, existing
    //		ones removed, or node sizes modified. This means that the nodes are
    //		placed at the same location or in the same order as in the previous
    //		layout whenever possible. In this mode, the layout algorithm
    //		processes the changes incrementally rather than redoing the entire
    //		layout for every change.  
    //		</p>
    //		<p>
    //		To preserve the stability, the incremental mode can keep some
    //		regions free. Therefore, the total area of the layout can be larger
    //		than when nonincremental mode is used.  
    //		</p>
    //		<p>
    //		Note that the layout is redone from scratch after a change in one of
    //		the following parameters:  
    //		<ul>
    //		<li> layout region</li>  
    //		<li> grid offset</li>  
    //		<li> layout mode</li>  
    //		<li> margins</li>  
    //		</ul>  
    //		</p>
    //		<p>
    //		The default value is <code>false</code> (disabled).  
    //		</p>
    
    if (enable != this._incrementalMode)
    {
      this._incrementalMode = enable;
      this.onParameterChanged("IncrementalMode");
    }
  },

  isIncrementalMode : function()
  {
    // summary:
    //		Returns 'true' if the incremental mode is enabled, and
    //		'false' otherwise.
    
    return (false ? ibm_ilog.graphlayout.grid.GridLayout._defaultIncrementalMode : this._incrementalMode); // Boolean
  },

  setGlobalHorizontalAlignment : function(alignment)
  {
    // summary:
    //		Sets the global horizontal alignment style. 
    // description:
    //		Sets the global horizontal alignment style. 
    //		This method controls the horizontal alignment of nodes either inside
    //		their grid cell if the layout mode (see <code>
    //		GridLayout.setLayoutMode()</code>) is <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code> or <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;HEIGHT</code>, or inside the columns
    //		if the layout mode is <code> GridLayout.TILE&#95;TO&#95;COLUMNS</code>. This
    //		parameter is not used if the layout mode (see <code>
    //		GridLayout.setLayoutMode()</code>) is <code>
    //		GridLayout.TILE&#95;TO&#95;ROWS</code>.  
    //		<p>
    //		Valid values are:  
    //		<ul>
    //		<li> <code> GridLayout.CENTER</code> - the node is centered in its
    //		grid cell or column.</li>  
    //		<li> <code> GridLayout.LEFT</code> - the node is aligned to the left
    //		border of the cell or column.</li>  
    //		<li> <code> GridLayout.RIGHT</code> - the node is aligned to the
    //		left border of the cell or column.</li>  
    //		<li> <code> GridLayout.MIXED</code> - each node can have a different
    //		alignment option. In this case, the horizontal alignment of each
    //		individual node can be set by the method <code>
    //		GridLayout.setHorizontalAlignment()</code> so that different
    //		alignments can occur in the same layout.</li>  
    //		</ul>  
    //		</p>
    //		<p>
    //		The default value is <code> GridLayout.CENTER</code>.  
    //		</p>
    
    if (
      !
        (alignment == ibm_ilog.graphlayout.grid.GridLayout.CENTER || alignment == ibm_ilog.graphlayout.grid.GridLayout.LEFT || alignment == ibm_ilog.graphlayout.grid.GridLayout.RIGHT ||
            alignment == ibm_ilog.graphlayout.grid.GridLayout.MIXED))
      {
        ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.grid.GridLayout, "graphlayout.expert.message.6377E",  alignment);
      }

    if (alignment != this._globalHorizontalAlignment)
    {
      this._globalHorizontalAlignment = alignment;
      this.onParameterChanged("GlobalHorizontalAlignment");
    }
  },

  getGlobalHorizontalAlignment : function()
  {
    // summary:
    //		Returns the global horizontal alignment style.
    
    return (false ? ibm_ilog.graphlayout.grid.GridLayout._defaultHorizontalAlignment : this._globalHorizontalAlignment); // int
  },

  setHorizontalAlignment : function(node, alignment)
  {
    // summary:
    //		Sets the horizontal alignment style of an individual node. 
    // description:
    //		Sets the horizontal alignment style of an individual node. 
    //		This alignment style is used only if the global horizontal alignment
    //		is set to <code> GridLayout.MIXED</code>. Otherwise, all nodes have
    //		the alignment style that is specified as the global alignment style.
    //		 
    //		<p>
    //		This parameter controls the horizontal alignment of nodes either
    //		inside their grid cells if the layout mode (see <code>
    //		GridLayout.setLayoutMode()</code>) is <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code> or <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;HEIGHT</code>, or within the columns
    //		if the layout mode is <code> GridLayout.TILE&#95;TO&#95;COLUMNS</code>.  
    //		</p>
    //		<p>
    //		This parameter is not used if the layout mode (see <code>
    //		GridLayout.setLayoutMode()</code>) is <code>
    //		GridLayout.TILE&#95;TO&#95;ROWS</code>.  
    //		</p>
    //		<p>
    //		Valid values are:  
    //		<ul>
    //		<li> <code> GridLayout.CENTER</code> - the node is centered in its
    //		grid cell or column.</li>  
    //		<li> <code> GridLayout.LEFT</code> - the node is aligned to the left
    //		border of the cell or column.</li>  
    //		<li> <code> GridLayout.RIGHT</code> - the node is aligned to the
    //		right border of the cell or column.</li>  
    //		</ul>  
    //		</p>
    //		<p>
    //		The default value is <code> GridLayout.CENTER</code>.  
    //		</p>
    // node: Object
    //		The node instance.
    // alignment: int
    //		The horizontal alignment style of an individual node.
    //		Valid values are: ' GridLayout.CENTER', '
    //		GridLayout.LEFT' or ' GridLayout.RIGHT'.
    
    if (!(alignment == ibm_ilog.graphlayout.grid.GridLayout.CENTER || alignment == ibm_ilog.graphlayout.grid.GridLayout.LEFT || alignment == ibm_ilog.graphlayout.grid.GridLayout.RIGHT))
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.grid.GridLayout, "graphlayout.expert.message.6378E",  alignment);
    }

    ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.setNodeParameter(this, node, ibm_ilog.graphlayout.grid.GridLayout._HORIZONTAL_ALIGNMENT_PROPERTY, alignment,
      ibm_ilog.graphlayout.grid.GridLayout._defaultHorizontalAlignment);
  },

  getHorizontalAlignment : function(node)
  {
    // summary:
    //		Returns the local horizontal alignment style of the node.  
    // node: Object
    //		The node instance.
    // returns:
    //		The horizontal alignment style of an individual node. Valid
    //		values are: ' GridLayout.CENTER', '
    //		GridLayout.LEFT' or ' GridLayout.RIGHT'.
    
    return ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.getNodeEnumParameter(this, node, ibm_ilog.graphlayout.grid.GridLayout._HORIZONTAL_ALIGNMENT_PROPERTY,
        ibm_ilog.graphlayout.grid.GridLayout._defaultHorizontalAlignment); // int
  },

  setGlobalVerticalAlignment : function(alignment)
  {
    // summary:
    //		Sets the global vertical alignment style. 
    // description:
    //		Sets the global vertical alignment style. 
    //		This method controls the vertical alignment of nodes either inside
    //		their grid cell if the layout mode (see <code>
    //		GridLayout.setLayoutMode()</code>) is <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code> or <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;HEIGHT</code>, or inside the rows if
    //		the layout mode is <code> GridLayout.TILE&#95;TO&#95;ROWS</code>. This
    //		parameter is not used if the layout mode (see <code>
    //		GridLayout.setLayoutMode()</code>) is <code>
    //		GridLayout.TILE&#95;TO&#95;COLUMNS</code>.  
    //		<p>
    //		Valid values are:  
    //		<ul>
    //		<li> <code> GridLayout.CENTER</code> - the node is centered in its
    //		grid cell or column.</li>  
    //		<li> <code> GridLayout.TOP</code> - the node is aligned to the top
    //		border of the cell or column.</li>  
    //		<li> <code> GridLayout.BOTTOM</code> - the node is aligned to the
    //		bottom border of the cell or column.</li>  
    //		<li> <code> GridLayout.MIXED</code> - each node can have a different
    //		alignment option. In this case, the vertical alignment of each
    //		individual node can be set by the method <code>
    //		GridLayout.setVerticalAlignment()</code> so that different
    //		alignments can occur in the same layout.</li>  
    //		</ul>  
    //		</p>
    //		<p>
    //		The default value is <code> GridLayout.CENTER</code>.  
    //		</p>
    
    if (
      !
        (alignment == ibm_ilog.graphlayout.grid.GridLayout.CENTER || alignment == ibm_ilog.graphlayout.grid.GridLayout.TOP || alignment == ibm_ilog.graphlayout.grid.GridLayout.BOTTOM ||
            alignment == ibm_ilog.graphlayout.grid.GridLayout.MIXED))
      {
        ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.grid.GridLayout, "graphlayout.expert.message.6379E",  alignment);
      }

    if (alignment != this._globalVerticalAlignment)
    {
      this._globalVerticalAlignment = alignment;
      this.onParameterChanged("GlobalVerticalAlignment");
    }
  },

  getGlobalVerticalAlignment : function()
  {
    // summary:
    //		Returns the global vertical alignment style.
    
    return (false ? ibm_ilog.graphlayout.grid.GridLayout._defaultVerticalAlignment : this._globalVerticalAlignment); // int
  },

  setVerticalAlignment : function(node, alignment)
  {
    // summary:
    //		Sets the vertical alignment style of an individual node. 
    // description:
    //		Sets the vertical alignment style of an individual node. 
    //		This alignment style is used only if the global vertical alignment
    //		is set to <code> GridLayout.MIXED</code>. Otherwise, all nodes have
    //		the alignment style that is specified as the global alignment style.
    //		 
    //		<p>
    //		This parameter controls the vertical alignment of nodes either
    //		inside their grid cell if the layout mode (see <code>
    //		GridLayout.setLayoutMode()</code>) is <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code> or <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;HEIGHT</code>, or within the rows if
    //		the layout mode is <code> GridLayout.TILE&#95;TO&#95;ROWS</code>.  
    //		</p>
    //		<p>
    //		This parameter is not used if the layout mode (see <code>
    //		GridLayout.setLayoutMode()</code>) is <code>
    //		GridLayout.TILE&#95;TO&#95;COLUMNS</code>.  
    //		</p>
    //		<p>
    //		Valid values are:  
    //		<ul>
    //		<li> <code> GridLayout.CENTER</code> - the node is centered in its
    //		grid cell or column.</li>  
    //		<li> <code> GridLayout.TOP</code> - the node is aligned to the top
    //		border of the cell or column.</li>  
    //		<li> <code> GridLayout.BOTTOM</code> - the node is aligned to the
    //		bottom border of the cell or column.</li>  
    //		</ul>  
    //		</p>
    //		<p>
    //		The default value is <code> GridLayout.CENTER</code>.  
    //		</p>
    // node: Object
    //		The node instance.
    // alignment: int
    //		The vertical alignment style of an individual node.
    //		Possible values are: ' GridLayout.CENTER', '
    //		GridLayout.TOP', '
    //		GridLayout.BOTTOM'.
    
    if (!(alignment == ibm_ilog.graphlayout.grid.GridLayout.CENTER || alignment == ibm_ilog.graphlayout.grid.GridLayout.TOP || alignment == ibm_ilog.graphlayout.grid.GridLayout.BOTTOM))
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.grid.GridLayout, "graphlayout.expert.message.6380E",  alignment);
    }

    ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.setNodeParameter(this, node, ibm_ilog.graphlayout.grid.GridLayout._VERTICAL_ALIGNMENT_PROPERTY, alignment,
      ibm_ilog.graphlayout.grid.GridLayout._defaultVerticalAlignment);
  },

  getVerticalAlignment : function(node)
  {
    // summary:
    //		Returns the local vertical alignment style of the node.  
    // node: Object
    //		The node instance
    // returns:
    //		The vertical alignment style of an individual node. Possible
    //		values are: ' GridLayout.CENTER', '
    //		GridLayout.TOP', ' GridLayout.BOTTOM'.
    
    return ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.getNodeEnumParameter(this, node, ibm_ilog.graphlayout.grid.GridLayout._VERTICAL_ALIGNMENT_PROPERTY,
        ibm_ilog.graphlayout.grid.GridLayout._defaultVerticalAlignment); // int
  },

  setNodeComparator : function(comparator)
  {
    // summary:
    //		Sets the comparator used for sorting the nodes. 
    // description:
    //		Sets the comparator used for sorting the nodes. 
    //		The valid values are the following:  
    //		<ul>
    //		<li> <code> GridLayout.AUTOMATIC&#95;ORDERING</code> - The algorithm is
    //		free to choose an order aimed at reducing the total area occupied by
    //		the layout.</li>  
    //		<li> <code> GridLayout.NO&#95;ORDERING</code> - No ordering is
    //		performed.</li>  
    //		<li> <code> GridLayout.DESCENDING&#95;HEIGHT</code> - The nodes are
    //		ordered in descending order of height.</li>  
    //		<li> <code> GridLayout.ASCENDING&#95;HEIGHT</code> - The nodes are
    //		ordered in ascending order of height.</li>  
    //		<li> <code> GridLayout.DESCENDING&#95;WIDTH</code> - The nodes are
    //		ordered in descending order of width.</li>  
    //		<li> <code> GridLayout.ASCENDING&#95;WIDTH</code> - The nodes are
    //		ordered in ascending order of width.</li>  
    //		<li> <code> GridLayout.DESCENDING&#95;AREA</code> - The nodes are
    //		ordered in descending order of area.</li>  
    //		<li> <code> GridLayout.ASCENDING&#95;AREA</code> - The nodes are ordered
    //		in ascending order of area.</li>  
    //		<li> <code> GridLayout.ASCENDING&#95;INDEX</code> - The nodes are
    //		ordered in ascending order of index value (see <code>
    //		GridLayout.setIndex()</code>).</li>  
    //		<li> <code> GridLayout.DESCENDING&#95;INDEX</code> - The nodes are
    //		ordered in descending order of index value (see <code>
    //		GridLayout.setIndex()</code>).</li>  
    //		<li> <code>null</code> - The nodes are ordered in an arbitrary
    //		way.</li>  
    //		<li> Any other implementation of the
    //		<code>java.util.Comparator</code> interface - the nodes are ordered
    //		according to this custom comparator  . </li>  
    //		</ul>
    //		The default value is <code> GridLayout.AUTOMATIC&#95;ORDERING</code>.  
    //		<p>
    //		The ordering of the nodes starts at the upper-left corner.  
    //		</p>
    //		<p>
    //		In incremental mode (see <code>
    //		GridLayout.setIncrementalMode()</code>) or when nodes are fixed (see
    //		<code> ibm&#95;ilog.graphlayout.GraphLayout.setFixed()</code>) the order
    //		of the nodes is not guaranteed to obey the comparator, since this
    //		specification competes with the other constraints.  
    //		</p>
    //		<p>
    //		If the layout mode is <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code> or <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;HEIGHT</code>, the order options are
    //		applied only for nodes whose size (including margins) is smaller
    //		than the grid cell size (see <code>
    //		GridLayout.setHorizontalGridOffset()</code> and <code>
    //		GridLayout.setVerticalGridOffset()</code>).  
    //		</p>
    
    if (comparator != this._comparator)
    {
      this._comparator = comparator;
      this.setCriticalParametersUpToDate("NodeComparator", false);
    }
  },

  getNodeComparator : function()
  {
    // summary:
    //		Returns the comparator used for sorting the nodes.
    
    return (false ? ibm_ilog.graphlayout.grid.GridLayout._defaultComparator : this._comparator); // Function
  },

  setIndex : function(node, index)
  {
    // summary:
    //		Sets the index of a node. 
    // description:
    //		Sets the index of a node. 
    //		When the layout is performed, the nodes for which indexes have been
    //		specified are arranged in the order corresponding to their index
    //		values (starting in the upper-left corner with the smallest index
    //		value); the nodes for which indexes have not been specified are
    //		arranged after them. You can specify the class field <code>
    //		GridLayout.NO&#95;INDEX</code> as an index value if you want to clear an
    //		index value that you previously specified.  
    //		<p>
    //		Note that <code>index</code> must not be negative. The values of the
    //		indexes for consecutive nodes are not necessarily consecutive. Only
    //		the order of the values is important.  
    //		</p>
    // node: Object
    //		The node instance.
    // index: int
    //		The index of the specified node. When the layout is
    //		performed, the nodes for which indexes have been specified are
    //		arranged in the order corresponding to their index values (starting
    //		in the upper-left corner with the smallest index value).
    
    if (index < 0 && index != ibm_ilog.graphlayout.grid.GridLayout.NO_INDEX)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.grid.GridLayout, "graphlayout.expert.message.6381E",  index);
    }

    ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.setNodeParameter(this, node, ibm_ilog.graphlayout.grid.GridLayout._INDEX_PROPERTY, Number(index ),
      Number(ibm_ilog.graphlayout.grid.GridLayout.NO_INDEX ));
  },

  getIndex : function(node)
  {
    // summary:
    //		Returns the index value associated with a node. 
    // description:
    //		Returns the index value associated with a node. 
    //		It returns <code> GridLayout.NO&#95;INDEX</code> if <code>node</code>
    //		has no index value.  
    // node: Object
    //		The node instance.
    // returns:
    //		The specified index value of the node, or '
    //		GridLayout.NO_INDEX' if
    //		no value is specified.
    
    return ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.getNodeIntParameter(this, node, ibm_ilog.graphlayout.grid.GridLayout._INDEX_PROPERTY, ibm_ilog.graphlayout.grid.GridLayout.NO_INDEX); // int
  },

  setHorizontalGridOffset : function(offset)
  {
    // summary:
    //		Sets the spacing of the grid lines on the horizontal axis. 
    // description:
    //		Sets the spacing of the grid lines on the horizontal axis. 
    //		<p>
    //		The default value is <code>40</code>.  
    //		</p>
    //		<p>
    //		This parameter is not used if the layout mode (see <code>
    //		GridLayout.setLayoutMode()</code>) is <code>
    //		GridLayout.TILE&#95;TO&#95;ROWS</code> or <code>
    //		GridLayout.TILE&#95;TO&#95;COLUMNS</code>.  
    //		</p>
    
    if (offset < 0.01)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.grid.GridLayout, "graphlayout.expert.message.6382E",  offset);
    }

    if (offset != this._horizontalGridOffset)
    {
      this._horizontalGridOffset = offset;
      this.setCriticalParametersMatrixUpToDate("HorizontalGridOffset", false);
    }
  },

  getHorizontalGridOffset : function()
  {
    // summary:
    //		Returns the horizontal grid offset.
    
    return (false ? ibm_ilog.graphlayout.grid.GridLayout._defaultHorizontalGridOffset : this._horizontalGridOffset); // Number
  },

  setVerticalGridOffset : function(offset)
  {
    // summary:
    //		Sets the spacing of the grid lines on the vertical axis. 
    // description:
    //		Sets the spacing of the grid lines on the vertical axis. 
    //		<p>
    //		The default value is <code>40</code>.  
    //		</p>
    //		<p>
    //		This parameter is not used if the layout mode (see <code>
    //		GridLayout.setLayoutMode()</code>) is <code>
    //		GridLayout.TILE&#95;TO&#95;ROWS</code> or <code>
    //		GridLayout.TILE&#95;TO&#95;COLUMNS</code>.  
    //		</p>
    
    if (offset < 0.01)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.grid.GridLayout, "graphlayout.expert.message.6383E",  offset);
    }

    if (offset != this._verticalGridOffset)
    {
      this._verticalGridOffset = offset;
      this.setCriticalParametersMatrixUpToDate("VerticalGridOffset", false);
    }
  },

  getVerticalGridOffset : function()
  {
    // summary:
    //		Returns the vertical grid offset.
    
    return (false ? ibm_ilog.graphlayout.grid.GridLayout._defaultVerticalGridOffset : this._verticalGridOffset); // Number
  },

  setTopMargin : function(margin)
  {
    // summary:
    //		Sets the top margin parameter. 
    // description:
    //		Sets the top margin parameter. 
    //		<p>
    //		If the layout mode is <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code> or <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;HEIGHT</code>, the top margin is the
    //		minimum distance between the top border of a node (or its
    //		user-specified box - see <code>
    //		GridLayout.setNodeBoxInterface()</code>) and the top border of the
    //		grid cell.  
    //		</p>
    //		<p>
    //		If the layout mode is <code> GridLayout.TILE&#95;TO&#95;ROWS</code> or
    //		<code> GridLayout.TILE&#95;TO&#95;COLUMNS</code>, the minimum vertical
    //		distance between two nodes (or their user-specified boxes) is the
    //		sum of the top and bottom margins.  
    //		</p>
    //		<p>
    //		The default value is <code>5</code>.  
    //		</p>
    
    if (margin != this._topMargin)
    {
      this._topMargin = margin;
      this.setCriticalParametersUpToDate("TopMargin", false);
    }
  },

  getTopMargin : function()
  {
    // summary:
    //		Returns the top margin.
    
    return (false ? ibm_ilog.graphlayout.grid.GridLayout._defaultTopMargin : this._topMargin); // Number
  },

  setBottomMargin : function(margin)
  {
    // summary:
    //		Sets the bottom margin parameter. 
    // description:
    //		Sets the bottom margin parameter. 
    //		<p>
    //		If the layout mode is <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code> or <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;HEIGHT</code>, the bottom margin is
    //		the minimum distance between the bottom border of a node (or its
    //		user-specified box - see <code>
    //		GridLayout.setNodeBoxInterface()</code>) and the bottom border of
    //		the grid cell.  
    //		</p>
    //		<p>
    //		If the layout mode is <code> GridLayout.TILE&#95;TO&#95;ROWS</code> or
    //		<code> GridLayout.TILE&#95;TO&#95;COLUMNS</code>, the minimum vertical
    //		distance between two nodes (or their user-specified boxes) is the
    //		sum of the top and bottom margins.  
    //		</p>
    //		<p>
    //		The default value is <code>5</code>.  
    //		</p>
    
    if (margin != this._bottomMargin)
    {
      this._bottomMargin = margin;
      this.setCriticalParametersUpToDate("BottomMargin", false);
    }
  },

  getBottomMargin : function()
  {
    // summary:
    //		Returns the bottom margin.
    
    return (false ? ibm_ilog.graphlayout.grid.GridLayout._defaultBottomMargin : this._bottomMargin); // Number
  },

  setLeftMargin : function(margin)
  {
    // summary:
    //		Sets the left margin parameter. 
    // description:
    //		Sets the left margin parameter. 
    //		<p>
    //		If the layout mode is <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code> or <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;HEIGHT</code>, the left margin is the
    //		minimum distance between the left border of a node (or its
    //		user-specified box - see <code>
    //		GridLayout.setNodeBoxInterface()</code>) and the left border of the
    //		grid cell.  
    //		</p>
    //		<p>
    //		If the layout mode is <code> GridLayout.TILE&#95;TO&#95;ROWS</code> or
    //		<code> GridLayout.TILE&#95;TO&#95;COLUMNS</code>, the minimum horizontal
    //		distance between two nodes (or their user-specified boxes) is the
    //		sum of the left and right margins.  
    //		</p>
    //		<p>
    //		The default value is <code>5</code>.  
    //		</p>
    
    if (margin != this._leftMargin)
    {
      this._leftMargin = margin;
      this.setCriticalParametersUpToDate("LeftMargin", false);
    }
  },

  getLeftMargin : function()
  {
    // summary:
    //		Returns the left margin.
    
    return (false ? ibm_ilog.graphlayout.grid.GridLayout._defaultLeftMargin : this._leftMargin); // Number
  },

  setRightMargin : function(margin)
  {
    // summary:
    //		Sets the right margin parameter. 
    // description:
    //		Sets the right margin parameter. 
    //		<p>
    //		If the layout mode is <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code> or <code>
    //		GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;HEIGHT</code>, the right margin is the
    //		minimum distance between the right border of a node (or its
    //		user-specified box - see <code>
    //		GridLayout.setNodeBoxInterface()</code>) and the right border of the
    //		grid cell.  
    //		</p>
    //		<p>
    //		If the layout mode is <code> GridLayout.TILE&#95;TO&#95;ROWS</code> or
    //		<code> GridLayout.TILE&#95;TO&#95;COLUMNS</code>, the minimum horizontal
    //		distance between two nodes (or their user-specified boxes) is the
    //		sum of the left and right margins.  
    //		</p>
    //		<p>
    //		The default value is <code>5</code>.  
    //		</p>
    
    if (margin != this._rightMargin)
    {
      this._rightMargin = margin;
      this.setCriticalParametersUpToDate("RightMargin", false);
    }
  },

  getRightMargin : function()
  {
    // summary:
    //		Returns the right margin.
    
    return (false ? ibm_ilog.graphlayout.grid.GridLayout._defaultRightMargin : this._rightMargin); // Number
  },

  setMaxNumberOfNodesPerRowOrColumn : function(nNodes)
  {
    // summary:
    //		Sets the maximum number of nodes per row or per column. 
    // description:
    //		Sets the maximum number of nodes per row or per column. 
    //		<p>
    //		In <code> GridLayout.TILE&#95;TO&#95;ROWS</code> mode, the number is the
    //		maximum number of nodes per row. In <code>
    //		GridLayout.TILE&#95;TO&#95;COLUMNS</code> mode, the number is the maximum
    //		number of nodes per column.  
    //		</p>
    //		<p>
    //		The layout places as many nodes on each row or column as possible
    //		given the size of the nodes, the dimensional parameters (layout
    //		region and margins) and the specified maximum number of nodes per
    //		row or column.  
    //		</p>
    //		<p>
    //		The minimum value is <code>1</code>. The default value is
    //		<code>Number.MAX&#95;VALUE</code> , that is, the number of nodes placed
    //		in each row or column is bounded only by the size of the nodes and
    //		the dimensional parameters. The parameter has no effect if the
    //		layout mode is <code> GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;WIDTH</code> or
    //		<code> GridLayout.TILE&#95;TO&#95;GRID&#95;FIXED&#95;HEIGHT</code>.  
    //		</p>
    
    if (nNodes < 1)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.grid.GridLayout, "graphlayout.expert.message.6384E", null);
    }

    if (nNodes != this._maxNumberOfNodesPerRowOrColumn)
    {
      this._maxNumberOfNodesPerRowOrColumn = nNodes;
      this.setCriticalParametersUpToDate("MaxNumberOfNodesPerRowOrColumn", false);
    }
  },

  getMaxNumberOfNodesPerRowOrColumn : function()
  {
    // summary:
    //		Returns the maximum number of nodes per row in '
    //		GridLayout.TILE_TO_ROWS' mode or the maximum number of nodes
    //		per column in ' GridLayout.TILE_TO_COLUMNS' mode.
    
    return (false ? ibm_ilog.graphlayout.grid.GridLayout._defaultMaxNumberOfNodesPerRowOrColumn : this._maxNumberOfNodesPerRowOrColumn); // int
  },

  setNodeBoxInterface : function(nodeBoxInterface)
  {
    // summary:
    //		Sets an object that provides the rectangle defining the location and
    //		size of each node. 
    // description:
    //		Sets an object that provides the rectangle defining the location and
    //		size of each node. 
    //		<p>
    //		This method allows a node size other than the bounding box to be
    //		taken into account by the layout algorithm.  
    //		</p>
    //		<p>
    //		If you do not call this method, the layout algorithm uses the
    //		bounding box of the node (see  IGraphLayoutModel.getObjectBounds()).
    //		 
    //		</p>
    //		<p>
    //		The default value is <code>null</code>. You can call this method
    //		with a <code>null</code> argument to restore the default behavior. 
    //		</p>
    
    if (this._nodeBoxInterface != nodeBoxInterface)
    {
      this._nodeBoxInterface = nodeBoxInterface;
      this.onParameterChanged("NodeBoxInterface");
    }
  },

  getNodeBoxInterface : function()
  {
    // summary:
    //		Returns the object that provides the rectangle defining the location
    //		and size of each node, if one is specified. 
    // description:
    //		Returns the object that provides the rectangle defining the location
    //		and size of each node, if one is specified. 
    //		Otherwise, it returns <code>null</code>.
    
    return this._nodeBoxInterface; // ibm_ilog.graphlayout.INodeBoxProvider
  },

  setCriticalParametersUpToDate : function(parameterName, uptodate )
  {
    if (!uptodate) {
      this.cleanInternalData();
    }
    this.setCriticalParametersMatrixUpToDate(parameterName, uptodate);
    this.setCriticalParametersRowColumnUpToDate(uptodate);
  },

  isCriticalParametersUpToDate : function(layoutRegion)
  {
    switch (this.getLayoutMode())
    {
      case ibm_ilog.graphlayout.grid.GridLayout.TILE_TO_GRID_FIXED_WIDTH:
      case ibm_ilog.graphlayout.grid.GridLayout.TILE_TO_GRID_FIXED_HEIGHT:
        return this.isCriticalParametersMatrixUpToDate() && this.isSameLayoutRegion(layoutRegion); // Boolean
      case ibm_ilog.graphlayout.grid.GridLayout.TILE_TO_ROWS:
      case ibm_ilog.graphlayout.grid.GridLayout.TILE_TO_COLUMNS:
        return this.isCriticalParametersRowColumnUpToDate() && this.isSameLayoutRegion(layoutRegion); // Boolean
      default:
        return false; // Boolean
    }
  },

  isSameLayoutRegion : function(layoutRegion)
  {
    return this._previousLayoutRegion != null && ibm_ilog.graphlayout.internalutil.TranslateUtil.rectEquals(layoutRegion,
        this._previousLayoutRegion); // Boolean
  },

  setCriticalParametersMatrixUpToDate : function(parameterName, option

)
  {
    this._criticalParamMatrixUpToDate = option;

    if (option == false && parameterName != null)
    {
      this.onParameterChanged(parameterName);
    }
    else {
      this.setParametersUpToDate(option);
    }
  },

  isCriticalParametersMatrixUpToDate : function()
  {
    // summary:
    //		Returns false is a critical parameter changed since the last time
    //		the layout was successfully performed. 
    // description:
    //		Returns false is a critical parameter changed since the last time
    //		the layout was successfully performed. 
    //		A critical parameter is one that, if changes, makes the previous
    //		layout invalid (for incremental mode). If such a change occurs, the
    //		layout has to be rebuild from scratch (currently).
    // tags:
    //		private
    
    return this._criticalParamMatrixUpToDate; // Boolean
  },

  setCriticalParametersRowColumnUpToDate : function(option)
  {
    // summary:
    //		In all cases when this is called because a layout parameter has
    //		changed, the '
    //		ibm_ilog.graphlayout.GraphLayout.onParameterChanged()' has
    //		already been called. 
    // description:
    //		In all cases when this is called because a layout parameter has
    //		changed, the <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.onParameterChanged()</code> has
    //		already been called. 
    //		Hence we
    //		don't need the parameter name here, and can all <code> ibm&#95;ilog.graphlayout.GraphLayout.setParametersUpToDate()</code> directly.
    // tags:
    //		private
    
    this._criticalParamRowColumnUpToDate = option;
    this.setParametersUpToDate(option);
  },

  isCriticalParametersRowColumnUpToDate : function()
  {
    // summary:
    //		Returns false is a critical parameter changed since the last time
    //		the layout was successfully performed. 
    // description:
    //		Returns false is a critical parameter changed since the last time
    //		the layout was successfully performed. 
    //		A critical parameter is one that, if changes, makes the previous
    //		layout invalid (for incremental mode). If such a change occurs, the
    //		layout has to be rebuild from scratch (currently).
    // tags:
    //		private
    
    return this._criticalParamRowColumnUpToDate; // Boolean
  },

  callLayoutStepPerformedInternal : function()
  {
    // summary:
    //		Informs the layout instance that a step of the layout algorithm has
    //		been performed. 
    // description:
    //		Informs the layout instance that a step of the layout algorithm has
    //		been performed. 
    //		The method notified the listeners of the layout events. In order to
    //		automatically avoid that notification is done too often, it notifies
    //		only if there was a delay of at least 50 ms since the last
    //		notification.
    // tags:
    //		private
    
    if (this._preliminaryStopped) {
      return;
    }
    this.callLayoutStepPerformedIfNeeded();
    this._preliminaryStopped = this.isLayoutTimeElapsed() || this.isStoppedImmediately();
  },

  mayContinue : function()
  {
    // summary:
    //		Returns 'true' if the layout can continue.
    // tags:
    //		private
    
    return !this._preliminaryStopped; // Boolean
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.grid.GridLayout,
{
  _HORIZONTAL_ALIGNMENT_PROPERTY : null,

  _VERTICAL_ALIGNMENT_PROPERTY : null,

  _INDEX_PROPERTY : null,

  CENTER : null,

  LEFT : null,

  RIGHT : null,

  TOP : null,

  BOTTOM : null,

  MIXED : null,

  TILE_TO_ROWS : null,

  TILE_TO_COLUMNS : null,

  TILE_TO_GRID_FIXED_WIDTH : null,

  TILE_TO_GRID_FIXED_HEIGHT : null,

  AUTOMATIC_ORDERING : null,

  NO_ORDERING : null,

  DESCENDING_HEIGHT : null,

  ASCENDING_HEIGHT : null,

  ASCENDING_WIDTH : null,

  DESCENDING_WIDTH : null,

  ASCENDING_AREA : null,

  DESCENDING_AREA : null,

  ASCENDING_INDEX : null,

  DESCENDING_INDEX : null,

  NO_INDEX : null,

  _defaultHorizontalAlignment : null,

  _defaultVerticalAlignment : null,

  _defaultLayoutMode : null,

  _defaultIncrementalMode : null,

  _defaultHorizontalGridOffset : null,

  _defaultVerticalGridOffset : null,

  _defaultTopMargin : null,

  _defaultBottomMargin : null,

  _defaultLeftMargin : null,

  _defaultRightMargin : null,

  _defaultComparator : null,

  _defaultMaxNumberOfNodesPerRowOrColumn : null,

  _defaultNodeBoxInterface : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.grid.GridLayout;
    if(ibm_ilog.graphlayout.GraphLayout._fields_init)
      ibm_ilog.graphlayout.GraphLayout._fields_init(c);
    
    c._HORIZONTAL_ALIGNMENT_PROPERTY = "HorizontalAlignment";
    c._VERTICAL_ALIGNMENT_PROPERTY = "VerticalAlignment";
    c._INDEX_PROPERTY = "Index";
    c.CENTER = ibm_ilog.graphlayout.internalutil.AlignmentOptions.CENTER;
    c.LEFT = ibm_ilog.graphlayout.internalutil.AlignmentOptions.LEFT;
    c.RIGHT = ibm_ilog.graphlayout.internalutil.AlignmentOptions.RIGHT;
    c.TOP = ibm_ilog.graphlayout.internalutil.AlignmentOptions.TOP;
    c.BOTTOM = ibm_ilog.graphlayout.internalutil.AlignmentOptions.BOTTOM;
    c.MIXED = ibm_ilog.graphlayout.internalutil.AlignmentOptions.MIXED;
    c.TILE_TO_ROWS = ibm_ilog.graphlayout.internalutil.rowcolumngrid.LayoutModes.TILE_TO_ROWS;
    c.TILE_TO_COLUMNS = ibm_ilog.graphlayout.internalutil.rowcolumngrid.LayoutModes.TILE_TO_COLUMNS;
    c.TILE_TO_GRID_FIXED_WIDTH = ibm_ilog.graphlayout.internalutil.rowcolumngrid.LayoutModes.TILE_TO_GRID_FIXED_WIDTH;
    c.TILE_TO_GRID_FIXED_HEIGHT = ibm_ilog.graphlayout.internalutil.rowcolumngrid.LayoutModes.TILE_TO_GRID_FIXED_HEIGHT;
    c.AUTOMATIC_ORDERING = ibm_ilog.graphlayout.internalutil.rowcolumngrid.OrderingModes.AUTOMATIC_ORDERING;
    c.NO_ORDERING = ibm_ilog.graphlayout.internalutil.rowcolumngrid.OrderingModes.NO_ORDERING;
    c.DESCENDING_HEIGHT = ibm_ilog.graphlayout.internalutil.rowcolumngrid.OrderingModes.DESCENDING_HEIGHT;
    c.ASCENDING_HEIGHT = ibm_ilog.graphlayout.internalutil.rowcolumngrid.OrderingModes.ASCENDING_HEIGHT;
    c.ASCENDING_WIDTH = ibm_ilog.graphlayout.internalutil.rowcolumngrid.OrderingModes.ASCENDING_WIDTH;
    c.DESCENDING_WIDTH = ibm_ilog.graphlayout.internalutil.rowcolumngrid.OrderingModes.DESCENDING_WIDTH;
    c.ASCENDING_AREA = ibm_ilog.graphlayout.internalutil.rowcolumngrid.OrderingModes.ASCENDING_AREA;
    c.DESCENDING_AREA = ibm_ilog.graphlayout.internalutil.rowcolumngrid.OrderingModes.DESCENDING_AREA;
    c.ASCENDING_INDEX = ibm_ilog.graphlayout.internalutil.rowcolumngrid.OrderingModes.ASCENDING_INDEX;
    c.DESCENDING_INDEX = ibm_ilog.graphlayout.internalutil.rowcolumngrid.OrderingModes.DESCENDING_INDEX;
    c.NO_INDEX = -1;
    c._defaultHorizontalAlignment = ibm_ilog.graphlayout.grid.GridLayout.CENTER;
    c._defaultVerticalAlignment = ibm_ilog.graphlayout.grid.GridLayout.CENTER;
    c._defaultLayoutMode = ibm_ilog.graphlayout.grid.GridLayout.TILE_TO_GRID_FIXED_WIDTH;
    c._defaultIncrementalMode = false;
    c._defaultHorizontalGridOffset = 40.0;
    c._defaultVerticalGridOffset = 40.0;
    c._defaultTopMargin = 5;
    c._defaultBottomMargin = 5;
    c._defaultLeftMargin = 5;
    c._defaultRightMargin = 5;
    c._defaultComparator = ibm_ilog.graphlayout.grid.GridLayout.AUTOMATIC_ORDERING;
    c._defaultMaxNumberOfNodesPerRowOrColumn = /*Number.MAX_VALUE*/2147483647;
    c._defaultNodeBoxInterface = null;
  }
  
}
);

ibm_ilog.graphlayout.grid.GridLayout._getGlobalProperties = function()
{
  // tags:
  //		private
  var properties = [
    { name: 'allowedTime', defaultValue: 32000 },
    { name: 'layoutRegion', defaultValue: null },
    { name: 'preserveFixedNodes', defaultValue: false },
    { name: 'layoutMode', defaultValue: ibm_ilog.graphlayout.grid.GridLayout.TILE_TO_GRID_FIXED_WIDTH },
    { name: 'incrementalMode', defaultValue: false },
    { name: 'globalHorizontalAlignment', defaultValue: ibm_ilog.graphlayout.grid.GridLayout.CENTER },
    { name: 'globalVerticalAlignment', defaultValue: ibm_ilog.graphlayout.grid.GridLayout.CENTER },
    { name: 'nodeComparator', defaultValue: ibm_ilog.graphlayout.grid.GridLayout.AUTOMATIC_ORDERING },
    { name: 'horizontalGridOffset', defaultValue: 40 },
    { name: 'verticalGridOffset', defaultValue: 40 },
    { name: 'topMargin', defaultValue: 5 },
    { name: 'bottomMargin', defaultValue: 5 },
    { name: 'leftMargin', defaultValue: 5 },
    { name: 'rightMargin', defaultValue: 5 },
    { name: 'maxNumberOfNodesPerRowOrColumn', defaultValue: 2147483647 }
  ];
  var baseProperties = ibm_ilog.graphlayout.GraphLayout._getGlobalProperties();
  return baseProperties ? baseProperties.concat(properties) : properties;
};

ibm_ilog.graphlayout.grid.GridLayout._getNodeProperties = function()
{
  // tags:
  //		private
  var properties = [
    { name: 'fixed', defaultValue: false },
    { name: 'horizontalAlignment', defaultValue: ibm_ilog.graphlayout.grid.GridLayout.CENTER },
    { name: 'verticalAlignment', defaultValue: ibm_ilog.graphlayout.grid.GridLayout.CENTER },
    { name: 'index', defaultValue: -1 }
  ];
  var baseProperties = ibm_ilog.graphlayout.GraphLayout._getNodeProperties();
  return baseProperties ? baseProperties.concat(properties) : properties;
};

ibm_ilog.graphlayout.grid.GridLayout._getLinkProperties = function()
{
  // tags:
  //		private
  return ibm_ilog.graphlayout.GraphLayout._getLinkProperties();
};

(function(){ ibm_ilog.graphlayout.grid.GridLayout._fields_init(); })();

return dojo.getObject("ibm_ilog.graphlayout.grid.GridLayout");});
require(["ibm_ilog/graphlayout/grid/GridLayout"]);

},
'ibm_ilog*graphlayout/internalutil/LayoutUtil':function(){
define(["dojo","dijit","dojox","ibm_ilog/graphlayout/internalutil/TranslateUtil","ibm_ilog/graphlayout/IIterator"], function(dojo, dijit, dojox){
dojo.getObject("ibm_ilog.graphlayout.internalutil.LayoutUtil", 1);
/* builder delete begin
dojo.provide('ibm_ilog.graphlayout.internalutil.LayoutUtil');


 builder delete end */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.IIterator');


 builder delete end */
dojo.declare('ibm_ilog.graphlayout.internalutil.LayoutUtil', null, 
{
  // summary:
  //		This class regroups some graph layout utilities. 
  // description:
  //		This class regroups some graph layout utilities. 
  //		
  // tags:
  //		private
  
  constructor : function()
  {
    
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.internalutil.LayoutUtil,
{
  PI : null,
  TWO_PI : null,
  FLOAT_MAX_VALUE : null,
  FLOAT_POSITIVE_INFINITY : null,
  FLOAT_NEGATIVE_INFINITY : null,

  _voidEnum : null,

  _voidIter : null,

  isValidNumber : function(x, y)
  {
    return x < ibm_ilog.graphlayout.internalutil.LayoutUtil.FLOAT_MAX_VALUE && -x < ibm_ilog.graphlayout.internalutil.LayoutUtil.FLOAT_MAX_VALUE &&
      y < ibm_ilog.graphlayout.internalutil.LayoutUtil.FLOAT_MAX_VALUE && -y < ibm_ilog.graphlayout.internalutil.LayoutUtil.FLOAT_MAX_VALUE &&
      x != ibm_ilog.graphlayout.internalutil.LayoutUtil.FLOAT_POSITIVE_INFINITY && x != ibm_ilog.graphlayout.internalutil.LayoutUtil.FLOAT_NEGATIVE_INFINITY &&
      y != ibm_ilog.graphlayout.internalutil.LayoutUtil.FLOAT_POSITIVE_INFINITY && y != ibm_ilog.graphlayout.internalutil.LayoutUtil.FLOAT_NEGATIVE_INFINITY && !isNaN(x) && !isNaN(y); // Boolean
  },

  getRootModel : function(model)
  {
    var rootModel = model.getRoot();
    if (rootModel == null) {
      return model; // ibm_ilog.graphlayout.AbstractGraphLayoutModel
    }
    return rootModel; // ibm_ilog.graphlayout.AbstractGraphLayoutModel
  },

  elementAt : function(vect, index, length, reversedOrder)
  {
    return (reversedOrder ? vect[length - index - 1] : vect[index]); // Object
  },

  isEmpty : function(graphModel)
  {
    var nodes = new ibm_ilog.graphlayout.internalutil.ArrayIterator(graphModel.getNodes());
    return ((nodes == null) ? true : !nodes.hasNext()); // Boolean
  },

  getVoidEnumeration : function()
  {
    return ibm_ilog.graphlayout.internalutil.LayoutUtil._voidEnum; // ibm_ilog.graphlayout.IIterator
  },

  getVoidIterator : function()
  {
    return ibm_ilog.graphlayout.internalutil.LayoutUtil._voidIter; // ibm_ilog.graphlayout.IIterator
  },

  getEnumerationCount : function(e)
  {
    if (e == null) {
      return 0; // int
    }
    var count = 0;

    while (e.hasNext())
    {
      e.next();
      count++;
    }

    return count; // int
  },

  fixConstantModeManagerFrameAutoMargin : function(model, subgraph)
  {
  },

  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.internalutil.LayoutUtil;
    
    c.PI = Math.PI;
    c.TWO_PI = 2 * Math.PI;
    c.FLOAT_MAX_VALUE = /*Number.MAX_VALUE*/(3.4028235E38);
    c.FLOAT_POSITIVE_INFINITY = Number.POSITIVE_INFINITY;
    c.FLOAT_NEGATIVE_INFINITY = Number.NEGATIVE_INFINITY;
    c._voidEnum = new ibm_ilog.graphlayout.internalutil.LayoutUtil.IlvVoidEnumeration();
    c._voidIter = new ibm_ilog.graphlayout.internalutil.LayoutUtil.IlvVoidIterator();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.internalutil.LayoutUtil.IlvVoidEnumeration', ibm_ilog.graphlayout.IIterator, 
{

  constructor : function()
  {
    
  },
  hasMoreElements : function()
  {
    return false; // Boolean
  },

  nextElement : function()
  {
    throw new Error("IlvVoidEnumeration"); // Object
  }

}
);
dojo.declare('ibm_ilog.graphlayout.internalutil.LayoutUtil.IlvVoidIterator', ibm_ilog.graphlayout.IIterator, 
{

  constructor : function()
  {
    
  },
  hasNext : function()
  {
    return false; // Boolean
  },

  next : function()
  {
    throw new Error("IlvVoidIterator"); // Object
  },

  remove : function()
  {
  }

}
);

(function(){ ibm_ilog.graphlayout.internalutil.LayoutUtil._fields_init(); })();

return dojo.getObject("ibm_ilog.graphlayout.internalutil.LayoutUtil");});
require(["ibm_ilog/graphlayout/internalutil/LayoutUtil"]);

},
'ibm_ilog*graphlayout/internalutil/LinkStyles':function(){
define(["dojo","dijit","dojox","ibm_ilog/graphlayout/internalutil/TranslateUtil"], function(dojo, dijit, dojox){
dojo.getObject("ibm_ilog.graphlayout.internalutil.LinkStyles", 1);
/* builder delete begin
dojo.provide('ibm_ilog.graphlayout.internalutil.LinkStyles');


 builder delete end */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');


 builder delete end */
dojo.declare('ibm_ilog.graphlayout.internalutil.LinkStyles', null, 
{
  // summary:
  //		This class contains all enumeration constants used for any link
  //		styles. 
  // description:
  //		This class contains all enumeration constants used for any link
  //		styles. 
  //		This ensures that ALL setLinkStyle or setGlobalLinkStyle of ALL
  //		layout algorithms. It also contains some generic support for the link
  //		styles.  
  // tags:
  //		private
  
  constructor : function()
  {
    
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.internalutil.LinkStyles,
{
  NO_RESHAPE_STYLE : null,
  STRAIGHT_LINE_STYLE : null,
  ORTHOGONAL_STYLE : null,
  POLYLINE_STYLE : null,
  DIRECT_STYLE : null,
  TWO_BENDS_ORTHOGONAL_STYLE : null,
  THREE_BENDS_ORTHOGONAL_STYLE : null,

  MIXED_STYLE : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.internalutil.LinkStyles;
    
    c.NO_RESHAPE_STYLE = 0;
    c.STRAIGHT_LINE_STYLE = 1;
    c.ORTHOGONAL_STYLE = 2;
    c.POLYLINE_STYLE = 3;
    c.DIRECT_STYLE = 4;
    c.TWO_BENDS_ORTHOGONAL_STYLE = 5;
    c.THREE_BENDS_ORTHOGONAL_STYLE = 6;
    c.MIXED_STYLE = 99;
  }
  
}
);

(function(){ ibm_ilog.graphlayout.internalutil.LinkStyles._fields_init(); })();

return dojo.getObject("ibm_ilog.graphlayout.internalutil.LinkStyles");});
require(["ibm_ilog/graphlayout/internalutil/LinkStyles"]);

},
'ibm_ilog*graphlayout/nls/messages':function(){
define({root:
// NLS_CHARSET=UTF-8

({

  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer

  // Message ranges
  //
  // ilog.views.graphlayout  6000 - 6259 (lots free)
  // genericquadtree         6260 - 6279
  // rowcolumngrid           6280 - 6299
  // bus                     6300 - 6324
  // circular                6325 - 6374
  // grid                    6375 - 6399
  // hierarchical            6400 - 6449
  // multiple                6450 - 6459
  // random                  6460 - 6469
  //
  // link                    6475 - 6499 (not yet)
  // longlink                6550 - 6599
  // shortlink               6600 - 6674
  // recursive               6675 - 6699
  // tree                    6700 - 6749
  // uniform                 6750 - 6774
  // topomesh                6775 - 6799 (not yet)
  // labellayout             6800 - 6899 (not yet)
  // labellayout.annealing   6900 - 6949 (not yet)
  // labellayout.random      6950 - 6960 (not yet)


  //###############################################################
  // Property file for circular layout
  //###############################################################
  // ibm_ilog.graphlayout.circular
  // Message Range: 6325-6374
  //###############################################################

  // Scenario: This error occurs if circular layout is applied in mode
  // cluster by IDs, but no cluster IDs are found in the graph.
  // Required action: Specify cluster IDs or use a different clustering mode
  graphlayout_expert_message_6325E : "CWZDD6325E: No cluster found. You must provide clustering information.",

  // Scenario: This error occurs when the clustering mode property for
  // circular layout is set to an invalid value.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6326E : "CWZDD6326E: Unsupported clustering mode option: ${0}.",

  // Scenario: This error occurs when the cluster ID property for
  // circular layout is set to null.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6327E : "CWZDD6327E: Cluster ID must not be null.",

  // Scenario: This error occurs when the index of a node in a cluster for
  // circular layout is set to a negative value.
  // Required action: Use a positive value.
  graphlayout_expert_message_6328E : "CWZDD6328E: Index must not be negative.",

  // Scenario: This error occurs when information for a cluster of 
  // circular layout is queried by an index that does not exist.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6329E : "CWZDD6329E: Cluster index ${0} must be at least a value of 0 and smaller than the number of clusters (${1}).",

  // Scenario: This error occurs when information for a null node of 
  // circular layout is queried.
  // Required action: Choose a different node.
  graphlayout_expert_message_6330E : "CWZDD6330E: Node must not be null.",

  // Scenario: This error occurs when information for a node of 
  // circular layout is queried, but this node is no longer in the graph.
  // Required action: Choose a different node.
  graphlayout_expert_message_6331E : "CWZDD6331E: Node is not in the attached graph.",

  // Scenario: This error occurs when information for a node of a cluster of
  // circular layout is queried, but this node is not in that cluster.
  // Required action: Choose a different node.
  graphlayout_expert_message_6332E : "CWZDD6332E: Node is not in the cluster ${0}.",

  // Scenario: This error occurs when a layout property of circular layout
  // is set to a negative value when only positive values are allowed.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6333E : "CWZDD6333E: Negative value ${0} not allowed.",

  // Scenario: This error occurs when the link style parameter
  // is set to an unsupported value.
  // Required action: Verify that a valid value is used to set
  // the link style parameter.
  graphlayout_expert_message_6334E : "CWZDD6334E: Unsupported link style: ${0}.",

  // Scenario: This error occurs when the multilink mode parameter
  // is set to an unsupported value.
  // Required action: Verify that a valid value is used to set
  // the multilink mode parameter.
  graphlayout_expert_message_6335E : "CWZDD6335E: Unsupported multilink mode: ${0}.",

  // Scenario: This error occurs when the value of a spacing property is
  // set to a negative value, but this spacing property does not support
  // negative values.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6336E : "CWZDD6336E: Unsupported negative value: ${0}.",


  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer


  //###############################################################
  // Property file for grid layout
  //###############################################################
  // ibm_ilog.graphlayout.grid
  // Message Range: 6375-6399
  //###############################################################

  //
  //
  //
  //
  //
  //
  //

  // Scenario: This error occurs when you set the value of the
  // property layoutMode in a Grid layout with an incorrect value.
  // Required action: Verify that the value provided to property 
  // layoutMode in Grid layout is one of the possible values.
  graphlayout_expert_message_6376E : "CWZDD6376E: Invalid layout mode: ${0}.",

  // Scenario: This error occurs when you set the value of the
  // property globalHorizontalAlignment in a Grid layout with an incorrect value.
  // Required action: Verify that the value provided to property 
  // globalHorizontalAlignment in Grid layout is one of the possible values.
  graphlayout_expert_message_6377E : "CWZDD6377E: Invalid global horizontal alignment value: ${0}.",

  // Scenario: This error occurs when you set the value of the
  // horizontal alignment parameter in a Grid layout with an incorrect value.
  // Required action: Verify that the value provided to horizontal 
  // alignment parameter in Grid layout is one of the possible values.
  graphlayout_expert_message_6378E : "CWZDD6378E: Invalid horizontal alignment value: ${0}.",

  // Scenario: This error occurs when you set the value of the
  // property globalVerticalAlignment in a Grid layout with an incorrect value.
  // Required action: Verify that the value provided to property 
  // globalVerticalAlignment in Grid layout is one of the possible values.
  graphlayout_expert_message_6379E : "CWZDD6379E: Invalid global vertical alignment value: ${0}.",

  // Scenario: This error occurs when you set the value of the
  // vertical alignment parameter in a Grid layout with an incorrect value.
  // Required action: Verify that the value provided to vertical 
  // alignment parameter in Grid layout is one of the possible values.
  graphlayout_expert_message_6380E : "CWZDD6380E: Invalid vertical alignment value: ${0}.",

  // Scenario: This error occurs when you set the value of the
  // index parameter in a Grid layout with an incorrect value.
  // Required action: Verify that the value provided to index 
  // parameter in Grid layout is one of the possible values.
  graphlayout_expert_message_6381E : "CWZDD6381E: Invalid index: ${0}.",

  // Scenario: This error occurs when you set the value of the
  // horizontal grid offset parameter in a Grid layout to a value
  // that is too small.
  // Required action: Verify that the value provided to parameter 
  // horizontal grid offset is bigger than 0.01.
  graphlayout_expert_message_6382E : "CWZDD6382E: The value ${0} of parameter horizontal grid offset is too small.",

  // Scenario: This error occurs when you set the value of the
  // vertical grid offset parameter in a Grid layout to a value
  // that is too small.
  // Required action: Verify that the value provided to parameter 
  // vertical grid offset is bigger than 0.01.
  graphlayout_expert_message_6383E : "CWZDD6383E: The value ${0} of parameter vertical grid offset is too small.",

  // Scenario: This error occurs when you set the value of the
  // maximum number of nodes per row or column in a Grid layout to a value
  // that is lower than one.
  // Required action: Verify that the value provided to parameter 
  // maxNumberOfNodesPerRowOrColumn is valid.
  graphlayout_expert_message_6384E : "CWZDD6384E: The maximum number of nodes must be at least one.",



  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer


  //###############################################################
  // Property file for hierarchical layout
  //###############################################################
  // ibm_ilog.graphlayout.hierarchical
  // Message Range: 6400-6449
  //###############################################################

  // Scenario: This error occurs when a unsupported method is called.
  // Required action: This method must not be used.
  graphlayout_expert_message_6400E : "CWZDD6400E: This operation is not supported.",

  // Scenario: This error occurs when an infinite loop occurs
  // in class algorithm when breaking the cycles that are not
  // self-loops or 2-cycles.
  // Required action: Verify that the graph layout model has
  // a correct structure. 
  graphlayout_expert_message_6401E : "CWZDD6401E: An infinite loop has occurred in algorithm.",

  // Scenario: This error occurs when an invalid value is specified
  // for parameter connector style in Hierarchical layout.
  // Required action: Verify that the connector style property
  // has a correct value.
  graphlayout_expert_message_6402E : "CWZDD6402E: Illegal connector style value.",

  // Scenario: This error occurs when trying to iterate over the
  // nodes of a link instance.
  // Required action: Verify that the graph layout model is
  // correctly created.
  graphlayout_expert_message_6403E : "CWZDD6403E: This operation must not occur with a link argument.",

  // Scenario: This error occurs when you can no longer iterate over
  // the list of segments.
  // Required action: Verify that the graph layout model is
  // correctly created.
  graphlayout_expert_message_6404E : "CWZDD6404E: Reached the end of the list of segments.",

  // Scenario: This error occurs when the graph layout model contains
  // objects that are neither nodes or links.
  // Required action: Verify that the graph layout model is
  // correctly created.
  graphlayout_expert_message_6405E : "CWZDD6405E: Object must be a node or a segment.",

  // Scenario: This error occurs when the flow direction property is
  // set to an invalid value.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6406E : "CWZDD6406E: Unsupported flow direction option: ${0}.",

  // Scenario: This error occurs when the leveling strategy property is
  // set to an invalid value.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6407E : "CWZDD6407E: Unsupported leveling strategy value: ${0}.",

  // Scenario: This error occurs when the level justification property is
  // set to an invalid value.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6408E : "CWZDD6408E: Unsupported level justification value: ${0}.",

  // Scenario: This error occurs when the connector style property is
  // set to an invalid value.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6409E : "CWZDD6409E: Unsupported connector style value: ${0}.",

  // Scenario: This error occurs when the global link style property is
  // set to an invalid value.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6410E : "CWZDD6410E: Unsupported global link style value: ${0}.",

  // Scenario: This error occurs when the link style property is
  // set to an invalid value.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6411E : "CWZDD6411E: Unsupported link style value: ${0}.",

  // Scenario: This error occurs when the value of a spacing property is
  // set to a negative value, but this spacing property does not support
  // negative values.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6412E : "CWZDD6412E: Unsupported negative value: ${0}.",

  // Scenario: This error occurs when the value of aperture angle property
  // is set to an invalid value.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6413E : "CWZDD6413E: The aperture angle value must be between 10 and 90.",

  // Scenario: This error occurs when the side that is used to specify the number
  // of ports in a node is invalid.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6414E : "CWZDD6414E: Unsupported node side option: ${0}.",

  // Scenario: This error occurs when value of the origin point mode property
  // is invalid.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6415E : "CWZDD6415E: Unsupported origin point mode value: ${0}.",

  // Scenario: This error occurs when value of the destination point mode property
  // is invalid.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6416E : "CWZDD6416E: Unsupported destination point mode value: ${0}.",

  // Scenario: This error occurs when the value of the 
  // incrementalAbsoluteLevelPositionTendency property is invalid.
  // Required action: Verify that a value between 0 and 100 is used.
  graphlayout_expert_message_6417E : "CWZDD6417E: Unsupported value ${0} for the incrementalAbsoluteLevelPositionTendency property. The value must be between 0 and 100.",

  // Scenario: This error occurs when value of the 
  // incrementalNodeMovementMode property is invalid.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6418E : "CWZDD6418E: Unsupported value ${0} for mode.",



  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer


  //###############################################################
  // Property file for long link layout
  //###############################################################
  // ibm_ilog.graphlayout.longlink
  // Message Range: 6550-6599
  //###############################################################

  // Scenario: This error occurs when setting the value of
  // Long Link Layout parameter horizontalGridOffset to a negative
  // or zero value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6550E : "CWZDD6550E: Negative or zero horizontal grid offset in Long Link Layout: ${0}.",

  // Scenario: This error occurs when setting the value of
  // Long Link Layout parameter verticalGridOffset to a negative
  // or zero value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6551E : "CWZDD6551E: Negative or zero vertical grid offset in Long Link Layout: ${0}.",

  // Scenario: This error occurs when setting the value of the
  // horizontalGridBase Long Link Layout parameter to a negative
  // value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6552E : "CWZDD6552E: Negative horizontal base coordinate of the grid in Long Link Layout: ${0}.",

  // Scenario: This error occurs when setting the value of the
  // verticalGridBase Long Link Layout parameter to a negative
  // value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6553E : "CWZDD6553E: Negative vertical base coordinate of the grid in Long Link Layout ${0}.",

  // Scenario: This error occurs when setting the value of the
  // horizontalMinOffset Long Link Layout parameter to a negative
  // value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6554E : "CWZDD6554E: Negative minimum horizontal offset in Long Link Layout: ${0}.",

  // Scenario: This error occurs when setting the value of the
  // verticalMinOffset Long Link Layout parameter to a negative
  // value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6555E : "CWZDD6555E: Negative minimum vertical offset in Long Link Layout: ${0}.",


  // Scenario: This error occurs when setting the value of the
  // minNodeCornerOffset Long Link Layout parameter to a negative
  // value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6556E : "CWZDD6556E: Negative minimum node corner offset in Long Link Layout: ${0}.",

  // Scenario: This error occurs when setting the value of the
  // minStartSegmentLength Long Link Layout parameter to a negative
  // value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6557E : "CWZDD6557E: Negative minimum start segment length in Long Link Layout: ${0}.",

  // Scenario: This error occurs when setting the value of the
  // minEndSegmentLength Long Link Layout parameter to a negative
  // value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6558E : "CWZDD6558E: Negative minimum end segment length in Long Link Layout: ${0}.",

  // Scenario: This error occurs when setting the value of the
  // allowedTime per link Long Link Layout parameter to a negative
  // or zero value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6559E : "CWZDD6559E: Allowed time in Long Link Layout cannot be negative or zero.",

  // Scenario: This error occurs when setting the value of the
  // maxBacktrack Long Link Layout parameter to a negative
  // value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6560E : "CWZDD6560E: Negative maximum number of backtrack steps in Long Link Layout: ${0}.",

  // Scenario: This error occurs when setting the value of the
  // globalLinkStyle Long Link Layout parameter to an invalid value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6561E : "CWZDD6561E: Unsupported link style in Long Link Layout: ${0}.",

  // Scenario: This error occurs when setting the value of the 
  // link style Long Link Layout parameter for a specific link instance
  // to an invalida value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6562E : "CWZDD6562E: Unsupported link style parameter value for a link instance in Long Link Layout: ${0}.",

  // Scenario: This error occurs when setting the value of the link style Long
  // Link Layout parameter for a specific link instance
  // to an invalid value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6563E : "CWZDD6563E: Negative number of crossing iterations in Long Link Layout: ${0}.",

  // Scenario: This error occurs when setting the value of the globalOriginPointMode Long
  // Link Layout parameter to an invalid value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6564E : "CWZDD6564E: Unsupported mode for the connection point of the links on the origin nodes in Long Link Layout: ${0}.",

  // Scenario: This error occurs when setting the value of the globalDestinationPointMode Long
  // Link Layout parameter to an invalid value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6565E : "CWZDD6565E: Unsupported mode for the connection point of the links on the destination nodes in Long Link Layout: ${0}.",

  // Scenario: This error occurs when setting the value of Long
  // Link Layout parameter origin point mode of a specific link
  // instance to an invalid value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6566E : "CWZDD6566E: Unsupported mode for the connection point of a link instance on the origin node in Long Link Layout: ${0}.",

  // Scenario: This error occurs when setting the value of Long
  // Link Layout parameter destination point mode of a specific link
  // instance to an invalid value.
  // Required action: Verify that property is set to an appropriate value.
  graphlayout_expert_message_6567E : "CWZDD6567E: Unsupported mode for the connection point of a link instance on the destination node in Long Link Layout: ${0}.",

  // Scenario: This error occurs when adding a line obstacle
  // whose bounds do not correspond to a line. A line has either
  // the width or the height as a value of zero.
  // Required action: Verify that the obstacle being added is correct.
  graphlayout_expert_message_6568E : "CWZDD6568E: Line obstacle must have zero width or zero height in Long Link Layout.",




  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer


  //###############################################################
  // Property file for short link layout
  //###############################################################
  // ibm_ilog.graphlayout.shortlink
  // Message Range: 6600-6649
  //###############################################################

  // Scenario: This errors occurs when there are no links to 
  // route by Short Link layout.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6600E : "CWZDD6600E: Combinatorial optimization variables cannot be null in Short Link Layout.",

  // Scenario: This error occurs when counting the crossings between
  // link and the other links and nodes, but the link data is not available.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6601E : "CWZDD6601E: Link data cannot be null in Short Link Layout.",

  // Scenario: This error occurs when the link data created by
  // Short Link layout to represent a link is missing the shape
  // information.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6602E : "CWZDD6602E: Link data is missing shape information in Short Link Layout.",

  // Scenario: This error occurs when the Short link layout is
  // computing the new link shape and the link has only two points.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6603E : "CWZDD6603E: Cannot refine a link with less than three points in Short Link Layout.",

  // Scenario: This error occurs when the incremental link reshape
  // model parameter is configured with an invalid value in 
  //Short link layout.
  // Required action: Verify that incremental link reshape mode is
  // correctly set.
  graphlayout_expert_message_6604E : "CWZDD6604E: Unexpected incremental link reshape mode in Short Link Layout: ${0}.",

  // Scenario: This error occurs when start node or end node
  // is not correctly specified in Short link layout.
  // Required action: Verify that the graph layout model is correct.
  graphlayout_expert_message_6605E : "CWZDD6605E: Link from or to node side cannot be null in Short Link Layout.",

  // Scenario: This error occurs when Short link layout cannot
  // find link shapes that are allowed for the links in the model.
  // Required action: Verify that the graph layout model is correct.
  graphlayout_expert_message_6606E : "CWZDD6606E: Short Link Layout cannot find link shapes allowed for the links.",

  // Scenario: This error occurs when trying to retrieve the 
  // link shapes before having computed them in Short link layout. 
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6607E : "CWZDD6607E: Shape types need to be calculated prior to retrieving their values in Short Link Layout.",

  // Scenario: This error occurs when trying to retrieve the 
  // link shape based on an index that is equal or greater to
  // the maximum index. 
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6608E : "CWZDD6608E: Shape type index ${0} is equal or greater than the available number of shape types ${1} in Short Link Layout.",

  // Scenario: This error occurs when trying to retrieve link information
  // and the link has less than two points specifying its path.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6609E : "CWZDD6609E: Link has less than two points: ${0}.",

  // Scenario: This error occurs when applying an offset to the 
  // points of this link, but the number of link points is not
  // the same as the number of points to which the offset will
  // be applied.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6610E : "CWZDD6610E: Cannot apply an offset if number of points differ: ${0} and ${1}.",

  // Scenario: This error occurs when applying an offset to the 
  // points of this link but the number of master bend points is not
  // the same as the number of bends.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6611E : "CWZDD6611E: Cannot apply an offset if the length of masterBendPoints (${0}) is smaller than the number of bends ${1}.",

  // Scenario: This error occurs when applying an offset 
  // to a horizontal or vertical segment, but the link is not
  // orthogonal.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6612E : "CWZDD6612E: ApplyOrthogonalOffset can only be applied to orthogonal shapes.",

  // Scenario: This error occurs when requesting to restore the link
  // shape on slave links.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6613E : "CWZDD6613E: Internal error: This method cannot be called for slave links.",

  // Scenario: This error occurs when requesting information about link 
  // end points prior to setting the end points in the link.
  // Required action: Verify that the link has correct end points specified
  // before querying end point information.
  graphlayout_expert_message_6614E : "CWZDD6614E: Specify from node side prior to querying information about start and end nodes in a link.",

  // Scenario: This error occurs when asking if a link intersects \
  // with itself.
  // Required action: Verify that the correct link argument is used
  // when querying intersection information.
  graphlayout_expert_message_6615E : "CWZDD6615E: Cannot request intersection information for the same link.",

  // Scenario: This error occurs when the Short Link Layout is null \
  // during layout start.
  // Required action: Verify that the correct link layout is used.
  graphlayout_expert_message_6616E : "CWZDD6616E: Short Link Layout cannot be null.",

  // Scenario: This error occurs when the Short Link Layout creates a \
  // link shape for a certain link with a negative number of bends.
  // Required action: This is an internal error. Contact support for
  // assistance.
  graphlayout_expert_message_6617E : "CWZDD6617E: Maximum number of bends cannot be negative: ${0}.",

  // Scenario: This error occurs when creating a Link Data that is 
  // not a fixed link.
  // Required action: This is an internal error. Contact support for
  // assistance.
  graphlayout_expert_message_6618E : "CWZDD6618E: Use this operation only by fixed links.",

  // Scenario: This error occurs when creating a Link Data that is 
  // a multiple link bundle.
  // Required action: This is an internal error. Contact support for
  // assistance.
  graphlayout_expert_message_6619E : "CWZDD6619E: This operation is not intended for multilink bundles.",

  // Scenario: This error occurs when a subclass of IGraphLayoutModel
  // is created and does not implement the getLinkPoints method correctly.
  // Required action: Verify that you correctly implement the getLinkPoints method
  // in your graph layout model implementation.
  graphlayout_expert_message_6620E : "CWZDD6620E: The getLinkPoints method called on ${0} for the link ${1} returned an array of length ${2}, while it must return an array of length at least 2.",

  // Scenario: This error occurs when retrieving a link point based
  // on an index and the index argument is out of bounds.
  // Required action: Verify that the method call uses the correct argument.
  graphlayout_expert_message_6621E : "CWZDD6621E: Array index out of bounds when retrieving a link point.",


  // Scenario: This error occurs when an incorrect link shape is produced.
  // Required action: This is an internal error. Contact support for
  // assistance.
  graphlayout_expert_message_6622E : "CWZDD6622E: Internal error: expected quasi self-intergraph link.",

  // Scenario: This error occurs the node side when the link is
  // connected and is not supported.
  // Required action: Verify that you use a value node side value.
  graphlayout_expert_message_6623E : "CWZDD6623E: Unsupported node side ${0} in Short Link Layout.",

  // Scenario: This error occurs when the self link style specified for a
  // link is not supported.
  // Required action: Verify that you use a valid self link style value.
  graphlayout_expert_message_6624E : "CWZDD6624E: Unsupported self link style ${0} in Short Link Layout.",

  // Scenario: This error occurs when the filter that is set on the
  // Short Link Layout has rejected all possible combinations of node
  // side for a link.
  // Required action: Verify that the node side filter is correctly 
  // implemented.
  graphlayout_expert_message_6625E : "CWZDD6625E: The node side filter has rejected all the combinations of node side for the link.",

  // Scenario: This error occurs when the link is fixed to a 
  // destination side that is not one of the possible values. 
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6626E : "CWZDD6626E: Unsupported destination side: ${0}.",

  // Scenario: This error occurs when the link is fixed to an
  // origin side that is not one of the possible values. 
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6627E : "CWZDD6627E: Unsupported origin side: ${0}.",

  // Scenario: This error occurs when the link is fixed to a
  // origin side that is not one of the possible values. 
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6628E : "CWZDD6628E: Unsupported fixed origin side: ${0}.",

  // Scenario: This error occurs when the link is fixed to a
  // destination side that is not one of the possible values. 
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6629E : "CWZDD6629E: Unsupported fixed destination side: ${0}.",

  // Scenario: This error occurs when querying the node side to 
  // which <code>point</code> is the closest. 
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6630E : "CWZDD6630E: Unsupported node side in Short Link Layout: ${0}.",

  // Scenario: This error occurs when the number of points in 
  // the link is not enough to enable the Short Link Layout
  // algorithm to refine its shape. 
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6631E : "CWZDD6631E: Cannot refine a link with less than three points.",

  //
  //
  //
  //
  //
  //
  //
  //

  // Scenario: This error occurs when the value of the globalLinkStyle parameter
  // in the Short Link Layout is not in the list of
  // possible values.
  // Required action: Verify that the correct value is used for
  // the parameter.
  graphlayout_expert_message_6633E : "CWZDD6633E: Unsupported global link style in Short Link Layout: ${0}. ",

  // Scenario: This error occurs when the value of the globalLinkStyle parameter
  // in the Short Link Layout is not in the list of
  // possible values.
  // Required action: Verify that the correct value is used for
  // the parameter.
  graphlayout_expert_message_6634E : "CWZDD6634E: Unsupported individual link style ${0} for link ${1} in Short Link Layout. ",

  //
  //
  //
  //
  //
  //
  //

  // Scenario: This error occurs when a link that is not a multilink
  // data indicates that it is a master link. 
  // Required action: This is an internal error. Contact support for
  // assistance.
  graphlayout_expert_message_6636E : "CWZDD6636E: Internal error: isMaster returns true on ${0}.",

  // Scenario: This error occurs when the global or individual
  // origin point mode parameter is set to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout origin point mode.
  graphlayout_expert_message_6637E : "CWZDD6637E: Unsupported origin point mode in Short Link Layout: ${0}.",
 
  // Scenario: This error occurs when the global or individual 
  // destination point mode parameter is set to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout destination point mode.
  graphlayout_expert_message_6638E : "CWZDD6638E: Unsupported destination point mode in Short Link Layout: ${0}.",

  // Scenario: This error occurs when the global link style
  // parameter is set to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout global link style.
  graphlayout_expert_message_6639E : "CWZDD6639E: Unsupported global link style in Short Link Layout: ${0}.",

  // Scenario: This error occurs when the individual link style
  // parameter for a link instance is set to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout link style for individual links.
  graphlayout_expert_message_6640E : "CWZDD6640E: Unsupported individual link style in Short Link Layout: ${0}.",

  // Scenario: This error occurs when the global self link style
  // parameter is set to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout global self link style.
  graphlayout_expert_message_6641E : "CWZDD6641E: Unsupported self link style in Short Link Layout: ${0}.",

  // Scenario: This error occurs when the connector style
  // parameter is set to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout connector style.
  graphlayout_expert_message_6642E : "CWZDD6642E: Unsupported connector style in Short Link Layout: ${0}.",

  // Scenario: This error occurs when the evenlySpacedPinsMarginRatio
  // parameter is set to a negative value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout evenlySpacedPinsMarginRatio .
  graphlayout_expert_message_6643E : "CWZDD6643E: Evenly spaced pins margin ratio must not be negative in Short Link Layout: ${0}.",

  // Scenario: This error occurs when the linkBundlesMode
  // parameter is set to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout linkBundlesMode.
  graphlayout_expert_message_6644E : "CWZDD6644E: Unsupported link bundles mode in Short Link Layout: ${0}.",

  // Scenario: This error occurs when the globalIncrementalUnmodifiedLinkReshapeMode
  // parameter is set to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout globalIncrementalUnmodifiedLinkReshapeMode.
  graphlayout_expert_message_6645E : "CWZDD6645E: Unsupported globalIncrementalUnmodifiedLinkReshapeMode property in Short Link Layout: ${0}.",

  // Scenario: This error occurs when the individual 
  // incrementalUnmodifiedLinkReshapeMode parameter is set 
  // to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout incrementalUnmodifiedLinkReshapeMode
  // for individual links.
  graphlayout_expert_message_6646E : "CWZDD6646E: Unsupported incrementalUnmodifiedLinkReshapeMode property in Short Link Layout: ${0}.",

  // Scenario: This error occurs when the globalIncrementalModifiedLinkReshapeMode
  // parameter is set to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout globalIncrementalModifiedLinkReshapeMode.
  graphlayout_expert_message_6647E : "CWZDD6647E: Unsupported globalIncrementalModifiedLinkReshapeMode property in Short Link Layout: ${0}.",

  // Scenario: This error occurs when the individual 
  // incrementalModifiedLinkReshapeMode parameter is set 
  // to an invalid value. 
  // Required action: Verify that you have correctly configured
  // the Short Link Layout incrementalModifiedLinkReshapeMode
  // for individual links.
  graphlayout_expert_message_6648E : "CWZDD6648E: Unsupported incrementalModifiedLinkReshapeMode property in Short Link Layout: ${0}.",

  // Scenario: This error occurs when the maximum number of
  // iterations that are configured is negative.
  // Required action: Verify that you have correctly configured
  // the Short Link Layout maximum number of iterations.
  graphlayout_expert_message_6649E : "CWZDD6649E: Negative maximum number of iterations of the Short Link Layout: ${0}.",


  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer

  // Message ranges
  //
  // ilog.views.graphlayout  6000 - 6259 (lots free)
  // genericquadtree         6260 - 6279
  // rowcolumngrid           6280 - 6299
  // bus                     6300 - 6324
  // circular                6325 - 6374
  // grid                    6375 - 6399
  // hierarchical            6400 - 6449
  // multiple                6450 - 6459
  // random                  6460 - 6469
  //
  // link                    6475 - 6499 (not yet)
  // longlink                6550 - 6599
  // shortlink               6600 - 6674
  // recursive               6675 - 6699
  // tree                    6700 - 6749
  // uniform                 6750 - 6774
  // topomesh                6775 - 6799 (not yet)
  // labellayout             6800 - 6899 (not yet)
  // labellayout.annealing   6900 - 6949 (not yet)
  // labellayout.random      6950 - 6960 (not yet)




  //###############################################################
  // Property file for graph layout
  //###############################################################
  // ibm_ilog.graphlayout
  // Message Range: 6000-6102
  //###############################################################

  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //


  // Scenario: This error occurs when you pass a null graph layout model
  // to an API.
  // This error is thrown by 
  // ibm_ilog.graphlayout.DefaultLayoutProvider
  // and ibm_ilog.graphlayout.GraphLayout
  // Required action: Verify that the correct graph layout model is used.
  //
  graphlayout_expert_message_6012E : "CWZDD6012E: Graph model cannot be null.",
 
  // Scenario: This error occurs when a graph layout model that is already disposed 
  // is associated with a preferred layout.
  // This error is thrown
  // by ibm_ilog.graphlayout.DefaultLayoutProvider.
  // Required action: Verify that the correct graph layout model is used.
  graphlayout_expert_message_6013E : "CWZDD6013E: You cannot set the preferred layout for a graph model that is already disposed.",

  // Scenario: This error occurs when a preferred layout that is associated to
  // a graph layout model is set and does not correspond to the original 
  // graph layout used to create the graph layout model. This error is thrown
  // by ibm_ilog.graphlayout.DefaultLayoutProvider.
  // Required action: Verify that the correct graph layout model is used.
  graphlayout_expert_message_6014E : "CWZDD6014E: Should not be called for a model that is internally created by another layout; ${0} has not been created by ${1} by the specified preferred layout: ${2}",

  // Scenario: This error occurs when you retrieve a graph layout that is associated
  // to a graph layout model, but the graph layout is attached to another
  // graph layout model that is already disposed. This error occurs
  // when there is misuse of dispose and detach. This error is thrown
  // by ibm_ilog.graphlayout.DefaultLayoutProvider.
  // Required action: Verify the correct use of dispose when handling
  // graph layout model instances.
  graphlayout_expert_message_6015E : "CWZDD6015E: The preferred layout is attached to a disposed graph layout model. Detach the layout before disposing any graph layout model.",
 
  // Scenario: This error occurs when attempting to attach a graph layout model
  // to a graph layout instance, and the graph layout model has been internally
  // created by another layout instance.
  // Required action: Verify that the correct graph layout model instance
  // is used.
  graphlayout_expert_message_6016E : "CWZDD6016E: Cannot attach an internally created model: ${0}.",

  // Scenario: When a layout instance is controlled by IlvDefaultLayoutProvider,
  // the provider registers itself on the layout to enable
  // the layout to perform cleaning operations in the detach method. This error 
  // occurs when the layout provider is registered with an invalid value.
  // This is an internal error.
  // Required action: Contact support for assistance.
  //
  graphlayout_expert_message_6017E : "CWZDD6017E: Illegal situation.",

  // Scenario: This error occurs when a method of the GraphLayout class
  // is used, but the graph layout model that is attached to the graph layout
  // instance is not specified.
  // Required action: Verify that a valid graph layout model is used.
  graphlayout_expert_message_6018E : "CWZDD6018E: No attached graph layout model or the graph layout model is null.",

  // Scenario: This error occurs when attempting to perform a graph layout
  // while it is still performing a previous request.
  // Required action: Perform a graph layout only when the previous graph
  // layout process ends.
  graphlayout_expert_message_6019E : "CWZDD6019E: You cannot start this layout while it is running.",

  // Scenario: This error occurs when the graph layout does not succeed
  // in creating a graph layout report.
  // Required action: Verify that method createLayoutReport is correctly implemented.
  graphlayout_expert_message_6020E : "CWZDD6020E: Failed to create the layout report.",

  // Scenario: This error occurs when a graph layout incorrectly assumes that
  // there are several connected components, but there is only one connected component.
  // Required action: Verify that the contents of the graph layout model is correct.
  graphlayout_expert_message_6021E : "CWZDD6021E: Unexpected number (too small) of connected components: ${0}.",

  // Scenario: This error occurs when a new graph layout algorithm implements
  // without overriding the method layout.
  // Required action: Implement the method layout in the GraphLayout subclass.
  graphlayout_expert_message_6022E : "CWZDD6022E: This subclasses must override the method.",

  // Scenario: This error occurs when an invalid value is used to set the 
  // GraphLayout.coordinatesMode property.
  // Required action: Verify that the value used to set GraphLayout.coordinatesMode property is among the possible values.
  graphlayout_expert_message_6023E : "CWZDD6023E: Unsupported coordinates mode: ${0}.",

  // Scenario: This error occurs when attempting to tell the graph layout to
  // preserve node position when layout does not support this feature.
  // Required action: Verify that the layout is the correct one.
  graphlayout_expert_message_6024E : "CWZDD6024E: This layout class does not support fixed nodes preservation.",

  // Scenario: This error occurs when attempting to tell the graph layout to
  // preserve link position when layout does not support this feature.
  // Required action: Verify that the layout is the correct one.
  graphlayout_expert_message_6025E : "CWZDD6025E: This layout class does not support fixed links preservation.",

  // Scenario: This error occurs when attempting to tell the graph layout to
  // handle connected components when layout does not support this feature.
  // Required action: Verify that the layout is the correct one.
  graphlayout_expert_message_6026E : "CWZDD6026E: This layout class does not support the connected components layout mechanism.",

  // Scenario: This error occurs when attempting to tell the graph layout to
  // handle a specific layout region when layout does not support this feature.
  // Required action: Verify that the layout is the correct one.
  graphlayout_expert_message_6027E : "CWZDD6027E: This layout class does not support the layout region mechanism.",

  // Scenario: This error occurs when attempting to tell the graph layout to
  // use a random generator seed value when layout does not support this feature.
  // Required action: Verify that the layout is the correct one.
  graphlayout_expert_message_6028E : "CWZDD6028E: This layout class does not support the random generator seed value mechanism.",

  // Scenario: This error occurs when attempting to tell the graph layout to
  // respect an allowed time configuration when layout does not support this feature.
  // Required action: Verify that the layout is the correct one.
  graphlayout_expert_message_6029E : "CWZDD6029E: This layout class does not support the allowed time mechanism.",

  // Scenario: This error occurs when attempting to set a negative value to
  // the GraphLayout.allowedTime property.
  // Required action: Verify that property allowedTime is assigned to a positive value.
  graphlayout_expert_message_6030E : "CWZDD6030E: A negative value for allowed time is not supported.",

  // Scenario: This error occurs when attempting to tell the graph layout to
  // use a link connection box provider when the layout does not support this feature. 
  // Required action: Verify that the layout is the correct one.
  graphlayout_expert_message_6031E : "CWZDD6031E: This layout class does not support the link connection box mechanism.",

  // Scenario: This error occurs when attempting to tell the graph layout to
  // use the spline routing feature when the layout does not support this feature. 
  // Required action: Verify that the layout is the correct one.
  graphlayout_expert_message_6032E : "CWZDD6032E: This layout class does not support the generic optimized spline routing mechanism.",

  // Scenario: This error occurs when the GraphLayout.minSplineCurveSize property 
  // is set to a negative value.
  // Required action: Verify that a valid value is used when specifying the GraphLayout.minSplineCurveSize property 
  graphlayout_expert_message_6033E : "CWZDD6033E: Negative minimal spline curve size: ${0}.",

  // Scenario: This error occurs when the GraphLayout.maxSplineCurveSize property 
  // is set to a negative value.
  // Required action: Verify that a valid value is used when specifying the GraphLayout.maxSplineCurveSize property 
  graphlayout_expert_message_6034E : "CWZDD6034E: Negative maximum spline curve size: ${0}.",

  // Scenario: This error occurs when the GraphLayout.balanceSplineCurveThreshold property 
  // is set to a negative value.
  // Required action: Verify that a valid value is used when specifying the GraphLayout.balanceSplineCurveThreshold property 
  graphlayout_expert_message_6035E : "CWZDD6035E: Negative balance spline curve threshold: ${0}.",

  // Scenario: This error occurs when the GraphLayout.balanceSplineCurveThreshold property 
  // is set to a negative value.
  // Required action: Verify that a valid value is used when specifying the property GraphLayout.balanceSplineCurveThreshold
  graphlayout_expert_message_6036E : "CWZDD6036E: Invalid layout region mode: ${0}.",

  // Scenario: This error occurs when the layout provider instance that
  // returns the layout instances that are used during a recursive layout is not
  // specified.
  // Required action: Verify that a valid layout provider is specified. 
  graphlayout_expert_message_6037E : "CWZDD6037E: Layout provider cannot be null.",

  // Scenario: This error occurs when several requests to perform a layout
  // recursivelly occur for the same model.
  // Required action: Verify that a layout request occurs only when
  // the previous layout is complete.
  graphlayout_expert_message_6038E : "CWZDD6038E: A recursive layout has been already started for ${0}.",

  // Scenario: This error occurs when a model cannot be created for a 
  // connected component.
  // Required action: Verify that the graph layout model is a 
  // subclass of AbstractGraphLayoutModel, which is an appropriate
  // implementation for the createGraphModel method.
  graphlayout_expert_message_6039E : "CWZDD6039E: Cannot create a graph layout model for a connected component.",

  // Scenario: This error occurs when adding a node to a graph
  // layout model which already contains the node instance.
  // Required action: Verify that the graph layout model is
  // correctly implemented.
  graphlayout_expert_message_6040E : "CWZDD6040E: Node ${0} is already contained in graph layout model ${1}.",

  // Scenario: This error occurs when adding a link to a graph
  // layout model which already contains the link instance.
  // Required action: Verify that the graph layout model is
  // correctly implemented.
  graphlayout_expert_message_6041E : "CWZDD6041E: Link ${0} is already contained in graph layout model ${1}.",

  // Scenario: This error occurs when a model cannot be created for a 
  // subgraph.
  // Required action: Verify that the graph layout model is a 
  // subclass of AbstractGraphLayoutModel, which is an appropriate
  // implementation for method createGraphModel.
  graphlayout_expert_message_6042E : "CWZDD6042E: Cannot create a graph layout model for a subgraph.",

  // Scenario: This error occurs when querying link related 
  // information from a graph layout model that does not contain
  // any link.
  // Required action: Verify that the graph layout model has
  // been correctly created. 
  graphlayout_expert_message_6043E : "CWZDD6043E: The graph layout model does not contain any link.",

  // Scenario: This error occurs when verifying that a layout is
  // not attached to any model when using methods that require
  // the graph model to know the structure of the graph.
  // Required action: Attach the correct graph layout model to the
  // graph layout instance before calling the method.
  graphlayout_expert_message_6044E : "CWZDD6044E: Graph layout is not attached to any graph layout model.",

  // Scenario: This error occurs when verifying if a given graph
  // layout model has a tree structure, but the given start node
  // has not been correctly specified.
  // Required action: Verify that the correct parameters are
  // passed as arguments to the method.
  graphlayout_expert_message_6045E : "CWZDD6045E: Start node cannot be null.",

  // Scenario: This error occurs when an error occurs during
  // connectivity test.
  // Required action: Verify that graph layout model is
  // created correctly.
  graphlayout_expert_message_6046E : "CWZDD6046E: Internal error during connectivity test. There are ${0} nodes in a connected component and only ${1} nodes in the graph layout model ${2}.",
 
  // Scenario: This error occurs when a method can not be
  // executed with an empty graph layout model.
  // Required action: Verify that the graph layout model is
  // created correctly.
  graphlayout_expert_message_6047E : "CWZDD6047E: This operation cannot be performed for empty graphs.",

  // Scenario: This error occurs when trying to configure parameters
  // to a null node or link instance.
  // Required action: Verify that the correct values are used
  // as argument for the method.
  graphlayout_expert_message_6048E : "CWZDD6048E: The object cannot be null.",

  // Scenario: This error occurs when trying to configure parameters
  // to a node or link instance that is not part of the attached
  // graph layout model.
  // Required action: Verify that the correct values are used
  // as argument for the method.
  graphlayout_expert_message_6049E : "CWZDD6049E: The object ${0} must be a node or a link in the attached graph layout model ${1}.",

  // Scenario: This error occurs when trying to access parameters
  // to a null node instance.
  // Required action: Verify that the correct value is used
  // as argument for the method.
  graphlayout_expert_message_6050E : "CWZDD6050E: The node cannot be null.",

  // Scenario: This error occurs when trying to access parameters
  // to a null link instance.
  // Required action: Verify that the correct value is used
  // as argument for the method.
  graphlayout_expert_message_6051E : "CWZDD6051E: The link cannot be null.",

  // Scenario: This error occurs when a non-supported method is called.
  // Required action: This method should not be used.
  graphlayout_expert_message_6058E : "CWZDD6058E: This operation is not supported.",

  // Scenario: This error occurs when a request to retrieve  
  // information about biconnected components of the graph
  // is performed prior to the execution of the algorithm that
  // identifies the biconnected components.
  // Required action: Verify that the algorithm runs before querying 
  // biconnected components information.
  graphlayout_expert_message_6059E : "CWZDD6059E: The algorithm perform prior to querying information about biconnected components of the graph.",

  // Scenario: This error occurs when a request to retrieve  
  // information about biconnected components of the graph
  // is performed prior to the execution of the algorithm that
  // identifies the biconnected components.
  // Required action: Verify that the algorithm runs before querying 
  // biconnected components information.
  graphlayout_expert_message_6060E : "CWZDD6060E: Initial partition is not created.",

  // Scenario: This error occurs when a request to iterate over a
  // list is performed, but there are no more elements.
  // Required action: Verify that the list is correct.
  graphlayout_expert_message_6061E : "CWZDD6061E: There are no more elements.",

  // Scenario: This error occurs when a request to retrieve a property
  // from a link is performed on a non-link object.
  // Required action: Verify that the argument of the method is a link
  graphlayout_expert_message_6062E : "CWZDD6062E: The argument of the method is not a link.",

  // Scenario: This error occurs when a request to retrieve a property
  // from a node is performed on a non-node object.
  // Required action: Verify that the argument of the method is a link
  graphlayout_expert_message_6063E : "CWZDD6063E: The argument of the method is not a node.",

  // Scenario: This error occurs when a link is in a graph, but its start node
  // or end node is not.
  // Required action: Verify that the graph is created correctly.
  graphlayout_expert_message_6064E : "CWZDD6064E: Link start node and end node must be in the graph.",

  // Scenario: This error occurs when a link is in a graph, but its start node
  // is not.
  // Required action: Verify that the graph is created correctly .
  graphlayout_expert_message_6065E : "CWZDD6065E: Start node of link must be in the graph.",

  // Scenario: This error occurs when a link is in a graph, but its end node
  // is not.
  // Required action: Verify that the graph is created correctly .
  graphlayout_expert_message_6066E : "CWZDD6066E: End node of link must be in the graph.",

  // Scenario: This error occurs when an object is used as argument of a method
  // but it is neither a node nor a link in a graph.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6067E : "CWZDD6067E: Object is neither a node nor a link.",

  // Scenario: This error occurs when a node that is used as argument
  // of a method is null.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6068E : "CWZDD6068E: Node is null.",

  // Scenario: This error occurs when a node that is used as argument
  // of a method is not part of the graph being analyzed.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6069E : "CWZDD6069E: Node is not a node of this graph.",

  // Scenario: This error occurs when a graph that is used as argument
  // of a method is null.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6070E : "CWZDD6070E: Graph argument is null.",

  // Scenario: This error occurs when a link that is used as argument
  // of a method is null.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6071E : "CWZDD6071E: Link argument is null.",

  // Scenario: This error occurs when a link that is used as argument
  // of a method is not part of the graph being analyzed.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6072E : "CWZDD6072E: Link is not part of this graph.",

  // Scenario: This error occurs when a node that is used as argument
  // of a method is not the start node or the end node of the link.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6073E : "CWZDD6073E: Node is neither the start node nor the end node of the link.",

  // Scenario: This error occurs when setting the bounds to a node to
  // a null value.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6074E : "CWZDD6074E: Node bounds cannot be null.",

  // Scenario: This error occurs when querying values of a model
  // which has not been collected yet. This is an internal error.
  // Required action: Contact support for assistance.
  graphlayout_expert_message_6075E : "CWZDD6075E: Model is not defined; the method should be called only after data has been collected.",

  // Scenario: This error occurs when a subgraph that is used as argument
  // of a method is not part of the graph being analyzed.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6076E : "CWZDD6076E: Subgraph is not a part of this graph.",

  // Scenario: This error occurs when analyzing the common ancestor
  // of two nodes, but one of the nodes is null.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6077E : "CWZDD6077E: Objects should not be null.",

  // Scenario: This error occurs when the value of the model argument
  // is null.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6078E : "CWZDD6078E: Invalid value for ${0} argument.",

  // Scenario: This error occurs when the value of the property
  // name argument is null.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6079E : "CWZDD6079E: Invalid value for property name argument.",

  // Scenario: This error occurs when the value of the argument
  // startNode is null.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6080E : "CWZDD6080E: Invalid value for start node argument.",

  // Scenario: This error occurs when setting an element in an array
  // to an index that is larger than the array capacity.
  // Required action: Verify that the correct argument is used.
  graphlayout_expert_message_6081E : "CWZDD6081E: Index ${0} cannot be larger than current capacity - 1 (${1}).",

  // Scenario: This error occurs when the absolute difference between 
  // two angles, assomption made that alpha 1 is the start angle, 
  // alpha2 is the end angle, and the interval is in trigonometric direction. 
  // Assomption is also made that both angles are in 0 - 2PI.
  // Required action: Verify that the correct arguments are used.
  graphlayout_expert_message_6082E : "CWZDD6082E: Angle must be from zero to 2pi.",


  // Scenario: This error occurs when the representation of a link
  // indicates that the link path is empty. This is an internal error.
  // Required action: Contact support for assistance.
  graphlayout_expert_message_6083E : "CWZDD6083E: Path is empty.",

  // Scenario: This error occurs when the number of nodes in a graph
  // is invalid. This is an internal error.
  // Required action: Contact support for assistance.
  graphlayout_expert_message_6084E : "CWZDD6084E: Bad number of nodes: ${0}.",

  // Scenario: This error occurs when the zoom factor of the matrix
  // set in the view is invalid.
  // Required action: Verify that the zoom factor is specified correctly.
  graphlayout_expert_message_6085E : "CWZDD6085E: Zoom factor cannot be be zero.",

  // Scenario: This error occurs when trying to move nodes when just
  // link routing is being performed.
  // Required action: Verify that the custom layout algorithm is correctly implemented.
  graphlayout_expert_message_6086E : "CWZDD6086E: Link routing should not move nodes.",

  // Scenario: This error occurs when building the topology of a graph
  // prior to graph layout execution but an error has caused an
  // inconsistency on the graph structures.
  // Required action: Verify that the custom layout algorithm is implemented correctly.
  graphlayout_expert_message_6087E : "CWZDD6087E: There are more nodes in the graph than expected.",

  // Scenario: This error occurs when building the topology of a graph
  // prior to graph layout execution but an error has caused an
  // inconsistency on the graph structures.
  // Required action: Verify that the custom layout algorithm is implemented correctly.
  graphlayout_expert_message_6088E : "CWZDD6088E: There are more links in the graph than expected.",

  // ---------------------------------------------------------------------------
  // Generic layout parameter messages

  // Scenario: This error occurs when a graph layout parameter is set
  // that expects only one out of a fixed set of choices, but the provided
  // value is not a valid choice.
  // Required action: Verify that a valid value is used to set
  // the layout parameter.
  graphlayout_expert_message_6090E : "CWZDD6090E: Illegal option: ${0}.",

  // Scenario: This error occurs when a graph layout parameter is set
  // that expects only a positive number but but the provided
  // value is negative.
  // Required action: Verify that a valid value is used to set
  // the layout parameter.
  graphlayout_expert_message_6091E : "CWZDD6091E: Unsupported negative value: ${0}.",

  // Scenario: This error occurs when a graph layout parameter is set
  // to null that expects a non-null value.
  // Required action: Verify that a valid value is used to set
  // the layout parameter.
  graphlayout_expert_message_6092E : "CWZDD6092E: Unsupported null value.",

  // ---------------------------------------------------------------------------


  // Scenario: This error occurs when the internal data structures of a
  // graph layout algorithm are messed up. This indicates a bug in the library.
  // Required action: Report this error to product support.
  graphlayout_expert_message_6150E : "CWZDD6150E: Internal error ${0}. Report this error to product support and explain how to reproduce the error.",


  //#########################
  // ibm_ilog.graphlayout (used only in Flex)

  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //



  //#########################
  // ilog.views.graphlayout.rowcolumngrid (used by Grid and Bus Layout)
  // Message Range: 6280-6299
  //##########################

  // Scenario: This error occurs when you set the value of the
  // property layoutMode in a Grid layout with an incorrect value.
  // Required action: Verify that the value provided to property
  // layoutMode in Grid layout is one of the possible values.
  graphlayout_expert_message_6280E : "CWZDD6280E: Invalid layout mode: ${0}.",

  // Scenario: This error occurs when the processing of nodes in
  // a graph to create a matrix for Grid Layout. It indicates that
  // an internal error has occurred during this process.
  // Required action: Verify that the graph layout model is correct and
  // that layout parameters are configured correctly.
  graphlayout_expert_message_6281E : "CWZDD6281E: Extra big floating node processed as normal big floating node (width = ${0}).",

  // Scenario: This error occurs the indexes of the nodes are negative. 
  // Required action: Verify that graph layout model is correct and
  // that layout parameters are configured correctly.
  graphlayout_expert_message_6282E : "CWZDD6282E: Indexes cannot be negative, with the exception of fixed nodes.",

  // Scenario: This error when the node is larger than the
  // available space in the grid.
  // Required action: Verify that graph layout model is correct and
  // that layout parameters are configured correctly.
  graphlayout_expert_message_6283E : "CWZDD6283E: Extra large nodes must be left-aligned.",

  // Scenario: This error when the node is larger than the
  // available space in the grid and the grid is configured to
  // not allow nodes to be placed outside of its available area.
  // Required action: Verify that graph layout model is correct and
  // that layout parameters are configured correctly.
  graphlayout_expert_message_6284E : "CWZDD6284E: Cannot go outside available area.",



  //#########################
  // Generic

  //
  //
  //
  //
  //

  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer


  //###############################################################
  // Property file for multiple layout
  //###############################################################
  // ibm_ilog.graphlayout
  // Message Range: 6450-6459
  //###############################################################

  // Scenario: This error occurs a graph layout model has not
  // yet been attached to the first layout in a Multiple layout
  // configuration.
  // Required action: Verify that the graph layout model is 
  // correctly attached to the first layout when using a multiple layout.
  graphlayout_expert_message_6450E : "CWZDD6450E: Graph layout model on first layout cannot be null.",

  // Scenario: This error occurs a graph layout model has not
  // yet been attached to the second layout in a Multiple layout
  // configuration.
  // Required action: Verify that the graph layout model is 
  // correctly attached to the second layout when using a multiple layout.
  graphlayout_expert_message_6451E : "CWZDD6451E: Graph layout model on second layout cannot be null.",




  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer


  //###############################################################
  // Property file for random layout
  //###############################################################
  // ibm_ilog.graphlayout.random
  // Message Range: 6460-6469
  //###############################################################

  // Scenario: This error occurs when a graph layout model contains
  // null nodes.
  // Required action: Verify that the graph layout model is 
  // correct.
  graphlayout_expert_message_6460E : "CWZDD6460E: Null node retrieved from graph layout model.",

  // Scenario: This error occurs when an invalid value is set to
  // the global link style parameter in Random Layout
  // Required action: Verify that a valid value is used to set
  // parameter global link style.
  graphlayout_expert_message_6461E : "CWZDD6461E: Unsupported global link style option in Random Layout. ",




  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer


  //###############################################################
  // Property file for recursive layout
  //###############################################################
  // ibm_ilog.graphlayout
  // Message Range: 6675-6699
  //###############################################################

  // Scenario: This error occurs when a method of the class GraphLayout
  // is used but the graph layout model attached to the graph layout
  // instance has not been specified.
  // Required action: Verify that a valid graph layout model is used.
  graphlayout_expert_message_6675E : "CWZDD6675E: No attached graph layout model or the graph layout model is null.",

  // Scenario: This error occurs when the layout provider instance which will
  // return the layout instances used during a recursive layout has not been
  // specified.
  // Required action: Verify that a valid layout provider is specified. 
  graphlayout_expert_message_6676E : "CWZDD6676E: Layout provider cannot be null.",


  // Scenario: This error occurs when creating a recursive layout
  // with a null reference layout.
  // Required action: Verify that the correct value is used
  // as argument for the method.
  graphlayout_expert_message_6677E : "CWZDD6677E: The reference layout cannot be null.",

  // Scenario: This error occurs when creating a recursive layout
  // with another recursive layout as reference layout.
  // Required action: Verify that the correct value is used
  // as argument for the method.
  graphlayout_expert_message_6678E : "CWZDD6678E: A recursive layout cannot have another recursive layout as reference layout.",

  // Scenario: This error occurs invoking the method RecursiveLayout.setLayout
  // for a recursive layout instance that is using a reference layout
  // or a specified layout provider.
  // Required action: Verify that the method is only used for recursive
  // layout instances that are in internal layout provider mode.
  graphlayout_expert_message_6679E : "CWZDD6679E: Only use the setLayout method in internal provider mode.",

  // Scenario: This error occurs invoking the method 
  // for a recursive layout instance that is not yet attached to a
  // graph layout model.
  // Required action: Verify that a graph layout model is correctly
  // attached to the recursive layout instance.
  graphlayout_expert_message_6680E : "CWZDD6680E: A graph layout model must be attached before you use the method ${0}.",

  // Scenario: This error occurs specifying a layout to a subgraph
  // which is not a MultipleLayout.
  // Required action: Verify that the correct MultipleLayout instance
  // is used when setting a layout to a subgraph in a RecursiveMultipleLayout.
  graphlayout_expert_message_6681E : "CWZDD6681E: An instance of MultipleLayout is expected when specifying a layout for subgraph.",

  // Scenario: This error occurs specifying an invalid value to a property.
  // Required action: Verify that the correct value is used.
  graphlayout_expert_message_6682E : "CWZDD6682E: Illegal value ${0} for ${1} property.",





  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer


  //###############################################################
  // Property file for tree layout
  //###############################################################
  // ibm_ilog.graphlayout.tree
  // Message Range: 6700-6749
  //###############################################################

  // Scenario: This error occurs when the global link style
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout global link style.
  graphlayout_expert_message_6700E : "CWZDD6700E: Unsupported global link style in Tree Layout: ${0}.",

  // Scenario: This error occurs when the connector style
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout connector style.
  graphlayout_expert_message_6701E : "CWZDD6701E: Unsupported connector style in Tree Layout: ${0}.",

  // Scenario: This error occurs when the flow direction
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout flow direction.
  graphlayout_expert_message_6702E : "CWZDD6702E: Unsupported flow direction in Tree Layout: ${0}.",

  // Scenario: This error occurs when the layout mode
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout layout mode.
  graphlayout_expert_message_6703E : "CWZDD6703E: Unsupported layout mode in Tree Layout: ${0}.",

  // Scenario: This error occurs when the balloon angle spacing
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout balloon angle spacing.
  graphlayout_expert_message_6704E : "CWZDD6704E: Unsupported balloon angle spacing in Tree Layout: ${0}.",

  // Scenario: This error occurs when the balloon radius mode
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout balloon radius mode.
  graphlayout_expert_message_6705E : "CWZDD6705E: Unsupported balloon radius mode in Tree Layout: ${0}.",

  // Scenario: This error occurs when the level alignment
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout level alignment.
  graphlayout_expert_message_6706E : "CWZDD6706E: Unsupported level alignment in Tree Layout: ${0}.",

  // Scenario: This error occurs when the global alignment
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout global alignment.
  graphlayout_expert_message_6707E : "CWZDD6707E: Unsupported global alignment in Tree Layout: ${0}.",

  // Scenario: This error occurs when the sibling offset
  // parameter is set to a negative value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout sibling offset.
  graphlayout_expert_message_6708E : "CWZDD6708E: Negative sibling offset in Tree Layout: ${0}.",

  // Scenario: This error occurs when the parent-child offset
  // parameter is set to a negative value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout parent-child offset.
  graphlayout_expert_message_6709E : "CWZDD6709E: Negative parent-child offset in Tree Layout: ${0}.",

  // Scenario: This error occurs when the branch offset
  // parameter is set to a negative value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout branch offset.
  graphlayout_expert_message_6710E : "CWZDD6710E: Negative branch offset in Tree Layout: ${0}.",

  // Scenario: This error occurs when the tip-over branch offset
  // parameter is set to a negative value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout tip-over branch offset.
  graphlayout_expert_message_6711E : "CWZDD6711E: Negative tip-over branch offset in Tree Layout: ${0}.",

  // Scenario: This error occurs when the associate offset
  // parameter is set to a negative value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout associate offset.
  graphlayout_expert_message_6712E : "CWZDD6712E: Negative associate offset in Tree Layout: ${0}.",

  // Scenario: This error occurs when the parent-child associate offset
  // parameter is set to a negative value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout parent-child associate offset.
  graphlayout_expert_message_6713E : "CWZDD6713E: Negative parent-child associate offset in Tree Layout: ${0}.",

  // Scenario: This error occurs when the aspect
  // parameter is set to a negative or zero value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout aspect offset.
  graphlayout_expert_message_6714E : "CWZDD6714E: Negative or zero aspect ratio in Tree Layout: ${0}.",

  // Scenario: This error occurs when the individual link style
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout individual link style.
  graphlayout_expert_message_6715E : "CWZDD6715E: Unsupported individual link style in Tree Layout: ${0}.",

  // Scenario: This error occurs when the individual alignment
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout individual alignment.
  graphlayout_expert_message_6716E : "CWZDD6716E: Unsupported individual alignment in Tree Layout: ${0}.",

  // Scenario: This error occurs when the individual child alignment
  // parameter is set to an invalid value in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout individual child alignment.
  graphlayout_expert_message_6717E : "CWZDD6717E: Unsupported individual child alignment in Tree Layout: ${0}.",

  // Scenario: This error occurs when the side option used to
  // specify the subtree block margin is invalid in Tree Layout 
  // Required action: Verify that you have correctly configured
  // the Tree Layout subtree block margin side.
  graphlayout_expert_message_6718E : "CWZDD6718E: Unsupported subtree block margin side option in Tree Layout: ${0}.",



  //ISMESSAGEFILE TRUE
  //COMPONENTPREFIX CWZDD
  //COMPONENTNAMEFOR CWZDD IBM ILOG Dojo Diagrammer


  //###############################################################
  // Property file for uniform layout
  //###############################################################
  // ibm_ilog.graphlayout.forcedirected
  // Message Range: 6750-6774
  //###############################################################

  // Could reduce all internal errors to just 1 message, using ID 6150
  // which is used otherwhere as generic internal error message

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6750E : "CWZDD6750E: Internal error: Unexpected self link found in abstract graph (1).",

  // Scenario: This error occurs when performing the the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6751E : "CWZDD6751E: Internal error: Unexpected neighbor of sNode.",

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6752E : "CWZDD6752E: Internal error: Unexpected self link found in abstract graph (2).",

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6753E : "CWZDD6753E: Found no free pNode for mNode ${0}.",

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6754E : "CWZDD6754E: Internal error: User data cannot be null on the pNode.",

  // Scenario: This error occurs when performing the layout algorithm. 
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6755E : "CWZDD6755E: mNode can only be added to pNode or pNode with mNode.",

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6756E : "CWZDD6756E: Unexpected null userData on pNode ${0}.",

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6757E : "CWZDD6757E: Coarsening did not reduce the number of nodes ${0}.",

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6758E : "CWZDD6758E: Node cannot be null.",

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6759E : "CWZDD6759E: Unexpected null sNode.",

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6760E : "CWZDD6760E: Unexpected null pNode.",

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6761E : "CWZDD6761E: Self link must not occur in abstract graph.",

  // Scenario: This error occurs when performing the layout algorithm.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6762E : "CWZDD6762E: Original layout cannot be null.",

  // Scenario: This error occurs when the algorithm can no longer
  // identify whether nodes are fixed or not.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6763E : "CWZDD6763E: Impossible to know if nodes are fixed or not.",

  // Scenario: This error occurs during execution of the layout algorithm
  // in Fast-Multilevel model.
  // Required action: This is an internal error. Contact
  // support for assistance.
  graphlayout_expert_message_6764E : "CWZDD6764E: Internal error in fast multilevel support.",

  // Scenario: This error occurs when an invalid value is set
  // to nodes placement parameter.
  // Required action: Verify that the appropriate value is set.
  graphlayout_expert_message_6765E : "CWZDD6765E: Unsupported nodes placement algorithm option: ${0}.",
 
  // Scenario: This error occurs if the layout algorithm was
  // not able to create the required data structures.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6766E : "CWZDD6766E: Internal error: Internal data structures are not created correctly.",

  // Scenario: This error occurs when the layout algorithm is
  // not able to reach convergence.
  // Required action: Verify that all configuration is correctly
  // set.
  graphlayout_expert_message_6767E : "CWZDD6767E: Cannot reach convergence.",

  // Scenario: This error occurs if the layout algorithm was
  // not able to create the required data structures.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6768E : "CWZDD6768E: Internal error (position data).",

  // Scenario: This error occurs when computing the length of the
  // links in the layout algorithm.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6769E : "CWZDD6769E: Internal error: Half diagonal vector not initialized.",

  // Scenario: This error occurs when the internal data structures
  // that carry node information have not been correctly created.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6770E : "CWZDD6770E: Internal error: The nodes are not created correctly.",

  // Scenario: This error occurs when the layout mode parameter
  // is set to an invalid value.
  // Required action: Verify that a valid value is used to set
  // the layout mode parameter.
  graphlayout_expert_message_6771E : "CWZDD6771E: Unsupported layout mode: ${0}.",

  // Scenario: This error occurs when the number of iterations parameter
  // is set to a negative value.
  // Required action: Verify that a valid value is used to set
  // the number of iterations parameter.
  graphlayout_expert_message_6772E : "CWZDD6772E: Number of iterations cannot be negative: ${0}.",

  // Scenario: This error occurs when the link style parameter
  // is set to an unsupported value.
  // Required action: Verify that a valid value is used to set
  // the link style parameter.
  graphlayout_expert_message_6773E : "CWZDD6773E: Unsupported link style: ${0}.",

  // Scenario: This error occurs when the multilink mode parameter
  // is set to an unsupported value.
  // Required action: Verify that a valid value is used to set
  // the multilink mode parameter.
  graphlayout_expert_message_6774E : "CWZDD6774E: Unsupported multilink mode: ${0}.",

  // Scenario: This error occurs when the value of a spacing property is
  // set to a negative value but this spacing property does not support
  // negative values.
  // Required action: Verify that the appropriate value is used.
  graphlayout_expert_message_6775E : "CWZDD6775E: Unsupported negative value: ${0}.",


  //###############################################################
  // Property file for generic quadtree 
  //###############################################################
  // ibm_ilog.graphlayout.internalutil.genericquadtree
  // Message Range: 6260-6279
  //###############################################################

  // Scenario: This is an internal error that occurs when
  // an instance is created with an invalid parameter.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6260E : "CWZDD6260E: Object interface argument cannot be null. ",

  // Scenario: This is an internal error that occurs when
  // an object cannot be removed from an internal structure.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6261E : "CWZDD6261E: Object was not removed.",

  // Scenario: This is an internal error that occurs when
  // an object is added to a quadtree where it is already present.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6262E : "CWZDD6262E: GenericQuadtree.add: Object ${0} [${1}] is already in quadtree.",

  // Scenario: This is an internal error that occurs when
  // an object is removed from a quadtree where it was not present.
  // Required action: This is an internal error. Contact support
  // for assistance.
  graphlayout_expert_message_6263E : "CWZDD6263E: GenericQuadtree.remove: Object ${0} [${1}] is not in quadtree.",

  _end : null
})
,
"en":1,
"en-us":1
});

},
'ibm_ilog*graphlayout/internalutil/MovementModes':function(){
define(["dojo","dijit","dojox","ibm_ilog/graphlayout/internalutil/TranslateUtil","ibm_ilog/graphlayout/internalutil/ConnectionPointModes"], function(dojo, dijit, dojox){
dojo.getObject("ibm_ilog.graphlayout.internalutil.MovementModes", 1);
/* builder delete begin
dojo.provide('ibm_ilog.graphlayout.internalutil.MovementModes');


 builder delete end */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.ConnectionPointModes');


 builder delete end */
dojo.declare('ibm_ilog.graphlayout.internalutil.MovementModes', ibm_ilog.graphlayout.internalutil.ConnectionPointModes, 
{
  // summary:
  //		This class contains all enumeration constants used for movement
  //		modes. 
  // description:
  //		This class contains all enumeration constants used for movement
  //		modes. 
  //		This ensures that ALL movement modes of ALL layout algorithms share
  //		the same values.   
  //		<p>
  //		It also contains some generic support for the movement modes.   
  //		</p>
  // tags:
  //		private
  
  constructor : function()
  {
    
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.internalutil.MovementModes,
{
  FIXED_IN_X_MODE : null,
  FIXED_IN_Y_MODE : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.internalutil.MovementModes;
    if(ibm_ilog.graphlayout.internalutil.ConnectionPointModes._fields_init)
      ibm_ilog.graphlayout.internalutil.ConnectionPointModes._fields_init(c);
    
    c.FIXED_IN_X_MODE = 1;
    c.FIXED_IN_Y_MODE = 2;
  }
  
}
);

(function(){ ibm_ilog.graphlayout.internalutil.MovementModes._fields_init(); })();

return dojo.getObject("ibm_ilog.graphlayout.internalutil.MovementModes");});
require(["ibm_ilog/graphlayout/internalutil/MovementModes"]);

},
'ibm_ilog*graphlayout/internalutil/HashTable':function(){
define(["dojo","dijit","dojox"], function(dojo, dijit, dojox){
dojo.getObject("ibm_ilog.graphlayout.internalutil.HashTable", 1);
/* builder delete begin
dojo.provide("ibm_ilog.graphlayout.internalutil.HashTable");


 builder delete end */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// #######################################
// ######## NOT Generated by J2JS ########
// ###### DO NOT DELETE THIS FILE! #######
// #######################################

// ------------------------------------------------------------------------
// Utility methods used in the code generated by J2JS.
// ------------------------------------------------------------------------

dojo.declare('ibm_ilog.graphlayout.internalutil.HashTable', null, {
	
	_hash : null,
	
	count : 0,
	
	constructor : function() {
		this._hash = {};
	},
	
	add : function(key, value)
	{
		var skey = this._skey(key);
		if(!this._hash[skey])
			this.count++;
		this._hash[skey] = new ibm_ilog.graphlayout.internalutil.HashTableEntry(key, value);
	},
	
	item : function(key)
	{
		var skey = this._skey(key);
		var entry = this._hash[skey];
		if(entry)
			return entry.value;
		return undefined;
	},
	
	remove : function(key)
	{
		var skey = this._skey(key);
		if(this._hash[skey] && !ibm_ilog.graphlayout.internalutil.HashTable._emptyObj[skey]){
			delete this._hash[skey];
			this.count--;
			return true;
		}
		return false;
	},
	
	clear : function()
	{
		this._hash = {};
		this.count = 0;
	},
	
	containsKey : function(key)
	{
		var skey = this._skey(key);
		return this._hash[skey] && !ibm_ilog.graphlayout.internalutil.HashTable._emptyObj[skey];
	},
	
	getEntryList : function()
	{
		var entries = [];
		for(var skey in this._hash)
			if(!ibm_ilog.graphlayout.internalutil.HashTable._emptyObj[skey])
				entries.push(this._hash[skey]);
		return entries;
	},
	
	getValueList : function()
	{
		var values = [];
		for(var skey in this._hash)
			if(!ibm_ilog.graphlayout.internalutil.HashTable._emptyObj[skey])
				values.push(this._hash[skey].value);
		return values;
	},
	
	getKeyList : function()
	{
		var keys = [];
		for(var skey in this._hash)
			if(!ibm_ilog.graphlayout.internalutil.HashTable._emptyObj[skey])
				keys.push(this._hash[skey].key);
		return keys;
	},
	
	getIterator : function()
	{
		return new ibm_ilog.graphlayout.internalutil.ArrayIterator(this.getEntryList());
	},
	
	_skey : function(key)
	{
		var type = typeof(key);
		if(type == "string")
			return key;
		if(type == "number")
			return String(key);
		if(typeof(key.hashCode) == "function")
			return String(key.hashCode());
		if(!key._hash_string)
			key._hash_string = String(++(ibm_ilog.graphlayout.internalutil.HashTable._nextHashCode));
		return key._hash_string;
	}
});

dojo.declare('ibm_ilog.graphlayout.internalutil.HashTableEntry', null, {
	key : null,
	value : null,
	constructor : function(key, value)
	{
		this.key = key;
		this.value = value;
	}
});

dojo.mixin(ibm_ilog.graphlayout.internalutil.HashTable, {
	_emptyObj : {},
	_nextHashCode : 0
});

return dojo.getObject("ibm_ilog.graphlayout.internalutil.HashTable");});
require(["ibm_ilog/graphlayout/internalutil/HashTable"]);

},
'ibm_ilog*graphlayout/internalutil/TranslateUtil':function(){
define(["dojo","dijit","dojox"], function(dojo, dijit, dojox){
dojo.getObject("ibm_ilog.graphlayout.internalutil.TranslateUtil", 1);
/* builder delete begin
dojo.provide("ibm_ilog.graphlayout.internalutil.TranslateUtil");


 builder delete end */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// #######################################
// ######## NOT Generated by J2JS ########
// ###### DO NOT DELETE THIS FILE! #######
// #######################################

// ------------------------------------------------------------------------
// Utility methods used in the code generated by J2JS.
// ------------------------------------------------------------------------

ibm_ilog.graphlayout.internalutil.TranslateUtil = {
	
	NEAR_ZERO_FLOAT : 1.0e-20,
	
	noop : function()
	{
	},
	
	newArray : function(size, v1, v2, v3)
	{
		var array = new Array(size);
		if (v1 !== undefined) {
			for (var i = 0; i < size; i++) {
				if(arguments.length > 2)
					array[i] = ibm_ilog.graphlayout.internalutil.TranslateUtil.newArray(v1, v2, v3);
				else
					array[i] = v1;
			}
		}
		return array;
	},
	
	copyArrayInto : function(src, dst)
	{
		for(var i = 0; i < src.length; i++)
			dst[i] = src[i];
		return dst;
	},
	
	addAllArray : function(dst, src)
	{
		for(var i = 0; i < src.length; i++)
			dst.push(src[i]);
		return dst;
	},
	
	arrayCopy : function(srcArray, srcIndex, dstArray, dstIndex, length)
	{
		for(var i = 0; i < length; i++)
			dstArray[dstIndex+i] = srcArray[srcIndex+i];
	},
	
	removeArrayObject : function(array, obj)
	{
		var index = dojo.indexOf(array, obj);
		if(index >= 0){
			array.splice(index, 1);
			return true;
		}
		return false;
	},
	
	enumToArray : function(e)
	{
		var a = [];
		while(e.hasNext())
			a.push(e.next());
		return a;
	},
    
    sortNumberArrayList:function(t){
        t.sort(function (a,b) {return a - b;});
        return t; 
    },
	
	compareNumber: function(s1, s2){
		if (s1 < s2) 
			return -1;
		else if (s1 > 2) 
				return 1;
		return 0;
	},
	
	// Set functions:
	
	addSetObject: function(set, obj)
	{
		// TODO: should test equality with equals() method when available,
		// but in the graph layout code reference equality seems enough...
		if(dojo.indexOf(set, obj) >= 0)
			return false;
		set.push(obj);
		return true;
	},
	
	// Rectangle functions:
	    
	moveRect : function(rect, x, y)
	{
		rect.x = x;
		rect.y = y;
	},
	
	reshapeRect : function(rect, x, y, width, height)
	{
		rect.x = x;
		rect.y = y;
		rect.width = width;
		rect.height = height;
	},
	
    reshapeFromRect:function(rect, rect2){
        rect.x = rect2.x;
        rect.y = rect2.y;
        rect.width = rect2.width;
        rect.height = rect2.height;
    },
    
	addPoint : function(rect1, px, py)
	{
      var a;
      var b;
      var minx;
      var miny;
      var maxx;
      var maxy;
      
      a = rect1.x;
      b = px;
      minx = (a < b) ?  a : b; // faster than Math.min
      a += rect1.width;
      maxx = (a > b) ? a : b;
      a = rect1.y;
      b = py;
      miny =  (a < b) ?  a : b;
      a += rect1.height;
      maxy = (a > b) ? a : b;
      rect1.x = minx;
      rect1.y = miny;
      rect1.width  = (maxx-minx);
      rect1.height = (maxy-miny);      
	},
	
    addRect : function(rect1, rect2)
    {
      var a;
      var b;
      var minx;
      var miny;
      var maxx;
      var maxy;
      
      a = rect1.x;
      b = rect2.x;
      minx = (a < b) ?  a : b; // faster than Math.min
      a += rect1.width;
      b += rect2.width;
      maxx = (a > b) ? a : b;
      a = rect1.y;
      b = rect2.y;
      miny =  (a < b) ?  a : b;
      a += rect1.height;
      b += rect2.height;
      maxy = (a > b) ? a : b;
      rect1.x = minx;
      rect1.y = miny;
      rect1.width  = (maxx-minx);
      rect1.height = (maxy-miny);
    },
	
    rectEquals: function(thisRect, other) {
		if(thisRect == other)
			return true;
		if(!thisRect || !other)
			return false;
        return thisRect.x == other.x &&
               thisRect.y == other.y &&
               thisRect.width == other.width &&
               thisRect.height == other.height;
    },
    
    rectIntersects: function(thisRect, rect) {
        return (rect.x < (thisRect.x + thisRect.width)) &&
               (thisRect.x < (rect.x + rect.width)) &&
               (rect.y < (thisRect.y + thisRect.height)) &&
               (thisRect.y < (rect.y + rect.height));
        
    },
    
    inflateRect: function(thisRect, x, y) {
        thisRect.x -= x;
        thisRect.y -= y;
        thisRect.width += (2 * x);
        thisRect.height += (2 * y);
    },
    
    rectContains:function(thisRect, x, y){
        return 
            ((thisRect.x <= x) && 
            (x < thisRect.x + thisRect.width) && 
            (thisRect.y <= y) &&
            (y < thisRect.y + thisRect.height));
        
    },
    
    rectContainsRect:function(thisRect, rect){
        return 
            ((thisRect.x <= rect.x) && 
            (rect.x + rect.width <= thisRect.x + thisRect.width) && 
            (thisRect.y <= rect.y) &&
            (rect.y + rect.height <= thisRect.y + thisRect.height));
    },
    
    getRectMaxX: function(rect)
    {
    	return rect.x + rect.width;
    },
	
    getRectMaxY: function(rect)
    {
    	return rect.y + rect.height;
    },
	
    getRectCenterX: function(rect)
    {
    	return rect.x + rect.width/2;
    },
	
    getRectCenterY: function(rect)
    {
    	return rect.y + rect.height/2;
    },
	
	// Point functions:
	
	movePoint : function(thisPoint, x, y)
	{
		thisPoint.x = x;
		thisPoint.y = y;
	},
	
	translatePoint : function(thisPoint, dx, dy)
	{
		thisPoint.x += dx;
		thisPoint.y += dy;
	},
	
	setPointLocation : function(thisPoint, p)
	{
		thisPoint.x = p.x;
		thisPoint.y = p.y;
	},
	
	floorPoint : function(thisPoint)
	{
		return {
			x: Math.floor(thisPoint.x),
			y: Math.floor(thisPoint.y)
		};
	},
	
	xFloorPoint : function(thisPoint)
	{
		return Math.floor(thisPoint.x);
	},
	
	yFloorPoint : function(thisPoint)
	{
		return Math.floor(thisPoint.y);
	},
	
	pointEquals : function(thisPoint, other)
	{
		if(thisPoint == other)
			return true;
		if(!thisPoint || !other)
			return false;
		return thisPoint.x == other.x &&
			   thisPoint.y == other.y;
	}	
};


dojo.declare('ibm_ilog.graphlayout.internalutil.GraphModelData', null, {
    /**
     * Default constructor
     */
    constructor: function(model)
    {
      model.setParameter(ibm_ilog.graphlayout.internalutil.GraphModelData.GraphModelDataKey, this);
    },
    
    // checking of layout that created me
    _checkOriginatingLayout : true,

    // A flag which indicates whether a recursive layout has been started
    // from this graph model.
    _duringRecursiveLayout : false,

    _originatingLayout : null,
    
    /**
     * Gets whether the extended checking of internally created
     * graph models is enabled.
     * 
     * If a grapher is attached directly, a graph model is created
     * internally. Internally created graph models are automatically
     * disposed of when no longer needed. If the checking is enabled,
     * exceptions are thrown in certain situations that are a potential
     * misuse of the internally created graph model, since it may be
     * disposed of too early.
     * The option is enabled by default.
     * Normally, you should not disable this option.
     */
    isInternalGraphModelChecking : function() {
      return this._checkOriginatingLayout;
    },
     
    setInternalGraphModelChecking : function(value) {
      this._checkOriginatingLayout = value;
    },

    /**
     * Gets whether we are inside a recursive layout.
     */
    isDuringRecursiveLayout : function() {
      return this._duringRecursiveLayout;
    },
    
    setDuringRecursiveLayout : function(value) {
      this._duringRecursiveLayout = value;
    },

    getOriginatingLayout : function() {
      return this._originatingLayout;
    },
    
    setOriginatingLayout : function(value) {
      this._originatingLayout = value;
    }
});

dojo.mixin(ibm_ilog.graphlayout.internalutil.GraphModelData, {
	
	GraphModelDataKey : "__GraphModelData",
    
    /**
     * Returns the graph model data of a graph model.
     */
    getData : function(model) {
      var data = model.getParameter(ibm_ilog.graphlayout.internalutil.GraphModelData.GraphModelDataKey);
      if (data == null)
        return new ibm_ilog.graphlayout.internalutil.GraphModelData(model);
      else
        return data;
    },

     /**
      * This is only here for translation purpose.
      */
     setInternalGraphModelChecking : function(model, flag) {
       ibm_ilog.graphlayout.internalutil.GraphModelData.getData(model).setInternalGraphModelChecking(flag);
     }
	
});

dojo.declare('ibm_ilog.graphlayout.internalutil.ArrayIterator', null, {
	// summary:
	//		implementation of the IIterator interface on a plain Array

	_array : null,
	_index : 0,

	constructor : function(array)
	{
		// summary:
		//		Creates an ArrayIterator based on a specified array.
		// array: Array: The Array to iterate over.
		
		this._array = array;
	},

	hasNext : function() {
		return this._index < this._array.length;
	},
	
	next: function() {
		if(this._index >= this._array.length)
			throw new Error("No such element");
		return this._array[this._index++];
	}
});

ibm_ilog.graphlayout.GraphLayoutRegionMode = {};
ibm_ilog.graphlayout.GraphLayoutRegionMode.RECTANGLE_IN_CONTAINER_COORDINATES = 0;
ibm_ilog.graphlayout.GraphLayoutRegionMode.RECTANGLE_IN_VIEW_COORDINATES = 1;
ibm_ilog.graphlayout.GraphLayoutRegionMode.VIEW_BOUNDS = 2;

ibm_ilog.graphlayout.internalutil.MatrixUtil = {
	zoomFactor : function(t)
	{
		return Math.min(Math.abs(t.xx), Math.abs(t.yy));
	},
	zoomXFactor : function(t)
	{
		return Math.abs(t.xx);
	},
	zoomYFactor : function(t)
	{
		return Math.abs(t.yy);
	},
	transformPoint : function(t, p)
	{
		var tmp = t.transformPoint(p);
		p.x = tmp.x;
		p.y = tmp.y;
		return p;
	},
	inversePoint : function(t, p)
	{
		var tmp = t.inverse().transformPoint(p);
		p.x = tmp.x;
		p.y = tmp.y;
		return p;
	},
	transformRectangle : function(t, r)
	{
		var tmp = t.transformRectangle(r);
		r.x = tmp.x;
		r.y = tmp.y;
		r.width = tmp.width;
		r.height = tmp.height;
		return r;
	},
	inverseRectangle : function(t, r)
	{
		var tmp = t.inverse().transformRectangle(r);
		r.x = tmp.x;
		r.y = tmp.y;
		r.width = tmp.width;
		r.height = tmp.height;
		return r;
	},
	compose: function(t1, t2)
	{
		var t = dojox.gfx.matrix.multiply(t1, t2);
		t1.xx = t.xx;
		t1.xy = t.xy;
		t1.yx = t.yx;
		t1.yy = t.yy;
		t1.dx = t.dx;
		t1.dy = t.dy;
	}
};

return dojo.getObject("ibm_ilog.graphlayout.internalutil.TranslateUtil");});
require(["ibm_ilog/graphlayout/internalutil/TranslateUtil"]);

},
'ibm_ilog*graphlayout/IIterator':function(){
define(["dojo","dijit","dojox"], function(dojo, dijit, dojox){
dojo.getObject("ibm_ilog.graphlayout.IIterator", 1);
/* builder delete begin
dojo.provide("ibm_ilog.graphlayout.IIterator");


 builder delete end */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// #######################################
// ######## NOT Generated by J2JS ########
// ###### DO NOT DELETE THIS FILE! #######
// #######################################

// ------------------------------------------------------------------------
// Iterator interface used 
// ------------------------------------------------------------------------

dojo.declare("ibm_ilog.graphlayout.IIterator", null, {
	// summary:
	//		A class to enumerate a set of values.
	// description:
	//		This class is used in the <code>ibm&#95;graphlayout</code> API to return a set of values that can be enumerated.
	//		You can use either the <code>hasNext()</code>/<code>next()</code> or <code>hasMoreElements()</code>/<code>nextElement()</code> pairs of methods,
	//		as follows:
	//		<pre>
	//		  var constraints = layout.getConstraints(); // returns an IITerator
	//		  while(constraints.hasNext()){
	//		    var constraint = constraints.next();
	//		    ...
	//		  }
	//		</pre>

	hasNext : function() {
		// summary:
		//		Returns true if another value is available, or false if the enumeration is done.
		return this.hasMoreElements(); // Boolean
	},
	
	next: function() {
		// summary:
		//		Returns the next value of the enumeration, or throws an Error if no value is available.
		return this.nextElement(); // Object
	},
	
	hasMoreElements : function() {
		// summary:
		//		Returns true if another value is available, or false if the enumeration is done.
		return this.hasNext(); // Boolean
	},
	
	nextElement: function() {
		// summary:
		//		Returns the next value of the enumeration, or throws an Error if no value is available.
		return this.next(); // Object
	}  
});

return dojo.getObject("ibm_ilog.graphlayout.IIterator");});
require(["ibm_ilog/graphlayout/IIterator"]);

},
'ibm_ilog*graphlayout/internalutil/SplineRouter':function(){
define(["dojo","dijit","dojox","ibm_ilog/graphlayout/internalutil/TranslateUtil","ibm_ilog/graphlayout/internalutil/Point","ibm_ilog/graphlayout/internalutil/Rectangle"], function(dojo, dijit, dojox){
dojo.getObject("ibm_ilog.graphlayout.internalutil.SplineRouter", 1);
/* builder delete begin
dojo.provide('ibm_ilog.graphlayout.internalutil.SplineRouter');


 builder delete end */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.Point');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.Rectangle');


 builder delete end */
dojo.declare('ibm_ilog.graphlayout.internalutil.SplineRouter', null, 
{
  // summary:
  //		A simple utility that corrects the bend points of links so that they
  //		become appropriate for splines. 
  // description:
  //		A simple utility that corrects the bend points of links so that they
  //		become appropriate for splines. 
  //		It assumes that we use smooth splines. polyline route. (This may not
  //		work with short link layout). The algorithm can handle intergraph
  //		links but requires a SubgraphData graph model in this case, because
  //		it needs a flat view of all node obstacles.  
  // tags:
  //		private
  
  _model: null,
  _layout: null,
  _percCompleteController: null,
  _percentageFromAll: null,
  _equalizeThreshold: null,
  _maxCurveLen: null,
  _minCurveLen: null,
  _includeNormalLinks: null,
  _includeIntergraphLinks: null,

  A : null,

  B : null,

  C : null,

  P : null,

  QR : null,
  _doIntergraphLinkCheck: null,
  _changed: null,
  _indexedSet: null,

  constructor : function(layout, percController, percentageFromAll, minCurveLen, maxCurveLen, equalizeThreshold, normalLinks, intergraphLinks)
  {
    this.A = new ibm_ilog.graphlayout.internalutil.Point();
    this.B = new ibm_ilog.graphlayout.internalutil.Point();
    this.C = new ibm_ilog.graphlayout.internalutil.Point();
    this.P = new ibm_ilog.graphlayout.internalutil.Point();
    this.QR = new ibm_ilog.graphlayout.internalutil.Rectangle();
    this._model = layout.getGraphModel();
    this._layout = layout;
    this._percCompleteController = percController;
    this._percentageFromAll = percentageFromAll;
    this._minCurveLen = minCurveLen;
    this._maxCurveLen = maxCurveLen;
    this._equalizeThreshold = equalizeThreshold;
    this._includeNormalLinks = normalLinks;
    this._includeIntergraphLinks = intergraphLinks;
    if (this._minCurveLen > this._maxCurveLen) {
      this._minCurveLen = this._maxCurveLen;
    }
  },
  
  isObstacle : function(node)
  {
    // summary:
    //		Returns whether the node is considered an obstacle.
    // tags:
    //		private
    
    return true; // Boolean
  },

  isReshapeAllowed : function(link)
  {
    // summary:
    //		Returns whether reshaping the link is allowed.
    // tags:
    //		private
    
    return true; // Boolean
  },

  isInvisibleToLink : function(node, link)
  {
    // summary:
    //		Returns whether the node is invisible to the link. 
    // description:
    //		Returns whether the node is invisible to the link. 
    //		If thats the case, the
    //		node's corner are not taken into account when calculating the spline bends for the link. The default implementation returns true if the link is an intergraph link of the SubgraphData graph model and the node is a subgraph that contains an end of the link.
    // tags:
    //		private
    
    if (this._doIntergraphLinkCheck)
    {
      var dmodel = this._model;
      if (dmodel.fromEndsInside(link, node)) {
        return true; // Boolean
      }
      if (dmodel.toEndsInside(link, node)) {
        return true; // Boolean
      }
    }

    return false; // Boolean
  },

  getCorners : function(node, bbox)
  {
    // summary:
    //		Returns the corners of a node. 
    // description:
    //		Returns the corners of a node. 
    //		The default implementation returns the corners of the bounding box
    //		of the node. To support different node shapes better, overridden
    //		versions can take the more precise corners of the node into account.
    // tags:
    //		private
    
    var corners = ibm_ilog.graphlayout.internalutil.TranslateUtil.newArray(4, null);
    corners[0] = new ibm_ilog.graphlayout.internalutil.Point(bbox.x, bbox.y);
    corners[1] = new ibm_ilog.graphlayout.internalutil.Point(bbox.x + bbox.width, bbox.y);
    corners[2] = new ibm_ilog.graphlayout.internalutil.Point(bbox.x, bbox.y + bbox.height);
    corners[3] = new ibm_ilog.graphlayout.internalutil.Point(bbox.x + bbox.width, bbox.y + bbox.height);
    return corners; // Array
  }

}
);

return dojo.getObject("ibm_ilog.graphlayout.internalutil.SplineRouter");});
require(["ibm_ilog/graphlayout/internalutil/SplineRouter"]);

},
'ibm_ilog*graphlayout/RLayoutModes':function(){
define(["dojo","dijit","dojox","ibm_ilog/graphlayout/internalutil/TranslateUtil"], function(dojo, dijit, dojox){
dojo.getObject("ibm_ilog.graphlayout.RLayoutModes", 1);
/* builder delete begin
dojo.provide('ibm_ilog.graphlayout.RLayoutModes');


 builder delete end */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');


 builder delete end */
dojo.declare('ibm_ilog.graphlayout.RLayoutModes', null, 
{
  // summary:
  //		This class contains all enumeration constants used for the layout
  //		modes for Recursive Layout. 
  // description:
  //		This class contains all enumeration constants used for the layout
  //		modes for Recursive Layout. 
  //		It also contains some generic support.   
  // tags:
  //		private
  
  constructor : function()
  {
    
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.RLayoutModes,
{
  REFERENCE_LAYOUT_MODE : null,
  INTERNAL_PROVIDER_MODE : null,
  SPECIFIED_PROVIDER_MODE : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.RLayoutModes;
    
    c.REFERENCE_LAYOUT_MODE = 0;
    c.INTERNAL_PROVIDER_MODE = 1;
    c.SPECIFIED_PROVIDER_MODE = 2;
  }
  
}
);

(function(){ ibm_ilog.graphlayout.RLayoutModes._fields_init(); })();

return dojo.getObject("ibm_ilog.graphlayout.RLayoutModes");});
require(["ibm_ilog/graphlayout/RLayoutModes"]);

},
'ibm_ilog*graphlayout/internalutil/Rectangle':function(){
define(["dojo","dijit","dojox"], function(dojo, dijit, dojox){
dojo.getObject("ibm_ilog.graphlayout.internalutil.Rectangle", 1);
/* builder delete begin
dojo.provide("ibm_ilog.graphlayout.internalutil.Rectangle");


 builder delete end */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// #######################################
// ######## NOT Generated by J2JS ########
// ###### DO NOT DELETE THIS FILE! #######
// #######################################

// ------------------------------------------------------------------------
// Utility methods used in the code generated by J2JS.
// ------------------------------------------------------------------------

dojo.declare('ibm_ilog.graphlayout.internalutil.Rectangle', null, {
    x: 0,
    y: 0,
    width: 0,
    height: 0,
    
    constructor: function(x, y, width, height) {
        this.x = x || 0;
        this.y = y || 0;
        this.width = width || 0;
        this.height = height || 0;
    }
});

return dojo.getObject("ibm_ilog.graphlayout.internalutil.Rectangle");});
require(["ibm_ilog/graphlayout/internalutil/Rectangle"]);

},
'ibm_ilog*graphlayout/internalutil/rowcolumngrid/LayoutModes':function(){
define(["dojo","dijit","dojox","ibm_ilog/graphlayout/internalutil/TranslateUtil"], function(dojo, dijit, dojox){
dojo.getObject("ibm_ilog.graphlayout.internalutil.rowcolumngrid.LayoutModes", 1);
/* builder delete begin
dojo.provide('ibm_ilog.graphlayout.internalutil.rowcolumngrid.LayoutModes');


 builder delete end */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');


 builder delete end */
dojo.declare('ibm_ilog.graphlayout.internalutil.rowcolumngrid.LayoutModes', null, 
{
  // summary:
  //		This class contains all enumeration constants used for layouts modes
  //		for internalutil/rowcolumngrid. 
  // description:
  //		This class contains all enumeration constants used for layouts modes
  //		for internalutil/rowcolumngrid. 
  //		This ensures that ALL modes of ALL layout algorithms share the same
  //		values.    
  // tags:
  //		private
  /*=====
  // TILE_TO_GRID_FIXED_WIDTH: int
  //		Tile-to-grid layout mode with fixed width of the grid.
  TILE_TO_GRID_FIXED_WIDTH : null,
  // TILE_TO_GRID_FIXED_HEIGHT: int
  //		Tile-to-grid layout mode with fixed height of the grid.
  TILE_TO_GRID_FIXED_HEIGHT : null,
  // TILE_TO_ROWS: int
  //		Tile-to-rows layout mode.
  TILE_TO_ROWS : null,
  // TILE_TO_COLUMNS: int
  //		Tile-to-columns layout mode.
  TILE_TO_COLUMNS : null,
  =====*/
  
  constructor : function()
  {
    
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.internalutil.rowcolumngrid.LayoutModes,
{
  TILE_TO_GRID_FIXED_WIDTH : null,

  TILE_TO_GRID_FIXED_HEIGHT : null,

  TILE_TO_ROWS : null,

  TILE_TO_COLUMNS : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.internalutil.rowcolumngrid.LayoutModes;
    
    c.TILE_TO_GRID_FIXED_WIDTH = 2;
    c.TILE_TO_GRID_FIXED_HEIGHT = 3;
    c.TILE_TO_ROWS = 0;
    c.TILE_TO_COLUMNS = 1;
  }
  
}
);

(function(){ ibm_ilog.graphlayout.internalutil.rowcolumngrid.LayoutModes._fields_init(); })();

return dojo.getObject("ibm_ilog.graphlayout.internalutil.rowcolumngrid.LayoutModes");});
require(["ibm_ilog/graphlayout/internalutil/rowcolumngrid/LayoutModes"]);

},
'ibm_ilog*graphlayout/internalutil/Point':function(){
define(["dojo","dijit","dojox"], function(dojo, dijit, dojox){
dojo.getObject("ibm_ilog.graphlayout.internalutil.Point", 1);
/* builder delete begin
dojo.provide("ibm_ilog.graphlayout.internalutil.Point");


 builder delete end */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// #######################################
// ######## NOT Generated by J2JS ########
// ###### DO NOT DELETE THIS FILE! #######
// #######################################

// ------------------------------------------------------------------------
// Utility methods used in the code generated by J2JS.
// ------------------------------------------------------------------------

dojo.declare('ibm_ilog.graphlayout.internalutil.Point', null, {
	x : 0,
	y : 0,
	
	constructor : function(x, y)
	{
		this.x = x || 0;
		this.y = y || 0;
	}
});

return dojo.getObject("ibm_ilog.graphlayout.internalutil.Point");});
require(["ibm_ilog/graphlayout/internalutil/Point"]);

},
'ibm_ilog*graphlayout/GraphLayout':function(){
define(["dojo","dijit","dojox","ibm_ilog/graphlayout/_GraphLayout","ibm_ilog/graphlayout/grid/GridLayout","ibm_ilog/graphlayout/RecursiveLayout"], function(dojo, dijit, dojox){
dojo.getObject("ibm_ilog.graphlayout.GraphLayout", 1);
/* builder delete begin
dojo.provide("ibm_ilog.graphlayout.GraphLayout");

 builder delete end */
/* builder delete begin
dojo.require("ibm_ilog.graphlayout._GraphLayout");

 builder delete end */
/* builder delete begin
dojo.require("ibm_ilog.graphlayout.grid.GridLayout");

 builder delete end */
/* builder delete begin
dojo.require("ibm_ilog.graphlayout.RecursiveLayout");

 builder delete end */
dojo.requireIf(!!dojo.global.ibm_ilog.diagram, 'ibm_ilog.diagram.graphlayout._base');

return dojo.getObject("ibm_ilog.graphlayout.GraphLayout");});
require(["ibm_ilog/graphlayout/GraphLayout"]);

},
'ibm_ilog*graphlayout/_RecursiveLayout':function(){
define(["dojo","dijit","dojox","ibm_ilog/graphlayout/internalutil/TranslateUtil","ibm_ilog/graphlayout/internalutil/LogResUtil","ibm_ilog/graphlayout/DefaultLayoutProvider","ibm_ilog/graphlayout/GraphLayout","ibm_ilog/graphlayout/RLayoutModes"], function(dojo, dijit, dojox){
dojo.getObject("ibm_ilog.graphlayout._RecursiveLayout", 1);
/* builder delete begin
dojo.provide('ibm_ilog.graphlayout._RecursiveLayout');


 builder delete end */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.LogResUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.DefaultLayoutProvider');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.GraphLayout');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.RLayoutModes');


 builder delete end */
dojo.declare('ibm_ilog.graphlayout.RecursiveLayout', ibm_ilog.graphlayout.GraphLayout, 
{
  // summary:
  //		The main class for the Recursive Layout algorithm. 
  // description:
  //		The main class for the Recursive Layout algorithm. 
  //		<p>
  //		This is not a layout algorithm but rather a facility to perform
  //		layouts recursively in a nested graph. Unless otherwise mentioned,
  //		the normal layout algorithms such as <code>
  //		ibm&#95;ilog.graphlayout.hierarchical.HierarchicalLayout</code>, <code>
  //		ibm&#95;ilog.graphlayout.tree.TreeLayout</code>, <code>
  //		ibm&#95;ilog.graphlayout.MultipleLayout</code>, and so forth work on a
  //		flat graph, that is, they lay out the attached graph but not the
  //		subgraphs of the attached graph. The Recursive Layout is different:
  //		it traverses the nesting structure starting from the attached graph
  //		and applies a layout recursively on all subgraphs. It can be tailored
  //		for which sublayout has to be applied to which subgraph.   
  //		</p>
  //		<p>
  //		There are basically two scenarios:  
  //		<ul>
  //		<li> The same layout style must be applied to all subgraphs.</li>  
  //		<li> An individual layout style must be applied to each
  //		subgraphs.</li>  
  //		</ul>
  //		<b>First scenario: Same layout style everywhere</b>  
  //		</p>
  //		<p>
  //		The following example shows the first scenario:   
  //		</p>
  //		<pre>
  //		GraphLayout layout = new RecursiveLayout(new TreeLayout());
  //		layout.attach(topLevelGrapher);
  //		LayoutReport report = layout.performLayout(true, true); </pre>
  //		In this case, a tree layout is performed recursively to the top-level
  //		graph and to each subgraph. All layouts are performed with the same
  //		global layout parameters as for the layout instance passed as an
  //		argument to the constructor of <code>RecursiveLayout</code>, which is
  //		called its <i>reference layout</i>. You can access the reference
  //		layout instance to change the global layout parameters:   
  //		<pre>
  //		TreeLayout treeLayout = (TreeLayout)layout.getReferenceLayout();
  //		treeLayout.setFlowDirection(Direction.Left); </pre>
  //		Internally, a clone of the reference instance is created for each
  //		subgraph. This clone remains attached as long as the Recursive Layout
  //		is attached to the top-level graph. Before layout is performed, the
  //		global layout parameters are copied from the reference instance to
  //		each clone. If you need to set layout parameters for individual nodes
  //		and links, you have to access the layout instance of the subgraph
  //		that owns the node or link:   
  //		<pre>
  //		TreeLayout treeLayout = (TreeLayout)layout.getLayout(subgraph);
  //		treeLayout.setAlignment(node, TreeLayout.TIP&#95;OVER); </pre>     
  //		<p>
  //		In the typical case, when you use instances of <code>Graphic</code>
  //		as nodes and instances of <code>Grapher</code> as subgraphs, it is:  
  //		</p>
  //		<pre>
  //		TreeLayout treeLayout = (TreeLayout)layout.getLayout(node.getGraphicBag());
  //		treeLayout.setAlignment(node, TreeLayout.TIP&#95;OVER); </pre>   
  //		<p>
  //		<b>Second scenario: Different layout styles at different
  //		subgraphs</b>  
  //		</p>
  //		<p>
  //		The following example shows the second scenario: Each subgraph should
  //		be laid out by a different layout style or with individual layout
  //		parameters. In this case, we need a layout provider (see <code>
  //		ibm&#95;ilog.graphlayout.ILayoutProvider</code>) that specifies which
  //		layout instance is used for which subgraph.   
  //		</p>
  //		<pre>
  //		GraphLayout layout = new RecursiveLayout(layoutProvider);
  //		layout.attach(topLevelGrapher);
  //		LayoutReport report = layout.performLayout(true, true); </pre>
  //		The layout provider returns a different layout instance for each
  //		subgraph. For example, it may return a grid layout for the top-level
  //		graph, but a tree layout for one subgraph and a bus layout for
  //		another subgraph of the top-level graph. Furthermore, each layout can
  //		have different global layout parameters. You can implement your own
  //		application-specific layout provider, or you can use the predefined
  //		<code> ibm&#95;ilog.graphlayout.DefaultLayoutProvider</code> or <code>
  //		RecursiveLayoutProvider</code> that allows you to specify the
  //		preferred layout of each subgraph. If neither a reference layout nor
  //		a layout provider is given to the Recursive Layout, an internal
  //		default layout provider of class <code>RecursiveLayoutProvider</code>
  //		is used. This allows you to specify the layouts of subgraphs in a
  //		very convenient way:   
  //		<pre>
  //		RecursiveLayout layout = new RecursiveLayout();
  //		layout.attach(topLevelGrapher);
  //		// specify the layout of the top-level graph
  //		layout.setLayout(null, new GridLayout());
  //		// specify the layout of subgraphs
  //		layout.setLayout(subgraph1, new TreeLayout());
  //		layout.setLayout(subgraph2, new BusLayout());
  //		// perform the layout
  //		LayoutReport report = layout.performLayout(true, true); </pre>
  //		In this scenario, there is no reference layout. All layout parameters
  //		of different subgraphs are independent. You access the layout
  //		instance of each individual subgraph in order to change global layout
  //		parameters for this subgraph as well as parameters of nodes and links
  //		of the subgraph. For instance, if the attached top-level graph
  //		contains two subgraphs, and node1 belongs to subgraph1 and node2
  //		belongs to subgraph2, you can set individual global and local layout
  //		parameters in this way:   
  //		<pre>
  //		// access the layout of the top-level graph
  //		GridLayout gridLayout = (GridLayout)layout.getLayout(null);
  //		gridLayout.setLayoutMode(GridLayout.TILE&#95;TO&#95;COLUMNS);
  //		// access the layouts of the subgraph
  //		TreeLayout treeLayout = (TreeLayout)layout.getLayout(subgraph1);
  //		treeLayout.setFlowDirection(Direction.Left);
  //		treeLayout.setAlignment(node1, TreeLayout.TIP&#95;OVER);
  //		BusLayout busLayout = (BusLayout)layout.getLayout(subgraph2);
  //		busLayout.setOrdering(BusLayout.ORDER&#95;BY&#95;HEIGHT);
  //		busLayout.setBus(node2);
  //		</pre>    
  //		<p>
  //		<b>Notes:</b>  
  //		<ul>
  //		<li> The normal layout algorithms such as <code>
  //		ibm&#95;ilog.graphlayout.hierarchical.HierarchicalLayout</code>, <code>
  //		ibm&#95;ilog.graphlayout.tree.TreeLayout</code>, <code>
  //		ibm&#95;ilog.graphlayout.MultipleLayout</code>, and so forth work only on
  //		a flat graph, but for convenience, you can apply <code>
  //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code> with the
  //		<code>traverse</code> flag set to <code>true</code>. This does not
  //		mean that the normal layout instance works on the entire nested graph
  //		including the subgraphs in this case. In fact, internally it uses a
  //		Recursive Layout in reference layout mode, that is, a clone of the
  //		top-level graph layout instance is created for each subgraph, and
  //		these clones are applied recursively to the nested graph. Each clone
  //		still treats only a flat graph.</li>  
  //		<li> It is not possible to create a Recursive Layout that has a
  //		Recursive Layout as reference layout:   
  //		<pre>
  //		layout = new RecursiveLayout(new RecursiveLayout()); </pre>
  //		This calls the copy constructor of the Recursive Layout, but does not
  //		create a Recursive Layout in reference layout mode. A Recursive
  //		Layout inside another Recursive Layout would traverse the nested
  //		graph and perform the Recursive Layout for each subgraph, which,
  //		however, itself would recursively traverse the nested graph again.
  //		This would just be waste of run time.</li>  
  //		<li> The layout event listeners installed at the Recursive Layout
  //		receive layout events whenever the layout of a subgraph fires a
  //		layout event. These events, however, do not contain the information
  //		on which sublayout was started or finished. If you need this
  //		information, you should install an event listener at all
  //		sublayouts.</li>  
  //		<li> If you want to combine <code>MultipleLayout</code> and
  //		<code>RecursiveLayout</code>, you should use <code>
  //		RecursiveMultipleLayout</code>, in particular when you use explicitly
  //		specified labeling models. The Recursive Layout that has a Multiple
  //		Layout as the reference layout works as long as default labeling
  //		models (instances of <code>
  //		ibm&#95;ilog.graphlayout.label.DefaultLabelingModel</code>) are used. The
  //		Recursive Multiple Layout is more flexible; it is in principle a
  //		Recursive Layout that has instances of Multiple Layout as sublayouts
  //		for the subgraphs.  Additionally, the Recursive Multiple Layout
  //		ensures that the correct labeling models (clones of the specified
  //		labeling model) are created in the nested graph. </li>  
  //		</ul>  
  //		</p>
  /*=====
  // REFERENCE_LAYOUT_MODE: int
  //		Layout mode with reference layout.
  REFERENCE_LAYOUT_MODE : null,
  // INTERNAL_PROVIDER_MODE: int
  //		Layout mode with internal layout provider.
  INTERNAL_PROVIDER_MODE : null,
  // SPECIFIED_PROVIDER_MODE: int
  //		Layout mode with explicitly specified provider.
  SPECIFIED_PROVIDER_MODE : null,
  =====*/
  
  constructor : function()
  {
    
  this.DEFAULT_RECURSIVE_ALLOWED_TIME = 1000000000;},

  _layoutProvider: null,
  _referenceLayout: null,

  _mode: null,
  _subgraphCorrection: null,

  _force: null,
  _subgraphsToLayout: null,
  _actLayout: null,
  _startTime: null,
  _stoppedBeforeCompletion: null,
  _oldAllowedTime: null,

  _basePercentage: null,
  _numSubLayouts: null,

  _usePercentageCompletionSubstitute: null,
  _numStepsInSublayout: null,

  DEFAULT_RECURSIVE_ALLOWED_TIME : null,

  constructor : function(layout, layoutProvider)
  {
  // summary:
  //        Creates a new instance of the Recursive Layout algorithm that allows
  //        you to apply layouts to the entire nested graph.
  // description:
  //        If a layout instance is provided, this constructor creates a new
  //        recursive layout instance using the layout as a reference. In this
  //        case, the recursive layout mode is REFERENCE_LAYOUT_MODE.
  //        If the given layout is a recursive layout, this constructor creates
  //        a new recursive layout instance by copying the given one.
  //        
  //        If a layout instance is not provided, but a layout provider is passed
  //        as parameter, the recursive layout instance will have a layout mode
  //        set to SPECIFIED_PROVIDER_MODE. Therefore using the
  //        layout instances as specified by the layout provider.
  //        
  //        If neither the layout nor the layout provider are specified,
  //        the recursive layout instance created is set to INTERNAL_LAYOUT_MODE.
  // layout: ibm_ilog.graphlayout.GraphLayout:
  //        If the given layout is a recursive layout, this constructor
  //        creates a new layout instance by copying the given one. If this is another
  //        layout, this constructor creates a new instance of the Recursive Layout
  //        algorithm that allows you to apply the reference layout to the entire nested graph.
  // layoutProvider: ibm_ilog.graphlayout.ILayoutProvider:
  //        Allows to specify a different layout style or individual
  //        layout parameters to each subgraph of the nested graph. When this parameter is
  //        specified, the layout mode of this Recursive Layout is SPECIFIED_PROVIDER_MODE.
    if(layout instanceof ibm_ilog.graphlayout.GraphLayout &&
       layoutProvider instanceof ibm_ilog.graphlayout.GraphLayout){
      layout = new ibm_ilog.graphlayout.MultipleLayout(layout, layoutProvider);
      layoutProvider = null;
    }
    if (layout != null) {
      if (layout instanceof ibm_ilog.graphlayout.RecursiveLayout) {
        // Copy source layout
        this.copyParameters(layout);
        this.setParametersUpToDate(false);
      } else {
        // Use given layout as reference
        this.setLayoutMode(ibm_ilog.graphlayout.RecursiveLayout.REFERENCE_LAYOUT_MODE, layout, null);
      }
    } else {
      if (layoutProvider != null) {
        this.setLayoutMode(ibm_ilog.graphlayout.RecursiveLayout.SPECIFIED_PROVIDER_MODE, null, layoutProvider);
      } else {
        this.setLayoutMode(ibm_ilog.graphlayout.RecursiveLayout.INTERNAL_PROVIDER_MODE, null, null);
      }
    }
  },
  
  init : function()
  {
    // summary:
    //		Initializes instance variables. 
    // description:
    //		Initializes instance variables. 
    //		<p>
    //		You should not call this method directly. The method is called
    //		internally by the constructor without arguments and by the copy
    //		constructor. The method must be overridden by subclasses that need
    //		to initialize additional instance variables.
    //		</p>
    // tags:
    //		protected
    
    this.inherited("init", arguments, []);
    this._subgraphCorrection = null;
    this.DEFAULT_RECURSIVE_ALLOWED_TIME = 100000000;
    this.setAllowedTime(this.DEFAULT_RECURSIVE_ALLOWED_TIME);
  },

  copy : function()
  {
    // summary:
    //		Copies the layout instance. 
    // description:
    //		Copies the layout instance. 
    //		<p>
    //		This method copies the layout instance by calling the copy
    //		constructor. Note that the parameters which are specific to a node
    //		or a link are not copied. It depends on the layout mode what is
    //		copied.  
    //		<ul>
    //		<li> <code> RecursiveLayout.REFERENCE&#95;LAYOUT&#95;MODE</code> - The
    //		reference layout is copied deeply.</li>  
    //		<li> <code> RecursiveLayout.INTERNAL&#95;PROVIDER&#95;MODE</code> - The
    //		information on which subgraph uses which sublayout is not
    //		copied.</li>  
    //		<li> <code> RecursiveLayout.SPECIFIED&#95;PROVIDER&#95;MODE</code> - The
    //		specified layout provider is copied, but not deeply.</li>  
    //		</ul>  
    //		</p>
    // returns:
    //		A copy of the layout instance.
    
    return new ibm_ilog.graphlayout.RecursiveLayout(this); // ibm_ilog.graphlayout.GraphLayout
  },

  copyParameters : function(source)
  {
    // summary:
    //		Copies the parameters from a given layout instance. 
    // description:
    //		Copies the parameters from a given layout instance. 
    //		Note that the parameters which are specific to a node or a link are
    //		not copied. It depends on the layout mode what is copied:  
    //		<ul>
    //		<li> <code> RecursiveLayout.REFERENCE&#95;LAYOUT&#95;MODE</code> - The
    //		reference layout is copied deeply.</li>  
    //		<li> <code> RecursiveLayout.INTERNAL&#95;PROVIDER&#95;MODE</code> - The
    //		information on which subgraph uses which sublayout is not
    //		copied.</li>  
    //		<li> <code> RecursiveLayout.SPECIFIED&#95;PROVIDER&#95;MODE</code> - The
    //		specified layout provider is copied, but not deeply.</li>  
    //		</ul>  
    // source: ibm_ilog.graphlayout.GraphLayout
    //		The layout instance from which the parameters are copied.
    
    this.inherited("copyParameters", arguments, [source]);

    if (source instanceof ibm_ilog.graphlayout.RecursiveLayout)
    {
      var rsource = source;

      this._savePreferredLayouts = rsource._savePreferredLayouts;
      this._loadLayoutMode = rsource._loadLayoutMode;

      this._subgraphCorrection = rsource._subgraphCorrection;
      this._mode = rsource.getLayoutMode();

      switch (this._mode)
      {
        case ibm_ilog.graphlayout.RecursiveLayout.REFERENCE_LAYOUT_MODE:
          this.copyReferenceLayout(rsource._referenceLayout);

          this.initDefaultLayoutProvider();

          break;
        case ibm_ilog.graphlayout.RecursiveLayout.INTERNAL_PROVIDER_MODE:
          this.initRecursiveLayoutProvider();

          break;
        case ibm_ilog.graphlayout.RecursiveLayout.SPECIFIED_PROVIDER_MODE:
          break;
      }
    }
  },

  initDefaultLayoutProvider : function()
  {
    // summary:
    // tags:
    //		private
    
  },

  initRecursiveLayoutProvider : function()
  {
    // summary:
    // tags:
    //		private
    
  },

  setLayoutMode : function(mode, referenceLayout, layoutProvider)
  {
    // summary:
    //		Set the layout mode. 
    // description:
    //		Set the layout mode. 
    //		This is nonpublic. It is used for the save/loadParameters mechanism.
    // tags:
    //		private
    
    if (this.getGraphModel() != null) {
      this.beforeDetach();
    }
    var msg = null;
    this._mode = mode;

    switch (mode)
    {
      case ibm_ilog.graphlayout.RecursiveLayout.REFERENCE_LAYOUT_MODE:
        if (referenceLayout == null)
        {
          ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.RecursiveLayout, "graphlayout.expert.message.6677E");
        }

        if (referenceLayout instanceof ibm_ilog.graphlayout.RecursiveLayout)
        {
          ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.RecursiveLayout, "graphlayout.expert.message.6678E");
        }

        this._referenceLayout = referenceLayout;

        this.initDefaultLayoutProvider();

        break;
      case ibm_ilog.graphlayout.RecursiveLayout.INTERNAL_PROVIDER_MODE:
        this._referenceLayout = null;

        this.initRecursiveLayoutProvider();

        break;
      case ibm_ilog.graphlayout.RecursiveLayout.SPECIFIED_PROVIDER_MODE:
        if (layoutProvider == null)
        {
          ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.RecursiveLayout, "graphlayout.expert.message.6676E");
        }

        this._referenceLayout = null;
        this._layoutProvider = layoutProvider;
        break;
    }
    if (this.getGraphModel() != null) {
      this.afterAttach(this.getGraphModel());
    }
  },

  getLayoutMode : function()
  {
    // summary:
    //		Returns the layout mode of the Recursive Layout. 
    // description:
    //		Returns the layout mode of the Recursive Layout. 
    //		The possible values are:  
    //		<ul>
    //		<li> <code> RecursiveLayout.REFERENCE&#95;LAYOUT&#95;MODE</code> - The same
    //		layout style with the same global layout parameters is applied to
    //		all subgraphs of the nested graph.</li>  
    //		<li> <code> RecursiveLayout.INTERNAL&#95;PROVIDER&#95;MODE</code> - The
    //		layout is applied using an internal recursive layout provider. The
    //		layout styles of individual subgraphs can be specified by <code>
    //		RecursiveLayout.setLayout()</code>.</li>  
    //		<li> <code> RecursiveLayout.SPECIFIED&#95;PROVIDER&#95;MODE</code> - The
    //		layout is applied using an explicitly specified layout
    //		provider.</li>  
    //		</ul>  
    // returns:
    //		The layout mode.
    
    return this._mode; // int
  },

  getLayoutProvider : function()
  {
    // summary:
    //		Returns the layout provider. 
    // description:
    //		Returns the layout provider. 
    //		<p>
    //		If the reference layout mode is used, this method returns an
    //		internally created instance of <code>
    //		ibm&#95;ilog.graphlayout.DefaultLayoutProvider</code>.  
    //		</p>
    //		<p>
    //		If the internal provider mode is used, this method returns an
    //		internally created instance of <code>
    //		RecursiveLayoutProvider</code>.  
    //		</p>
    //		<p>
    //		In both reference layout and internal provider modes, you should not
    //		manipulate the internally created layout provider directly.  
    //		</p>
    //		<p>
    //		If the specified provider mode is used, it returns the specified
    //		layout provider.  
    //		</p>
    // returns:
    //		The layout provider, which is the instance that is responsible
    //		for specifying the layout instance to be used for laying out each
    //		graph.
    
    return this._layoutProvider; // ibm_ilog.graphlayout.ILayoutProvider
  },

  getReferenceLayout : function()
  {
    // summary:
    //		Returns the reference layout if the reference layout mode is used;
    //		returns 'null' otherwise. 
    // description:
    //		Returns the reference layout if the reference layout mode is used;
    //		returns <code>null</code> otherwise. 
    //		<p>
    //		In reference layout mode, the reference layout is used to lay out
    //		the top-level graph. Clones of the reference layout are used to lay
    //		out the subgraphs. The entire nested graph is laid out with the
    //		global layout parameters of the reference layout. If you change
    //		global layout parameters of the reference layout, this will affect
    //		the layout of subgraphs as well, because the global layout
    //		parameters are copied from the reference layout to the layouts of
    //		the subgraphs.  
    //		</p>
    // returns:
    //		The reference layout if the reference layout mode is used.
    
    return this._referenceLayout; // ibm_ilog.graphlayout.GraphLayout
  },

  copyReferenceLayout : function(sourceReferenceLayout)
  {
    // summary:
    //		Copies the input reference layout.
    // tags:
    //		private
    
    if (sourceReferenceLayout == this._referenceLayout) {
      return;
    }
    if (sourceReferenceLayout == null)
    {
      if (this._referenceLayout != null) {
        this._referenceLayout.detach();
      }
      this._referenceLayout = null;
    }
    else
    {
      if (this._referenceLayout == null) {
        this._referenceLayout = sourceReferenceLayout.copy();
      }
      else if (sourceReferenceLayout.declaredClass == this._referenceLayout.declaredClass) {
        this._referenceLayout.copyParameters(sourceReferenceLayout);
      }
      else
      {
        var tmodel = this._referenceLayout.getGraphModel();
        this._referenceLayout.detach();
        this._referenceLayout = sourceReferenceLayout.copy();
        if (tmodel != null) {
          this._referenceLayout.attach(tmodel);
        }
      }
    }
  },

  setLayout : function(subgraph, layout)
  {
    // summary:
    //		Sets the layout instance to be used for the input subgraph. 
    // description:
    //		Sets the layout instance to be used for the input subgraph. 
    //		If <code>null</code> is passed as the subgraph, the input layout is
    //		used for the top-level graph. If <code>null</code> is passed as the
    //		layout, no layout will be performed for the corresponding subgraph. 
    //		
    //		<p>
    //		You can use this method only in internal provider mode. You must
    //		attach a grapher or graph model first before using this method. Each
    //		subgraph must get a different layout instance, that is, the layout
    //		instances cannot be shared among different subgraphs. The input
    //		layout is automatically attached and detached by the Recursive
    //		Layout as needed.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // subgraph: Object
    //		The subgraph or 'null'.
    // layout: ibm_ilog.graphlayout.GraphLayout
    //		The layout instance used to lay out the subgraph. This
    //		should be a new layout instance that is not used anywhere else.
    
    this.setLayout(subgraph, layout, true, false);
  },

  getLayout : function(subgraph)
  {
    // summary:
    //		Returns the layout instance to be used for the input subgraph. 
    // description:
    //		Returns the layout instance to be used for the input subgraph. 
    //		If <code>null</code> is passed as the subgraph, the layout instance
    //		of the top-level graph is returned. You can use this method in all
    //		layout modes. You must attach a  graph model first before using this
    //		method. The method may return <code>null</code> if no layout should
    //		be performed for the subgraph.  
    //		<p>
    //		In reference layout mode, changing global layout parameters of the
    //		layout instances of subgraphs is useless, because during layout, the
    //		global parameters of the reference layout are used for each
    //		subgraph.  
    //		</p>
    // subgraph: Object
    //		The subgraph or 'null'.
    // returns:
    //		The layout instance used to lay out the subgraph.
    
    var model = this.getGraphModel();

    if (model == null)
    {
      var name = "getLayout";
      var params = [name ];
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.RecursiveLayout, "graphlayout.expert.message.6680E", params);
    }

    var provider = this.getLayoutProvider();
    var submodel;
    var result;

    if (subgraph == null || subgraph == this.getGraphModel())
    {
      submodel = model;

      var flag = ibm_ilog.graphlayout.internalutil.GraphModelData.getData(model).internalGraphModelChecking;

      try
      {
        ibm_ilog.graphlayout.internalutil.GraphModelData.setInternalGraphModelChecking(model, false);
        result = this.getCleanLayout(submodel, provider.getGraphLayout(submodel));
      }
      finally
      {
        ibm_ilog.graphlayout.internalutil.GraphModelData.setInternalGraphModelChecking(model, flag);
      }
    }
    else
    {
      submodel = model.getGraphModel(subgraph);
      result = this.getCleanLayout(submodel, provider.getGraphLayout(submodel));
    }

    return result; // ibm_ilog.graphlayout.GraphLayout
  },

  getLayouts : function(preOrder)
  {
    // summary:
    //		Returns the instances of 'GraphLayout' for the nested
    //		graph encapsulated by the graph model of this layout instance. 
    // description:
    //		Returns the instances of <code>GraphLayout</code> for the nested
    //		graph encapsulated by the graph model of this layout instance. 
    //		You can use this method in all layout modes. You must attach a 
    //		graph model before using this method.  
    //		<p>
    //		This method returns the layout instance for the top-level graph and
    //		recursively for all subgraphs. The order of the enumeration can be
    //		preorder (that is, the layout of the parent graph comes before the
    //		layout of the subgraphs) or postorder (that is, the layout of the
    //		subgraphs comes before the layout of the parent graph).  
    //		</p>
    //		<p>
    //		In reference layout mode, changing global layout parameters of the
    //		layout instances of subgraphs is useless, because during layout, the
    //		global parameters of the reference layout are used for each
    //		subgraph.  
    //		</p>
    // preOrder: Boolean
    //		If 'true', the layout instances are returned
    //		in preorder, otherwise in postorder.
    // returns:
    //		The instances of 'GraphLayout' for the nested
    //		graph encapsulated by the graph model of this layout instance.
    
    return this.getLayoutsImpl(preOrder); // ibm_ilog.graphlayout.IIterator
  },

  getCleanLayout : function(model, layout)
  {
    // summary:
    //		Cleans the mess in reference layout mode. 
    // description:
    //		Cleans the mess in reference layout mode. 
    //		Normally this is not necessary, if people would follow the
    //		documentation. But just to be sure nobody has messed up in
    //		REFERENCE&#95;LAYOUT&#95;MODE, we make sure that the layout has the same
    //		global parameters as the reference layout.
    // tags:
    //		private
    
    if (this.getLayoutMode() == ibm_ilog.graphlayout.RecursiveLayout.REFERENCE_LAYOUT_MODE)
    {
      if (layout == null || !layout.declaredClass == this.getReferenceLayout().declaredClass)
      {
        if (model == null && layout != null) {
          model = layout.getGraphModel();
        }
        layout = this.getReferenceLayout().copy();
        var provider = this.getLayoutProvider();
        if (model != null) {
          provider.setPreferredLayout(model, layout);
        }
      }
      else if (layout != this.getReferenceLayout()) {
        layout.copyParameters(this.getReferenceLayout());
      }
    }

    return layout; // ibm_ilog.graphlayout.GraphLayout
  },

  attach : function(graphModel)
  {
    // summary:
    //		Allows you to specify the top-level graph model of the nested graph
    //		you want to lay out. 
    // description:
    //		Allows you to specify the top-level graph model of the nested graph
    //		you want to lay out. 
    //		<p>
    //		In addition to the functionality of the base class, the Recursive
    //		Layout prepares and attaches the reference layout in layout mode
    //		<code> RecursiveLayout.REFERENCE&#95;LAYOUT&#95;MODE</code>.  
    //		</p>
    // graphModel: ibm_ilog.graphlayout.AbstractGraphLayoutModel
    //		The graph model.
    
    this.inherited("attach", arguments, [graphModel]);
    this.afterAttach(graphModel);
  },

  afterAttach : function(graphModel)
  {
    // summary:
    //		In reference layout mode, attach the reference layout.
    // tags:
    //		private
    
    if (this.getLayoutMode() == ibm_ilog.graphlayout.RecursiveLayout.REFERENCE_LAYOUT_MODE)
    {
      var refLayout = this.getReferenceLayout();
      var provider = this.getLayoutProvider();

      var flag = ibm_ilog.graphlayout.internalutil.GraphModelData.getData(graphModel).internalGraphModelChecking;

      try
      {
        ibm_ilog.graphlayout.internalutil.GraphModelData.setInternalGraphModelChecking(graphModel, false);
        provider.setPreferredLayout(graphModel, refLayout);
      }
      finally
      {
        ibm_ilog.graphlayout.internalutil.GraphModelData.setInternalGraphModelChecking(graphModel, flag);
      }

      if (refLayout.getGraphModel() != graphModel)
      {
        if (refLayout.getGraphModel() != null) {
          refLayout.detach();
        }
        refLayout.attach(graphModel);
      }
    }
  },

  detach : function()
  {
    // summary:
    //		Detaches the graph model from the layout instance. 
    // description:
    //		Detaches the graph model from the layout instance. 
    //		When you attach a new graph model to the layout instance, you do not
    //		need to detach the old graph model because this is done
    //		automatically when you call <code> RecursiveLayout.attach()</code>.
    //		The <code>detach</code> method performs cleaning operations on the
    //		graph model. In addition to the cleaning operations in the base
    //		class, the Recursive Layout detaches the sublayouts of subgraphs. In
    //		internal provider mode, it also cleans all settings of layout
    //		instances for subgraphs.  
    //		<p>
    //		Note that you must call this method when you no longer need the
    //		layout instance. Otherwise, some objects may not be garbage
    //		collected.  
    //		</p>
    
    this.beforeDetach();
    this.inherited("detach", arguments, []);
  },

  beforeDetach : function()
  {
    // summary:
    //		Detach the sublayouts if necessary.
    // tags:
    //		private
    
    var model = this.getGraphModel();

    if (model != null)
    {
      var provider = this.getLayoutProvider();

      if (provider != null && provider instanceof ibm_ilog.graphlayout.DefaultLayoutProvider) {
        (provider).detachLayouts(model, true);
      }
      else
      {
        var e = this.getLayoutsImpl(true);

        while (e.hasNext())
        {
          var layout = e.next();
          if (layout != null && layout.getGraphModel() != null) {
            layout.detach();
          }
        }
      }
    }
  },

  performLayout : function(force, traverse)
  {
    // summary:
    //      This is different from the implementation of the base class; the Recursive
    //      Layout always ignores the <code>traverse</code> flag because the layout is
    //      always done recursively.
    this._force = force;
    return this.inherited("performLayout", arguments, [force, false]);
  },
  
  performSubgraphLayout : function(subgraph, force, traverse)
  {
  // summary:
  //        Starts the layout algorithm with a subgraph.
  // description:
  //        Layout is performed for <code>subgraph</code> and, the <code>traverse</code>
  //        flag is set to <code>true</code> recursively for all subgraphs
  //        contained in this <code>subgraph</code>. If the <code>subgraph</code> is set
  //        to <code>null</code>, the layout is started at the top level graph.
  // subgraph:
  //        The subgraph to start the layout.
  // force:
  //        If <code>true</code>, the method {@link #isLayoutNeeded}
  //        is not called. No check is made to determine if it is necessary
  //        to perform the layout.
  // traverse:
  //        If <code>true</code>, the layout is applied recursively
  //        to all subgraphs contained in the subgraph.
  //        Otherwise, it is only applied on the input subgraph.
  // returns:
  //        The report with information about the execution of
  //        the graph layout in the given subgraph.
    this.collectSubgraphsToLayout(subgraph, traverse);
    this.performLayout(force);
    this._subgraphsToLayout = null;
    return this.getLayoutReport();
  },
  
  performSublayout : function(subgraph, layout, force)
  {
  // summary:
  //        Starts the input layout algorithm.
  // description:
  //        This method is used when this layout controls the input layout as
  //        a sublayout.
  //        Layout classes can override this method if changes are needed with
  //        respect to the way in which the input layout is started.
  //        You should not call this method directly.
  //        In addition to the functionality of the base class, the Recursive
  //        Layout prepares the sublayouts according to the layout mode.
  // subgraph:
  //        The subgraph if used during nested layout, or <code>null</code>.
  // layout:
  //        The sublayout to be preformed.
  // force:
  //        If <code>true</code>, no check is made to determine if
  //        it is necessary to perform the layout.
  // returns:
  //        The layout code.
  //        @see GraphLayoutReport#code
    if(this._callSuper_performSublayout)
      return this.inherited("performSublayout", arguments, [subgraph, layout, force, true]);
    return this.performSublayoutImpl(subgraph, layout, force, true);
  },
  
  mayContinue : function()
  {
    // summary:
    //		Returns true if layout should continue.
    // tags:
    //		private
    
    if (this._stoppedBeforeCompletion) {
      return false; // Boolean
    }
    if (this.isLayoutTimeElapsed() || this.isStoppedImmediately())
    {
      this._stoppedBeforeCompletion = true;
      return false; // Boolean
    }

    return true; // Boolean
  },

  setSubgraphCorrectionInterface : function(ifc)
  {
    // summary:
    //		Sets the correction strategy for subgraphs. 
    // description:
    //		Sets the correction strategy for subgraphs. 
    //		The method <code> ISubgraphCorrection.correct()</code> of the
    //		subgraph correction interface is called immediately after the layout
    //		of the subgraph has finished. This allows you, for instance, to
    //		correct the position of the subgraph after its contents have been
    //		laid out.  
    //		<p>
    //		If all subgraphs are laid out completely, and the layout mode of all
    //		layouts in the nested graph is not incremental, then you do not need
    //		to install any subgraph correction interface. However, in the
    //		following situations, it is useful to install a subgraph correction
    //		interface:  
    //		<ul>
    //		<li> The subgraph is laid out, but its parent graph is not laid out
    //		(because no layout is specified for the parent graph).</li>  
    //		<li> The subgraph is laid out, but the subgraph is specified as
    //		fixed inside the parent graph (for instance by <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.isFixed()</code>).</li>  
    //		<li> The subgraph and its parent graph are laid out, but the layout
    //		of the parent graph uses an incremental mode that analyzes the old
    //		position of the subgraph (see for instance <code>
    //		ibm&#95;ilog.graphlayout.tree.TreeLayout.setIncrementalMode()</code> or
    //		<code>
    //		ibm&#95;ilog.graphlayout.hierarchical.HierarchicalLayout.setIncrementalMode()</code>).
    //		</li>  
    //		</ul>
    //		If subgraphs of type <code> ibm&#95;ilog.diagram.Graph</code> are used,
    //		the layout of the subgraph affects the bounding box of the subgraph.
    //		The subgraph may appear at a completely different position after
    //		layout, even though no layout of the parent graph was performed that
    //		contains the subgraph as a node, and even though <code>
    //		ibm&#95;ilog.diagram.Graph.moveObject()</code> was never called for the
    //		subgraph. The reason for this effect is simply the internal bounding
    //		box mechanism of <code> ibm&#95;ilog.diagram.Graph</code>. This effect
    //		is very unfortunate in the situations that were described above.
    //		There are two predefined subgraph correction strategies that help to
    //		eliminate this effect: <code>
    //		SubgraphCorrectionBarycenterFixed</code> and <code>
    //		SubgraphCorrectionBoundsFixed</code>.   
    //		</p>
    
    if (this._subgraphCorrection != ifc)
    {
      this._subgraphCorrection = ifc;
      this.onParameterChanged("SubgraphCorrectionInterface");
    }
  },

  getSubgraphCorrectionInterface : function()
  {
    // summary:
    //		Returns the subgraph correction interface that is applied after the
    //		nodes and links of the subgraph were laid out. 
    // description:
    //		Returns the subgraph correction interface that is applied after the
    //		nodes and links of the subgraph were laid out. 
    //		<p>
    //		It returns <code>null</code> if none is specified.  
    //		</p>
    
    return this._subgraphCorrection; // ibm_ilog.graphlayout.ISubgraphCorrection
  },

  setAllowedTime : function(time)
  {
    // summary:
    //		Sets the upper limit for the duration of the layout algorithm. 
    // description:
    //		Sets the upper limit for the duration of the layout algorithm. 
    //		<p>
    //		The default value for Recursive layout is <code>1000000000</code>
    //		(1000000 seconds). The allowed time is additionally limited by the
    //		allowed time parameter on the sublayouts.  
    //		</p>
    // time: Number
    //		The allowed time in milliseconds.
    
    this.inherited("setAllowedTime", arguments, [time]);
  },

  getAllowedTime : function()
  {
    // summary:
    //		Returns the currently allowed time for the layout algorithm in
    //		milliseconds. 
    // description:
    //		Returns the currently allowed time for the layout algorithm in
    //		milliseconds. 
    //		The allowed time is additionally limited by the allowed time
    //		parameter on the sublayouts. The effective allowed time is the
    //		minimum of the sum of allowed times for for the sublayouts and the
    //		value returned as allowed time for this Recursive layout.  
    //		<p>
    //		Note that the method <code>performLayout</code> does not
    //		automatically stop the layout when the allowed time is exceeded. It
    //		only delegates  the stop to the sublayouts, and it is entirely the
    //		responsibility of the implementation of the method <code>
    //		RecursiveLayout.layout()</code> on the sublayouts to do this.  
    //		</p>
    
    return (false ? this.DEFAULT_RECURSIVE_ALLOWED_TIME : this.inherited("getAllowedTime", arguments, [])); // Number
  },

  setMinBusyTime : function(time)
  {
    // summary:
    //		Sets the minimal time the layout algorithm can be busy between two
    //		calls of '
    //		ibm_ilog.graphlayout.GraphLayout.onLayoutStepPerformed()' when
    //		the method '
    //		ibm_ilog.graphlayout.GraphLayout.callLayoutStepPerformedIfNeeded()'
    //		is used. 
    // description:
    //		Sets the minimal time the layout algorithm can be busy between two
    //		calls of <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.onLayoutStepPerformed()</code> when
    //		the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.callLayoutStepPerformedIfNeeded()</code>
    //		is used. 
    //		In reference layout mode, it also calls <code>setMinBusyTime</code> 
    //		at the reference layout, hence all layouts of subgraphs will use
    //		this parameter setting. If a graph is attached and the layout mode
    //		is the internal or specified provider mode, it traverses the nesting
    //		hierarchy and calls <code>setMinBusyTime</code>  for all layout
    //		instances of subgraphs. However, if you insert subgraphs after
    //		calling this method, or if you change the layout instances of
    //		subgraphs in your specified provider or via <code>
    //		RecursiveLayout.setLayout()</code> in the internal provider after
    //		calling this method, the new layouts of these subgraphs may have a
    //		different setting.  
    //		<p>
    //		Warning: In internal or specified provider mode, this method does
    //		not throw an exception when no graph model is yet attached. However,
    //		if no graph model is yet attached, the method cannot traverse any
    //		nesting hierarchy.  
    //		</p>
    //		<p>
    //		The default value is <code>50</code> (milliseconds). 
    //		</p>
    
    this.inherited("setMinBusyTime", arguments, [time]);

    if (this.getLayoutMode() == ibm_ilog.graphlayout.RecursiveLayout.REFERENCE_LAYOUT_MODE) {
      this.getReferenceLayout().setMinBusyTime(time);
    }
    else if (this.getGraphModel() != null)
    {
      var e = this.getLayoutsImpl(true);

      while (e.hasNext())
      {
        var layout = e.next();
        if (layout != null) {
          layout.setMinBusyTime(time);
        }
      }
    }
  },

  setLayoutRunning : function(running, fromParents)
  {
    // summary:
    //		Sets whether layout is running. 
    // description:
    //		Sets whether layout is running. 
    //		This method is part of IBM ILOG Dojo Diagrammer internals. You
    //		should not use it.   
    // running: Boolean
    //		Whether layout is running or not.
    // fromParents: Boolean
    //		Whether this notification is from a parent layout or
    //		from this layout instance.
    
    this.inherited("setLayoutRunning", arguments, [running, fromParents]);

    if (this.getGraphModel() != null)
    {
      var e = this.getLayoutsImpl(true);

      while (e.hasNext())
      {
        var layout = e.next();
        if (layout != null) {
          layout.setLayoutRunning(running, true);
        }
      }
    }
  },

  contentsChanged : function(event)
  {
    // summary:
    //		Called when the structure or the geometry of the graph changes. 
    // description:
    //		Called when the structure or the geometry of the graph changes. 
    //		This method is the implementation of the <code>
    //		ibm&#95;ilog.graphlayout.GraphModelListener</code> interface.  
    // event: ibm_ilog.graphlayout.GraphLayoutModelEvent
    //		The event which describes the change that has occurred in
    //		the graph model.
    
    this.contentsChangedImpl(event.graphModel, event);
  },

  setInputCheckEnabled : function(enable)
  {
    // summary:
    //		Sets whether checks are enabled for the  nodes, links, and/or labels
    //		  provided as arguments for the different methods of this layout
    //		algorithm and its sublayout algorithms. 
    // description:
    //		Sets whether checks are enabled for the  nodes, links, and/or labels
    //		  provided as arguments for the different methods of this layout
    //		algorithm and its sublayout algorithms. 
    //		<p>
    //		In reference layout mode, it also calls
    //		<code>setInputCheckEnabled</code>  at the reference layout, hence
    //		all layouts of subgraphs will use this parameter setting. If a graph
    //		is attached and the layout mode is the internal or specified
    //		provider mode, it traverses the nesting hierarchy and calls
    //		<code>setInputCheckEnabled</code>  for all layout instances of
    //		subgraphs. However, if you insert subgraphs after calling this
    //		method, or if you change the layout instances of subgraphs in your
    //		specified provider or via <code> RecursiveLayout.setLayout()</code>
    //		in the internal provider after calling this method, the new layouts
    //		of these subgraphs may have a different setting.  
    //		</p>
    //		<p>
    //		Warning: In internal or specified provider mode, this method does
    //		not throw an exception when no graph model is yet attached. However,
    //		if no graph model is yet attached, the method cannot traverse any
    //		nesting hierarchy.  
    //		</p>
    //		<p>
    //		It is enabled by default. 
    //		</p>
    
    this.inherited("setInputCheckEnabled", arguments, [enable]);

    if (this.getLayoutMode() == ibm_ilog.graphlayout.RecursiveLayout.REFERENCE_LAYOUT_MODE) {
      this.getReferenceLayout().setInputCheckEnabled(enable);
    }
    else if (this.getGraphModel() != null)
    {
      var e = this.getLayoutsImpl(true);

      while (e.hasNext())
      {
        var layout = e.next();
        if (layout != null) {
          layout.setInputCheckEnabled(enable);
        }
      }
    }
  },

  stopImmediately : function()
  {
    // summary:
    //		Stops the running layout algorithm as soon as possible. 
    // description:
    //		Stops the running layout algorithm as soon as possible. 
    //		This works only if all layouts of all subgraphs support stopping the
    //		layout immediately. If the currently running sublayout of a subgraph
    //		does not support this feature, the sublayout will run to completion,
    //		but the layouts of other subgraphs will not be started.   
    //		<p>
    //		This method can be used if multiple threads are used for layout and
    //		GUI control. The GUI control thread calls this method to notify the
    //		layout thread that the layout run must be stopped. The layout
    //		algorithm will perform some final cleanup operations before
    //		terminating. Therefore, the layout thread will continue until the
    //		cleanup operations are finished. The GUI thread, however, returns
    //		immediately from this method.   
    //		</p>
    //		<p>
    //		If the layout algorithm is stopped before completion, the result
    //		code of the layout report is <code>
    //		ibm&#95;ilog.graphlayout.GraphLayoutReport.STOPPED&#95;AND&#95;INVALID</code>.  
    //		</p>
    // returns:
    //		'true' if the algorithm can be stopped at this time.
    
    var result = this.inherited("stopImmediately", arguments, []);

    if (this.getGraphModel() != null)
    {
      var e = this.getLayoutsImpl(true);

      while (e.hasNext())
      {
        var layout = e.next();

        if (layout != null && layout.isLayoutRunning())
        {
          result = layout.stopImmediately() && result;
        }
      }
    }

    return (result); // Boolean
  },

  setAutoCheckAppropriateLinksEnabled : function(enable)
  {
    // summary:
    //		Sets whether the layout checks whether links are appropriate. 
    // description:
    //		Sets whether the layout checks whether links are appropriate. 
    //		This is internally used. You should not use it.  
    // returns:
    //		The previous value.
    
    var e = this.getLayoutsImpl(true);

    while (e.hasNext())
    {
      var layout = e.next();
      if (layout != null) {
        layout.setAutoCheckAppropriateLinksEnabled(enable);
      }
    }

    return this.inherited("setAutoCheckAppropriateLinksEnabled", arguments, [enable]); // Boolean
  },

  isParametersUpToDate : function()
  {
    // summary:
    //		Returns 'false' if at least one parameter was modified
    //		since the last time the layout was successfully performed on the
    //		same graph or if the layout has never been performed successfully on
    //		the same graph. 
    // description:
    //		Returns <code>false</code> if at least one parameter was modified
    //		since the last time the layout was successfully performed on the
    //		same graph or if the layout has never been performed successfully on
    //		the same graph. 
    //		It returns <code>true</code> if no changes occurred.  
    //		<p>
    //		The method returns <code>false</code> if the parameters of one of
    //		the sublayouts is out-of-date.  
    //		</p>
    
    if (this.getGraphModel() != null)
    {
      var e = this.getLayoutsImpl(true);

      while (e.hasNext())
      {
        var layout = e.next();
        if (layout != null && !layout.isParametersUpToDate()) {
          return false; // Boolean
        }
      }
    }

    return this.inherited("isParametersUpToDate", arguments, []); // Boolean
  },

  isStructureUpToDate : function()
  {
    // summary:
    //		Returns 'false' if at least one modification occurred in
    //		the structure of the graph since the last time the layout was
    //		successfully performed on the same graph or if the layout has never
    //		been performed successfully on the same graph. 
    // description:
    //		Returns <code>false</code> if at least one modification occurred in
    //		the structure of the graph since the last time the layout was
    //		successfully performed on the same graph or if the layout has never
    //		been performed successfully on the same graph. 
    //		Returns <code>true</code> if no changes occurred.  
    //		<p>
    //		The method returns <code>false</code> if the structure of one of the
    //		sublayouts is out-of-date.  
    //		</p>
    
    if (this.getGraphModel() != null)
    {
      var e = this.getLayoutsImpl(true);

      while (e.hasNext())
      {
        var layout = e.next();
        if (layout != null && !layout.isStructureUpToDate()) {
          return false; // Boolean
        }
      }
    }

    return this.inherited("isStructureUpToDate", arguments, []); // Boolean
  },

  isGeometryUpToDate : function()
  {
    // summary:
    //		Returns 'false' if at least one node or link was moved or
    //		reshaped since the last time the layout was successfully performed
    //		on the same graph or if the layout has never been performed
    //		successfully on the same graph. 
    // description:
    //		Returns <code>false</code> if at least one node or link was moved or
    //		reshaped since the last time the layout was successfully performed
    //		on the same graph or if the layout has never been performed
    //		successfully on the same graph. 
    //		It returns <code>true</code> if no changes occurred.  
    //		<p>
    //		The method returns <code>false</code> if the geometry of one of the
    //		sublayouts is out-of-date.  
    //		</p>
    
    if (this.getGraphModel() != null)
    {
      var e = this.getLayoutsImpl(true);

      while (e.hasNext())
      {
        var layout = e.next();
        if (layout != null && !layout.isGeometryUpToDate()) {
          return false; // Boolean
        }
      }
    }

    return this.inherited("isGeometryUpToDate", arguments, []); // Boolean
  },

  supportsPercentageComplete : function()
  {
    // summary:
    //		Indicates whether the layout class can estimate the percentage of
    //		completion during the run of the layout. 
    // description:
    //		Indicates whether the layout class can estimate the percentage of
    //		completion during the run of the layout. 
    //		If all layouts of subgraphs support this feature, the percentage
    //		value is calculated from the sublayouts.  
    //		<p>
    //		If some sublayouts do not support this feature, the Recursive Layout
    //		algorithm can indicate by discrete percentage values how many
    //		layouts of subgraphs are already finished. For instance, if the
    //		nesting hierarchy contains five graphs, the percentage will increase
    //		in fixed steps by 20%.  
    //		</p>
    //		<p>
    //		The calculated percentage values are not very precise.  
    //		</p>
    
    return true; // Boolean
  },

  supportsStopImmediately : function()
  {
    // summary:
    //		Indicates whether the layout class can immediately interrupt the
    //		current run of the layout in a controlled way. 
    // description:
    //		Indicates whether the layout class can immediately interrupt the
    //		current run of the layout in a controlled way. 
    //		<p>
    //		In principle, the Recursive Layout supports this feature. If,
    //		however, the sublayout of a subgraph is running and does not support
    //		this feature, then the sublayout runs to completion first before the
    //		entire nested layout is stopped.  
    //		</p>
    //		<p>
    //		If the layout algorithm is stopped before completion, the result
    //		code of the layout report is <code>
    //		ibm&#95;ilog.graphlayout.GraphLayoutReport.STOPPED&#95;AND&#95;INVALID</code>.  
    //		</p>
    
    return true; // Boolean
  },

  supportsAllowedTime : function()
  {
    // summary:
    //		Indicates whether the layout class can stop the layout computation
    //		when a user-defined allowed time is exceeded. 
    // description:
    //		Indicates whether the layout class can stop the layout computation
    //		when a user-defined allowed time is exceeded. 
    //		<p>
    //		In principle, the Recursive Layout supports this feature. If,
    //		however, the sublayout of a subgraph is running and does not support
    //		this feature, then the sublayout runs to completion first before the
    //		entire nested layout is stopped when the allowed time has elapsed.  
    //		</p>
    //		<p>
    //		If the layout algorithm is stopped before completion, the result
    //		code of the layout report is <code>
    //		ibm&#95;ilog.graphlayout.GraphLayoutReport.STOPPED&#95;AND&#95;INVALID</code>.  
    //		</p>
    
    return true; // Boolean
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.RecursiveLayout,
{
  REFERENCE_LAYOUT_MODE : null,

  INTERNAL_PROVIDER_MODE : null,

  SPECIFIED_PROVIDER_MODE : null,
  _fields_init : function()
  {
    
    ibm_ilog.graphlayout.RecursiveLayout.REFERENCE_LAYOUT_MODE = ibm_ilog.graphlayout.RLayoutModes.REFERENCE_LAYOUT_MODE;
    ibm_ilog.graphlayout.RecursiveLayout.INTERNAL_PROVIDER_MODE = ibm_ilog.graphlayout.RLayoutModes.INTERNAL_PROVIDER_MODE;
    ibm_ilog.graphlayout.RecursiveLayout.SPECIFIED_PROVIDER_MODE = ibm_ilog.graphlayout.RLayoutModes.SPECIFIED_PROVIDER_MODE;
  }
  
}
);

ibm_ilog.graphlayout.RecursiveLayout._getGlobalProperties = function()
{
  // tags:
  //		private
  return ibm_ilog.graphlayout.GraphLayout._getGlobalProperties();
};

ibm_ilog.graphlayout.RecursiveLayout._getNodeProperties = function()
{
  // tags:
  //		private
  return ibm_ilog.graphlayout.GraphLayout._getNodeProperties();
};

ibm_ilog.graphlayout.RecursiveLayout._getLinkProperties = function()
{
  // tags:
  //		private
  return ibm_ilog.graphlayout.GraphLayout._getLinkProperties();
};

(function(){ ibm_ilog.graphlayout.RecursiveLayout._fields_init(); })();

return dojo.getObject("ibm_ilog.graphlayout._RecursiveLayout");});
require(["ibm_ilog/graphlayout/_RecursiveLayout"]);

},
'ibm_ilog*graphlayout/layer_base_mobile':function(){
define(["dojo","dijit","dojox","ibm_ilog/graphlayout/GraphLayout","ibm_ilog/graphlayout/RecursiveLayout","ibm_ilog/graphlayout/MultipleLayout","ibm_ilog/graphlayout/RecursiveMultipleLayout","ibm_ilog/graphlayout/grid/GridLayout","ibm_ilog/graphlayout/Direction","ibm_ilog/graphlayout/_GraphLayout","ibm_ilog/graphlayout/internalutil/ConnectionPointModes","ibm_ilog/graphlayout/internalutil/ConnectorStyles","ibm_ilog/graphlayout/internalutil/MovementModes","ibm_ilog/graphlayout/internalutil/ReshapeModes","ibm_ilog/graphlayout/internalutil/SplineRouter","ibm_ilog/graphlayout/_RecursiveLayout"], function(dojo, dijit, dojox){
dojo.getObject("ibm_ilog.graphlayout.layer_base_mobile", 1);
/* builder delete begin
dojo.provide('ibm_ilog.graphlayout.layer_base');


 builder delete end */
// The first group of classes must be included in the specified order

/* builder delete begin
dojo.require('ibm_ilog.graphlayout.GraphLayout');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.RecursiveLayout');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.MultipleLayout');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.RecursiveMultipleLayout');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.grid.GridLayout');



 builder delete end */
// The second group lists the remaining base classes. The commented
// classes are included by the classes in the first group, so they
// don't need to be listed, but I left them just for reference

/* builder delete begin
dojo.require("ibm_ilog.graphlayout.Direction");

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout._GraphLayout');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.ConnectionPointModes');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.ConnectorStyles');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.MovementModes');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.ReshapeModes');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.SplineRouter');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout._RecursiveLayout');


 builder delete end */
dojo.setObject('dojo.i18n._preloadLocalizations', function(){});

return dojo.getObject("ibm_ilog.graphlayout.layer_base_mobile");});
require(["ibm_ilog/graphlayout/layer_base_mobile"]);

},
'ibm_ilog*graphlayout/_GraphLayout':function(){
define(["dojo","dijit","dojox","ibm_ilog/graphlayout/internalutil/TranslateUtil","ibm_ilog/graphlayout/internalutil/DefaultParameterContainer","ibm_ilog/graphlayout/internalutil/LayoutParametersUtil","ibm_ilog/graphlayout/internalutil/LogResUtil","ibm_ilog/graphlayout/internalutil/Rectangle","ibm_ilog/graphlayout/internalutil/TranslateUtil","ibm_ilog/graphlayout/DefaultLayoutProvider"], function(dojo, dijit, dojox){
dojo.getObject("ibm_ilog.graphlayout._GraphLayout", 1);
/* builder delete begin
dojo.provide('ibm_ilog.graphlayout._GraphLayout');


 builder delete end */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.DefaultParameterContainer');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.LayoutParametersUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.LogResUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.Rectangle');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.DefaultLayoutProvider');


 builder delete end */
dojo.declare('ibm_ilog.graphlayout.GraphLayout', null, 
{
  // summary:
  //		The base class of the Graph Layout algorithms. 
  // description:
  //		The base class of the Graph Layout algorithms. 
  //		<p>
  //		IBM ILOG Dojo Diagrammer provides special support for applications
  //		that need to display graphs (also called networks) of nodes and
  //		links. Using the <code> ibm&#95;ilog.diagram.Graph</code> class, any
  //		graphic object can be defined to behave like a node and can be
  //		connected to other nodes with links, which themselves can have many
  //		different forms. Used in conjunction with layout algorithms, this
  //		feature is often used to create network topologies for
  //		telecommunications networks and system management applications.  
  //		</p>
  //		<p>
  //		The class <code>GraphLayout</code> is abstract and cannot be used
  //		directly. You must use one of its concrete subclasses.  
  //		</p>
  //		<p>
  //		You can also create your own subclasses to implement other layout
  //		algorithms.   
  //		</p>
  //		<p>
  //		The class contains layout parameters or options that can be useful
  //		for different layout algorithms. The implementation of the <code>
  //		ibm&#95;ilog.graphlayout.GraphLayout.layout()</code> method is solely
  //		responsible for whether or not the current settings of the parameters
  //		are taken into account.  
  //		</p>
  //		<p>
  //		Note that all layout parameters that are specific to nodes or links,
  //		such as the "fixed" attribute (see <code>
  //		ibm&#95;ilog.graphlayout.GraphLayout.setFixed()</code>, <code>
  //		ibm&#95;ilog.graphlayout.GraphLayout.isFixed()</code>), can be accessed
  //		only while the graph that contains the nodes or links is attached to
  //		the layout instance.     
  //		</p>
  //		<p>
  //		 
  //		</p>
  //		<p>
  //		To learn more about the layout algorithms and the corresponding
  //		<code>GraphLayout</code> subclasses, read the sections of the
  //		Reference Manual describing those classes and the IBM ILOG Dojo
  //		Diagrammer User's Manual.  
  //		</p>
  //		<p>
  //		Note that when implementing a subclass of <code>GraphLayout</code>, the initialization of all instance variables of the subclass needs to be done in the overridden implementation of the method <code> ibm&#95;ilog.graphlayout.GraphLayout.init()</code>. This is to prevent execution of methods of the subclasses before the initialization of the instance variables of the subclasses.  
  //		</p>
  //		<p>
  //		Note also that you must call the method <code> ibm&#95;ilog.graphlayout.GraphLayout.detach()</code> when you no longer need the layout instance, otherwise some objects may not be garbage collected. This is necessary only if the layout instance is directly created by your code. Calling <code> ibm&#95;ilog.graphlayout.GraphLayout.detach()</code> is not necessary if the layout instance is created internally by the IBM ILOG Dojo Diagrammer Graph Layout library, when using an <code> DefaultLayoutProvider</code> for recursive layout.  
  //		</p>
  //		<p>
  //		 
  //		</p>
  
  _uniqueId: null,

  _NODE_OR_LINK_PROPERTY_NAME: null,

  _allowedTime: null,
  _minBusyTime: null,
  _preserveFixedNodesOption: null,
  _preserveFixedLinksOption: null,

  _seedValue: null,

  _userDefinedSeedOption: null,
  _inputCheckEnabled: null,
  _connectedCompLayoutEnabled: null,

  _linkConnectionBoxInterface: null,

  _splineRoutingEnabled: null,
  _minSplineCurveSize: null,
  _maxSplineCurveSize: null,
  _balanceSplineCurveThreshold: null,

  _linkClipping : false,
  _rectangleToFit: null,
  _rectangleToFitArgument: null,
  _viewToFit: null,
  _fitToViewEnabled: null,
  _oldLayoutRegion: null,
  _estimatedLayoutRegion: null,

  _layoutRegionMode : null,
  _recursiveLayout: null,
  _providersThatContainMe: null,

  _calledFromRecUtil: null,

  _connectedComponentsLayout: null,

  _connectedCompCollection: null,

  _isConnectivityTestDone: null,
  _isConnectedGraph: null,

  _isStoppedImmediately: null,
  _isStoppedPrematurely: null,

  _structureUpToDate: null,

  _geometryUpToDate: null,

  _parametersUpToDate: null,

  _isLayoutRunning: null,

  _layoutRunningCount : null,

  _duringConnectedCompLayout: null,

  _lastLayoutStepPerformedTime: null,

  _graphModel: null,

  _parentLayout: null,

  _layoutReport: null,

  _connectedCompLayoutReport: null,

  _properties: null,

  _numberOfSublayouts: null,
  _sublayoutCounter: null,
  _actSublayoutPoints: null,
  _maxSublayoutPoints: null,
  _sublayoutPoints: null,

  constructor : function(source )
  {
    this._layoutRunningCount = 0;
    source = source || null;
    this.init();
    // Do nothing when called from MultipleLayout with 2 arguments
    if(arguments.length > 1 || !(source instanceof ibm_ilog.graphlayout.GraphLayout)) return;
    if (source != null) {
      this.copyParameters(source);
      this.setParametersUpToDate(false);
    }
  },
  
  copyParameters : function(source)
  {
    // summary:
    //		Copies the parameters from a given layout instance. 
    // description:
    //		Copies the parameters from a given layout instance. 
    //		<p>
    //		Note that the parameters which are specific to a node or a link are
    //		not copied. The other parameters, including the layout region
    //		specification and  link connection box interfaces, are also copied.
    //		If the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.supportsLayoutOfConnectedComponents()</code>
    //		returns <code>true</code>, a copy of the layout instance used for
    //		laying out the connected components is set on this layout instance. 
    //		
    //		</p>
    //		<p>
    //		If a method of the type <code>supportsXXX</code> is associated with
    //		a parameter, the parameter is copied only if the corresponding
    //		method returns <code>true</code>.  
    //		</p>
    //		<p>
    //		Subclasses that need to copy additional parameters must override
    //		this method. The method can be implemented as follows:    
    //		</p>
    // source: ibm_ilog.graphlayout.GraphLayout
    //		The layout instance from which the parameters are copied.
    
    if (this.supportsAllowedTime()) {
      this.setAllowedTime(source.getAllowedTime());
    }
    this.setMinBusyTime(source.getMinBusyTime());
    if (this.supportsPreserveFixedNodes()) {
      this.setPreserveFixedNodes(source.isPreserveFixedNodes());
    }
    if (this.supportsPreserveFixedLinks()) {
      this.setPreserveFixedLinks(source.isPreserveFixedLinks());
    }
    if (this.supportsRandomGenerator())
    {
      this.setSeedValueForRandomGenerator(source.getSeedValueForRandomGenerator());
      this.setUseSeedValueForRandomGenerator(source.isUseSeedValueForRandomGenerator());
    }

    this.setInputCheckEnabled(source.isInputCheckEnabled());
    if (this.supportsLayoutOfConnectedComponents()) {
      this.setLayoutOfConnectedComponentsEnabled(source.isLayoutOfConnectedComponentsEnabled());
    }
    this.setLinkClipping(source.isLinkClipping());
    if (this.supportsLinkConnectionBox()) {
      this.setLinkConnectionBoxInterface(source.getLinkConnectionBoxInterface());
    }
    if (this.supportsLayoutRegion())
    {
      var rect = source._rectangleToFit;
      this._rectangleToFit =
        (rect != null ? new ibm_ilog.graphlayout.internalutil.Rectangle(source._rectangleToFit .x, source._rectangleToFit .y, source._rectangleToFit .width, source._rectangleToFit .height) : null);
      rect = source._rectangleToFitArgument;
      this._rectangleToFitArgument =
        (rect != null ? new ibm_ilog.graphlayout.internalutil.Rectangle(source._rectangleToFitArgument .x, source._rectangleToFitArgument .y, source._rectangleToFitArgument .width,
            source._rectangleToFitArgument .height) : null);

      this._viewToFit = source._viewToFit;
      this._fitToViewEnabled = source._fitToViewEnabled;
      this.setLayoutRegionMode(source.layoutRegionMode);
    }

    if (this.supportsSplineRouting())
    {
      this.setSplineRoutingEnabled(source.isSplineRoutingEnabled());
      this.setMinSplineCurveSize(source.getMinSplineCurveSize());
      this.setMaxSplineCurveSize(source.getMaxSplineCurveSize());
      this.setBalanceSplineCurveThreshold(source.getBalanceSplineCurveThreshold());
    }

    if (this.supportsLayoutOfConnectedComponents()) {
      this.copyLayoutOfConnectedComponents(source);
    }
  },

  init : function()
  {
    // summary:
    //		Initializes instance variables. 
    // description:
    //		Initializes instance variables. 
    //		<p>
    //		You should not call this method directly. The method is called
    //		internally by the constructor without arguments and by the copy
    //		constructor.  
    //		</p>
    //		<p>
    //		The method must be overridden by subclasses that need to initialize
    //		additional instance variables. The initialization of all the
    //		instance variables of the subclasses must be done in this method.
    //		</p>
    // tags:
    //		protected
    
    this.initPropertiesNames();
    this._allowedTime = ibm_ilog.graphlayout.GraphLayout._defaultAllowedTime;
    this._minBusyTime = ibm_ilog.graphlayout.GraphLayout._defaultMinBusyTime;
    this._preserveFixedNodesOption = ibm_ilog.graphlayout.GraphLayout._defaultPreserveFixedNodes;
    this._preserveFixedLinksOption = ibm_ilog.graphlayout.GraphLayout._defaultPreserveFixedNodes;
    this._seedValue = ibm_ilog.graphlayout.GraphLayout._defaultSeedValue;
    this._userDefinedSeedOption = ibm_ilog.graphlayout.GraphLayout._defaultUserDefinedSeedOption;
    this._inputCheckEnabled = ibm_ilog.graphlayout.GraphLayout._defaultInputCheckEnabled;
    this._connectedCompLayoutEnabled = this.isLayoutOfConnectedComponentsEnabledByDefault();
    this._coordMode = ibm_ilog.graphlayout.GraphLayout._defaultCoordMode;

    this._linkClipping = true;
    this._linkConnectionBoxInterface = ibm_ilog.graphlayout.GraphLayout._defaultLinkConnectionBoxInterface;
    this._splineRoutingEnabled = ibm_ilog.graphlayout.GraphLayout._defaultSplineRoutingEnabled;
    this._minSplineCurveSize = ibm_ilog.graphlayout.GraphLayout._defaultMinSplineCurveSize;
    this._maxSplineCurveSize = ibm_ilog.graphlayout.GraphLayout._defaultMaxSplineCurveSize;
    this._balanceSplineCurveThreshold = ibm_ilog.graphlayout.GraphLayout._defaultBalanceSplineCurveThreshold;

    this._rectangleToFit = ibm_ilog.graphlayout.GraphLayout._defaultRectangleToFit;
    this._rectangleToFitArgument = ibm_ilog.graphlayout.GraphLayout._defaultRectangleToFit;
    this._fitToViewEnabled = ibm_ilog.graphlayout.GraphLayout._defaultFitToViewEnabled;

    this._calledFromRecUtil = false;

    this._isConnectedGraph = true;

    this._numberOfSublayouts = 1;
    this._maxSublayoutPoints = 1;
    this._sublayoutPoints = ibm_ilog.graphlayout.internalutil.TranslateUtil.newArray(1, 0);
    this._sublayoutPoints[0] = 1;
  },

  copy : function()
  {
    // summary:
    //		Copies the layout instance. 
    // description:
    //		Copies the layout instance. 
    //		<p>
    //		Note that the parameters which are specific to a node or a link are
    //		not copied. The other parameters, including the layout region
    //		specification and link connection box interfaces, are also copied.
    //		If the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.supportsLayoutOfConnectedComponents()</code>
    //		returns <code>true</code>, a copy of the layout instance used for
    //		laying out the connected components is set on the new instance.  
    //		</p>
    //		<p>
    //		If a method of the type <code>supportsXXX</code> is associated with
    //		a parameter, the parameter is copied only if the corresponding
    //		method returns <code>true</code>.  
    //		</p>
    // returns:
    //		A copy of the layout instance.
    },
  
  initPropertiesNames : function()
  {
    // summary:
    //		Initialize the property names.
    // tags:
    //		private
    
    // synchronized (...)
    
      ibm_ilog.graphlayout.GraphLayout._uniqueIdCounter++;
      this._uniqueId = ibm_ilog.graphlayout.GraphLayout._uniqueIdCounter;
    
    this._NODE_OR_LINK_PROPERTY_NAME = (ibm_ilog.graphlayout.GraphLayout._PROPERTY_BASE_NAME + this.getInstanceId());
  },

  toString : function () {
    // summary:
    //		Returns a printable string representing this layout instance.
    // description:
    //		Returns a printable string containing the fully qualified class name
    //		and the identifier returned by the method <code>getInstanceId()</code>.
    // returns:
    //		A printable string representing this layout instance.
    return "[" + this.declaredClass + " " + this.getInstanceId() + "]"; // String
  },
  getInstanceId : function()
  {
    // summary:
    //		A utility method that returns a unique integer value for each layout
    //		instance. 
    // description:
    //		A utility method that returns a unique integer value for each layout
    //		instance. 
    //		Use this method to obtain names for properties that are unique for
    //		each layout instance.  
    // returns:
    //		A unique integer value for each layout instance.
    
    return this._uniqueId; // int
  },

  attach : function(graphModel)
  {
    // summary:
    //		Sets the graph model to be laid out. 
    // description:
    //		Sets the graph model to be laid out. 
    //		<p>
    //		You must attach the graph model before performing the layout, that
    //		is, before calling the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code>, and before
    //		specifying layout parameters for specific nodes or links.  
    //		</p>
    //		<p>
    //		This method first calls <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.detach()</code> if a graph model is
    //		already attached. After attaching the model, the method 
    //		<code>onAttached</code> is called, passing this layout instance as
    //		argument. The method does nothing if the graph model is already
    //		attached.  
    //		</p>
    // graphModel: ibm_ilog.graphlayout.AbstractGraphLayoutModel
    //		The graph model to lay out.
    
    if (graphModel == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6012E");
    }

    if (graphModel == this._graphModel) {
      return;
    }
    if (ibm_ilog.graphlayout.internalutil.GraphModelData.getData(graphModel).internalGraphModelChecking && ibm_ilog.graphlayout.internalutil.GraphModelData.getData(graphModel).originatingLayout !=
      null)
    {
      var params = [graphModel ];
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6016E", params);
    }

    if (this._graphModel != null) {
      this.detach();
    }
    this._graphModel = graphModel;

    this._addAsModelListener(this._graphModel);
    this._graphModel.onAttach(this);
    if (this._connectedCompCollection != null)
    {
      this._connectedCompCollection.dispose();
      this._connectedCompCollection = null;
    }

    this._structureUpToDate = false;
    this._geometryUpToDate = false;
    this._parametersUpToDate = false;
    this._estimatedLayoutRegion = null;

    ibm_ilog.graphlayout.internalutil.TranslateUtil.noop();
  },

  detach : function()
  {
    // summary:
    //		Detaches the graph model from the layout instance. 
    // description:
    //		Detaches the graph model from the layout instance. 
    //		<p>
    //		When a new graph model is attached to the layout instance, it is not
    //		necessary to detach the previously attached graph model because this
    //		is done automatically when the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.attach()</code> is called.  
    //		</p>
    //		<p>
    //		This method performs cleaning operations on the graph model (for
    //		example, properties added to the graph model objects and graph model
    //		listeners are removed). The method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.cleanGraphModel()</code> is called
    //		with the currently attached graph model as the argument. The methods
    //		<code> ibm&#95;ilog.graphlayout.GraphLayout.cleanNode()</code> and
    //		<code> ibm&#95;ilog.graphlayout.GraphLayout.cleanLink()</code> are
    //		called for each node and link returned by the methods  <code>
    //		AbstractGraphLayoutModel.getNodes()</code>, <code>
    //		AbstractGraphLayoutModel.getLinks()</code> and <code>
    //		AbstractGraphLayoutModel.getIntergraphLinks()</code> .   
    //		</p>
    //		<p>
    //		Subclasses can override this method to remove additional information
    //		stored in the layout instance.  
    //		</p>
    //		<p>
    //		After detaching the model, the method  <code>onDetached</code> is
    //		called, passing this layout instance as an argument.   
    //		</p>
    //		<p>
    //		Note that you must call this method when you no longer need the
    //		layout instance; otherwise, some objects may not be garbage
    //		collected.  
    //		</p>
    
    if (this._graphModel != null)
    {
      this.onDetached();
      this.setStructureUpToDate(false);
      this.setGeometryUpToDate(false);
      this.setParametersUpToDate(false);

      this.cleanGraphModel(this._graphModel);

      var e = new ibm_ilog.graphlayout.internalutil.ArrayIterator(this._graphModel.getNodes());

      while (e.hasNext())
        this.cleanNode(this._graphModel, e.next());

      e = new ibm_ilog.graphlayout.internalutil.ArrayIterator(this._graphModel.getLinks());

      while (e.hasNext())
        this.cleanLink(this._graphModel, e.next());

      e = (new ibm_ilog.graphlayout.internalutil.ArrayIterator(this._graphModel.getIntergraphLinks()));

      while (e.hasNext())
        this.cleanLink(this._graphModel, e.next());

      if (this._connectedCompCollection != null)
      {
        this._connectedCompCollection.dispose();
        this._connectedCompCollection = null;
      }

      this._isConnectivityTestDone = false;
      if (this._connectedComponentsLayout != null) {
        this._connectedComponentsLayout.detach();
      }
      var graphModel = this._graphModel;

      this._graphModel = null;

      if (this._recursiveLayout != null)
      {
        var rlayout = this._recursiveLayout;
        this._recursiveLayout = null;
        rlayout.detach();
      }

      this.cleanLayoutProvidersThatContainMe(graphModel);

      ibm_ilog.graphlayout.internalutil.TranslateUtil.noop();

      if (ibm_ilog.graphlayout.internalutil.GraphModelData.getData(graphModel).originatingLayout == this) {
        graphModel.dispose();
      }
    }
  },

   /**
    * Invoked when the graph layout algorithm is attached to a graph
    * layout model.
    */
   onAttached : function() {
     this._updateLayoutRegion();
   },
  
   /**
    * Invoked when the graph layout algorithm is detached from a graph
    * layout model.
    */
   onDetached : function() {
   },
  
  addLayoutProviderThatContainsMe : function(layoutProvider)
  {
    // summary:
    //		When a layout instance is controlled by DefaultLayoutProvider, the
    //		provider registers itself on the layout, in order to allow the
    //		layout to perform cleaning operations in the detach method. 
    // description:
    //		When a layout instance is controlled by DefaultLayoutProvider, the
    //		provider registers itself on the layout, in order to allow the
    //		layout to perform cleaning operations in the detach method. 
    //		The mechanism is memory-optimized for the case that a layout is
    //		controlled by only one provider, which is the most common case. The
    //		&#95;providersThatContainMe is a DefaultLayoutProvider if there is only
    //		one, otherwise it is a Vector of the providers.
    // tags:
    //		private
    
    if (this._providersThatContainMe == null) {
      this._providersThatContainMe = layoutProvider;
    }
    else if (this._providersThatContainMe instanceof ibm_ilog.graphlayout.DefaultLayoutProvider)
    {
      if (this._providersThatContainMe != layoutProvider)
      {
        var v = new Array();
        v.push(this._providersThatContainMe);
        v.push(layoutProvider);
        this._providersThatContainMe = v;
      }
    }
    else if (this._providersThatContainMe instanceof Array)
    {
      var w = this._providersThatContainMe;
      if (!(dojo.indexOf(w, layoutProvider)>=0)) {
        w.push(layoutProvider);
      }
    }
    else
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6017E");
    }
  },

  removeLayoutProviderThatContainsMe : function(layoutProvider)
  {
    // summary:
    //		Unregisters the provider at the layout.
    // tags:
    //		private
    
    if (this._providersThatContainMe == null) {
      return;
    }
    if (this._providersThatContainMe == layoutProvider)
    {
      this._providersThatContainMe = null;
      return;
    }

    if (this._providersThatContainMe instanceof Array)
    {
      var v = this._providersThatContainMe;
      ibm_ilog.graphlayout.internalutil.TranslateUtil.removeArrayObject(v, layoutProvider);
      if (v.length == 1) {
        this._providersThatContainMe = v[0];
      }
    }
  },

  cleanLayoutProvidersThatContainMe : function(graphModel)
  {
    // summary:
    //		Clean the providers that contains this layout instance.
    // tags:
    //		private
    
    if (this._providersThatContainMe == null) {
      return;
    }

    var providers = this._providersThatContainMe;
    this._providersThatContainMe = null;

    var flag = ibm_ilog.graphlayout.internalutil.GraphModelData.getData(graphModel).internalGraphModelChecking;

    try
    {
      var provider;
      ibm_ilog.graphlayout.internalutil.GraphModelData.setInternalGraphModelChecking(graphModel, false);

      if (providers instanceof ibm_ilog.graphlayout.DefaultLayoutProvider)
      {
        provider = providers;
        provider.setPreferredLayout(graphModel, null);
      }
      else if (providers instanceof Array)
      {
        var e =  new ibm_ilog.graphlayout.internalutil.ArrayIterator((providers));

        while (e.hasNext())
        {
          provider = e.next();
          provider.setPreferredLayout(graphModel, null);
        }
      }
    }
    finally
    {
      ibm_ilog.graphlayout.internalutil.GraphModelData.setInternalGraphModelChecking(graphModel, flag);
    }
  },

  cleanGraphModel : function(graphModel)
  {
    // summary:
    //		Cleans a graph model. 
    // description:
    //		Cleans a graph model. 
    //		This method removes any data that has been stored by the layout
    //		algorithm on a graph model.  
    //		<p>
    //		Subclasses can override this method to remove additional information
    //		stored in the graph model.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // graphModel: ibm_ilog.graphlayout.AbstractGraphLayoutModel
    //		The graph model to be cleaned.
    
    if (graphModel == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6012E");
    }
    this._removeAsModelListener(graphModel);
  },

  cleanNode : function(graphModel, node)
  {
    // summary:
    //		Cleans a node. 
    // description:
    //		Cleans a node. 
    //		This method removes any data that has been stored by the layout
    //		algorithm on a node.  
    //		<p>
    //		The method is automatically called by <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.contentsChanged()</code> whenever a
    //		<code> GraphLayoutModelEvent</code> of type <code>
    //		GraphLayoutModelEvent.NODE&#95;REMOVED</code> is received.  
    //		</p>
    //		<p>
    //		Subclasses can override this method to remove additional information
    //		stored in the nodes.  
    //		</p>
    //		<p>
    //		Notice that the method may be called multiple times for the same
    //		node. At the time this method is called, the node may already be
    //		removed; therefore, overridden versions of this method should be
    //		implemented so that they work even if the object is no longer a node
    //		of <code>graphModel</code>.  
    //		</p>
    // graphModel: ibm_ilog.graphlayout.AbstractGraphLayoutModel
    //		The graph model to which the 'node'
    //		belongs.
    // node: Object
    //		The node to be cleaned.
    
    this.cleanNodeOrLink(graphModel, node);
  },

  cleanLink : function(graphModel, link)
  {
    // summary:
    //		Cleans a link. 
    // description:
    //		Cleans a link. 
    //		This method removes any data that has been stored by the layout
    //		algorithm on a regular link or on an intergraph link.  
    //		<p>
    //		The method is automatically called by <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.contentsChanged()</code> whenever a
    //		<code> GraphLayoutModelEvent</code> of type <code>
    //		GraphLayoutModelEvent.LINK&#95;REMOVED</code> is received.  
    //		</p>
    //		<p>
    //		Subclasses can override this method to remove additional information
    //		stored in the links.  
    //		</p>
    //		<p>
    //		Notice that the method may be called multiple times for the same
    //		link. At the time this method is called, the link may already be
    //		removed; therefore, overridden versions of this method should be
    //		implemented so that they work even if the object is no longer a link
    //		of <code>graphModel</code>.  
    //		</p>
    // graphModel: ibm_ilog.graphlayout.AbstractGraphLayoutModel
    //		The graph model to which the 'link'
    //		belongs.
    // link: Object
    //		The link to be cleaned.
    
    this.cleanNodeOrLink(graphModel, link);
  },

  cleanNodeOrLink : function(graphModel, nodeOrLink)
  {
    // summary:
    //		Cleans a node or a link.
    // tags:
    //		private
    
    if (graphModel == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6012E");
    }

    graphModel.setParameter(nodeOrLink, this._NODE_OR_LINK_PROPERTY_NAME, null);
  },

  setGraphModel : function(graphModel)
  {
    // summary:
    //		Sets the graph model to be laid out. 
    // description:
    //		Sets the graph model to be laid out. 
    //		You should not call this method. Instead, use the  method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.attach()</code>.
    
    this._graphModel = graphModel;
    this.setStructureUpToDate(false);
    this.setGeometryUpToDate(false);
  },

  getGraphModel : function()
  {
    // summary:
    //		Returns the graph model to lay out if a graph model is attached. 
    // description:
    //		Returns the graph model to lay out if a graph model is attached. 
    //		Otherwise, the method returns <code>null</code>.   
    //		<p>
    //		During the layout of a disconnected graph by a layout class that
    //		supports the connected components layout mechanism (see <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.supportsLayoutOfConnectedComponents()</code>)
    //		and for which this mechanism is enabled (see <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.isLayoutOfConnectedComponentsEnabled()</code>),
    //		the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.getGraphModel()</code> may return a
    //		different graph model from the one originally attached using the
    //		method <code> ibm&#95;ilog.graphlayout.GraphLayout.attach()</code>. For
    //		details, see the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code>.  
    //		</p>
    // returns:
    //		The graph model to lay out if one is attached.
    
    return this._graphModel; // ibm_ilog.graphlayout.AbstractGraphLayoutModel
  },

  setParentLayout : function(parent)
  {
    // summary:
    //		Sets the parent layout of this layout instance. 
    // description:
    //		Sets the parent layout of this layout instance. 
    //		You should not call this method directly.
    
    this._parentLayout = parent;
  },

  getParentLayout : function()
  {
    // summary:
    //		Returns the parent layout. 
    // description:
    //		Returns the parent layout. 
    //		If a layout instance <code>A</code> creates or uses another layout
    //		instance <code>B</code> to accomplish a part of or the total layout
    //		work, the layout instance <code>A</code> is called the "parent" of
    //		the layout instance <code>B</code>. The parent layout instance is
    //		responsible for declaring itself as a parent of <code>B</code> by
    //		calling the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setParentLayout()</code> on it. The
    //		layout instance <code>B</code> is called a sublayout of
    //		<code>A</code>.  
    //		<p>
    //		Sublayouts never have their own local layout listeners. Layout
    //		events have parent layouts as the source.  
    //		</p>
    //		<p>
    //		The method returns <code>null</code> if the layout instance has no
    //		parent.  
    //		</p>
    
    return this._parentLayout; // ibm_ilog.graphlayout.GraphLayout
  },

  performLayout : function(force, traverse)
  {
    //  summary: 
    //		Starts the layout algorithm using the currently attached graph 
    //		model and the current settings for the layout parameters.
    //  force: Boolean
    //		If 'true', the method isLayoutNeeded is not called. 
    //		No check is made to determine if it is necessary to perform the layout.
    //  traverse: Boolean
    //		If 'true', the layout is applied to the attached graph 
    //		model and recursively to all subgraph models of the attached graph 
    //		model. Otherwise, it is only applied on the attached graph model.
    //  returns:
    //		The layout code (see ibm_ilog.graphlayout.GraphLayoutReport.getCode()).
    
    if (traverse)
      return this.performRecursiveLayout(force, false); // int
    else
    {
      var report = this.performNonRecursiveLayout(force, false);
      return report.code; // int
    }
  },
  
  performSublayout : function(subgraph, layout, force)
  {
   // summary: Starts the input layout algorithm.
   // description: 
   //		This is used when this layout controls the input layout as sublayout.
   //		Layout classes can override this method if changes are needed with
   //		respect to the way how the input layout is started.</p>
   //		<p>You should not call this method directly.</p>
  
     // overridden in RecursiveLayout
    return layout.performLayout(force, false);
  },
  
  performRecursiveLayout : function(force, redraw)
  {
    // summary:
    //		Starts the layout algorithm on the currently attached graph model
    //		and recursively on its subgraphs (if any). 
    // description:
    //		Starts the layout algorithm on the currently attached graph model
    //		and recursively on its subgraphs (if any). 
    //		All subgraphs are laid out with the same global parameters. This is
    //		equivalent to <code>getRecursiveLayout().performLayout(force,
    //		redraw)</code>.  
    //		<p>
    //		 
    //		</p>
    // tags:
    //		private
    
    return this.getRecursiveLayout().performLayout(force);
    
  },

  getRecursiveLayout : function()
  {
    // summary:
    //		Returns the instance of Recursive Layout that is used to perform
    //		this layout recursively when you call '
    //		ibm_ilog.graphlayout.GraphLayout.performLayout()' with the
    //		traverse flag set to 'true'. 
    // description:
    //		Returns the instance of Recursive Layout that is used to perform
    //		this layout recursively when you call <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code> with the
    //		traverse flag set to <code>true</code>. 
    //		The returned instance of Recursive Layout uses this layout as a
    //		reference layout, and it is attached to the same graph model as this
    //		graph model. You should call this method only when a graph model is
    //		attached. You should not detach the returned layout nor attach it to
    //		any other graph model.   
    //		<p>
    //		The returned instance always uses the reference layout mode (see
    //		<code> ibm&#95;ilog.graphlayout.RecursiveLayout.getLayoutMode()</code>).
    //		  This is an expert feature, available when the graph layout is
    //		laying out a model that is not displayed in a Graph or Diagram.   
    //		</p>
    // returns:
    //		The recursive layout instance responsible for performing the
    //		layout when traversing the graph hierarchy.
    
    var graphModel = this.getGraphModel();

    if (graphModel == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6018E");
    }

    if (this instanceof ibm_ilog.graphlayout.RecursiveLayout) {
      return this; // ibm_ilog.graphlayout.RecursiveLayout
    }
    if (this._recursiveLayout == null)
    {
      this._recursiveLayout = new ibm_ilog.graphlayout.RecursiveLayout(this);
      var flag = ibm_ilog.graphlayout.internalutil.GraphModelData.getData(graphModel).internalGraphModelChecking;

      try
      {
        ibm_ilog.graphlayout.internalutil.GraphModelData.setInternalGraphModelChecking(graphModel, false);
        this._recursiveLayout.attach(graphModel);
      }
      finally
      {
        ibm_ilog.graphlayout.internalutil.GraphModelData.setInternalGraphModelChecking(graphModel, flag);
      }
    }

    return this._recursiveLayout; // ibm_ilog.graphlayout.RecursiveLayout
  },

  getLayouts : function(preOrder)
  {
    // summary:
    //		Returns the instances of 'GraphLayout' for the nested
    //		graph encapsulated by the graph model of this layout instance. 
    // description:
    //		Returns the instances of <code>GraphLayout</code> for the nested
    //		graph encapsulated by the graph model of this layout instance. 
    //		<p>
    //		This method returns this layout instance and recursively the layout
    //		instances for all subgraphs that are clones of this layout instance.
    //		The order of the enumeration can be preorder (that is, the layout of
    //		the parent graph comes before the layout of the subgraphs) or
    //		postorder (that is, the layout of the subgraphs comes before the
    //		layout of the parent graph).  
    //		</p>
    //		<p>
    //		This method is equivalent to
    //		<code>getRecursiveLayout().getLayouts(preOrder)</code>.  This is an
    //		expert feature, available when the graph layout is laying out a
    //		model that is not displayed in a Graph or Diagram.   
    //		</p>
    // preOrder: Boolean
    //		If 'true', the layout instances are returned
    //		in preorder, otherwise in postorder.
    // returns:
    //		This layout instance and recursively the layout instances for
    //		all subgraphs that are clones of this layout instance.
    
    return this.getRecursiveLayout().getLayouts(preOrder); // ibm_ilog.graphlayout.IIterator
  },

  getLayout : function(subgraph)
  {
    // summary:
    //		Returns the layout instance for a subgraph of the nested graph
    //		encapsulated by the graph model of this layout instance. 
    // description:
    //		Returns the layout instance for a subgraph of the nested graph
    //		encapsulated by the graph model of this layout instance. 
    //		The returned layout instance is a clone of this layout instance.  
    //		<p>
    //		This method is equivalent to
    //		<code>getRecursiveLayout().getLayout(subgraph)</code>.  This is an
    //		expert feature, available when the graph layout is laying out a
    //		model that is not displayed in a Graph or Diagram.   
    //		</p>
    // subgraph: Object
    //		The subgraph object. This must not be the root graph.
    // returns:
    //		The layout instance.
    
    return this.getRecursiveLayout().getLayout(subgraph); // ibm_ilog.graphlayout.GraphLayout
  },

  calcSublayoutPointsForPercentageComplete : function(connectedCompCollection)
  {
    // summary:
    //		Calculates the point value that allows correcting the percentage
    //		complete value if several sublayouts are running.
    // tags:
    //		private
    
    this._numberOfSublayouts = connectedCompCollection.getNodesCount() + 1;
    this._sublayoutPoints = ibm_ilog.graphlayout.internalutil.TranslateUtil.newArray(this._numberOfSublayouts, 0);
    this._maxSublayoutPoints = 0;
    var i = 0;
    var h;
    var sumNodesAndLinks = 0;
    var model;
    var nodes = new ibm_ilog.graphlayout.internalutil.ArrayIterator(connectedCompCollection.getNodes());

    while (nodes.hasNext())
    {
      model = nodes.next();
      h = model.getNodesCount() + model.getLinksCount();
      sumNodesAndLinks += h;
      this._maxSublayoutPoints += (3 * h);
      this._sublayoutPoints[i++] = (3 * h);
    }

    this._sublayoutPoints[i] = sumNodesAndLinks;
    this._maxSublayoutPoints += sumNodesAndLinks;
    this._actSublayoutPoints = 0;
  },

  isLayoutNeeded : function()
  {
    // summary:
    //		Verifies that it is necessary to perform the layout. 
    // description:
    //		Verifies that it is necessary to perform the layout. 
    //		<p>
    //		Basically, the method returns <code>false</code> if no changes
    //		occurred on the graph model (no nodes or links were inserted,
    //		removed, reshaped, or moved) and no parameters changed since the
    //		last time the layout was successfully performed using this layout
    //		instance. Otherwise, the method returns <code>true</code>.  
    //		</p>
    // returns:
    //		'true' if it is necessary to perform the layout,
    //		'false' otherwise.
    // tags:
    //		protected
    
    var graphModel = this.getGraphModel();
    return graphModel != null && graphModel.isLayoutNeeded(this); // Boolean
  },

  isLocalRecursiveLayoutNeeded : function(layoutProvider, recLayout, rootModel, traverse)
  {
    // summary:
    //		Checks whether layout is needed when layout is performed recursively
    //		on a hierarchy of nested subgraphs. 
    // description:
    //		Checks whether layout is needed when layout is performed recursively
    //		on a hierarchy of nested subgraphs. 
    //		<p>
    //		This method is called on the layout of the parent graph before the
    //		layout of the subgraphs is started. This allows the parent layout to
    //		negotiate with the subgraph layouts whether the parent layout treats
    //		the subgraphs as well, or whether the layouts of the subgraphs must
    //		run individually. If this method returns <code>false</code>, this
    //		layout is not performed, because some parent layout can handle the
    //		subgraph already.  
    //		</p>
    //		<p>
    //		The method is only called during a recursive layout (started  by
    //		<code> ibm&#95;ilog.graphlayout.RecursiveLayout</code> ). The default
    //		implementation returns always <code>true</code>.  This is an expert
    //		feature, available when the graph layout is laying out a model that
    //		is not displayed in a Graph or Diagram.   
    //		</p>
    // layoutProvider: ibm_ilog.graphlayout.ILayoutProvider
    //		The object that provides a layout instance to be
    //		used for laying out each subgraph.
    // recLayout: ibm_ilog.graphlayout.GraphLayout
    //		The recursive layout that started the recursive
    //		application of layouts. This can be 'null'.
    // rootModel: ibm_ilog.graphlayout.AbstractGraphLayoutModel
    //		The graph model that is the root of the nesting
    //		hierarchy of graph models.
    // traverse: Boolean
    //		If 'false', this layout is intended to be
    //		only applied to its own graph model. If 'true', this
    //		layout is intended to be applied to its graph model and the layout
    //		instances provided by the 'layoutProvider' are intended
    //		to be applied recursively to all nested subgraph models. The
    //		traverse flag is basically passed through from the call of '
    //		ibm_ilog.graphlayout.GraphLayout.performLayout()'.
    // returns:
    //		'true' if it is necessary to perform the layout,
    //		'false' otherwise.
    
    return true; // Boolean
  },

  layout : function() {
   // summary: 
   //		Executes the layout.
   // description: 
   //		This method must be implemented by each layout algorithm (subclasses of GraphLayout).  
    ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowGraphLayoutExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6022E");
  },
  
  beforeLayout : function()
  {
    // summary:
    //		Performs preprocessing operations before the layout of the entire
    //		graph. 
    // description:
    //		Performs preprocessing operations before the layout of the entire
    //		graph. 
    //		This is called in each layout run once per graph.  
    //		<p>
    //		The default implementation calls 
    //		<code>IGraphLayoutModel.beforeLayout(GraphLayout)</code>. Subclasses
    //		can override this method to perform some initialization operations
    //		when appropriate.  
    //		</p>
    // tags:
    //		protected
    
    this.getGraphModel().beforeLayout(this);
  },

  beforeLayoutOfSubgraph : function(subgraph)
  {
    // summary:
    //		Performs preprocessing operations before the layout of each subgraph
    //		or connected component. 
    // description:
    //		Performs preprocessing operations before the layout of each subgraph
    //		or connected component. 
    //		This method is called in each layout run once for each connected
    //		component.  
    //		<p>
    //		The default implementation does nothing. Subclasses can override
    //		this method to perform some initialization operations when
    //		appropriate.  
    //		</p>
    // subgraph: ibm_ilog.graphlayout.AbstractGraphLayoutModel
    //		Subgraph where layout is about to be performed.
    // tags:
    //		protected
    
  },

  afterLayoutOfSubgraph : function(subgraph)
  {
    // summary:
    //		Performs postprocessing operations after the layout of each subgraph
    //		or connected component. 
    // description:
    //		Performs postprocessing operations after the layout of each subgraph
    //		or connected component. 
    //		<p>
    //		The default implementation does nothing. Subclasses can override
    //		this method to perform some cleanup operations when appropriate.  
    //		</p>
    // subgraph: ibm_ilog.graphlayout.AbstractGraphLayoutModel
    //		Subgraph or connected component where layout has just
    //		been performed.
    // tags:
    //		protected
    
  },

  isLayoutRunning : function(checkParents )
  {
    // summary:
    //		Indicates whether this layout algorithm is running or not. 
    // description:
    //		Indicates whether this layout algorithm is running or not. 
    //		<p>
    //		If the parameter <code>checkParents</code> is <code>false</code>, 
    //		this method returns <code>true</code> if this layout has been
    //		started and is not yet completed. If the parameter
    //		<code>checkParents</code> is <code>true</code>, this method
    //		additionally checks whether any controlling parent layout is
    //		currently running.  
    //		</p>
    // checkParents: Boolean
    //		Indicates that this method should also check whether
    //		any controlling parent layout is currently running.
    // returns:
    //		'true' if this layout is currently running or (if
    //		'checkParents' is enabled) if any parent layout is
    //		currently running.
    
    if (this._isLayoutRunning)
      return true;

    if (checkParents) {
      return this._layoutRunningCount > 0; // Boolean
    }
    return false; // Boolean
  },

  setLayoutRunning : function(running, fromParents)
  {
    // summary:
    //		Sets whether layout is running. 
    // description:
    //		Sets whether layout is running. 
    //		The method is part of IBM ILOG Dojo Diagrammer internals. You should
    //		not use it.  
    // running: Boolean
    //		Whether layout is running or not.
    // fromParents: Boolean
    //		Whether this is a notification from a parent layout
    //		or from this layout instance.
    
    if (!fromParents) {
      this._isLayoutRunning = running;
    }
    if (running) {
      this._layoutRunningCount++;
    }
    else {
      this._layoutRunningCount--;
    }
  },

  onLayoutStepPerformed : function(layoutStarted, layoutFinished)
  {
  // summary: 
  //		Notifies of the layout events (if any).
  // description: 
  //		This method can be called by the layout classes when a step (or iteration)
  //		of the layout algorithm has been performed.  
    var parent = this.getParentLayout();
  
    if (parent != null)
      parent.onLayoutStepPerformed(false, false);
  },
  
  callLayoutStepPerformedIfNeeded : function()
  {
    // summary:
    //		Calls  'onLayoutStepPerformed' when necessary. 
    // description:
    //		Calls  <code>onLayoutStepPerformed</code> when necessary. 
    //		<p>
    //		This method is provided for convenience in the implementation of
    //		layout algorithms. It calls <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.onLayoutStepPerformed()</code> when
    //		the last call finished earlier than the minimal busy time before
    //		this call. It avoids calling <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.onLayoutStepPerformed()</code> when
    //		the layout time has elapsed or when the layout is notified to stop
    //		immediately, if the algorithm supports these features.  
    //		</p>
    //		<p>
    //		This mechanism is used by some algorithms to avoid the overhead of
    //		<code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.onLayoutStepPerformed()</code>
    //		becoming too high if it is called too often. Internal routines of
    //		layout algorithms can use this method often without worrying that
    //		too many layout events are raised.  
    //		</p>
    //		<p>
    //		Layout algorithms call <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.onLayoutStepPerformed()</code>
    //		directly instead of using this method when it is necessary to report
    //		a specific state (for example, when the layout report sets the code
    //		<code> GraphLayoutReport.LAYOUT&#95;STARTED</code> or <code>
    //		GraphLayoutReport.LAYOUT&#95;FINISHED</code>).  
    //		</p>
    
    if (this._isStoppedPrematurely) {
      return;
    }
    var actTime = new Date().getTime();

    if (actTime > this._lastLayoutStepPerformedTime + this.getMinBusyTime() || actTime < this._lastLayoutStepPerformedTime)
    {
      this.onLayoutStepPerformed(false, false);

      this._lastLayoutStepPerformedTime = new Date().getTime();
      if ((this.supportsAllowedTime() && this.isLayoutTimeElapsed()) || (this.supportsStopImmediately() && this.isStoppedImmediately())) {
        this._isStoppedPrematurely = true;
      }
    }
  },

  setMinBusyTime : function(time)
  {
    // summary:
    //		Sets the minimal time that the layout algorithm can be busy. 
    // description:
    //		Sets the minimal time that the layout algorithm can be busy. 
    //		This is the time between two calls of <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.onLayoutStepPerformed()</code> when
    //		the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.callLayoutStepPerformedIfNeeded()</code>
    //		is used.  
    //		<p>
    //		The objective is to avoid the overhead of <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.onLayoutStepPerformed()</code>
    //		becoming too high if the method is called too often. Internal
    //		routines of layout algorithms usually call <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.callLayoutStepPerformedIfNeeded()</code>,
    //		which calls <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.onLayoutStepPerformed()</code> if
    //		the time since the last call was at least the minimal busy time.  
    //		</p>
    //		<p>
    //		The default value is 50 (milliseconds).  
    //		</p>
    
    if (this._minBusyTime != time)
    {
      this._minBusyTime = time;

      this.onParameterChanged("MinBusyTime");
    }
  },

  getMinBusyTime : function()
  {
    // summary:
    //		Returns the minimal time that the layout algorithm can be busy
    //		between two calls of '
    //		ibm_ilog.graphlayout.GraphLayout.onLayoutStepPerformed()' when
    //		the method '
    //		ibm_ilog.graphlayout.GraphLayout.callLayoutStepPerformedIfNeeded()'
    //		is used.
    
    return (false ? ibm_ilog.graphlayout.GraphLayout._defaultMinBusyTime : this._minBusyTime); // Number
  },

  setStructureUpToDate : function(uptodate)
  {
    // summary:
    //		Sets whether the structure of the graph is up to date. 
    // description:
    //		Sets whether the structure of the graph is up to date. 
    //		<p>
    //		If the argument is <code>false</code>, notifies the layout instance
    //		that the structure of the graph was changed since the last time the
    //		layout was successfully performed.  
    //		</p>
    //		<p>
    //		Usually you do not need to call this method. The method is
    //		automatically called with a <code>true</code> argument each time the
    //		layout is successfully performed.  
    //		</p>
    
    this._structureUpToDate = uptodate;
    if (!uptodate) {
      this._estimatedLayoutRegion = null;
    }
  },

  isStructureUpToDate : function()
  {
    // summary:
    //		Returns whether the structure of the graph is up to date. 
    // description:
    //		Returns whether the structure of the graph is up to date. 
    //		<p>
    //		Returns <code>false</code> if at least one modification occurred in
    //		the structure of the graph model (a node or link was added or
    //		removed) since the last time the layout was successfully performed
    //		on the same graph model using this layout instance or if the layout
    //		has never been performed successfully on the same graph model. The
    //		following are considered to be modifications of the structure:
    //		adding or removing a node or link .  
    //		</p>
    //		<p>
    //		Returns <code>true</code> if no changes occurred.  
    //		</p>
    //		<p>
    //		This method is automatically called by <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.isLayoutNeeded()</code>.  
    //		</p>
    //		<p>
    //		Note that when the layout is performed successfully (that is, <code>
    //		GraphLayoutReport.getCode()</code> called on the layout report
    //		returns <code> GraphLayoutReport.LAYOUT&#95;DONE</code>), the layout
    //		instance is automatically notified that the structure is now
    //		up-to-date. It is also automatically notified of the topological
    //		modifications of the graph model using a manager-contents-changed
    //		listener.  
    //		</p>
    
    return this._structureUpToDate; // Boolean
  },

  setGeometryUpToDate : function(uptodate)
  {
    // summary:
    //		Sets whether the geometry of the graph is up to date. 
    // description:
    //		Sets whether the geometry of the graph is up to date. 
    //		<p>
    //		If the argument is <code>false</code>, notifies the layout instance
    //		that the geometry of the graph was changed since the last time the
    //		layout was successfully performed.  
    //		</p>
    //		<p>
    //		Usually you do not need to call this method. The method is
    //		automatically called with a <code>true</code> argument each time the
    //		layout is successfully performed.  
    //		</p>
    
    this._geometryUpToDate = uptodate;
    if (!uptodate) {
      this._estimatedLayoutRegion = null;
    }
  },

  isGeometryUpToDate : function()
  {
    // summary:
    //		Returns whether the geometry of the graph is up to date. 
    // description:
    //		Returns whether the geometry of the graph is up to date. 
    //		<p>
    //		Returns <code>false</code> if at least one node or link was moved or
    //		reshaped since the last time the layout was successfully performed
    //		on the same graph model or if the layout has never been performed
    //		successfully on the same graph model.  
    //		</p>
    //		<p>
    //		Returns <code>true</code> if no changes occurred.  
    //		</p>
    //		<p>
    //		This method is automatically called by <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.isLayoutNeeded()</code>.  
    //		</p>
    //		<p>
    //		Note that when the layout is performed successfully (that is, <code>
    //		GraphLayoutReport.getCode()</code> called on the layout report
    //		returns <code> GraphLayoutReport.LAYOUT&#95;DONE</code>), the layout
    //		instance is automatically notified that the geometry of the graph is
    //		now up-to-date.   
    //		</p>
    
    return this._geometryUpToDate; // Boolean
  },

  setOriginalCoordModeOfModel : function(mode)
  {
    // summary:
    //		Sets the original coordinates mode of the grapher adapter. 
    // description:
    //		Sets the original coordinates mode of the grapher adapter. 
    //		This is needed by GrapherAdapter store the original mode, before
    //		switching to the coordinates mode of layout.
    // tags:
    //		private
    
    this._originalCoordModeOfModel = mode;
  },

  getOriginalCoordModeOfModel : function()
  {
    // summary:
    //		Returns the original coordinates mode of the grapher adapter.
    // tags:
    //		private
    
    return this._originalCoordModeOfModel; // int
  },

  onParameterChanged : function(parameterName )
  {
    // summary:
    //		Called when a global layout parameter has changed. 
    // description:
    //		Called when a global layout parameter has changed. 
    //		<p>
    //		Global layout parameters affect all or many nodes and links. It
    //		calls <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setParametersUpToDate()</code> with
    //		a <code>false</code> argument  to notify the layout instance that
    //		the layout is not anymore up to date. It also fires a graph layout
    //		parameter event.  
    //		</p>
    //		<p>
    //		If you add new global parameters in your own subclass of
    //		<code>GraphLayout</code>, you should call this method each time they
    //		are modified.  
    //		</p>
    // parameterName: String
    //		Name of the parameter whose value has been changed.
    
    this.onParameterChangedImpl(null, parameterName);
  },

  onObjectParameterChanged : function(nodeOrLink, parameterName )
  {
    // summary:
    //		Called when a layout parameter for a specific node or link has
    //		changed. 
    // description:
    //		Called when a layout parameter for a specific node or link has
    //		changed. 
    //		<p>
    //		It calls <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setParametersUpToDate()</code> with
    //		a <code>false</code> argument  to notify the layout instance that
    //		the layout is not up-to-date. It also fires a graph layout parameter
    //		event.  
    //		</p>
    //		<p>
    //		If you add new parameters for specific nodes and links to your own
    //		subclass of <code>GraphLayout</code>, you should call this method
    //		each time they are modified.  
    //		</p>
    // nodeOrLink: Object
    //		Node or link instance for which a parameter has been
    //		changed.
    // parameterName: String
    //		Name of the parameter whose value has been changed.
    
    this.onParameterChangedImpl(nodeOrLink, parameterName);
  },

  /**
   * This does the real work.
   */
  onParameterChangedImpl : function(nodeOrLink, parameterName)
  {
   // this is easier, since we have no backward compatibility problem
   this.setParametersUpToDate(false);
  },
  
  fireGraphLayoutParameterEvent : function(uptodate, nodeOrLink, parameterName )
  {
    // summary:
    //		Fires an event that the graph layout parameters are either out of
    //		date or became up to date.
    // tags:
    //		private
    
  },

  setParametersUpToDate : function(uptodate)
  {
    // summary:
    //		Sets whether the parameters of the graph layout are up to date. 
    // description:
    //		Sets whether the parameters of the graph layout are up to date. 
    //		<p>
    //		If the argument is <code>false</code>, notifies the layout instance
    //		that a parameter value was changed.  
    //		</p>
    //		<p>
    //		This method is automatically called with a <code>false</code>
    //		argument each time the value of a parameter is changed using the
    //		methods provided in this class or in its subclasses provided in IBM
    //		ILOG Dojo Diagrammer.  
    //		</p>
    //		<p>
    //		The method is automatically called with a <code>true</code> argument
    //		each time the layout is successfully performed.  
    //		</p>
    
    this._parametersUpToDate = uptodate;

    this.fireGraphLayoutParameterEvent(uptodate, null, null);
  },

  isLayoutRegionChanged : function(oldRect, newRect)
  {
    // summary:
    //		Checks whether the new layout region must be considered as changed
    //		wrt. 
    // description:
    //		Checks whether the new layout region must be considered as changed
    //		wrt. 
    //		the layout region used at the last successful layout.
    // tags:
    //		private
    
    if (oldRect != null)
    {
      if (newRect == null) {
        return true; // Boolean
      }
      return Math.round(oldRect.x) != Math.round(newRect.x) || Math.round(oldRect.y) != Math.round(newRect.y) || Math.round(oldRect.width) != Math.round(newRect.width) ||
        Math.round(oldRect.height) != Math.round(newRect.height); // Boolean
    }

    return newRect != null; // Boolean
  },

  setInputCheckEnabled : function(enable)
  {
    // summary:
    //		Sets whether the checks for the nodes and/or links provided as
    //		arguments for the different methods of the layout algorithms are
    //		enabled. 
    // description:
    //		Sets whether the checks for the nodes and/or links provided as
    //		arguments for the different methods of the layout algorithms are
    //		enabled. 
    //		<p>
    //		If enabled, methods that require a node or a link as an argument
    //		check whether the object they receive is really a node or a link in
    //		the attached graph (using the methods <code>
    //		AbstractGraphLayoutModel.isNode()</code> and <code>
    //		AbstractGraphLayoutModel.isLink()</code>).  
    //		</p>
    //		<p>
    //		The checks can be disabled to avoid their overhead cost. The default
    //		value is <code>true</code>.  
    //		</p>
    
    if (enable != this._inputCheckEnabled)
    {
      this._inputCheckEnabled = enable;
      this.onParameterChanged("InputCheckEnabled");
    }
  },

  isInputCheckEnabled : function()
  {
    // summary:
    //		Returns 'true' if the checks for the nodes and/or links
    //		are enabled. 
    // description:
    //		Returns <code>true</code> if the checks for the nodes and/or links
    //		are enabled. 
    //		Returns <code>false</code> otherwise.
    
    return (false ? ibm_ilog.graphlayout.GraphLayout._defaultInputCheckEnabled : this._inputCheckEnabled); // Boolean
  },

  supportsPreserveFixedNodes : function()
  {
    // summary:
    //		Indicates whether the layout class allows the user to specify fixed
    //		nodes. 
    // description:
    //		Indicates whether the layout class allows the user to specify fixed
    //		nodes. 
    //		Fixed nodes are not moved during the layout.  
    //		<p>
    //		The default implementation always returns <code>false</code>.
    //		Subclasses can override this method in order to return
    //		<code>true</code>, that is, to indicate that this option is
    //		supported.  
    //		</p>
    //		<p>
    //		Note that fixed nodes can be handled differently by different layout
    //		algorithms. Some layout algorithms can adapt the layout of the
    //		non-fixed nodes to take into account the current positions of the
    //		fixed nodes. For details, refer to the documentation of the layout
    //		algorithm.  
    //		</p>
    
    return false; // Boolean
  },

  setPreserveFixedNodes : function(option)
  {
    // summary:
    //		Sets whether the layout avoids movement of fixed nodes. 
    // description:
    //		Sets whether the layout avoids movement of fixed nodes. 
    //		If the argument is <code>true</code>, specifies that the layout is
    //		not allowed to move the nodes indicated as fixed by the user. If the
    //		argument is <code>false</code>, the layout is free to move all the
    //		nodes of the graph. (This does not change the setting for the fixed
    //		nodes, which can still be used at any time in the future.)  
    //		<p>
    //		The default value is <code>false</code>.   
    //		</p>
    //		<p>
    //		Note that fixed nodes can be handled differently by different layout
    //		algorithms. Some layout algorithms can adapt the layout of the
    //		nonfixed nodes to take into account the current positions of the
    //		fixed nodes. For details, refer to the documentation of the layout
    //		algorithm.   
    //		</p>
    
    if (!this.supportsPreserveFixedNodes() && !false)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6024E");
    }

    if (this._preserveFixedNodesOption != option)
    {
      this._preserveFixedNodesOption = option;
      this.onParameterChanged("PreserveFixedNodes");
    }
  },

  isPreserveFixedNodes : function()
  {
    // summary:
    //		Returns 'true' if the layout is not allowed to move the
    //		nodes indicated as fixed by the user. 
    // description:
    //		Returns <code>true</code> if the layout is not allowed to move the
    //		nodes indicated as fixed by the user. 
    //		Returns <code>false</code> if the layout is free to move all the
    //		nodes.  
    //		<p>
    //		Always returns <code>false</code> if the layout does not support
    //		this option.  
    //		</p>
    //		<p>
    //		Note that fixed nodes can be handled differently by different layout
    //		algorithms. Some layout algorithms can adapt the layout of the
    //		nonfixed nodes to take into account the current positions of the
    //		fixed nodes. For details, refer to the documentation of the layout
    //		algorithm.  
    //		</p>
    
    if (!this.supportsPreserveFixedNodes()) {
      return false; // Boolean
    }
    return (false ? ibm_ilog.graphlayout.GraphLayout._defaultPreserveFixedNodes : this._preserveFixedNodesOption); // Boolean
  },

  setFixed : function(nodeOrLink, fixed)
  {
    // summary:
    //		Sets the specified node or link as fixed. 
    // description:
    //		Sets the specified node or link as fixed. 
    //		<p>
    //		Fixed nodes are not moved during the layout only if the method
    //		<code>isPreserveFixedNodes()</code> returns <code>true</code>. By
    //		default, no node is fixed.  
    //		</p>
    //		<p>
    //		Fixed links are not reshaped during the layout only if the method
    //		<code>isPreserveFixedLinks()</code> returns <code>true</code>. By
    //		default, no link is fixed.  
    //		</p>
    //		<p>
    //		  
    //		</p>
    // nodeOrLink: Object
    //		Node or link instance which is part of the graph
    //		model.
    // fixed: Boolean
    //		Indicates whether the object should remain fixed or not.
    
    if (this._graphModel != null)
    {
      if (this._graphModel.isNode(nodeOrLink))
      {
        if (!this.supportsPreserveFixedNodes())
        {
          ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6024E");
        }
      }
      else if (this._graphModel.isLink(nodeOrLink) || this._graphModel.isIntergraphLink(nodeOrLink))
      {
        if (!this.supportsPreserveFixedLinks())
        {
          ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6025E");
        }
      }
    }

    ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.setNodeOrLinkParameter(this, nodeOrLink, ibm_ilog.graphlayout.GraphLayout._FIXED_PROPERTY, Boolean(fixed ), Boolean(false ));
  },

  isFixed : function(nodeOrLink)
  {
    // summary:
    //		Returns whether the node or link is specified as fixed.  
    // nodeOrLink: Object
    //		Node or link instance present in the graph model
    //		attached to this layout.
    // returns:
    //		'true' if the node or link is specified as fixed.
    
    return ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.getNodeOrLinkBooleanParameter(this, nodeOrLink, ibm_ilog.graphlayout.GraphLayout._FIXED_PROPERTY, false); // Boolean
  },

  unfixAllNodes : function()
  {
    // summary:
    //		Removes the fixed attribute from all nodes in the graph model. 
    // description:
    //		Removes the fixed attribute from all nodes in the graph model. 
    //		An <code>Error</code> is thrown if the layout class does not support
    //		this option or if there is no attached graph model.
    
    if (!this.supportsPreserveFixedNodes())
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6024E");
    }

    if (this._graphModel == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6018E");
    }

    var nodes = new ibm_ilog.graphlayout.internalutil.ArrayIterator(this._graphModel.getNodes());

    while (nodes.hasNext())
      this.setFixed(nodes.next(), false);
  },

  supportsPreserveFixedLinks : function()
  {
    // summary:
    //		Indicates whether the layout class allows the user to specify fixed
    //		links. 
    // description:
    //		Indicates whether the layout class allows the user to specify fixed
    //		links. 
    //		Fixed links are not reshaped during the layout.  
    //		<p>
    //		The default implementation always returns <code>false</code>.
    //		Subclasses can override this method in order to return
    //		<code>true</code>; that is, to indicate that this option is
    //		supported.  
    //		</p>
    
    return false; // Boolean
  },

  setPreserveFixedLinks : function(option)
  {
    // summary:
    //		Sets whether the layout avoids movement of fixed links. 
    // description:
    //		Sets whether the layout avoids movement of fixed links. 
    //		If the argument is <code>true</code>, specifies that the layout is
    //		not allowed to reshape the links indicated as fixed by the user. If
    //		the argument is <code>false</code>, the layout is free to reshape
    //		all the links of the graph. (This does not change the setting for
    //		the fixed links, which can still be used at any time in the future.)
    //		<br>The default value is <code>false</code>.  
    //		<p>
    //		An <code>Error</code> is thrown if the layout class does not support
    //		this option.  
    //		</p>
    
    if (!this.supportsPreserveFixedLinks())
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6025E");
    }

    if (this._preserveFixedLinksOption != option)
    {
      this._preserveFixedLinksOption = option;
      this.onParameterChanged("PreserveFixedLinks");
    }
  },

  isPreserveFixedLinks : function()
  {
    // summary:
    //		Returns 'true' if the layout is not allowed to reshape
    //		the links indicated as fixed by the user. 
    // description:
    //		Returns <code>true</code> if the layout is not allowed to reshape
    //		the links indicated as fixed by the user. 
    //		Returns <code>false</code> if the layout is free to reshape all the
    //		links.  
    //		<p>
    //		Always  returns <code>false</code> if the layout does not support
    //		this option.  
    //		</p>
    
    if (!this.supportsPreserveFixedLinks()) {
      return false; // Boolean
    }
    return (false ? ibm_ilog.graphlayout.GraphLayout._defaultPreserveFixedLinks : this._preserveFixedLinksOption); // Boolean
  },

  unfixAllLinks : function()
  {
    // summary:
    //		Removes the fixed attribute from all links in the graph model. 
    // description:
    //		Removes the fixed attribute from all links in the graph model. 
    //		<p>
    //		An <code>Error</code> is thrown if the layout class does not support
    //		this option or if there is no attached graph model.  
    //		</p>
    
    if (!this.supportsPreserveFixedLinks())
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6025E");
    }

    if (this._graphModel == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6018E");
    }

    var links = new ibm_ilog.graphlayout.internalutil.ArrayIterator(this._graphModel.getLinks());

    while (links.hasNext())
      this.setFixed(links.next(), false);

    links = (new ibm_ilog.graphlayout.internalutil.ArrayIterator(this._graphModel.getIntergraphLinks()));

    while (links.hasNext())
      this.setFixed(links.next(), false);
  },

  supportsPercentageComplete : function()
  {
    // summary:
    //		Indicates whether the layout class can estimate the percentage of
    //		completion during the run of layout. 
    // description:
    //		Indicates whether the layout class can estimate the percentage of
    //		completion during the run of layout. 
    //		If supported, the percentage is stored in the layout report and can
    //		be retrieved by any layout event listener.   
    //		<p>
    //		The default implementation always returns <code>false</code>.
    //		Subclasses can override this method in order to return
    //		<code>true</code>; that is, to indicate that this option is
    //		supported.  
    //		</p>
    
    return false; // Boolean
  },

  increasePercentageComplete : function(newPercentage)
  {
    // summary:
    //		Increases the percentage of completion that is stored in the layout
    //		report to the input value. 
    // description:
    //		Increases the percentage of completion that is stored in the layout
    //		report to the input value. 
    //		Layout algorithms that support the percentage complete feature
    //		should call this method during the running of the layout. This
    //		method does not set the percentage to a lower value than the
    //		previous value. It also does not set the value to more than 100%. It
    //		silently ignores wrong input values.  
    // newPercentage: int
    //		New percentage of completion
    
    var parentLayout = this.getParentLayout();

    if (parentLayout != null) {
      parentLayout.increasePercentageComplete(newPercentage);
    }
    else if (newPercentage >= 0 && newPercentage <= 100 && this._layoutReport != null)
    {
      var percentage = newPercentage;
      if (this._duringConnectedCompLayout && this._sublayoutCounter < this._numberOfSublayouts) {
        percentage = Math.floor(100 * (this._actSublayoutPoints + Math.floor(newPercentage * this._sublayoutPoints[this._sublayoutCounter] / 100)) / this._maxSublayoutPoints);
      }
      if (this._layoutReport.getPercentageComplete() < percentage) {
        this._layoutReport.setPercentageComplete(percentage);
      }
    }
  },

  supportsStopImmediately : function()
  {
    // summary:
    //		Indicates whether the layout class can interrupt the current run of
    //		layout immediately in a controlled way. 
    // description:
    //		Indicates whether the layout class can interrupt the current run of
    //		layout immediately in a controlled way. 
    //		<p>
    //		The default implementation always returns <code>false</code>.
    //		Subclasses can override this method in order to return
    //		<code>true</code>, that is, to indicate that this option is
    //		supported.  
    //		</p>
    
    return false; // Boolean
  },

  stopImmediately : function()
  {
    // summary:
    //		Stops the running layout algorithm as soon as possible. 
    // description:
    //		Stops the running layout algorithm as soon as possible. 
    //		<p>
    //		This method only sets the flag <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.isStoppedImmediately()</code> to
    //		<code>true</code>; it is the responsibility of the implementation of
    //		the method <code> ibm&#95;ilog.graphlayout.GraphLayout.layout()</code>
    //		to react in an appropriate way. Layout algorithms that support the
    //		immediate stop feature should check the flag <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.isStoppedImmediately()</code> from
    //		time to time and react when this flag changes to <code>true</code>. 
    //		 
    //		</p>
    //		<p>
    //		Layout algorithms that are stopped in this way set the result code
    //		of the layout report to <code>
    //		GraphLayoutReport.STOPPED&#95;AND&#95;VALID</code> or <code>
    //		GraphLayoutReport.STOPPED&#95;AND&#95;INVALID</code>.  
    //		</p>
    // returns:
    //		'true' if it was possible to indicate to this layout
    //		to stop its execution, 'false' if this layout does not
    //		support this feature or if it cannot be stopped.
    
    if (!this.supportsStopImmediately()) {
      return (false); // Boolean
    }
    if (this._isStoppedImmediately) {
      return (true); // Boolean
    }
    this._isStoppedImmediately = true;

    var result = true;

    var connectedCompLayout = this._connectedComponentsLayout;

    if (connectedCompLayout != null && connectedCompLayout.isLayoutRunning() && connectedCompLayout.supportsStopImmediately())
    {
      var stopFlag = connectedCompLayout.stopImmediately();
      result = (result && stopFlag);
    }

    return (result); // Boolean
  },

  isStoppedImmediately : function()
  {
    // summary:
    //		Returns 'true' if the method '
    //		ibm_ilog.graphlayout.GraphLayout.stopImmediately()' was
    //		called. 
    // description:
    //		Returns <code>true</code> if the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.stopImmediately()</code> was
    //		called. 
    //		Layout algorithm classes can use this method to recognize that it
    //		was requested to stop the current layout run.  
    // returns:
    //		'true' if the method 'stopImmediately' was
    //		called.
    
    return this._isStoppedImmediately; // Boolean
  },

  setLayoutOfConnectedComponentsEnabled : function(enable)
  {
    // summary:
    //		Sets whether the generic connected component layout mechanism is
    //		enabled. 
    // description:
    //		Sets whether the generic connected component layout mechanism is
    //		enabled. 
    //		If enabled on a layout class that supports this mechanism (see
    //		<code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.supportsLayoutOfConnectedComponents()</code>),
    //		the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code> cuts the
    //		attached graph model into connected components and lays out each
    //		connected component separately. Then the connected components are
    //		placed using the layout instance returned by the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.getLayoutOfConnectedComponents()</code>.
    //		 
    //		<p>
    //		Notice that the connected component layout is not used if the graph
    //		is connected.   
    //		</p>
    //		<p>
    //		The default value is the value returned by the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.isLayoutOfConnectedComponentsEnabledByDefault()</code>.
    //		 
    //		</p>
    // enable: Boolean
    //		Set to 'true' to enable the connected component
    //		layout mechanism, or 'false' to disable.
    
    if (!this.supportsLayoutOfConnectedComponents() && !false)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6026E");
    }

    if (this._connectedCompLayoutEnabled != enable)
    {
      this._connectedCompLayoutEnabled = enable;

      this.setStructureUpToDate(false);
      this.onParameterChanged("LayoutOfConnectedComponentsEnabled");
    }
  },

  isLayoutOfConnectedComponentsEnabled : function()
  {
    // summary:
    //		Indicates whether the connected component layout mechanism is
    //		enabled. 
    // description:
    //		Indicates whether the connected component layout mechanism is
    //		enabled. 
    //		<p>
    //		The default value is the value returned by the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.isLayoutOfConnectedComponentsEnabledByDefault()</code>.
    //		 
    //		</p>
    
    return (false ? this.isLayoutOfConnectedComponentsEnabledByDefault() : this._connectedCompLayoutEnabled); // Boolean
  },

  isLayoutOfConnectedComponentsEnabledByDefault : function()
  {
    // summary:
    //		Returns 'true' if the connected components layout
    //		mechanism is enabled by default. 
    // description:
    //		Returns <code>true</code> if the connected components layout
    //		mechanism is enabled by default. 
    //		Otherwise, the method returns <code>false</code>.  
    //		<p>
    //		The default implementation always returns <code>false</code>.  
    //		</p>
    //		<p>
    //		Subclasses can override this method in order to return
    //		<code>true</code>, that is, to indicate that the connected
    //		components layout is enabled by default.  
    //		</p>
    // returns:
    //		'true' if the connected components layout mechanism
    //		is enabled by default.
    // tags:
    //		protected
    
    return false; // Boolean
  },

  setLayoutOfConnectedComponents : function(layout)
  {
    // summary:
    //		Sets the layout instance that lays out the connected components of
    //		the graph. 
    // description:
    //		Sets the layout instance that lays out the connected components of
    //		the graph. 
    //		When this method is not called, a default layout instance (see
    //		<code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.getLayoutOfConnectedComponents()</code>
    //		is used. You can call this method with a <code>null</code> argument
    //		to return to the default connected components layout instance.   
    //		<p>
    //		Note the following points:  
    //		<ul>
    //		<li>The layout instance passed as the argument cannot be used
    //		independently as long as it is set as a connected component
    //		layout.</li>  
    //		<li>The connected component layout is not used if the graph is
    //		connected.</li>  
    //		</ul>  
    //		</p>
    // layout: ibm_ilog.graphlayout.GraphLayout
    //		The layout instance to set, or 'null' to return
    //		to the default layout instance.
    
    if (!this.supportsLayoutOfConnectedComponents() && !false)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6026E");
    }

    if (layout != this._connectedComponentsLayout)
    {
      if (this._connectedComponentsLayout != null)
      {
        this._connectedComponentsLayout.setParentLayout(null);
        this._connectedComponentsLayout.detach();
      }

      if (layout != null) {
        layout.setParentLayout(this);
      }
      this._connectedComponentsLayout = layout;

      this.setStructureUpToDate(false);
      this.onParameterChanged("LayoutOfConnectedComponents");
    }
  },

  getLayoutOfConnectedComponents : function()
  {
    // summary:
    //		Returns the layout instance that lays out the connected components
    //		of the graph. 
    // description:
    //		Returns the layout instance that lays out the connected components
    //		of the graph. 
    //		<p>
    //		The method returns <code>null</code> if the layout instance does not
    //		support the layout of connected components. that is, if the method
    //		<code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.supportsLayoutOfConnectedComponents()</code>
    //		returns <code>false</code>.  
    //		</p>
    //		<p>
    //		Otherwise, if a layout instance has been specified using the method
    //		<code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setLayoutOfConnectedComponents()</code>,
    //		this instance is returned. If no layout instance has been specified
    //		using the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setLayoutOfConnectedComponents()</code>,
    //		the method returns an instance of <code>
    //		ibm&#95;ilog.graphlayout.grid.GridLayout</code>. Its layout region
    //		parameter is set by default to the rectangle <code>(0, 0, 800,
    //		800)</code>. The layout mode parameter is set to <code>
    //		ibm&#95;ilog.graphlayout.grid.GridLayout.TILE&#95;TO&#95;ROWS</code>. Note that
    //		the layout instance returned by this method cannot be used
    //		independently as long as it is set as a connected component layout. 
    //		
    //		</p>
    
    if (!this.supportsLayoutOfConnectedComponents()) {
      return null; // ibm_ilog.graphlayout.GraphLayout
    }
    if (this._connectedComponentsLayout == null)
    {
      var gridLayout = new ibm_ilog.graphlayout.grid.GridLayout();
      gridLayout.setParentLayout(this);
      gridLayout.setLayoutMode(ibm_ilog.graphlayout.grid.GridLayout.TILE_TO_ROWS);

      gridLayout.layoutRegion = { x:0, y:0, width:800, height:800 };
      this._connectedComponentsLayout = gridLayout;
    }

    return this._connectedComponentsLayout; // ibm_ilog.graphlayout.GraphLayout
  },

  copyLayoutOfConnectedComponents : function(source)
  {
    // summary:
    //		Copies the layout of connected components properly. 
    // description:
    //		Copies the layout of connected components properly. 
    //		This is tricky due to the fact that getLayoutOfConnectedComponents
    //		does a load on demand.
    // tags:
    //		private
    
    var sourceLayout = null;

    if (source.supportsLayoutOfConnectedComponents()) {
      sourceLayout = source._connectedComponentsLayout;
    }
    if (sourceLayout == this._connectedComponentsLayout) {
      return;
    }
    if (sourceLayout == null) {
      this.setLayoutOfConnectedComponents(null);
    }
    else
    {
      if (this._connectedComponentsLayout != null && this._connectedComponentsLayout.declaredClass == sourceLayout.declaredClass) {
        this._connectedComponentsLayout.copyParameters(sourceLayout);
      }
      else {
        this.setLayoutOfConnectedComponents(sourceLayout.copy());
      }
    }
  },

  supportsLayoutRegion : function()
  {
    // summary:
    //		Indicates whether the layout class can control the position and/or
    //		size of the graph drawing according to a user-defined region (a
    //		rectangle) or a user-defined area of a manager view. 
    // description:
    //		Indicates whether the layout class can control the position and/or
    //		size of the graph drawing according to a user-defined region (a
    //		rectangle) or a user-defined area of a manager view. 
    //		<p>
    //		The default implementation always returns <code>false</code>.  
    //		</p>
    //		<p>
    //		Subclasses can override this method in order to return
    //		<code>true</code>, that is, to indicate that this option is
    //		supported.  
    //		</p>
    
    return false; // Boolean
  },

  recordLayoutRegion : function()
  {
    // summary:
    //		Records the current value of the layout region. 
    // description:
    //		Records the current value of the layout region. 
    //		This will be used later to detect changes of the parameters. The
    //		method is called after each successful layout.
    // tags:
    //		private
    
    if (this.supportsLayoutRegion())
    {
      var layoutRegion = this.getCalcLayoutRegion();

      if (layoutRegion == null) {
        this._oldLayoutRegion = null;
      }
      else if (this._oldLayoutRegion == null) {
        this._oldLayoutRegion = new ibm_ilog.graphlayout.internalutil.Rectangle(layoutRegion.x, layoutRegion.y, layoutRegion.width, layoutRegion.height);
      }
      else {
        ibm_ilog.graphlayout.internalutil.TranslateUtil.reshapeRect(this._oldLayoutRegion, layoutRegion.x, layoutRegion.y,
          layoutRegion.width, layoutRegion.height);
      }
    }
  },

  setLayoutRegion : function(rect)
  {
    // summary:
    //		Sets the layout region as a rectangle 'rect'), with the
    //		dimensions of the rectangle being given in container (graph model)
    //		coordinates. 
    // description:
    //		Sets the layout region as a rectangle <code>rect</code>), with the
    //		dimensions of the rectangle being given in container (graph model)
    //		coordinates. 
    //		The
    //		region's new position is specified by <code>rect.x</code> and <code>rect.y</code>, and its new size is specified by <code>rect.width</code> and <code>rect.height</code>.  
    //		<p>
    //		For subclasses that support this parameter, the layout region is usually the rectangle that the graph must fit (exactly or approximately) after the layout is performed, or the rectangle which influences the position and/or size of the resulting layout. The way the layout region parameter is taken into account is the sole responsibility of the subclasses.  
    //		</p>
    //		<p>
    //		You should use this method if you want to perform the layout with no manager view attached to the graph model or if you want to define the region to fit in the manager coordinates. If you want the layout to fit a region of a manager view, with its dimensions in manager view coordinates, use the method <code> ibm&#95;ilog.graphlayout.GraphLayout.setLayoutRegion()</code>.  If you want to revert to the default layout region, that is the layout region which is computed by default if  no layout region has been previously specified, you can call this method with a <code>null</code> argument.  
    //		</p>
    //		<p>
    //		An <code>Error</code> is thrown if the layout does not support this mechanism, or if the width or height of <code>rect</code> is <code>0</code>.  
    //		</p>
    // rect: Rectangle
    //		The rectangle for the layout region, or 'null'.
    
    if (!ibm_ilog.graphlayout.internalutil.TranslateUtil.rectEquals(rect, this.getLayoutRegion()))
    {
      if (!this.supportsLayoutRegion())
      {
        ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6027E");
      }
      this._rectangleToFitArgument = rect ?  { x:rect.x, y:rect.y, width:rect.width, height:rect.height } : null;
      this._updateLayoutRegion();
      this.onParameterChanged("layoutRegion", this._rectangleToFitArgument);
    }
    
  },

  getSpecLayoutRegion : function()
  {
    // summary:
    //		Returns a copy of the rectangle that defines the layout region, as
    //		specified using the method '
    //		ibm_ilog.graphlayout.GraphLayout.layoutRegion'. 
    // description:
    //		Returns a copy of the rectangle that defines the layout region, as
    //		specified using the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.layoutRegion</code>. 
    //		<p>
    //		The implementation of the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.layout()</code> in subclasses of
    //		<code>GraphLayout</code> is solely responsible for whether the
    //		rectangle returned by this method is taken into account when
    //		calculating the layout, and in which manner.  The method returns
    //		<code>null</code> in the following cases:  
    //		<ul>
    //		<li> The layout region mechanism is not supported (that is, <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.supportsLayoutRegion()</code>
    //		returns <code>false</code>).</li>    
    //		<li> You do not call <code>setLayoutRegion</code> and no graph model
    //		is attached to the layout </li>   
    //		</ul>   
    //		</p>
    //		<p>
    //		Note that, except when specified using <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.layoutRegion</code>, the layout
    //		region can change with time (for example, because the size of the
    //		view passed as the argument to <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setLayoutRegion()</code> changes,
    //		or its transformer is changed).   
    //		</p>
    // returns:
    //		Returns a copy of the rectangle that defines the layout region.
    
    if (!this.supportsLayoutRegion())
    {
      return null; // Rectangle
    }

    return this.getSpecLayoutRegionImpl(); // Rectangle
  },

  getSpecLayoutRegionImpl : function()
  {
    // summary:
    //		Computes the specified layout region according to the layout region
    //		rectangle and the layout region mode.  
    // tags:
    //		private
    
    var rect = new ibm_ilog.graphlayout.internalutil.Rectangle();
    var referenceView = null;

    if (this._fitToViewEnabled)
    {
      referenceView = (this._viewToFit == null ? this.getView() : this._viewToFit);
      if (referenceView == null) {
        return null; // Rectangle
      }
      if (this._rectangleToFit == null)
      {
        var viewDim = ibm_ilog.graphlayout.internalutil.TranslateUtil.getDimension(referenceView);

        ibm_ilog.graphlayout.internalutil.TranslateUtil.reshapeRect(rect, 0, 0, viewDim.width, viewDim.height);
        if (rect.width < ibm_ilog.graphlayout.internalutil.TranslateUtil.NEAR_ZERO_FLOAT || rect.height < ibm_ilog.graphlayout.internalutil.TranslateUtil.NEAR_ZERO_FLOAT) {
          return null; // Rectangle
        }
      }
      else
      {
        ibm_ilog.graphlayout.internalutil.TranslateUtil.reshapeRect(rect, this._rectangleToFit.x, this._rectangleToFit.y,
          this._rectangleToFit.width, this._rectangleToFit.height);
      }
    }
    else if (this._rectangleToFit != null) {
      ibm_ilog.graphlayout.internalutil.TranslateUtil.reshapeRect(rect, this._rectangleToFit.x, this._rectangleToFit.y,
        this._rectangleToFit.width, this._rectangleToFit.height);
    }
    else {
      return null; // Rectangle
    }
    return rect; // Rectangle
  },

  getLayoutRegion : function()
  {
    // summary:
    //		Returns a copy of the rectangle that defines the layout region, as
    //		specified using the method '
    //		ibm_ilog.graphlayout.GraphLayout.layoutRegion', or
    //		'null' if no rectangle has been specified, or the
    //		specified rectangle was 'null'. 
    // description:
    //		Returns a copy of the rectangle that defines the layout region, as
    //		specified using the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.layoutRegion</code>, or
    //		<code>null</code> if no rectangle has been specified, or the
    //		specified rectangle was <code>null</code>.
    
    return this._rectangleToFitArgument;
    
  },

   getLayoutRegionMode: function() {
      // summary: 
      //		Gets the layout region mode.
     return this._layoutRegionMode;
   },
  
   setLayoutRegionMode : function(value) {
      // summary: 
      //		Sets the layout region mode.
     if (value != this._layoutRegionMode)
     {
       if (!this.supportsLayoutRegion())
       {
         ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6027E");
       }
       if ((value == ibm_ilog.graphlayout.GraphLayoutRegionMode.RECTANGLE_IN_CONTAINER_COORDINATES) ||
           (value == ibm_ilog.graphlayout.GraphLayoutRegionMode.RECTANGLE_IN_VIEW_COORDINATES) ||
           (value == ibm_ilog.graphlayout.GraphLayoutRegionMode.VIEW_BOUNDS)) {
         this._layoutRegionMode = value;
         this._updateLayoutRegion();
         this.onParameterChanged("layoutRegionMode", value);
       } else {
         ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6036E", value);
       }
     }
   },
  
   _updateLayoutRegion : function()
   {
     // tags:
     //		private
     var mode = this._layoutRegionMode;
  
     if (this._rectangleToFitArgument == null ||
         this._rectangleToFitArgument.width < 0 ||
         this._rectangleToFitArgument.height < 0)
       mode = ibm_ilog.graphlayout.GraphLayoutRegionMode.VIEW_BOUNDS;
  
     if (mode == ibm_ilog.graphlayout.GraphLayoutRegionMode.RECTANGLE_IN_CONTAINER_COORDINATES)
     {
       this._rectangleToFit = this._rectangleToFitArgument;
       this.setFitToViewEnabled(false);
       this._viewToFit = null;
     }
     else
     {
       // Get the diagram that is attached to this graph layout
       this._viewToFit = this.getView();
  
       if (this._viewToFit != null)
       {
         if (mode == ibm_ilog.graphlayout.GraphLayoutRegionMode.RECTANGLE_IN_VIEW_COORDINATES)
           this._rectangleToFit = this._rectangleToFitArgument;
         else
           this._rectangleToFit = null;
         this.setFitToViewEnabled(true);
       }
       else
       {
         this._rectangleToFit = this._rectangleToFitArgument;
         this.setFitToViewEnabled(false);
       }
     }
   },
   
  isFitToViewEnabled : function()
  {
    // summary:
    //		Returns 'true' if the graph drawing must fit (exactly or
    //		approximately) an area of a specific view. 
    // description:
    //		Returns <code>true</code> if the graph drawing must fit (exactly or
    //		approximately) an area of a specific view. 
    //		Otherwise, the method returns <code>false</code>.  
    // returns:
    //		'true' if the graph drawing must fit (exactly or
    //		approximately) an area of the diagram view.
    
    return this._fitToViewEnabled; // Boolean
  },

  setFitToViewEnabled : function(flag)
  {
    // summary:
    //		Sets the fit-to-view flag.  
    // tags:
    //		private
    
    this._fitToViewEnabled = flag;
  },

  getView : function()
  {
    // summary:
    //		Returns the first manager view attached to the grapher, or null if
    //		none.  
    // tags:
    //		private
    
    var obj = this._graphModel;
    if (obj == null)
      return null;
    try {
      // NOTE: If object is a GraphLayoutModelAdapter, property diagram
      // will be set.
      if (obj.getDiagram) {
          return obj.getDiagram() || null;
      }
    } catch (error) {
      // This happens is the graph model does not have a property diagram.
      // It should never happen for GraphLayoutModelAdapter
    }
    return null;
    
  },

  getViewMatrix : function() {
   // summary: 
   //		Returns the matrix that is applied to the first view attached to this layout.
    var view = this.getView();
    if (view != null) {
      // If view is a diagram, get the reference matrix from the top level graph
      if (view.getGraph) {
        return view.getGraph().getTransform();
      } else if(view.getTransform){
      // Otherwise, as view is a UIComponent get the matrix from its transform
        return view.getTransform();
      }
    }
    return null;
  },
  
  supportsRandomGenerator : function()
  {
    // summary:
    //		Indicates whether the layout class uses randomly generated numbers
    //		(or randomly chosen parameters) for which it can accept a
    //		user-defined seed value. 
    // description:
    //		Indicates whether the layout class uses randomly generated numbers
    //		(or randomly chosen parameters) for which it can accept a
    //		user-defined seed value. 
    //		When you perform the same layout on the same graph several times and
    //		use the same user-defined seed value (or some other constant value),
    //		the same random numbers are generated and, if the algorithm is
    //		deterministic, you obtain the same drawing of the graph model. If
    //		you want different drawings each time you perform the layout, you
    //		can modify the seed value and call the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setUseSeedValueForRandomGenerator()</code>
    //		with a <code>true</code> argument.  
    //		<p>
    //		 
    //		</p>
    //		<p>
    //		The default implementation always returns <code>false</code>.  
    //		</p>
    //		<p>
    //		Subclasses can override this method in order to return
    //		<code>true</code>, that is, to indicate that this option is
    //		supported.  
    //		</p>
    
    return false; // Boolean
  },

  setSeedValueForRandomGenerator : function(seed)
  {
    // summary:
    //		Sets the seed value for the random generator. 
    // description:
    //		Sets the seed value for the random generator. 
    //		The default value is <code>0</code>. The user-defined seed value is
    //		used only if you call
    //		<code>setUseSeedValueForRandomGenerator(boolean)</code> with a
    //		<code>true</code> argument.   
    //		<p>
    //		An <code>Error</code> is thrown if the layout does not support this
    //		mechanism.  
    //		</p>
    
    if (!this.supportsRandomGenerator() && !false)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6028E");
    }

    if (seed != this._seedValue)
    {
      this._seedValue = seed;
      this.onParameterChanged("SeedValueForRandomGenerator");
    }
  },

  getSeedValueForRandomGenerator : function()
  {
    // summary:
    //		Returns the user-defined seed value for the random generator. 
    // description:
    //		Returns the user-defined seed value for the random generator. 
    //		<p>
    //		An <code>Error</code> is thrown if the layout does not support this
    //		mechanism.  
    //		</p>
    
    return (false ? ibm_ilog.graphlayout.GraphLayout._defaultSeedValue : this._seedValue); // Number
  },

  setUseSeedValueForRandomGenerator : function(option)
  {
    // summary:
    //		Sets whether the user-defined seed value should be used for the
    //		random generator. 
    // description:
    //		Sets whether the user-defined seed value should be used for the
    //		random generator. 
    //		<p>
    //		An <code>Error</code> is thrown if the layout does not support this
    //		mechanism.  
    //		</p>
    
    if (!this.supportsRandomGenerator() && !false)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6028E");
    }

    if (this._userDefinedSeedOption != option)
    {
      this._userDefinedSeedOption = option;
      this.onParameterChanged("UseSeedValueForRandomGenerator");
    }
  },

  isUseSeedValueForRandomGenerator : function()
  {
    // summary:
    //		Returns 'true' if the user-defined seed value is used for
    //		the random generator and 'false' otherwise. 
    // description:
    //		Returns <code>true</code> if the user-defined seed value is used for
    //		the random generator and <code>false</code> otherwise. 
    //		<p>
    //		An error is thrown  An <code>Error</code> is thrown if the layout
    //		does not support this mechanism.  
    //		</p>
    
    return (false ? ibm_ilog.graphlayout.GraphLayout._defaultUserDefinedSeedOption : this._userDefinedSeedOption); // Boolean
  },

  supportsAllowedTime : function()
  {
    // summary:
    //		Indicates whether the layout class can stop the layout computation
    //		when a user-defined allowed time is exceeded. 
    // description:
    //		Indicates whether the layout class can stop the layout computation
    //		when a user-defined allowed time is exceeded. 
    //		<p>
    //		The default implementation always returns <code>false</code>.  
    //		</p>
    //		<p>
    //		Subclasses can override this method in order to return
    //		<code>true</code>, that is, to indicate that this option is
    //		supported.  
    //		</p>
    
    return false; // Boolean
  },

  getAllowedTime : function()
  {
    // summary:
    //		Returns the currently allowed time for the layout algorithm in
    //		milliseconds. 
    // description:
    //		Returns the currently allowed time for the layout algorithm in
    //		milliseconds. 
    //		<p>
    //		Note that the method <code>performLayout</code> does NOT
    //		automatically stop the layout when the allowed time is exceeded. It
    //		is entirely the responsibility of the implementation of the method
    //		<code> ibm&#95;ilog.graphlayout.GraphLayout.layout()</code> to do this. 
    //		  
    //		</p>
    
    if (!this.supportsAllowedTime()) {
      return /*Number.MAX_VALUE*/9223372036854775807; // Number
    }
    return (false ? ibm_ilog.graphlayout.GraphLayout._defaultAllowedTime : this._allowedTime); // Number
  },

  setAllowedTime : function(time)
  {
    // summary:
    //		Sets the upper limit for the duration of the layout algorithm. 
    // description:
    //		Sets the upper limit for the duration of the layout algorithm. 
    //		<p>
    //		When an iterative layout algorithm is used, the iterations can be
    //		stopped when this time is exceeded. Noniterative algorithms can also
    //		use this parameter as an upper limit for the computation time. The
    //		default value is normally <code>32000</code> (32 seconds).
    //		Subclasses that support this feature can use a different default
    //		value depending on their particular behavior. Layout algorithms that
    //		are stopped in this way set the result code of the layout report
    //		either to <code> GraphLayoutReport.STOPPED&#95;AND&#95;VALID</code> or to
    //		<code> GraphLayoutReport.STOPPED&#95;AND&#95;INVALID</code>.  
    //		</p>
    //		<p>
    //		When the connected components of disconnected graphs are laid out
    //		separately (see <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.supportsLayoutOfConnectedComponents()</code>),
    //		the specified allowed time is considered as the total time for the
    //		layout of all the connected components plus the time for the
    //		connected components layout.  
    //		</p>
    //		<p>
    //		Note that the layout algorithm may not obey exactly the allowed time
    //		specification.  
    //		</p>
    //		<p>
    //		Note for implementers of layout algorithms: the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code> does NOT
    //		automatically stop the layout when the allowed time is exceeded. It
    //		is the sole responsibility of the implementation of the method
    //		<code> ibm&#95;ilog.graphlayout.GraphLayout.layout()</code> to do this. 
    //		
    //		</p>
    //		<p>
    //		An <code>Error</code> is thrown if the layout does not support this
    //		mechanism.  
    //		</p>
    // time: Number
    //		The allowed time in milliseconds.
    
    if (!this.supportsAllowedTime() && !false)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6029E");
    }

    if (time < 0)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6030E");
    }

    if (this._allowedTime != time)
    {
      this._allowedTime = time;
      this.onParameterChanged("AllowedTime");
    }
  },

  isLayoutTimeElapsed : function()
  {
    // summary:
    //		Returns 'true' if, at the moment the method is called,
    //		the allowed layout time is exceeded; returns 'false'
    //		otherwise. 
    // description:
    //		Returns <code>true</code> if, at the moment the method is called,
    //		the allowed layout time is exceeded; returns <code>false</code>
    //		otherwise. 
    //		<p>
    //		You can call this method inside the implementation of the method
    //		<code> ibm&#95;ilog.graphlayout.GraphLayout.layout()</code>.  
    //		</p>
    // returns:
    //		'false' if the layout does not support this
    //		mechanism.
    // tags:
    //		protected
    
    if (this._layoutReport == null || !this.supportsAllowedTime()) {
      return false; // Boolean
    }
    return (new Date().getTime() - this._layoutReport.getStartLayoutTime()) > this.getAllowedTime(); // Boolean
  },

  getRemainingAllowedTime : function()
  {
    // summary:
    //		Returns the remaining allowed time. 
    // description:
    //		Returns the remaining allowed time. 
    //		The remaining allowed time is the difference between the allowed
    //		time given by <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.getAllowedTime()</code>, and the
    //		time elapsed since the beginning of layout execution.  
    // returns:
    //		A negative number is returned if one of the following conditions
    //		is met: 
    //		<ul>
    //		<li>The allowed time has elapsed.</li> 
    //		<li>The layout does not support the allowed time.</li> 
    //		<li>This method is called when the layout report is not yet
    //		available.</li> 
    //		<li>This method is called when the layout report is no longer
    //		available.</li> 
    //		</ul>
    
    if (this._layoutReport == null || !this.supportsAllowedTime()) {
      return -1; // Number
    }
    var remaining = this.getAllowedTime() - (new Date().getTime() - this._layoutReport.getStartLayoutTime());
    return (remaining >= 0 ? remaining : 0); // Number
  },

  supportsLayoutOfConnectedComponents : function()
  {
    // summary:
    //		Indicates whether the layout class can cut the attached graph into
    //		connected components, apply itself on each connected component
    //		separately, and then use the layout instance returned by the method
    //		'
    //		ibm_ilog.graphlayout.GraphLayout.getLayoutOfConnectedComponents()'
    //		to position the connected components. 
    // description:
    //		Indicates whether the layout class can cut the attached graph into
    //		connected components, apply itself on each connected component
    //		separately, and then use the layout instance returned by the method
    //		<code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.getLayoutOfConnectedComponents()</code>
    //		to position the connected components. 
    //		<p>
    //		The default implementation always returns <code>false</code>.
    //		Subclasses can override this method in order to return
    //		<code>true</code>, that is, to indicate that this option is
    //		supported.  
    //		</p>
    
    return false; // Boolean
  },

  //_modelsWeListenTo : null,
  
  _addAsModelListener : function(model)
  {
   // tags:
   //		private
  /*
   if(!this._modelsWeListenTo)
     this._modelsWeListenTo = new dojox.collections.Dictionary();
   if(!this._modelsWeListenTo.item(model)){
     model._dojoConnectHandle = dojo.connect(model, "contentsChanged", this, "contentsChanged");
     this._modelsWeListenTo.add(model, true);
   }
  */
  },
  
  _removeAsModelListener : function(model)
  {
   // tags:
   //		private
  /*
   if(this._modelsWeListenTo && this._modelsWeListenTo.item(model) == true){
     dojo.disconnect(model._dojoConnectHandle);
     delete this._modelsWeListenTo[model];
   }
  */
  },
  
  contentsChanged : function(event)
  {
    // summary:
    //		Called when the structure or the geometry of the graph changes. 
    // description:
    //		Called when the structure or the geometry of the graph changes. 
    //		<p>
    //		If the type of the event is <code>
    //		GraphLayoutModelEvent.STRUCTURE&#95;CHANGED</code>, the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setStructureUpToDate()</code> is
    //		called with a <code>false</code> argument. Or, if the type of the
    //		event is <code> GraphLayoutModelEvent.GEOMETRY&#95;CHANGED</code>, the
    //		method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setGeometryUpToDate()</code> is
    //		called with a <code>false</code> argument.  
    //		</p>
    //		<p>
    //		The method then calls <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.cleanNode()</code> if the type of
    //		the event  is <code> GraphLayoutModelEvent.NODE&#95;REMOVED</code> or
    //		<code> ibm&#95;ilog.graphlayout.GraphLayout.cleanLink()</code> if the
    //		type of the event is <code>
    //		GraphLayoutModelEvent.LINK&#95;REMOVED</code>. The node or link that is
    //		passed to the method called is obtained using <code>
    //		GraphLayoutModelEvent.getNodeOrLink()</code>.   
    //		</p>
    // event: ibm_ilog.graphlayout.GraphLayoutModelEvent
    //		The event indicating the change that has occurred in the
    //		graph model.
    
  },

  supportsLinkConnectionBox : function()
  {
    // summary:
    //		Indicates whether the layout class can use a link connection box
    //		interface to calculate the end points of a link. 
    // description:
    //		Indicates whether the layout class can use a link connection box
    //		interface to calculate the end points of a link. 
    //		The link connection box interface is an object that provides the
    //		rectangle to which the links are connected for each node and the
    //		tangential shift offset at each side for the connection points.  
    //		<p>
    //		If the layout class supports this feature and a connection box
    //		interface object is set using the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setLinkConnectionBoxInterface()</code>,
    //		the layout algorithm uses this object to calculate the connection
    //		points for links.   
    //		</p>
    //		<p>
    //		The default implementation always returns <code>false</code>.
    //		Subclasses can override this method in order to return
    //		<code>true</code>, that is, to indicate that this option is
    //		supported.  
    //		</p>
    
    return false; // Boolean
  },

  setLinkConnectionBoxInterface : function(linkConnectionBoxInterface)
  {
    // summary:
    //		Sets the link connection box interface for the connection points of
    //		links. 
    // description:
    //		Sets the link connection box interface for the connection points of
    //		links. 
    //		The link connection box interface is an object that provides the
    //		rectangle to which the links are connected for each node and the
    //		tangential shift offset at each side for the connection points.  
    //		<p>
    //		By default, the layout algorithm places the connection points of the
    //		links relative to the bounding box of the nodes (see  ).  
    //		</p>
    //		<p>
    //		By setting a link connection box interface, the links can be
    //		connected relative to a different box (see <code>
    //		ILinkConnectionBoxProvider.getBox()</code>). It is furthermore
    //		possible to "shift" the links tangentially by using the method
    //		<code> ILinkConnectionBoxProvider.getTangentialOffset()</code> from
    //		the interface <code> ILinkConnectionBoxProvider</code>:  
    //		<ul>
    //		<li> On the "top" and "bottom" sides of a node, the connection
    //		points are moved to the right if the offset is positive and to the
    //		left if the offset is negative.</li>  
    //		<li> On the "left" and "right" sides of a node, the connection
    //		points are moved to the bottom if the offset is positive and to the
    //		top if the offset is negative.</li>  
    //		</ul>
    //		The details of how the link connection box is used depend on the
    //		specific layout algorithm.   
    //		</p>
    //		<p>
    //		You can call this method with a <code>null</code> argument to
    //		restore the default behavior.  
    //		</p>
    //		<p>
    //		An <code>Error</code> is thrown if the layout does not support this
    //		mechanism.  
    //		</p>
    
    if (!this.supportsLinkConnectionBox() && !false)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6031E");
    }

    if (linkConnectionBoxInterface != this._linkConnectionBoxInterface)
    {
      this._linkConnectionBoxInterface = linkConnectionBoxInterface;
      this.onParameterChanged("LinkConnectionBoxInterface");
    }
  },

  getLinkConnectionBoxInterface : function()
  {
    // summary:
    //		Returns the link connection box interface used to calculate the
    //		connection points of links during layout. 
    // description:
    //		Returns the link connection box interface used to calculate the
    //		connection points of links during layout. 
    //		<p>
    //		Returns <code>null</code> if none is specified.  
    //		</p>
    
    return this._linkConnectionBoxInterface; // ibm_ilog.graphlayout.ILinkConnectionBoxProvider
  },

   isLinkClipping : function()
   {
    // summary: 
    //		Gets whether links should be clipped at the shape of the end nodes.
     return this._linkClipping;
   },
   
   setLinkClipping : function(value)
   {
    // summary: 
    //		Sets whether links should be clipped at the shape of the end nodes.
     if (this._linkClipping != value) {
       this._linkClipping = value;
       this.onParameterChanged("linkClipping", value);
     }
   },
  
  connectAllLinksToCenter : function()
  {
    // summary:
    //		Connects all links to the enter of their end nodes. 
    // description:
    //		Connects all links to the enter of their end nodes. 
    //		This method is provided for convenience in the implementation of
    //		layout algorithms. The method can be called by a layout algorithm to
    //		connect links to node centers after the end nodes are placed at
    //		their final positions and the link has its final shape.  
    //		<p>
    //		If a link connection box is set, it uses the virtual center of the
    //		connection box instead of the center of the bounding boxes of the
    //		end nodes. The virtual center is defined as the center of the
    //		connection box shifted by the average of the tangential "top" and
    //		"bottom" offset in the horizontal direction and by the average of
    //		the tangential "left" and "right" offset in the vertical direction.
    //		For instance, if the tangential offset is 20 at the top side and 10
    //		at all other sides, the average shift offset is <code>(20 + 10)/2 =
    //		15</code> in the horizontal direction and <code>(10 + 10)/2 =
    //		10</code> in the vertical direction; hence the virtual center is at
    //		<code>connectionBox.center()&#160;+&#160;(15,&#160;10)</code>.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // redraw: Boolean
    //		Whether the links need to be redrawn.
    
    var model = this.getGraphModel();
    var e = new ibm_ilog.graphlayout.internalutil.ArrayIterator(model.getLinks());
    var link;

    while (e.hasNext())
    {
      link = e.next();
      this.connectLinkToCenter(link, true, true);
    }
  },

  supportsSplineRouting : function()
  {
    // summary:
    //		Indicates whether the layout class supports the generic optimization
    //		of spline control points. 
    // description:
    //		Indicates whether the layout class supports the generic optimization
    //		of spline control points. 
    //		<p>
    //		 
    //		</p>
    //		<p>
    //		Subclasses can override this method in order to return
    //		<code>true</code>, that is, to indicate that this option is
    //		supported. Subclasses that do not route the links and always use
    //		straight links cannot benefit from the generic mechanism.  
    //		</p>
    
    return false; // Boolean
  },

  setSplineRoutingEnabled : function(flag)
  {
    // summary:
    //		Sets whether the calculation of optimized spline control points is
    //		enabled. 
    // description:
    //		Sets whether the calculation of optimized spline control points is
    //		enabled. 
    //		<p>
    //		 
    //		</p>
    //		<p>
    //		If the layout algorithm supports generic spline optimization, this
    //		option enables the optimization of spline control points. Such 
    //		optimization improves the result only if the splines use a
    //		smoothness between 0.1 and 0.9.  It does not affect links that are
    //		not reshaped by the layout algorithm or that are routed as straight
    //		lines.  
    //		</p>
    //		<p>
    //		This is an expert option. It is disabled by default.  
    //		</p>
    // flag: Boolean
    //		Set to 'true' to enable the optimization of
    //		spline control points.
    
    if (!this.supportsSplineRouting() && !false)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6032E");
    }

    if (flag != this._splineRoutingEnabled)
    {
      this._splineRoutingEnabled = flag;
      this.onParameterChanged("SplineRoutingEnabled");
    }
  },

  isSplineRoutingEnabled : function()
  {
    // summary:
    //		Tests whether the calculation of optimized spline control points is
    //		enabled.  
    // returns:
    //		If the calculation of optimized spline control points is
    //		enabled, 'true' is returned.
    
    if (false) {
      return ibm_ilog.graphlayout.GraphLayout._defaultSplineRoutingEnabled; // Boolean
    }
    return this._splineRoutingEnabled; // Boolean
  },

  setMinSplineCurveSize : function(size)
  {
    // summary:
    //		Sets the minimum curve size used when optimized spline control point
    //		routing is enabled. 
    // description:
    //		Sets the minimum curve size used when optimized spline control point
    //		routing is enabled. 
    //		<p>
    //		The parameter works only if the layout supports the generic spline
    //		optimization routing, and if it is enabled.  
    //		</p>
    //		<p>
    //		Bends in a spline have a size that is described roughly by the
    //		triangle the surrounds the curve part of a bend. Spline routing
    //		tries to set the side length of this triangle at each bend between
    //		the minimum curve size and the maximum curve size.  
    //		</p>
    //		<p>
    //		The default value is <code>5</code>.  
    //		</p>
    // size: Number
    //		The minimum spline curve size
    
    if (!this.supportsSplineRouting() && !false)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6032E");
    }

    if (size <= 0.0)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6033E",  size);
    }

    if (size != this._minSplineCurveSize)
    {
      this._minSplineCurveSize = size;
      this.onParameterChanged("MinSplineCurveSize");
    }
  },

  getMinSplineCurveSize : function()
  {
    // summary:
    //		Returns the minimum curve size used when optimized spline control
    //		points routing is enabled.  
    // returns:
    //		The minimum curve size used when optimized spline control points
    //		routing is enabled.
    
    if (false) {
      return ibm_ilog.graphlayout.GraphLayout._defaultMinSplineCurveSize; // Number
    }
    return this._minSplineCurveSize; // Number
  },

  setMaxSplineCurveSize : function(size)
  {
    // summary:
    //		Sets the maximum curve size used when optimized spline control point
    //		routing is enabled. 
    // description:
    //		Sets the maximum curve size used when optimized spline control point
    //		routing is enabled. 
    //		<p>
    //		The parameter works only if the layout supports the generic spline
    //		optimization routing, and if it is enabled.  
    //		</p>
    //		<p>
    //		Bends in a spline have a size that is described roughly by the
    //		triangle the surrounds the curve part of a bend. Spline routing
    //		tries to set the side length of this triangle at each bend between
    //		the minimum curve size and the maximum curve size.  
    //		</p>
    //		<p>
    //		The default value is <code>30</code>.  
    //		</p>
    // size: Number
    //		The maximum spline curve size
    
    if (!this.supportsSplineRouting() && !false)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6032E");
    }

    if (size <= 0.0)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6034E",  size);
    }

    if (size != this._maxSplineCurveSize)
    {
      this._maxSplineCurveSize = size;
      this.onParameterChanged("MaxSplineCurveSize");
    }
  },

  getMaxSplineCurveSize : function()
  {
    // summary:
    //		Returns the maximum curve size used when spline control point
    //		optimization routing is enabled.  
    // returns:
    //		The maximum curve size used when spline control point
    //		optimization routing is enabled.
    
    if (false) {
      return ibm_ilog.graphlayout.GraphLayout._defaultMaxSplineCurveSize; // Number
    }
    return this._maxSplineCurveSize; // Number
  },

  setBalanceSplineCurveThreshold : function(threshold)
  {
    // summary:
    //		Sets the threshold for spline curves at bends which the optimized
    //		spline control point routing uses to balance the curve. 
    // description:
    //		Sets the threshold for spline curves at bends which the optimized
    //		spline control point routing uses to balance the curve. 
    //		<p>
    //		The parameter works only if the layout supports generic spline
    //		optimization routing, and if it is enabled.  
    //		</p>
    //		<p>
    //		Bends in a spline have a size that is described roughly by the
    //		triangle the surrounds the curve part of a bend.  
    //		</p>
    //		<p>
    //		If the side length of the triangle is larger than the threshold, the
    //		algorithm tries to create a isosceles triangle. This results in more
    //		balanced bend curves.  
    //		</p>
    //		<p>
    //		If the side length of the triangle is smaller than the threshold, it
    //		uses non-isosceles triangles. Using isosceles triangles, the bend
    //		curve looks too sharp.  
    //		</p>
    //		<p>
    //		The default value is <code>10</code>.  
    //		</p>
    // threshold: Number
    //		The balance spline curve threshold.
    
    if (!this.supportsSplineRouting() && !false)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6032E");
    }

    if (threshold < 0.0)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6035E",  threshold);
    }

    if (threshold != this._balanceSplineCurveThreshold)
    {
      this._balanceSplineCurveThreshold = threshold;
      this.onParameterChanged("BalanceSplineCurveThreshold");
    }
  },

  getBalanceSplineCurveThreshold : function()
  {
    // summary:
    //		Returns the threshold for spline curves at bends which the optimized
    //		spline control point routing uses to balance the curve.  
    // returns:
    //		The threshold for spline curves at bends which the optimized
    //		spline control point routing uses to balance the curve.
    
    if (false) {
      return ibm_ilog.graphlayout.GraphLayout._defaultBalanceSplineCurveThreshold; // Number
    }
    return this._balanceSplineCurveThreshold; // Number
  },

  setParameter : function(key, value)
  {
    // summary:
    //		Sets the value of a property for the layout instance. 
    // description:
    //		Sets the value of a property for the layout instance. 
    //		If <code>value</code> is <code>null</code>, the parameter is
    //		removed. Otherwise, the parameter value is set to
    //		<code>value</code>.  
    // key: String
    //		The key string for the parameter.
    // value: Object
    //		The new value of the parameter.
    // returns:
    //		The value that was previously stored for 'key', or
    //		'null' if none.
    
    if (this._properties == null) {
      this._properties = new ibm_ilog.graphlayout.internalutil.DefaultParameterContainer();
    }
    return this._properties.setParameter(key, value); // Object
  },

  getParameter : function(key)
  {
    // summary:
    //		Returns the value of a parameter of the layout instance. 
    // description:
    //		Returns the value of a parameter of the layout instance. 
    //		The method returns <code>null</code> if the  parameter does not
    //		exist.  
    // key: String
    //		The key string for the parameter.
    // returns:
    //		The value stored for 'key'.
    
    return (this._properties != null ? this._properties.getParameter(key) : null); // Object
  },

  setObjectParameter : function(graphModel, nodeOrLink, key, value)
  {
    // summary:
    //		Sets the value of a parameter for a node or a link, using a given
    //		graph model. 
    // description:
    //		Sets the value of a parameter for a node or a link, using a given
    //		graph model. 
    //		<p>
    //		If <code>value</code> is <code>null</code>, the parameter is
    //		removed. Otherwise, the parameter value is set to
    //		<code>value</code>.  
    //		</p>
    //		<p>
    //		Notice that the method does not check whether the node or link
    //		actually belongs to <code>graphModel</code>. The input graph model
    //		does not need to be the graph model currently attached to this
    //		layout instance.  
    //		</p>
    // graphModel: ibm_ilog.graphlayout.AbstractGraphLayoutModel
    //		The graph model used for storing the parameter.
    // nodeOrLink: Object
    //		The node or link for which the parameter is to be set.
    // key: String
    //		The key string for the parameter.
    // value: Object
    //		The new value of the parameter.
    // returns:
    //		The value that was previously stored for 'key', or
    //		'null' if none.
    
    if (graphModel == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6012E");
    }

    var prop = graphModel.getParameter(nodeOrLink, this._NODE_OR_LINK_PROPERTY_NAME);

    if (prop == null && value != null)
    {
      prop = new ibm_ilog.graphlayout.internalutil.DefaultParameterContainer();
      graphModel.setParameter(nodeOrLink, this._NODE_OR_LINK_PROPERTY_NAME, prop);
    }

    return (prop != null ? prop.setParameter(key, value) : null); // Object
  },

  getObjectParameter : function(graphModel, nodeOrLink, key)
  {
    // summary:
    //		Returns the value of a  parameter of the layout instance. 
    // description:
    //		Returns the value of a  parameter of the layout instance. 
    //		This method returns <code>null</code> if the  does not exist.  
    //		<p>
    //		The method does not check that the specified node or link belongs to
    //		the specified <code>graphModel</code>. Also, the specified graph
    //		model does not need to be the graph model currently attached to this
    //		layout instance.  
    //		</p>
    // graphModel: ibm_ilog.graphlayout.AbstractGraphLayoutModel
    //		The graph model used for storing the parameter.
    // nodeOrLink: Object
    //		The node or link for which the parameter is to be
    //		retrieved.
    // key: String
    //		The key string for the parameter.
    // returns:
    //		The value of the parameter.
    
    if (graphModel == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6012E");
    }

    var prop = graphModel.getParameter(nodeOrLink, this._NODE_OR_LINK_PROPERTY_NAME);
    return (prop != null ? prop.getParameter(key) : null); // Object
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.GraphLayout,
{
  _uniqueIdCounter : null,

  _PROPERTY_BASE_NAME : null,

  _FIXED_PROPERTY : null,

  _defaultAllowedTime : null,

  _defaultMinBusyTime : null,

  _defaultPreserveFixedNodes : null,

  _defaultPreserveFixedLinks : null,

  _defaultAutoLayout : null,

  _defaultSeedValue : null,

  _defaultUserDefinedSeedOption : null,

  _defaultInputCheckEnabled : null,

  _defaultRectangleToFit : null,

  _defaultFitToViewEnabled : null,

  _defaultLinkConnectionBoxInterface : null,

  _defaultSplineRoutingEnabled : null,

  _defaultMinSplineCurveSize : null,

  _defaultMaxSplineCurveSize : null,

  _defaultBalanceSplineCurveThreshold : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.GraphLayout;
    
    c._uniqueIdCounter = -1;
    c._PROPERTY_BASE_NAME = "__ilvGraphLayout";
    c._FIXED_PROPERTY = "Fixed";
    c._defaultAllowedTime = 32000;
    c._defaultMinBusyTime = 50;
    c._defaultPreserveFixedNodes = false;
    c._defaultPreserveFixedLinks = false;
    c._defaultAutoLayout = false;
    c._defaultSeedValue = 0;
    c._defaultUserDefinedSeedOption = false;
    c._defaultInputCheckEnabled = true;
    c._defaultRectangleToFit = null;
    c._defaultFitToViewEnabled = true;
    c._defaultLinkConnectionBoxInterface = null;
    c._defaultSplineRoutingEnabled = false;
    c._defaultMinSplineCurveSize = 5.0;
    c._defaultMaxSplineCurveSize = 30.0;
    c._defaultBalanceSplineCurveThreshold = 10.0;
  }
  
}
);

ibm_ilog.graphlayout.GraphLayout._getGlobalProperties = function()
{
  // tags:
  //		private
  var properties = [
    { name: 'linkClipping', defaultValue: false }
  ];
  return properties;
};

ibm_ilog.graphlayout.GraphLayout._getNodeProperties = function()
{
  // tags:
  //		private
  return null;
};

ibm_ilog.graphlayout.GraphLayout._getLinkProperties = function()
{
  // tags:
  //		private
  return null;
};

(function(){ ibm_ilog.graphlayout.GraphLayout._fields_init(); })();

return dojo.getObject("ibm_ilog.graphlayout._GraphLayout");});
require(["ibm_ilog/graphlayout/_GraphLayout"]);

},
'ibm_ilog*graphlayout/internalutil/LogResUtil':function(){
define(["dojo","dijit","dojox","dojo/string","dojo/i18n","ibm_ilog/graphlayout/nls/messages"], function(dojo, dijit, dojox){
dojo.getObject("ibm_ilog.graphlayout.internalutil.LogResUtil", 1);
/* builder delete begin
dojo.provide("ibm_ilog.graphlayout.internalutil.LogResUtil");

 builder delete end */
dojo.requireIf(dojo.config._notDiagramForMobile, "dojo.i18n");
/* builder delete begin
dojo.require("dojo.string");


 builder delete end */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// #######################################
// ######## NOT Generated by J2JS ########
// ###### DO NOT DELETE THIS FILE! #######
// #######################################

// ------------------------------------------------------------------------
// Error logging methods used in the code generated by J2JS.
// ------------------------------------------------------------------------

ibm_ilog.graphlayout.internalutil.LogResUtil = {
	
	getLocalizedString: function(messageKey){
		// summary:
		//		Returns the localized string for the specified identifier.
		// description:
		//		This function normally fetches the specified string (using the dojo.i18n API)
		//		from the package name "ibm_ilog.graphlayout" and the bundle name "messages".
		//		On mobile platforms (that is, if dojo.config.diagramForMobile is true),
		//		dojo.i18n is not used (to reduce the size of downloaded code), so the id is
		//		returned unchanged. To localize messages on mobile, the application should
		//		replace this function (ibm_ilog.graphlayout.internalutil.LogResUtil.getLocalizedString)
		//		by a function that requests the localized string from the server.
		if(dojo.config.diagramForMobile){
			var s = messageKey.split('_');
			s = s[s.length-1];
			return "CWZDD" + s + ": " + messageKey;
		}
		dojo.requireLocalization("ibm_ilog.graphlayout", "messages");
		try { // workaround for i18n bug in dojo 1.7...
			var messages = dojo.i18n.getLocalization("ibm_ilog.graphlayout", "messages");
			return messages[messageKey];
		} catch(error){
			return messageKey;
		}
	},
	
	_throw : function(clazz, messageKey, params)
	{
		messageKey = messageKey.replace(/\./g, "_");
		var message = this.getLocalizedString(messageKey);
		if(arguments.length == 3){
			if(params === undefined) params = "undefined";
			message = dojo.string.substitute(message, (params instanceof Array) ? params : [ params ]);
		}
			
		console.log(message);
			
		var e = new Error(message);
		e._isIBMGraphLayoutError = true;
		e.sourceClass = clazz;
		throw e;
	},
	
	logAndThrowIllegalArgExc : function(clazz, messageKey, params)
	{
		this._throw(clazz, messageKey, params);
	},
	
	logAndThrowRuntimeExc : function(clazz, messageKey, params)
	{
		this._throw(clazz, messageKey, params);
	},
	
	logAndThrowGraphLayoutExc : function(clazz, messageKey, params)
	{
		this._throw(clazz, messageKey, params);
	}
};

return dojo.getObject("ibm_ilog.graphlayout.internalutil.LogResUtil");});
require(["ibm_ilog/graphlayout/internalutil/LogResUtil"]);

},
'ibm_ilog*graphlayout/Direction':function(){
define(["dojo","dijit","dojox"], function(dojo, dijit, dojox){
dojo.getObject("ibm_ilog.graphlayout.Direction", 1);
/* builder delete begin
dojo.provide("ibm_ilog.graphlayout.Direction");


 builder delete end */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// #######################################
// ######## NOT Generated by J2JS ########
// ###### DO NOT DELETE THIS FILE! #######
// #######################################

// ------------------------------------------------------------------------
// Direction constants used in the code generated by J2JS.
// ------------------------------------------------------------------------


ibm_ilog.graphlayout.Direction = {
	// summary:
	//		Defines the direction and alignment constants used in the graph layout API.
	// description:
	//		This object defines the direction and alignment constants used in the graph layout API.
	//		For example, to specify a left-to-right layout direction, you would call
	//		<code>layout.setFlowDirection(ibm&#95;graphlayout.Direction.RIGHT);</code>.
	// NONE: int
	//		Unspecified or invalid direction.
	NONE : 0,
	// LEFT: int
	//		Right-to-left direction.
	LEFT : 1,
	// RIGHT: int
	//		Left-to-right direction.
	RIGHT : 2,
	// TOP: int
	//		Bottom-to-top direction.
	TOP : 4,
	// BOTTOM: int
	//		Top-to-bottom direction
	BOTTOM : 8,
	// TOP_LEFT: int
	//		Top left alignment.
	TOP_LEFT : 5,
	// BOTTOM_LEFT: int
	//		Bottom left alignment.
	BOTTOM_LEFT : 9,
	// TOP_RIGHT: int
	//		Top right alignment.
	TOP_RIGHT : 6,
	// BOTTOM_RIGHT: int
	//		Bottom right alignment.
	BOTTOM_RIGHT : 10,
	// CENTER: int
	//		Center alignment.
	CENTER : 16,
	// HORIZONTAL_CENTER: int
	//		Horizontal center alignment.
	HORIZONTAL_CENTER : 32,
	// VERTICAL_CENTER: int
	//		Vertical center alignment.
	VERTICAL_CENTER : 64,
	// HORIZONTAL: int
	//		Horizontal direction.
	HORIZONTAL : 96,
	// VERTICAL: int
	//		Vertical direction.
	VERTICAL : 128,
	// LEADING: int
	//		Leading alignment.
	LEADING : 256,
	// TRAILING: int
	//		Trailing alignment.
	TRAILING : 257
};

return dojo.getObject("ibm_ilog.graphlayout.Direction");});
require(["ibm_ilog/graphlayout/Direction"]);

},
'ibm_ilog*graphlayout/internalutil/ConnectionPointModes':function(){
define(["dojo","dijit","dojox","ibm_ilog/graphlayout/internalutil/TranslateUtil"], function(dojo, dijit, dojox){
dojo.getObject("ibm_ilog.graphlayout.internalutil.ConnectionPointModes", 1);
/* builder delete begin
dojo.provide('ibm_ilog.graphlayout.internalutil.ConnectionPointModes');


 builder delete end */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');


 builder delete end */
dojo.declare('ibm_ilog.graphlayout.internalutil.ConnectionPointModes', null, 
{
  // summary:
  //		This class contains all enumeration constants used for connection
  //		point modes. 
  // description:
  //		This class contains all enumeration constants used for connection
  //		point modes. 
  //		This ensures that ALL setOrigin/DestinationPointMode or 
  //		setGlobalOrigin/DestinationPointMode of ALL layout algorithms share
  //		the same values.   
  //		<p>
  //		It also contains some generic support for the connection point modes.
  //		  
  //		</p>
  // tags:
  //		private
  
  constructor : function()
  {
    
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.internalutil.ConnectionPointModes,
{
  FREE_MODE : null,

  FIXED_MODE : null,

  MIXED_MODE : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.internalutil.ConnectionPointModes;
    
    c.FREE_MODE = 0;
    c.FIXED_MODE = 3;
    c.MIXED_MODE = 99;
  }
  
}
);

(function(){ ibm_ilog.graphlayout.internalutil.ConnectionPointModes._fields_init(); })();

return dojo.getObject("ibm_ilog.graphlayout.internalutil.ConnectionPointModes");});
require(["ibm_ilog/graphlayout/internalutil/ConnectionPointModes"]);

}}});

define([], 1);
